import "./cljs_env.js";
import "./cljs.core.js";
import "./goog.string.string.js";
import "./sci.impl.copy_vars.js";
import "./sci.impl.records.js";
import "./sci.impl.unrestrict.js";
import "./sci.impl.utils.js";
import "./sci.impl.vars.js";
goog.provide('sci.impl.io');
/**
 * create a dynamic var with clojure.core :ns meta
 */
sci.impl.io.core_dynamic_var = (function sci$impl$io$core_dynamic_var(var_args){
var G__37463 = arguments.length;
switch (G__37463) {
case 1:
return sci.impl.io.core_dynamic_var.cljs$core$IFn$_invoke$arity$1((arguments[(0)]));

break;
case 2:
return sci.impl.io.core_dynamic_var.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
case 3:
return sci.impl.io.core_dynamic_var.cljs$core$IFn$_invoke$arity$3((arguments[(0)]),(arguments[(1)]),(arguments[(2)]));

break;
default:
throw (new Error(["Invalid arity: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(arguments.length)].join('')));

}
});

(sci.impl.io.core_dynamic_var.cljs$core$IFn$_invoke$arity$1 = (function (name){
return sci.impl.io.core_dynamic_var.cljs$core$IFn$_invoke$arity$2(name,null);
}));

(sci.impl.io.core_dynamic_var.cljs$core$IFn$_invoke$arity$2 = (function (name,init_val){
return sci.impl.utils.dynamic_var.cljs$core$IFn$_invoke$arity$3(name,init_val,new cljs.core.PersistentArrayMap(null, 2, [new cljs.core.Keyword(null,"ns","ns",441598760),sci.impl.utils.clojure_core_ns,new cljs.core.Keyword("sci","built-in","sci/built-in",1244659599),true], null));
}));

(sci.impl.io.core_dynamic_var.cljs$core$IFn$_invoke$arity$3 = (function (name,init_val,extra_meta){
return sci.impl.utils.dynamic_var.cljs$core$IFn$_invoke$arity$3(name,init_val,cljs.core.assoc.cljs$core$IFn$_invoke$arity$variadic(extra_meta,new cljs.core.Keyword(null,"ns","ns",441598760),sci.impl.utils.clojure_core_ns,cljs.core.prim_seq.cljs$core$IFn$_invoke$arity$2([new cljs.core.Keyword("sci","built-in","sci/built-in",1244659599),true], 0)));
}));

(sci.impl.io.core_dynamic_var.cljs$lang$maxFixedArity = 3);

sci.impl.io.in$ = (function (){var _STAR_unrestricted_STAR__orig_val__37464 = sci.impl.unrestrict._STAR_unrestricted_STAR_;
var _STAR_unrestricted_STAR__temp_val__37465 = true;
(sci.impl.unrestrict._STAR_unrestricted_STAR_ = _STAR_unrestricted_STAR__temp_val__37465);

try{var G__37466 = sci.impl.io.core_dynamic_var.cljs$core$IFn$_invoke$arity$1(new cljs.core.Symbol(null,"*in*","*in*",1130010229,null));
sci.impl.vars.unbind(G__37466);

return G__37466;
}finally {(sci.impl.unrestrict._STAR_unrestricted_STAR_ = _STAR_unrestricted_STAR__orig_val__37464);
}})();
sci.impl.io.out = (function (){var _STAR_unrestricted_STAR__orig_val__37468 = sci.impl.unrestrict._STAR_unrestricted_STAR_;
var _STAR_unrestricted_STAR__temp_val__37469 = true;
(sci.impl.unrestrict._STAR_unrestricted_STAR_ = _STAR_unrestricted_STAR__temp_val__37469);

try{var G__37470 = sci.impl.io.core_dynamic_var.cljs$core$IFn$_invoke$arity$1(new cljs.core.Symbol(null,"*out*","*out*",1277591796,null));
sci.impl.vars.unbind(G__37470);

return G__37470;
}finally {(sci.impl.unrestrict._STAR_unrestricted_STAR_ = _STAR_unrestricted_STAR__orig_val__37468);
}})();
sci.impl.io.err = (function (){var _STAR_unrestricted_STAR__orig_val__37472 = sci.impl.unrestrict._STAR_unrestricted_STAR_;
var _STAR_unrestricted_STAR__temp_val__37473 = true;
(sci.impl.unrestrict._STAR_unrestricted_STAR_ = _STAR_unrestricted_STAR__temp_val__37473);

try{var G__37474 = sci.impl.io.core_dynamic_var.cljs$core$IFn$_invoke$arity$1(new cljs.core.Symbol(null,"*err*","*err*",2070937226,null));
sci.impl.vars.unbind(G__37474);

return G__37474;
}finally {(sci.impl.unrestrict._STAR_unrestricted_STAR_ = _STAR_unrestricted_STAR__orig_val__37472);
}})();
sci.impl.io.print_fn = (function (){var _STAR_unrestricted_STAR__orig_val__37484 = sci.impl.unrestrict._STAR_unrestricted_STAR_;
var _STAR_unrestricted_STAR__temp_val__37485 = true;
(sci.impl.unrestrict._STAR_unrestricted_STAR_ = _STAR_unrestricted_STAR__temp_val__37485);

try{var G__37486 = sci.impl.io.core_dynamic_var.cljs$core$IFn$_invoke$arity$1(new cljs.core.Symbol(null,"*print-fn*","*print-fn*",138509853,null));
sci.impl.vars.unbind(G__37486);

return G__37486;
}finally {(sci.impl.unrestrict._STAR_unrestricted_STAR_ = _STAR_unrestricted_STAR__orig_val__37484);
}})();
sci.impl.io.print_err_fn = (function (){var _STAR_unrestricted_STAR__orig_val__37490 = sci.impl.unrestrict._STAR_unrestricted_STAR_;
var _STAR_unrestricted_STAR__temp_val__37492 = true;
(sci.impl.unrestrict._STAR_unrestricted_STAR_ = _STAR_unrestricted_STAR__temp_val__37492);

try{var G__37508 = sci.impl.io.core_dynamic_var.cljs$core$IFn$_invoke$arity$1(new cljs.core.Symbol(null,"*print-err-fn*","*print-err-fn*",1241679298,null));
sci.impl.vars.unbind(G__37508);

return G__37508;
}finally {(sci.impl.unrestrict._STAR_unrestricted_STAR_ = _STAR_unrestricted_STAR__orig_val__37490);
}})();
sci.impl.io.print_meta = (new sci.lang.Var(cljs.core._STAR_print_meta_STAR_,new cljs.core.Symbol(null,"*print-meta*","*print-meta*",-919406644,null),new cljs.core.PersistentArrayMap(null, 6, [new cljs.core.Keyword(null,"name","name",1843675177),new cljs.core.Symbol(null,"*print-meta*","*print-meta*",-919406644,null),new cljs.core.Keyword(null,"arglists","arglists",1661989754),null,new cljs.core.Keyword(null,"doc","doc",1913296891),"If set to logical true, when printing an object, its metadata will also\n  be printed in a form that can be read back by the reader.\n\n  Defaults to false.",new cljs.core.Keyword(null,"dynamic","dynamic",704819571),true,new cljs.core.Keyword("sci","built-in","sci/built-in",1244659599),true,new cljs.core.Keyword(null,"ns","ns",441598760),sci.impl.utils.clojure_core_ns], null),false,null,null));
sci.impl.io.print_length = (new sci.lang.Var(cljs.core._STAR_print_length_STAR_,new cljs.core.Symbol(null,"*print-length*","*print-length*",-687693654,null),new cljs.core.PersistentArrayMap(null, 6, [new cljs.core.Keyword(null,"name","name",1843675177),new cljs.core.Symbol(null,"*print-length*","*print-length*",-687693654,null),new cljs.core.Keyword(null,"arglists","arglists",1661989754),null,new cljs.core.Keyword(null,"doc","doc",1913296891),"*print-length* controls how many items of each collection the\n  printer will print. If it is bound to logical false, there is no\n  limit. Otherwise, it must be bound to an integer indicating the maximum\n  number of items of each collection to print. If a collection contains\n  more items, the printer will print items up to the limit followed by\n  '...' to represent the remaining items. The root binding is nil\n  indicating no limit.",new cljs.core.Keyword(null,"dynamic","dynamic",704819571),true,new cljs.core.Keyword("sci","built-in","sci/built-in",1244659599),true,new cljs.core.Keyword(null,"ns","ns",441598760),sci.impl.utils.clojure_core_ns], null),false,null,null));
sci.impl.io.print_level = (new sci.lang.Var(cljs.core._STAR_print_level_STAR_,new cljs.core.Symbol(null,"*print-level*","*print-level*",-634488505,null),new cljs.core.PersistentArrayMap(null, 6, [new cljs.core.Keyword(null,"name","name",1843675177),new cljs.core.Symbol(null,"*print-level*","*print-level*",-634488505,null),new cljs.core.Keyword(null,"arglists","arglists",1661989754),null,new cljs.core.Keyword(null,"doc","doc",1913296891),"*print-level* controls how many levels deep the printer will\n  print nested objects. If it is bound to logical false, there is no\n  limit. Otherwise, it must be bound to an integer indicating the maximum\n  level to print. Each argument to print is at level 0; if an argument is a\n  collection, its items are at level 1; and so on. If an object is a\n  collection and is at a level greater than or equal to the value bound to\n  *print-level*, the printer prints '#' to represent it. The root binding\n  is nil indicating no limit.",new cljs.core.Keyword(null,"dynamic","dynamic",704819571),true,new cljs.core.Keyword("sci","built-in","sci/built-in",1244659599),true,new cljs.core.Keyword(null,"ns","ns",441598760),sci.impl.utils.clojure_core_ns], null),false,null,null));
sci.impl.io.print_namespace_maps = (new sci.lang.Var(true,new cljs.core.Symbol(null,"*print-namespace-maps*","*print-namespace-maps*",-1759108415,null),new cljs.core.PersistentArrayMap(null, 6, [new cljs.core.Keyword(null,"name","name",1843675177),new cljs.core.Symbol(null,"*print-namespace-maps*","*print-namespace-maps*",-1759108415,null),new cljs.core.Keyword(null,"arglists","arglists",1661989754),null,new cljs.core.Keyword(null,"doc","doc",1913296891),"*print-namespace-maps* controls whether the printer will print\n  namespace map literal syntax.\n\n  Defaults to false, but the REPL binds it to true.",new cljs.core.Keyword(null,"dynamic","dynamic",704819571),true,new cljs.core.Keyword("sci","built-in","sci/built-in",1244659599),true,new cljs.core.Keyword(null,"ns","ns",441598760),sci.impl.utils.clojure_core_ns], null),false,null,null));
sci.impl.io.flush_on_newline = (new sci.lang.Var(cljs.core._STAR_flush_on_newline_STAR_,new cljs.core.Symbol(null,"*flush-on-newline*","*flush-on-newline*",-737526501,null),new cljs.core.PersistentArrayMap(null, 6, [new cljs.core.Keyword(null,"name","name",1843675177),new cljs.core.Symbol(null,"*flush-on-newline*","*flush-on-newline*",-737526501,null),new cljs.core.Keyword(null,"arglists","arglists",1661989754),null,new cljs.core.Keyword(null,"doc","doc",1913296891),"When set to true, output will be flushed whenever a newline is printed.\n\n  Defaults to true.",new cljs.core.Keyword(null,"dynamic","dynamic",704819571),true,new cljs.core.Keyword("sci","built-in","sci/built-in",1244659599),true,new cljs.core.Keyword(null,"ns","ns",441598760),sci.impl.utils.clojure_core_ns], null),false,null,null));
sci.impl.io.print_readably = (new sci.lang.Var(cljs.core._STAR_print_readably_STAR_,new cljs.core.Symbol(null,"*print-readably*","*print-readably*",-761361221,null),new cljs.core.PersistentArrayMap(null, 6, [new cljs.core.Keyword(null,"name","name",1843675177),new cljs.core.Symbol(null,"*print-readably*","*print-readably*",-761361221,null),new cljs.core.Keyword(null,"arglists","arglists",1661989754),null,new cljs.core.Keyword(null,"doc","doc",1913296891),"When set to logical false, strings and characters will be printed with\n  non-alphanumeric characters converted to the appropriate escape sequences.\n\n  Defaults to true",new cljs.core.Keyword(null,"dynamic","dynamic",704819571),true,new cljs.core.Keyword("sci","built-in","sci/built-in",1244659599),true,new cljs.core.Keyword(null,"ns","ns",441598760),sci.impl.utils.clojure_core_ns], null),false,null,null));
sci.impl.io.print_dup_var = (new sci.lang.Var(cljs.core._STAR_print_dup_STAR_,new cljs.core.Symbol(null,"*print-dup*","*print-dup*",103854877,null),new cljs.core.PersistentArrayMap(null, 6, [new cljs.core.Keyword(null,"name","name",1843675177),new cljs.core.Symbol(null,"*print-dup*","*print-dup*",103854877,null),new cljs.core.Keyword(null,"arglists","arglists",1661989754),null,new cljs.core.Keyword(null,"doc","doc",1913296891),"When set to logical true, objects will be printed in a way that preserves\n  their type when read in later.\n\n  Defaults to false.",new cljs.core.Keyword(null,"dynamic","dynamic",704819571),true,new cljs.core.Keyword("sci","built-in","sci/built-in",1244659599),true,new cljs.core.Keyword(null,"ns","ns",441598760),sci.impl.utils.clojure_core_ns], null),false,null,null));
sci.impl.io.print_newline = (new sci.lang.Var(cljs.core._STAR_print_newline_STAR_,new cljs.core.Symbol(null,"*print-newline*","*print-newline*",1478078956,null),new cljs.core.PersistentArrayMap(null, 6, [new cljs.core.Keyword(null,"name","name",1843675177),new cljs.core.Symbol(null,"*print-newline*","*print-newline*",1478078956,null),new cljs.core.Keyword(null,"arglists","arglists",1661989754),null,new cljs.core.Keyword(null,"doc","doc",1913296891),"When set to logical false will drop newlines from printing calls.\n  This is to work around the implicit newlines emitted by standard JavaScript\n  console objects.",new cljs.core.Keyword(null,"dynamic","dynamic",704819571),true,new cljs.core.Keyword("sci","built-in","sci/built-in",1244659599),true,new cljs.core.Keyword(null,"ns","ns",441598760),sci.impl.utils.clojure_core_ns], null),false,null,null));
sci.impl.io.string_print = (function sci$impl$io$string_print(x){
var _STAR_print_fn_STAR__orig_val__37525 = cljs.core._STAR_print_fn_STAR_;
var _STAR_print_fn_STAR__temp_val__37526 = cljs.core.deref(sci.impl.io.print_fn);
(cljs.core._STAR_print_fn_STAR_ = _STAR_print_fn_STAR__temp_val__37526);

try{return cljs.core.string_print(x);
}finally {(cljs.core._STAR_print_fn_STAR_ = _STAR_print_fn_STAR__orig_val__37525);
}});
sci.impl.io.pr = (function sci$impl$io$pr(var_args){
var args__5775__auto__ = [];
var len__5769__auto___37706 = arguments.length;
var i__5770__auto___37707 = (0);
while(true){
if((i__5770__auto___37707 < len__5769__auto___37706)){
args__5775__auto__.push((arguments[i__5770__auto___37707]));

var G__37708 = (i__5770__auto___37707 + (1));
i__5770__auto___37707 = G__37708;
continue;
} else {
}
break;
}

var argseq__5776__auto__ = ((((0) < args__5775__auto__.length))?(new cljs.core.IndexedSeq(args__5775__auto__.slice((0)),(0),null)):null);
return sci.impl.io.pr.cljs$core$IFn$_invoke$arity$variadic(argseq__5776__auto__);
});

(sci.impl.io.pr.cljs$core$IFn$_invoke$arity$variadic = (function (objs){
var _STAR_print_fn_STAR__orig_val__37540 = cljs.core._STAR_print_fn_STAR_;
var _STAR_print_length_STAR__orig_val__37541 = cljs.core._STAR_print_length_STAR_;
var _STAR_print_level_STAR__orig_val__37542 = cljs.core._STAR_print_level_STAR_;
var _STAR_print_meta_STAR__orig_val__37543 = cljs.core._STAR_print_meta_STAR_;
var _STAR_print_namespace_maps_STAR__orig_val__37544 = cljs.core._STAR_print_namespace_maps_STAR_;
var _STAR_print_readably_STAR__orig_val__37545 = cljs.core._STAR_print_readably_STAR_;
var _STAR_print_newline_STAR__orig_val__37546 = cljs.core._STAR_print_newline_STAR_;
var _STAR_print_dup_STAR__orig_val__37547 = cljs.core._STAR_print_dup_STAR_;
var _STAR_print_fn_STAR__temp_val__37548 = cljs.core.deref(sci.impl.io.print_fn);
var _STAR_print_length_STAR__temp_val__37549 = cljs.core.deref(sci.impl.io.print_length);
var _STAR_print_level_STAR__temp_val__37550 = cljs.core.deref(sci.impl.io.print_level);
var _STAR_print_meta_STAR__temp_val__37551 = cljs.core.deref(sci.impl.io.print_meta);
var _STAR_print_namespace_maps_STAR__temp_val__37552 = cljs.core.deref(sci.impl.io.print_namespace_maps);
var _STAR_print_readably_STAR__temp_val__37553 = cljs.core.deref(sci.impl.io.print_readably);
var _STAR_print_newline_STAR__temp_val__37554 = cljs.core.deref(sci.impl.io.print_newline);
var _STAR_print_dup_STAR__temp_val__37555 = cljs.core.deref(sci.impl.io.print_dup_var);
(cljs.core._STAR_print_fn_STAR_ = _STAR_print_fn_STAR__temp_val__37548);

(cljs.core._STAR_print_length_STAR_ = _STAR_print_length_STAR__temp_val__37549);

(cljs.core._STAR_print_level_STAR_ = _STAR_print_level_STAR__temp_val__37550);

(cljs.core._STAR_print_meta_STAR_ = _STAR_print_meta_STAR__temp_val__37551);

(cljs.core._STAR_print_namespace_maps_STAR_ = _STAR_print_namespace_maps_STAR__temp_val__37552);

(cljs.core._STAR_print_readably_STAR_ = _STAR_print_readably_STAR__temp_val__37553);

(cljs.core._STAR_print_newline_STAR_ = _STAR_print_newline_STAR__temp_val__37554);

(cljs.core._STAR_print_dup_STAR_ = _STAR_print_dup_STAR__temp_val__37555);

try{return cljs.core.apply.cljs$core$IFn$_invoke$arity$2(cljs.core.pr,objs);
}finally {(cljs.core._STAR_print_dup_STAR_ = _STAR_print_dup_STAR__orig_val__37547);

(cljs.core._STAR_print_newline_STAR_ = _STAR_print_newline_STAR__orig_val__37546);

(cljs.core._STAR_print_readably_STAR_ = _STAR_print_readably_STAR__orig_val__37545);

(cljs.core._STAR_print_namespace_maps_STAR_ = _STAR_print_namespace_maps_STAR__orig_val__37544);

(cljs.core._STAR_print_meta_STAR_ = _STAR_print_meta_STAR__orig_val__37543);

(cljs.core._STAR_print_level_STAR_ = _STAR_print_level_STAR__orig_val__37542);

(cljs.core._STAR_print_length_STAR_ = _STAR_print_length_STAR__orig_val__37541);

(cljs.core._STAR_print_fn_STAR_ = _STAR_print_fn_STAR__orig_val__37540);
}}));

(sci.impl.io.pr.cljs$lang$maxFixedArity = (0));

/** @this {Function} */
(sci.impl.io.pr.cljs$lang$applyTo = (function (seq37531){
var self__5755__auto__ = this;
return self__5755__auto__.cljs$core$IFn$_invoke$arity$variadic(cljs.core.seq(seq37531));
}));

sci.impl.io.flush = (function sci$impl$io$flush(){
return null;
});
sci.impl.io.newline = (function sci$impl$io$newline(){
var _STAR_print_fn_STAR__orig_val__37559 = cljs.core._STAR_print_fn_STAR_;
var _STAR_print_fn_STAR__temp_val__37560 = cljs.core.deref(sci.impl.io.print_fn);
(cljs.core._STAR_print_fn_STAR_ = _STAR_print_fn_STAR__temp_val__37560);

try{return cljs.core.newline.cljs$core$IFn$_invoke$arity$0();
}finally {(cljs.core._STAR_print_fn_STAR_ = _STAR_print_fn_STAR__orig_val__37559);
}});
/**
 * pr to a string, returning it
 */
sci.impl.io.pr_str = (function sci$impl$io$pr_str(var_args){
var args__5775__auto__ = [];
var len__5769__auto___37711 = arguments.length;
var i__5770__auto___37712 = (0);
while(true){
if((i__5770__auto___37712 < len__5769__auto___37711)){
args__5775__auto__.push((arguments[i__5770__auto___37712]));

var G__37713 = (i__5770__auto___37712 + (1));
i__5770__auto___37712 = G__37713;
continue;
} else {
}
break;
}

var argseq__5776__auto__ = ((((0) < args__5775__auto__.length))?(new cljs.core.IndexedSeq(args__5775__auto__.slice((0)),(0),null)):null);
return sci.impl.io.pr_str.cljs$core$IFn$_invoke$arity$variadic(argseq__5776__auto__);
});

(sci.impl.io.pr_str.cljs$core$IFn$_invoke$arity$variadic = (function (objs){
var _STAR_print_length_STAR__orig_val__37573 = cljs.core._STAR_print_length_STAR_;
var _STAR_print_level_STAR__orig_val__37574 = cljs.core._STAR_print_level_STAR_;
var _STAR_print_meta_STAR__orig_val__37575 = cljs.core._STAR_print_meta_STAR_;
var _STAR_print_namespace_maps_STAR__orig_val__37576 = cljs.core._STAR_print_namespace_maps_STAR_;
var _STAR_print_readably_STAR__orig_val__37577 = cljs.core._STAR_print_readably_STAR_;
var _STAR_print_newline_STAR__orig_val__37578 = cljs.core._STAR_print_newline_STAR_;
var _STAR_print_dup_STAR__orig_val__37579 = cljs.core._STAR_print_dup_STAR_;
var _STAR_print_length_STAR__temp_val__37580 = cljs.core.deref(sci.impl.io.print_length);
var _STAR_print_level_STAR__temp_val__37581 = cljs.core.deref(sci.impl.io.print_level);
var _STAR_print_meta_STAR__temp_val__37582 = cljs.core.deref(sci.impl.io.print_meta);
var _STAR_print_namespace_maps_STAR__temp_val__37583 = cljs.core.deref(sci.impl.io.print_namespace_maps);
var _STAR_print_readably_STAR__temp_val__37584 = cljs.core.deref(sci.impl.io.print_readably);
var _STAR_print_newline_STAR__temp_val__37585 = cljs.core.deref(sci.impl.io.print_newline);
var _STAR_print_dup_STAR__temp_val__37586 = cljs.core.deref(sci.impl.io.print_dup_var);
(cljs.core._STAR_print_length_STAR_ = _STAR_print_length_STAR__temp_val__37580);

(cljs.core._STAR_print_level_STAR_ = _STAR_print_level_STAR__temp_val__37581);

(cljs.core._STAR_print_meta_STAR_ = _STAR_print_meta_STAR__temp_val__37582);

(cljs.core._STAR_print_namespace_maps_STAR_ = _STAR_print_namespace_maps_STAR__temp_val__37583);

(cljs.core._STAR_print_readably_STAR_ = _STAR_print_readably_STAR__temp_val__37584);

(cljs.core._STAR_print_newline_STAR_ = _STAR_print_newline_STAR__temp_val__37585);

(cljs.core._STAR_print_dup_STAR_ = _STAR_print_dup_STAR__temp_val__37586);

try{return cljs.core.apply.cljs$core$IFn$_invoke$arity$2(cljs.core.pr_str,objs);
}finally {(cljs.core._STAR_print_dup_STAR_ = _STAR_print_dup_STAR__orig_val__37579);

(cljs.core._STAR_print_newline_STAR_ = _STAR_print_newline_STAR__orig_val__37578);

(cljs.core._STAR_print_readably_STAR_ = _STAR_print_readably_STAR__orig_val__37577);

(cljs.core._STAR_print_namespace_maps_STAR_ = _STAR_print_namespace_maps_STAR__orig_val__37576);

(cljs.core._STAR_print_meta_STAR_ = _STAR_print_meta_STAR__orig_val__37575);

(cljs.core._STAR_print_level_STAR_ = _STAR_print_level_STAR__orig_val__37574);

(cljs.core._STAR_print_length_STAR_ = _STAR_print_length_STAR__orig_val__37573);
}}));

(sci.impl.io.pr_str.cljs$lang$maxFixedArity = (0));

/** @this {Function} */
(sci.impl.io.pr_str.cljs$lang$applyTo = (function (seq37567){
var self__5755__auto__ = this;
return self__5755__auto__.cljs$core$IFn$_invoke$arity$variadic(cljs.core.seq(seq37567));
}));

sci.impl.io.prn = (function sci$impl$io$prn(var_args){
var args__5775__auto__ = [];
var len__5769__auto___37715 = arguments.length;
var i__5770__auto___37716 = (0);
while(true){
if((i__5770__auto___37716 < len__5769__auto___37715)){
args__5775__auto__.push((arguments[i__5770__auto___37716]));

var G__37717 = (i__5770__auto___37716 + (1));
i__5770__auto___37716 = G__37717;
continue;
} else {
}
break;
}

var argseq__5776__auto__ = ((((0) < args__5775__auto__.length))?(new cljs.core.IndexedSeq(args__5775__auto__.slice((0)),(0),null)):null);
return sci.impl.io.prn.cljs$core$IFn$_invoke$arity$variadic(argseq__5776__auto__);
});

(sci.impl.io.prn.cljs$core$IFn$_invoke$arity$variadic = (function (objs){
var _STAR_print_fn_STAR__orig_val__37604 = cljs.core._STAR_print_fn_STAR_;
var _STAR_print_length_STAR__orig_val__37605 = cljs.core._STAR_print_length_STAR_;
var _STAR_print_level_STAR__orig_val__37606 = cljs.core._STAR_print_level_STAR_;
var _STAR_print_meta_STAR__orig_val__37607 = cljs.core._STAR_print_meta_STAR_;
var _STAR_print_namespace_maps_STAR__orig_val__37608 = cljs.core._STAR_print_namespace_maps_STAR_;
var _STAR_print_readably_STAR__orig_val__37609 = cljs.core._STAR_print_readably_STAR_;
var _STAR_print_newline_STAR__orig_val__37610 = cljs.core._STAR_print_newline_STAR_;
var _STAR_print_dup_STAR__orig_val__37611 = cljs.core._STAR_print_dup_STAR_;
var _STAR_print_fn_STAR__temp_val__37612 = cljs.core.deref(sci.impl.io.print_fn);
var _STAR_print_length_STAR__temp_val__37613 = cljs.core.deref(sci.impl.io.print_length);
var _STAR_print_level_STAR__temp_val__37614 = cljs.core.deref(sci.impl.io.print_level);
var _STAR_print_meta_STAR__temp_val__37615 = cljs.core.deref(sci.impl.io.print_meta);
var _STAR_print_namespace_maps_STAR__temp_val__37616 = cljs.core.deref(sci.impl.io.print_namespace_maps);
var _STAR_print_readably_STAR__temp_val__37617 = cljs.core.deref(sci.impl.io.print_readably);
var _STAR_print_newline_STAR__temp_val__37618 = cljs.core.deref(sci.impl.io.print_newline);
var _STAR_print_dup_STAR__temp_val__37619 = cljs.core.deref(sci.impl.io.print_dup_var);
(cljs.core._STAR_print_fn_STAR_ = _STAR_print_fn_STAR__temp_val__37612);

(cljs.core._STAR_print_length_STAR_ = _STAR_print_length_STAR__temp_val__37613);

(cljs.core._STAR_print_level_STAR_ = _STAR_print_level_STAR__temp_val__37614);

(cljs.core._STAR_print_meta_STAR_ = _STAR_print_meta_STAR__temp_val__37615);

(cljs.core._STAR_print_namespace_maps_STAR_ = _STAR_print_namespace_maps_STAR__temp_val__37616);

(cljs.core._STAR_print_readably_STAR_ = _STAR_print_readably_STAR__temp_val__37617);

(cljs.core._STAR_print_newline_STAR_ = _STAR_print_newline_STAR__temp_val__37618);

(cljs.core._STAR_print_dup_STAR_ = _STAR_print_dup_STAR__temp_val__37619);

try{return cljs.core.apply.cljs$core$IFn$_invoke$arity$2(cljs.core.prn,objs);
}finally {(cljs.core._STAR_print_dup_STAR_ = _STAR_print_dup_STAR__orig_val__37611);

(cljs.core._STAR_print_newline_STAR_ = _STAR_print_newline_STAR__orig_val__37610);

(cljs.core._STAR_print_readably_STAR_ = _STAR_print_readably_STAR__orig_val__37609);

(cljs.core._STAR_print_namespace_maps_STAR_ = _STAR_print_namespace_maps_STAR__orig_val__37608);

(cljs.core._STAR_print_meta_STAR_ = _STAR_print_meta_STAR__orig_val__37607);

(cljs.core._STAR_print_level_STAR_ = _STAR_print_level_STAR__orig_val__37606);

(cljs.core._STAR_print_length_STAR_ = _STAR_print_length_STAR__orig_val__37605);

(cljs.core._STAR_print_fn_STAR_ = _STAR_print_fn_STAR__orig_val__37604);
}}));

(sci.impl.io.prn.cljs$lang$maxFixedArity = (0));

/** @this {Function} */
(sci.impl.io.prn.cljs$lang$applyTo = (function (seq37597){
var self__5755__auto__ = this;
return self__5755__auto__.cljs$core$IFn$_invoke$arity$variadic(cljs.core.seq(seq37597));
}));

/**
 * prn to a string, returning it
 */
sci.impl.io.prn_str = (function sci$impl$io$prn_str(var_args){
var args__5775__auto__ = [];
var len__5769__auto___37718 = arguments.length;
var i__5770__auto___37719 = (0);
while(true){
if((i__5770__auto___37719 < len__5769__auto___37718)){
args__5775__auto__.push((arguments[i__5770__auto___37719]));

var G__37720 = (i__5770__auto___37719 + (1));
i__5770__auto___37719 = G__37720;
continue;
} else {
}
break;
}

var argseq__5776__auto__ = ((((0) < args__5775__auto__.length))?(new cljs.core.IndexedSeq(args__5775__auto__.slice((0)),(0),null)):null);
return sci.impl.io.prn_str.cljs$core$IFn$_invoke$arity$variadic(argseq__5776__auto__);
});

(sci.impl.io.prn_str.cljs$core$IFn$_invoke$arity$variadic = (function (objs){
var _STAR_print_length_STAR__orig_val__37633 = cljs.core._STAR_print_length_STAR_;
var _STAR_print_level_STAR__orig_val__37634 = cljs.core._STAR_print_level_STAR_;
var _STAR_print_meta_STAR__orig_val__37635 = cljs.core._STAR_print_meta_STAR_;
var _STAR_print_namespace_maps_STAR__orig_val__37636 = cljs.core._STAR_print_namespace_maps_STAR_;
var _STAR_print_readably_STAR__orig_val__37637 = cljs.core._STAR_print_readably_STAR_;
var _STAR_print_newline_STAR__orig_val__37638 = cljs.core._STAR_print_newline_STAR_;
var _STAR_print_dup_STAR__orig_val__37639 = cljs.core._STAR_print_dup_STAR_;
var _STAR_print_length_STAR__temp_val__37640 = cljs.core.deref(sci.impl.io.print_length);
var _STAR_print_level_STAR__temp_val__37641 = cljs.core.deref(sci.impl.io.print_level);
var _STAR_print_meta_STAR__temp_val__37642 = cljs.core.deref(sci.impl.io.print_meta);
var _STAR_print_namespace_maps_STAR__temp_val__37643 = cljs.core.deref(sci.impl.io.print_namespace_maps);
var _STAR_print_readably_STAR__temp_val__37644 = cljs.core.deref(sci.impl.io.print_readably);
var _STAR_print_newline_STAR__temp_val__37645 = cljs.core.deref(sci.impl.io.print_newline);
var _STAR_print_dup_STAR__temp_val__37646 = cljs.core.deref(sci.impl.io.print_dup_var);
(cljs.core._STAR_print_length_STAR_ = _STAR_print_length_STAR__temp_val__37640);

(cljs.core._STAR_print_level_STAR_ = _STAR_print_level_STAR__temp_val__37641);

(cljs.core._STAR_print_meta_STAR_ = _STAR_print_meta_STAR__temp_val__37642);

(cljs.core._STAR_print_namespace_maps_STAR_ = _STAR_print_namespace_maps_STAR__temp_val__37643);

(cljs.core._STAR_print_readably_STAR_ = _STAR_print_readably_STAR__temp_val__37644);

(cljs.core._STAR_print_newline_STAR_ = _STAR_print_newline_STAR__temp_val__37645);

(cljs.core._STAR_print_dup_STAR_ = _STAR_print_dup_STAR__temp_val__37646);

try{return cljs.core.apply.cljs$core$IFn$_invoke$arity$2(cljs.core.prn_str,objs);
}finally {(cljs.core._STAR_print_dup_STAR_ = _STAR_print_dup_STAR__orig_val__37639);

(cljs.core._STAR_print_newline_STAR_ = _STAR_print_newline_STAR__orig_val__37638);

(cljs.core._STAR_print_readably_STAR_ = _STAR_print_readably_STAR__orig_val__37637);

(cljs.core._STAR_print_namespace_maps_STAR_ = _STAR_print_namespace_maps_STAR__orig_val__37636);

(cljs.core._STAR_print_meta_STAR_ = _STAR_print_meta_STAR__orig_val__37635);

(cljs.core._STAR_print_level_STAR_ = _STAR_print_level_STAR__orig_val__37634);

(cljs.core._STAR_print_length_STAR_ = _STAR_print_length_STAR__orig_val__37633);
}}));

(sci.impl.io.prn_str.cljs$lang$maxFixedArity = (0));

/** @this {Function} */
(sci.impl.io.prn_str.cljs$lang$applyTo = (function (seq37628){
var self__5755__auto__ = this;
return self__5755__auto__.cljs$core$IFn$_invoke$arity$variadic(cljs.core.seq(seq37628));
}));

sci.impl.io.print = (function sci$impl$io$print(var_args){
var args__5775__auto__ = [];
var len__5769__auto___37721 = arguments.length;
var i__5770__auto___37722 = (0);
while(true){
if((i__5770__auto___37722 < len__5769__auto___37721)){
args__5775__auto__.push((arguments[i__5770__auto___37722]));

var G__37723 = (i__5770__auto___37722 + (1));
i__5770__auto___37722 = G__37723;
continue;
} else {
}
break;
}

var argseq__5776__auto__ = ((((0) < args__5775__auto__.length))?(new cljs.core.IndexedSeq(args__5775__auto__.slice((0)),(0),null)):null);
return sci.impl.io.print.cljs$core$IFn$_invoke$arity$variadic(argseq__5776__auto__);
});

(sci.impl.io.print.cljs$core$IFn$_invoke$arity$variadic = (function (objs){
var _STAR_print_fn_STAR__orig_val__37648 = cljs.core._STAR_print_fn_STAR_;
var _STAR_print_length_STAR__orig_val__37649 = cljs.core._STAR_print_length_STAR_;
var _STAR_print_level_STAR__orig_val__37650 = cljs.core._STAR_print_level_STAR_;
var _STAR_print_namespace_maps_STAR__orig_val__37651 = cljs.core._STAR_print_namespace_maps_STAR_;
var _STAR_print_readably_STAR__orig_val__37652 = cljs.core._STAR_print_readably_STAR_;
var _STAR_print_newline_STAR__orig_val__37653 = cljs.core._STAR_print_newline_STAR_;
var _STAR_print_dup_STAR__orig_val__37654 = cljs.core._STAR_print_dup_STAR_;
var _STAR_print_fn_STAR__temp_val__37655 = cljs.core.deref(sci.impl.io.print_fn);
var _STAR_print_length_STAR__temp_val__37656 = cljs.core.deref(sci.impl.io.print_length);
var _STAR_print_level_STAR__temp_val__37657 = cljs.core.deref(sci.impl.io.print_level);
var _STAR_print_namespace_maps_STAR__temp_val__37658 = cljs.core.deref(sci.impl.io.print_namespace_maps);
var _STAR_print_readably_STAR__temp_val__37659 = null;
var _STAR_print_newline_STAR__temp_val__37660 = cljs.core.deref(sci.impl.io.print_newline);
var _STAR_print_dup_STAR__temp_val__37661 = cljs.core.deref(sci.impl.io.print_dup_var);
(cljs.core._STAR_print_fn_STAR_ = _STAR_print_fn_STAR__temp_val__37655);

(cljs.core._STAR_print_length_STAR_ = _STAR_print_length_STAR__temp_val__37656);

(cljs.core._STAR_print_level_STAR_ = _STAR_print_level_STAR__temp_val__37657);

(cljs.core._STAR_print_namespace_maps_STAR_ = _STAR_print_namespace_maps_STAR__temp_val__37658);

(cljs.core._STAR_print_readably_STAR_ = _STAR_print_readably_STAR__temp_val__37659);

(cljs.core._STAR_print_newline_STAR_ = _STAR_print_newline_STAR__temp_val__37660);

(cljs.core._STAR_print_dup_STAR_ = _STAR_print_dup_STAR__temp_val__37661);

try{return cljs.core.apply.cljs$core$IFn$_invoke$arity$2(cljs.core.print,objs);
}finally {(cljs.core._STAR_print_dup_STAR_ = _STAR_print_dup_STAR__orig_val__37654);

(cljs.core._STAR_print_newline_STAR_ = _STAR_print_newline_STAR__orig_val__37653);

(cljs.core._STAR_print_readably_STAR_ = _STAR_print_readably_STAR__orig_val__37652);

(cljs.core._STAR_print_namespace_maps_STAR_ = _STAR_print_namespace_maps_STAR__orig_val__37651);

(cljs.core._STAR_print_level_STAR_ = _STAR_print_level_STAR__orig_val__37650);

(cljs.core._STAR_print_length_STAR_ = _STAR_print_length_STAR__orig_val__37649);

(cljs.core._STAR_print_fn_STAR_ = _STAR_print_fn_STAR__orig_val__37648);
}}));

(sci.impl.io.print.cljs$lang$maxFixedArity = (0));

/** @this {Function} */
(sci.impl.io.print.cljs$lang$applyTo = (function (seq37647){
var self__5755__auto__ = this;
return self__5755__auto__.cljs$core$IFn$_invoke$arity$variadic(cljs.core.seq(seq37647));
}));

/**
 * print to a string, returning it
 */
sci.impl.io.print_str = (function sci$impl$io$print_str(var_args){
var args__5775__auto__ = [];
var len__5769__auto___37724 = arguments.length;
var i__5770__auto___37725 = (0);
while(true){
if((i__5770__auto___37725 < len__5769__auto___37724)){
args__5775__auto__.push((arguments[i__5770__auto___37725]));

var G__37726 = (i__5770__auto___37725 + (1));
i__5770__auto___37725 = G__37726;
continue;
} else {
}
break;
}

var argseq__5776__auto__ = ((((0) < args__5775__auto__.length))?(new cljs.core.IndexedSeq(args__5775__auto__.slice((0)),(0),null)):null);
return sci.impl.io.print_str.cljs$core$IFn$_invoke$arity$variadic(argseq__5776__auto__);
});

(sci.impl.io.print_str.cljs$core$IFn$_invoke$arity$variadic = (function (objs){
var _STAR_print_length_STAR__orig_val__37664 = cljs.core._STAR_print_length_STAR_;
var _STAR_print_level_STAR__orig_val__37665 = cljs.core._STAR_print_level_STAR_;
var _STAR_print_meta_STAR__orig_val__37666 = cljs.core._STAR_print_meta_STAR_;
var _STAR_print_namespace_maps_STAR__orig_val__37667 = cljs.core._STAR_print_namespace_maps_STAR_;
var _STAR_print_readably_STAR__orig_val__37668 = cljs.core._STAR_print_readably_STAR_;
var _STAR_print_newline_STAR__orig_val__37669 = cljs.core._STAR_print_newline_STAR_;
var _STAR_print_dup_STAR__orig_val__37670 = cljs.core._STAR_print_dup_STAR_;
var _STAR_print_length_STAR__temp_val__37671 = cljs.core.deref(sci.impl.io.print_length);
var _STAR_print_level_STAR__temp_val__37672 = cljs.core.deref(sci.impl.io.print_level);
var _STAR_print_meta_STAR__temp_val__37673 = cljs.core.deref(sci.impl.io.print_meta);
var _STAR_print_namespace_maps_STAR__temp_val__37674 = cljs.core.deref(sci.impl.io.print_namespace_maps);
var _STAR_print_readably_STAR__temp_val__37675 = cljs.core.deref(sci.impl.io.print_readably);
var _STAR_print_newline_STAR__temp_val__37676 = cljs.core.deref(sci.impl.io.print_newline);
var _STAR_print_dup_STAR__temp_val__37677 = cljs.core.deref(sci.impl.io.print_dup_var);
(cljs.core._STAR_print_length_STAR_ = _STAR_print_length_STAR__temp_val__37671);

(cljs.core._STAR_print_level_STAR_ = _STAR_print_level_STAR__temp_val__37672);

(cljs.core._STAR_print_meta_STAR_ = _STAR_print_meta_STAR__temp_val__37673);

(cljs.core._STAR_print_namespace_maps_STAR_ = _STAR_print_namespace_maps_STAR__temp_val__37674);

(cljs.core._STAR_print_readably_STAR_ = _STAR_print_readably_STAR__temp_val__37675);

(cljs.core._STAR_print_newline_STAR_ = _STAR_print_newline_STAR__temp_val__37676);

(cljs.core._STAR_print_dup_STAR_ = _STAR_print_dup_STAR__temp_val__37677);

try{return cljs.core.apply.cljs$core$IFn$_invoke$arity$2(cljs.core.print_str,objs);
}finally {(cljs.core._STAR_print_dup_STAR_ = _STAR_print_dup_STAR__orig_val__37670);

(cljs.core._STAR_print_newline_STAR_ = _STAR_print_newline_STAR__orig_val__37669);

(cljs.core._STAR_print_readably_STAR_ = _STAR_print_readably_STAR__orig_val__37668);

(cljs.core._STAR_print_namespace_maps_STAR_ = _STAR_print_namespace_maps_STAR__orig_val__37667);

(cljs.core._STAR_print_meta_STAR_ = _STAR_print_meta_STAR__orig_val__37666);

(cljs.core._STAR_print_level_STAR_ = _STAR_print_level_STAR__orig_val__37665);

(cljs.core._STAR_print_length_STAR_ = _STAR_print_length_STAR__orig_val__37664);
}}));

(sci.impl.io.print_str.cljs$lang$maxFixedArity = (0));

/** @this {Function} */
(sci.impl.io.print_str.cljs$lang$applyTo = (function (seq37663){
var self__5755__auto__ = this;
return self__5755__auto__.cljs$core$IFn$_invoke$arity$variadic(cljs.core.seq(seq37663));
}));

sci.impl.io.println = (function sci$impl$io$println(var_args){
var args__5775__auto__ = [];
var len__5769__auto___37727 = arguments.length;
var i__5770__auto___37728 = (0);
while(true){
if((i__5770__auto___37728 < len__5769__auto___37727)){
args__5775__auto__.push((arguments[i__5770__auto___37728]));

var G__37729 = (i__5770__auto___37728 + (1));
i__5770__auto___37728 = G__37729;
continue;
} else {
}
break;
}

var argseq__5776__auto__ = ((((0) < args__5775__auto__.length))?(new cljs.core.IndexedSeq(args__5775__auto__.slice((0)),(0),null)):null);
return sci.impl.io.println.cljs$core$IFn$_invoke$arity$variadic(argseq__5776__auto__);
});

(sci.impl.io.println.cljs$core$IFn$_invoke$arity$variadic = (function (objs){
var _STAR_print_fn_STAR__orig_val__37679 = cljs.core._STAR_print_fn_STAR_;
var _STAR_print_length_STAR__orig_val__37680 = cljs.core._STAR_print_length_STAR_;
var _STAR_print_level_STAR__orig_val__37681 = cljs.core._STAR_print_level_STAR_;
var _STAR_print_meta_STAR__orig_val__37682 = cljs.core._STAR_print_meta_STAR_;
var _STAR_print_namespace_maps_STAR__orig_val__37683 = cljs.core._STAR_print_namespace_maps_STAR_;
var _STAR_print_readably_STAR__orig_val__37684 = cljs.core._STAR_print_readably_STAR_;
var _STAR_print_newline_STAR__orig_val__37685 = cljs.core._STAR_print_newline_STAR_;
var _STAR_print_dup_STAR__orig_val__37686 = cljs.core._STAR_print_dup_STAR_;
var _STAR_print_fn_STAR__temp_val__37687 = cljs.core.deref(sci.impl.io.print_fn);
var _STAR_print_length_STAR__temp_val__37688 = cljs.core.deref(sci.impl.io.print_length);
var _STAR_print_level_STAR__temp_val__37689 = cljs.core.deref(sci.impl.io.print_level);
var _STAR_print_meta_STAR__temp_val__37690 = cljs.core.deref(sci.impl.io.print_meta);
var _STAR_print_namespace_maps_STAR__temp_val__37691 = cljs.core.deref(sci.impl.io.print_namespace_maps);
var _STAR_print_readably_STAR__temp_val__37692 = cljs.core.deref(sci.impl.io.print_readably);
var _STAR_print_newline_STAR__temp_val__37693 = cljs.core.deref(sci.impl.io.print_newline);
var _STAR_print_dup_STAR__temp_val__37694 = cljs.core.deref(sci.impl.io.print_dup_var);
(cljs.core._STAR_print_fn_STAR_ = _STAR_print_fn_STAR__temp_val__37687);

(cljs.core._STAR_print_length_STAR_ = _STAR_print_length_STAR__temp_val__37688);

(cljs.core._STAR_print_level_STAR_ = _STAR_print_level_STAR__temp_val__37689);

(cljs.core._STAR_print_meta_STAR_ = _STAR_print_meta_STAR__temp_val__37690);

(cljs.core._STAR_print_namespace_maps_STAR_ = _STAR_print_namespace_maps_STAR__temp_val__37691);

(cljs.core._STAR_print_readably_STAR_ = _STAR_print_readably_STAR__temp_val__37692);

(cljs.core._STAR_print_newline_STAR_ = _STAR_print_newline_STAR__temp_val__37693);

(cljs.core._STAR_print_dup_STAR_ = _STAR_print_dup_STAR__temp_val__37694);

try{return cljs.core.apply.cljs$core$IFn$_invoke$arity$2(cljs.core.println,objs);
}finally {(cljs.core._STAR_print_dup_STAR_ = _STAR_print_dup_STAR__orig_val__37686);

(cljs.core._STAR_print_newline_STAR_ = _STAR_print_newline_STAR__orig_val__37685);

(cljs.core._STAR_print_readably_STAR_ = _STAR_print_readably_STAR__orig_val__37684);

(cljs.core._STAR_print_namespace_maps_STAR_ = _STAR_print_namespace_maps_STAR__orig_val__37683);

(cljs.core._STAR_print_meta_STAR_ = _STAR_print_meta_STAR__orig_val__37682);

(cljs.core._STAR_print_level_STAR_ = _STAR_print_level_STAR__orig_val__37681);

(cljs.core._STAR_print_length_STAR_ = _STAR_print_length_STAR__orig_val__37680);

(cljs.core._STAR_print_fn_STAR_ = _STAR_print_fn_STAR__orig_val__37679);
}}));

(sci.impl.io.println.cljs$lang$maxFixedArity = (0));

/** @this {Function} */
(sci.impl.io.println.cljs$lang$applyTo = (function (seq37678){
var self__5755__auto__ = this;
return self__5755__auto__.cljs$core$IFn$_invoke$arity$variadic(cljs.core.seq(seq37678));
}));

sci.impl.io.with_out_str = (function sci$impl$io$with_out_str(var_args){
var args__5775__auto__ = [];
var len__5769__auto___37730 = arguments.length;
var i__5770__auto___37731 = (0);
while(true){
if((i__5770__auto___37731 < len__5769__auto___37730)){
args__5775__auto__.push((arguments[i__5770__auto___37731]));

var G__37732 = (i__5770__auto___37731 + (1));
i__5770__auto___37731 = G__37732;
continue;
} else {
}
break;
}

var argseq__5776__auto__ = ((((2) < args__5775__auto__.length))?(new cljs.core.IndexedSeq(args__5775__auto__.slice((2)),(0),null)):null);
return sci.impl.io.with_out_str.cljs$core$IFn$_invoke$arity$variadic((arguments[(0)]),(arguments[(1)]),argseq__5776__auto__);
});

(sci.impl.io.with_out_str.cljs$core$IFn$_invoke$arity$variadic = (function (_,___$1,body){
return cljs.core.sequence.cljs$core$IFn$_invoke$arity$1(cljs.core.seq(cljs.core.concat.cljs$core$IFn$_invoke$arity$variadic((new cljs.core.List(null,new cljs.core.Symbol("cljs.core","let","cljs.core/let",-308701135,null),null,(1),null)),(new cljs.core.List(null,cljs.core.vec(cljs.core.sequence.cljs$core$IFn$_invoke$arity$1(cljs.core.seq(cljs.core.concat.cljs$core$IFn$_invoke$arity$2((new cljs.core.List(null,new cljs.core.Symbol(null,"s__37695__auto__","s__37695__auto__",-900917067,null),null,(1),null)),(new cljs.core.List(null,cljs.core.sequence.cljs$core$IFn$_invoke$arity$1(cljs.core.seq(cljs.core.concat.cljs$core$IFn$_invoke$arity$2((new cljs.core.List(null,new cljs.core.Symbol(null,"new","new",-444906321,null),null,(1),null)),(new cljs.core.List(null,new cljs.core.Symbol(null,"goog.string.StringBuffer","goog.string.StringBuffer",-1220229842,null),null,(1),null))))),null,(1),null)))))),null,(1),null)),cljs.core.prim_seq.cljs$core$IFn$_invoke$arity$2([(new cljs.core.List(null,cljs.core.sequence.cljs$core$IFn$_invoke$arity$1(cljs.core.seq(cljs.core.concat.cljs$core$IFn$_invoke$arity$variadic((new cljs.core.List(null,new cljs.core.Symbol("cljs.core","binding","cljs.core/binding",2050379843,null),null,(1),null)),(new cljs.core.List(null,cljs.core.vec(cljs.core.sequence.cljs$core$IFn$_invoke$arity$1(cljs.core.seq(cljs.core.concat.cljs$core$IFn$_invoke$arity$variadic((new cljs.core.List(null,new cljs.core.Symbol("cljs.core","*print-newline*","cljs.core/*print-newline*",6231625,null),null,(1),null)),(new cljs.core.List(null,true,null,(1),null)),cljs.core.prim_seq.cljs$core$IFn$_invoke$arity$2([(new cljs.core.List(null,new cljs.core.Symbol("cljs.core","*print-fn*","cljs.core/*print-fn*",1342365176,null),null,(1),null)),(new cljs.core.List(null,cljs.core.sequence.cljs$core$IFn$_invoke$arity$1(cljs.core.seq(cljs.core.concat.cljs$core$IFn$_invoke$arity$variadic((new cljs.core.List(null,new cljs.core.Symbol("cljs.core","fn","cljs.core/fn",-1065745098,null),null,(1),null)),(new cljs.core.List(null,cljs.core.vec(cljs.core.sequence.cljs$core$IFn$_invoke$arity$1(cljs.core.seq(cljs.core.concat.cljs$core$IFn$_invoke$arity$1((new cljs.core.List(null,new cljs.core.Symbol(null,"x__37696__auto__","x__37696__auto__",1154900906,null),null,(1),null)))))),null,(1),null)),cljs.core.prim_seq.cljs$core$IFn$_invoke$arity$2([(new cljs.core.List(null,cljs.core.sequence.cljs$core$IFn$_invoke$arity$1(cljs.core.seq(cljs.core.concat.cljs$core$IFn$_invoke$arity$variadic((new cljs.core.List(null,new cljs.core.Symbol(null,".",".",1975675962,null),null,(1),null)),(new cljs.core.List(null,new cljs.core.Symbol(null,"s__37695__auto__","s__37695__auto__",-900917067,null),null,(1),null)),cljs.core.prim_seq.cljs$core$IFn$_invoke$arity$2([(new cljs.core.List(null,sci.impl.utils.allowed_append,null,(1),null)),(new cljs.core.List(null,new cljs.core.Symbol(null,"x__37696__auto__","x__37696__auto__",1154900906,null),null,(1),null))], 0)))),null,(1),null))], 0)))),null,(1),null))], 0))))),null,(1),null)),cljs.core.prim_seq.cljs$core$IFn$_invoke$arity$2([body,(new cljs.core.List(null,cljs.core.sequence.cljs$core$IFn$_invoke$arity$1(cljs.core.seq(cljs.core.concat.cljs$core$IFn$_invoke$arity$2((new cljs.core.List(null,new cljs.core.Symbol("cljs.core","str","cljs.core/str",-1971828991,null),null,(1),null)),(new cljs.core.List(null,new cljs.core.Symbol(null,"s__37695__auto__","s__37695__auto__",-900917067,null),null,(1),null))))),null,(1),null))], 0)))),null,(1),null))], 0))));
}));

(sci.impl.io.with_out_str.cljs$lang$maxFixedArity = (2));

/** @this {Function} */
(sci.impl.io.with_out_str.cljs$lang$applyTo = (function (seq37697){
var G__37698 = cljs.core.first(seq37697);
var seq37697__$1 = cljs.core.next(seq37697);
var G__37699 = cljs.core.first(seq37697__$1);
var seq37697__$2 = cljs.core.next(seq37697__$1);
var self__5754__auto__ = this;
return self__5754__auto__.cljs$core$IFn$_invoke$arity$variadic(G__37698,G__37699,seq37697__$2);
}));


//# sourceMappingURL=sci.impl.io.js.map
