import "./cljs_env.js";
import "./cljs.core.js";
import "./clojure.string.js";
import "./goog.dom.dom.js";
import "./goog.useragent.useragent.js";
import "./goog.useragent.product.js";
import "./goog.uri.uri.js";
import "./shadow.json.js";
import "./shadow.cljs.devtools.client.env.js";
import "./shadow.cljs.devtools.client.console.js";
import "./shadow.cljs.devtools.client.hud.js";
import "./shadow.cljs.devtools.client.websocket.js";
import "./shadow.cljs.devtools.client.shared.js";
import "./shadow.remote.runtime.api.js";
import "./shadow.remote.runtime.shared.js";
goog.provide('shadow.cljs.devtools.client.browser');
shadow.cljs.devtools.client.browser.devtools_msg = (function shadow$cljs$devtools$client$browser$devtools_msg(var_args){
var args__5775__auto__ = [];
var len__5769__auto___41010 = arguments.length;
var i__5770__auto___41011 = (0);
while(true){
if((i__5770__auto___41011 < len__5769__auto___41010)){
args__5775__auto__.push((arguments[i__5770__auto___41011]));

var G__41012 = (i__5770__auto___41011 + (1));
i__5770__auto___41011 = G__41012;
continue;
} else {
}
break;
}

var argseq__5776__auto__ = ((((1) < args__5775__auto__.length))?(new cljs.core.IndexedSeq(args__5775__auto__.slice((1)),(0),null)):null);
return shadow.cljs.devtools.client.browser.devtools_msg.cljs$core$IFn$_invoke$arity$variadic((arguments[(0)]),argseq__5776__auto__);
});

(shadow.cljs.devtools.client.browser.devtools_msg.cljs$core$IFn$_invoke$arity$variadic = (function (msg,args){
if(shadow.cljs.devtools.client.env.log){
if(cljs.core.seq(shadow.cljs.devtools.client.env.log_style)){
return console.log.apply(console,cljs.core.into_array.cljs$core$IFn$_invoke$arity$1(cljs.core.into.cljs$core$IFn$_invoke$arity$2(new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [["%cshadow-cljs: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(msg)].join(''),shadow.cljs.devtools.client.env.log_style], null),args)));
} else {
return console.log.apply(console,cljs.core.into_array.cljs$core$IFn$_invoke$arity$1(cljs.core.into.cljs$core$IFn$_invoke$arity$2(new cljs.core.PersistentVector(null, 1, 5, cljs.core.PersistentVector.EMPTY_NODE, [["shadow-cljs: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(msg)].join('')], null),args)));
}
} else {
return null;
}
}));

(shadow.cljs.devtools.client.browser.devtools_msg.cljs$lang$maxFixedArity = (1));

/** @this {Function} */
(shadow.cljs.devtools.client.browser.devtools_msg.cljs$lang$applyTo = (function (seq40721){
var G__40722 = cljs.core.first(seq40721);
var seq40721__$1 = cljs.core.next(seq40721);
var self__5754__auto__ = this;
return self__5754__auto__.cljs$core$IFn$_invoke$arity$variadic(G__40722,seq40721__$1);
}));

shadow.cljs.devtools.client.browser.script_eval = (function shadow$cljs$devtools$client$browser$script_eval(code){
return goog.globalEval(code);
});
shadow.cljs.devtools.client.browser.do_js_load = (function shadow$cljs$devtools$client$browser$do_js_load(sources){
var seq__40728 = cljs.core.seq(sources);
var chunk__40729 = null;
var count__40730 = (0);
var i__40731 = (0);
while(true){
if((i__40731 < count__40730)){
var map__40738 = chunk__40729.cljs$core$IIndexed$_nth$arity$2(null,i__40731);
var map__40738__$1 = cljs.core.__destructure_map(map__40738);
var src = map__40738__$1;
var resource_id = cljs.core.get.cljs$core$IFn$_invoke$arity$2(map__40738__$1,new cljs.core.Keyword(null,"resource-id","resource-id",-1308422582));
var output_name = cljs.core.get.cljs$core$IFn$_invoke$arity$2(map__40738__$1,new cljs.core.Keyword(null,"output-name","output-name",-1769107767));
var resource_name = cljs.core.get.cljs$core$IFn$_invoke$arity$2(map__40738__$1,new cljs.core.Keyword(null,"resource-name","resource-name",2001617100));
var js = cljs.core.get.cljs$core$IFn$_invoke$arity$2(map__40738__$1,new cljs.core.Keyword(null,"js","js",1768080579));
$CLJS.SHADOW_ENV.setLoaded(output_name);

shadow.cljs.devtools.client.browser.devtools_msg.cljs$core$IFn$_invoke$arity$variadic("load JS",cljs.core.prim_seq.cljs$core$IFn$_invoke$arity$2([resource_name], 0));

shadow.cljs.devtools.client.env.before_load_src(src);

try{shadow.cljs.devtools.client.browser.script_eval([cljs.core.str.cljs$core$IFn$_invoke$arity$1(js),"\n//# sourceURL=",cljs.core.str.cljs$core$IFn$_invoke$arity$1($CLJS.SHADOW_ENV.scriptBase),cljs.core.str.cljs$core$IFn$_invoke$arity$1(output_name)].join(''));
}catch (e40739){var e_41013 = e40739;
if(shadow.cljs.devtools.client.env.log){
console.error(["Failed to load ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(resource_name)].join(''),e_41013);
} else {
}

throw (new Error(["Failed to load ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(resource_name),": ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(e_41013.message)].join('')));
}

var G__41014 = seq__40728;
var G__41015 = chunk__40729;
var G__41016 = count__40730;
var G__41017 = (i__40731 + (1));
seq__40728 = G__41014;
chunk__40729 = G__41015;
count__40730 = G__41016;
i__40731 = G__41017;
continue;
} else {
var temp__5804__auto__ = cljs.core.seq(seq__40728);
if(temp__5804__auto__){
var seq__40728__$1 = temp__5804__auto__;
if(cljs.core.chunked_seq_QMARK_(seq__40728__$1)){
var c__5568__auto__ = cljs.core.chunk_first(seq__40728__$1);
var G__41018 = cljs.core.chunk_rest(seq__40728__$1);
var G__41019 = c__5568__auto__;
var G__41020 = cljs.core.count(c__5568__auto__);
var G__41021 = (0);
seq__40728 = G__41018;
chunk__40729 = G__41019;
count__40730 = G__41020;
i__40731 = G__41021;
continue;
} else {
var map__40740 = cljs.core.first(seq__40728__$1);
var map__40740__$1 = cljs.core.__destructure_map(map__40740);
var src = map__40740__$1;
var resource_id = cljs.core.get.cljs$core$IFn$_invoke$arity$2(map__40740__$1,new cljs.core.Keyword(null,"resource-id","resource-id",-1308422582));
var output_name = cljs.core.get.cljs$core$IFn$_invoke$arity$2(map__40740__$1,new cljs.core.Keyword(null,"output-name","output-name",-1769107767));
var resource_name = cljs.core.get.cljs$core$IFn$_invoke$arity$2(map__40740__$1,new cljs.core.Keyword(null,"resource-name","resource-name",2001617100));
var js = cljs.core.get.cljs$core$IFn$_invoke$arity$2(map__40740__$1,new cljs.core.Keyword(null,"js","js",1768080579));
$CLJS.SHADOW_ENV.setLoaded(output_name);

shadow.cljs.devtools.client.browser.devtools_msg.cljs$core$IFn$_invoke$arity$variadic("load JS",cljs.core.prim_seq.cljs$core$IFn$_invoke$arity$2([resource_name], 0));

shadow.cljs.devtools.client.env.before_load_src(src);

try{shadow.cljs.devtools.client.browser.script_eval([cljs.core.str.cljs$core$IFn$_invoke$arity$1(js),"\n//# sourceURL=",cljs.core.str.cljs$core$IFn$_invoke$arity$1($CLJS.SHADOW_ENV.scriptBase),cljs.core.str.cljs$core$IFn$_invoke$arity$1(output_name)].join(''));
}catch (e40741){var e_41022 = e40741;
if(shadow.cljs.devtools.client.env.log){
console.error(["Failed to load ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(resource_name)].join(''),e_41022);
} else {
}

throw (new Error(["Failed to load ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(resource_name),": ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(e_41022.message)].join('')));
}

var G__41023 = cljs.core.next(seq__40728__$1);
var G__41024 = null;
var G__41025 = (0);
var G__41026 = (0);
seq__40728 = G__41023;
chunk__40729 = G__41024;
count__40730 = G__41025;
i__40731 = G__41026;
continue;
}
} else {
return null;
}
}
break;
}
});
shadow.cljs.devtools.client.browser.do_js_reload = (function shadow$cljs$devtools$client$browser$do_js_reload(msg,sources,complete_fn,failure_fn){
return shadow.cljs.devtools.client.env.do_js_reload.cljs$core$IFn$_invoke$arity$4(cljs.core.assoc.cljs$core$IFn$_invoke$arity$variadic(msg,new cljs.core.Keyword(null,"log-missing-fn","log-missing-fn",732676765),(function (fn_sym){
return null;
}),cljs.core.prim_seq.cljs$core$IFn$_invoke$arity$2([new cljs.core.Keyword(null,"log-call-async","log-call-async",183826192),(function (fn_sym){
return shadow.cljs.devtools.client.browser.devtools_msg(["call async ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(fn_sym)].join(''));
}),new cljs.core.Keyword(null,"log-call","log-call",412404391),(function (fn_sym){
return shadow.cljs.devtools.client.browser.devtools_msg(["call ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(fn_sym)].join(''));
})], 0)),(function (){
return shadow.cljs.devtools.client.browser.do_js_load(sources);
}),complete_fn,failure_fn);
});
/**
 * when (require '["some-str" :as x]) is done at the REPL we need to manually call the shadow.js.require for it
 * since the file only adds the shadow$provide. only need to do this for shadow-js.
 */
shadow.cljs.devtools.client.browser.do_js_requires = (function shadow$cljs$devtools$client$browser$do_js_requires(js_requires){
var seq__40742 = cljs.core.seq(js_requires);
var chunk__40743 = null;
var count__40744 = (0);
var i__40745 = (0);
while(true){
if((i__40745 < count__40744)){
var js_ns = chunk__40743.cljs$core$IIndexed$_nth$arity$2(null,i__40745);
var require_str_41027 = ["var ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(js_ns)," = shadow.js.require(\"",cljs.core.str.cljs$core$IFn$_invoke$arity$1(js_ns),"\");"].join('');
shadow.cljs.devtools.client.browser.script_eval(require_str_41027);


var G__41028 = seq__40742;
var G__41029 = chunk__40743;
var G__41030 = count__40744;
var G__41031 = (i__40745 + (1));
seq__40742 = G__41028;
chunk__40743 = G__41029;
count__40744 = G__41030;
i__40745 = G__41031;
continue;
} else {
var temp__5804__auto__ = cljs.core.seq(seq__40742);
if(temp__5804__auto__){
var seq__40742__$1 = temp__5804__auto__;
if(cljs.core.chunked_seq_QMARK_(seq__40742__$1)){
var c__5568__auto__ = cljs.core.chunk_first(seq__40742__$1);
var G__41032 = cljs.core.chunk_rest(seq__40742__$1);
var G__41033 = c__5568__auto__;
var G__41034 = cljs.core.count(c__5568__auto__);
var G__41035 = (0);
seq__40742 = G__41032;
chunk__40743 = G__41033;
count__40744 = G__41034;
i__40745 = G__41035;
continue;
} else {
var js_ns = cljs.core.first(seq__40742__$1);
var require_str_41036 = ["var ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(js_ns)," = shadow.js.require(\"",cljs.core.str.cljs$core$IFn$_invoke$arity$1(js_ns),"\");"].join('');
shadow.cljs.devtools.client.browser.script_eval(require_str_41036);


var G__41037 = cljs.core.next(seq__40742__$1);
var G__41038 = null;
var G__41039 = (0);
var G__41040 = (0);
seq__40742 = G__41037;
chunk__40743 = G__41038;
count__40744 = G__41039;
i__40745 = G__41040;
continue;
}
} else {
return null;
}
}
break;
}
});
shadow.cljs.devtools.client.browser.handle_build_complete = (function shadow$cljs$devtools$client$browser$handle_build_complete(runtime,p__40749){
var map__40750 = p__40749;
var map__40750__$1 = cljs.core.__destructure_map(map__40750);
var msg = map__40750__$1;
var info = cljs.core.get.cljs$core$IFn$_invoke$arity$2(map__40750__$1,new cljs.core.Keyword(null,"info","info",-317069002));
var reload_info = cljs.core.get.cljs$core$IFn$_invoke$arity$2(map__40750__$1,new cljs.core.Keyword(null,"reload-info","reload-info",1648088086));
var warnings = cljs.core.into.cljs$core$IFn$_invoke$arity$2(cljs.core.PersistentVector.EMPTY,cljs.core.distinct.cljs$core$IFn$_invoke$arity$1((function (){var iter__5523__auto__ = (function shadow$cljs$devtools$client$browser$handle_build_complete_$_iter__40751(s__40752){
return (new cljs.core.LazySeq(null,(function (){
var s__40752__$1 = s__40752;
while(true){
var temp__5804__auto__ = cljs.core.seq(s__40752__$1);
if(temp__5804__auto__){
var xs__6360__auto__ = temp__5804__auto__;
var map__40757 = cljs.core.first(xs__6360__auto__);
var map__40757__$1 = cljs.core.__destructure_map(map__40757);
var src = map__40757__$1;
var resource_name = cljs.core.get.cljs$core$IFn$_invoke$arity$2(map__40757__$1,new cljs.core.Keyword(null,"resource-name","resource-name",2001617100));
var warnings = cljs.core.get.cljs$core$IFn$_invoke$arity$2(map__40757__$1,new cljs.core.Keyword(null,"warnings","warnings",-735437651));
if(cljs.core.not(new cljs.core.Keyword(null,"from-jar","from-jar",1050932827).cljs$core$IFn$_invoke$arity$1(src))){
var iterys__5519__auto__ = ((function (s__40752__$1,map__40757,map__40757__$1,src,resource_name,warnings,xs__6360__auto__,temp__5804__auto__,map__40750,map__40750__$1,msg,info,reload_info){
return (function shadow$cljs$devtools$client$browser$handle_build_complete_$_iter__40751_$_iter__40753(s__40754){
return (new cljs.core.LazySeq(null,((function (s__40752__$1,map__40757,map__40757__$1,src,resource_name,warnings,xs__6360__auto__,temp__5804__auto__,map__40750,map__40750__$1,msg,info,reload_info){
return (function (){
var s__40754__$1 = s__40754;
while(true){
var temp__5804__auto____$1 = cljs.core.seq(s__40754__$1);
if(temp__5804__auto____$1){
var s__40754__$2 = temp__5804__auto____$1;
if(cljs.core.chunked_seq_QMARK_(s__40754__$2)){
var c__5521__auto__ = cljs.core.chunk_first(s__40754__$2);
var size__5522__auto__ = cljs.core.count(c__5521__auto__);
var b__40756 = cljs.core.chunk_buffer(size__5522__auto__);
if((function (){var i__40755 = (0);
while(true){
if((i__40755 < size__5522__auto__)){
var warning = cljs.core._nth(c__5521__auto__,i__40755);
cljs.core.chunk_append(b__40756,cljs.core.assoc.cljs$core$IFn$_invoke$arity$3(warning,new cljs.core.Keyword(null,"resource-name","resource-name",2001617100),resource_name));

var G__41043 = (i__40755 + (1));
i__40755 = G__41043;
continue;
} else {
return true;
}
break;
}
})()){
return cljs.core.chunk_cons(cljs.core.chunk(b__40756),shadow$cljs$devtools$client$browser$handle_build_complete_$_iter__40751_$_iter__40753(cljs.core.chunk_rest(s__40754__$2)));
} else {
return cljs.core.chunk_cons(cljs.core.chunk(b__40756),null);
}
} else {
var warning = cljs.core.first(s__40754__$2);
return cljs.core.cons(cljs.core.assoc.cljs$core$IFn$_invoke$arity$3(warning,new cljs.core.Keyword(null,"resource-name","resource-name",2001617100),resource_name),shadow$cljs$devtools$client$browser$handle_build_complete_$_iter__40751_$_iter__40753(cljs.core.rest(s__40754__$2)));
}
} else {
return null;
}
break;
}
});})(s__40752__$1,map__40757,map__40757__$1,src,resource_name,warnings,xs__6360__auto__,temp__5804__auto__,map__40750,map__40750__$1,msg,info,reload_info))
,null,null));
});})(s__40752__$1,map__40757,map__40757__$1,src,resource_name,warnings,xs__6360__auto__,temp__5804__auto__,map__40750,map__40750__$1,msg,info,reload_info))
;
var fs__5520__auto__ = cljs.core.seq(iterys__5519__auto__(warnings));
if(fs__5520__auto__){
return cljs.core.concat.cljs$core$IFn$_invoke$arity$2(fs__5520__auto__,shadow$cljs$devtools$client$browser$handle_build_complete_$_iter__40751(cljs.core.rest(s__40752__$1)));
} else {
var G__41044 = cljs.core.rest(s__40752__$1);
s__40752__$1 = G__41044;
continue;
}
} else {
var G__41045 = cljs.core.rest(s__40752__$1);
s__40752__$1 = G__41045;
continue;
}
} else {
return null;
}
break;
}
}),null,null));
});
return iter__5523__auto__(new cljs.core.Keyword(null,"sources","sources",-321166424).cljs$core$IFn$_invoke$arity$1(info));
})()));
if(shadow.cljs.devtools.client.env.log){
var seq__40758_41046 = cljs.core.seq(warnings);
var chunk__40759_41047 = null;
var count__40760_41048 = (0);
var i__40761_41049 = (0);
while(true){
if((i__40761_41049 < count__40760_41048)){
var map__40764_41050 = chunk__40759_41047.cljs$core$IIndexed$_nth$arity$2(null,i__40761_41049);
var map__40764_41051__$1 = cljs.core.__destructure_map(map__40764_41050);
var w_41052 = map__40764_41051__$1;
var msg_41053__$1 = cljs.core.get.cljs$core$IFn$_invoke$arity$2(map__40764_41051__$1,new cljs.core.Keyword(null,"msg","msg",-1386103444));
var line_41054 = cljs.core.get.cljs$core$IFn$_invoke$arity$2(map__40764_41051__$1,new cljs.core.Keyword(null,"line","line",212345235));
var column_41055 = cljs.core.get.cljs$core$IFn$_invoke$arity$2(map__40764_41051__$1,new cljs.core.Keyword(null,"column","column",2078222095));
var resource_name_41056 = cljs.core.get.cljs$core$IFn$_invoke$arity$2(map__40764_41051__$1,new cljs.core.Keyword(null,"resource-name","resource-name",2001617100));
console.warn(["BUILD-WARNING in ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(resource_name_41056)," at [",cljs.core.str.cljs$core$IFn$_invoke$arity$1(line_41054),":",cljs.core.str.cljs$core$IFn$_invoke$arity$1(column_41055),"]\n\t",cljs.core.str.cljs$core$IFn$_invoke$arity$1(msg_41053__$1)].join(''));


var G__41057 = seq__40758_41046;
var G__41058 = chunk__40759_41047;
var G__41059 = count__40760_41048;
var G__41060 = (i__40761_41049 + (1));
seq__40758_41046 = G__41057;
chunk__40759_41047 = G__41058;
count__40760_41048 = G__41059;
i__40761_41049 = G__41060;
continue;
} else {
var temp__5804__auto___41061 = cljs.core.seq(seq__40758_41046);
if(temp__5804__auto___41061){
var seq__40758_41062__$1 = temp__5804__auto___41061;
if(cljs.core.chunked_seq_QMARK_(seq__40758_41062__$1)){
var c__5568__auto___41063 = cljs.core.chunk_first(seq__40758_41062__$1);
var G__41064 = cljs.core.chunk_rest(seq__40758_41062__$1);
var G__41065 = c__5568__auto___41063;
var G__41066 = cljs.core.count(c__5568__auto___41063);
var G__41067 = (0);
seq__40758_41046 = G__41064;
chunk__40759_41047 = G__41065;
count__40760_41048 = G__41066;
i__40761_41049 = G__41067;
continue;
} else {
var map__40765_41068 = cljs.core.first(seq__40758_41062__$1);
var map__40765_41069__$1 = cljs.core.__destructure_map(map__40765_41068);
var w_41070 = map__40765_41069__$1;
var msg_41071__$1 = cljs.core.get.cljs$core$IFn$_invoke$arity$2(map__40765_41069__$1,new cljs.core.Keyword(null,"msg","msg",-1386103444));
var line_41072 = cljs.core.get.cljs$core$IFn$_invoke$arity$2(map__40765_41069__$1,new cljs.core.Keyword(null,"line","line",212345235));
var column_41073 = cljs.core.get.cljs$core$IFn$_invoke$arity$2(map__40765_41069__$1,new cljs.core.Keyword(null,"column","column",2078222095));
var resource_name_41074 = cljs.core.get.cljs$core$IFn$_invoke$arity$2(map__40765_41069__$1,new cljs.core.Keyword(null,"resource-name","resource-name",2001617100));
console.warn(["BUILD-WARNING in ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(resource_name_41074)," at [",cljs.core.str.cljs$core$IFn$_invoke$arity$1(line_41072),":",cljs.core.str.cljs$core$IFn$_invoke$arity$1(column_41073),"]\n\t",cljs.core.str.cljs$core$IFn$_invoke$arity$1(msg_41071__$1)].join(''));


var G__41075 = cljs.core.next(seq__40758_41062__$1);
var G__41076 = null;
var G__41077 = (0);
var G__41078 = (0);
seq__40758_41046 = G__41075;
chunk__40759_41047 = G__41076;
count__40760_41048 = G__41077;
i__40761_41049 = G__41078;
continue;
}
} else {
}
}
break;
}
} else {
}

if((!(shadow.cljs.devtools.client.env.autoload))){
return shadow.cljs.devtools.client.hud.load_end_success();
} else {
if(((cljs.core.empty_QMARK_(warnings)) || (shadow.cljs.devtools.client.env.ignore_warnings))){
var sources_to_get = shadow.cljs.devtools.client.env.filter_reload_sources(info,reload_info);
if(cljs.core.not(cljs.core.seq(sources_to_get))){
return shadow.cljs.devtools.client.hud.load_end_success();
} else {
if(cljs.core.seq(cljs.core.get_in.cljs$core$IFn$_invoke$arity$2(msg,new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Keyword(null,"reload-info","reload-info",1648088086),new cljs.core.Keyword(null,"after-load","after-load",-1278503285)], null)))){
} else {
shadow.cljs.devtools.client.browser.devtools_msg.cljs$core$IFn$_invoke$arity$variadic("reloading code but no :after-load hooks are configured!",cljs.core.prim_seq.cljs$core$IFn$_invoke$arity$2(["https://shadow-cljs.github.io/docs/UsersGuide.html#_lifecycle_hooks"], 0));
}

return shadow.cljs.devtools.client.shared.load_sources(runtime,sources_to_get,(function (p1__40748_SHARP_){
return shadow.cljs.devtools.client.browser.do_js_reload(msg,p1__40748_SHARP_,shadow.cljs.devtools.client.hud.load_end_success,shadow.cljs.devtools.client.hud.load_failure);
}));
}
} else {
return null;
}
}
});
shadow.cljs.devtools.client.browser.page_load_uri = (cljs.core.truth_(goog.global.document)?goog.Uri.parse(document.location.href):null);
shadow.cljs.devtools.client.browser.match_paths = (function shadow$cljs$devtools$client$browser$match_paths(old,new$){
if(cljs.core._EQ_.cljs$core$IFn$_invoke$arity$2("file",shadow.cljs.devtools.client.browser.page_load_uri.getScheme())){
var rel_new = cljs.core.subs.cljs$core$IFn$_invoke$arity$2(new$,(1));
if(((cljs.core._EQ_.cljs$core$IFn$_invoke$arity$2(old,rel_new)) || (clojure.string.starts_with_QMARK_(old,[rel_new,"?"].join(''))))){
return rel_new;
} else {
return null;
}
} else {
var node_uri = goog.Uri.parse(old);
var node_uri_resolved = shadow.cljs.devtools.client.browser.page_load_uri.resolve(node_uri);
var node_abs = node_uri_resolved.getPath();
var and__5043__auto__ = ((cljs.core._EQ_.cljs$core$IFn$_invoke$arity$1(shadow.cljs.devtools.client.browser.page_load_uri.hasSameDomainAs(node_uri))) || (cljs.core.not(node_uri.hasDomain())));
if(and__5043__auto__){
var and__5043__auto____$1 = cljs.core._EQ_.cljs$core$IFn$_invoke$arity$2(node_abs,new$);
if(and__5043__auto____$1){
return new$;
} else {
return and__5043__auto____$1;
}
} else {
return and__5043__auto__;
}
}
});
shadow.cljs.devtools.client.browser.handle_asset_update = (function shadow$cljs$devtools$client$browser$handle_asset_update(p__40766){
var map__40767 = p__40766;
var map__40767__$1 = cljs.core.__destructure_map(map__40767);
var msg = map__40767__$1;
var updates = cljs.core.get.cljs$core$IFn$_invoke$arity$2(map__40767__$1,new cljs.core.Keyword(null,"updates","updates",2013983452));
var reload_info = cljs.core.get.cljs$core$IFn$_invoke$arity$2(map__40767__$1,new cljs.core.Keyword(null,"reload-info","reload-info",1648088086));
var seq__40768 = cljs.core.seq(updates);
var chunk__40770 = null;
var count__40771 = (0);
var i__40772 = (0);
while(true){
if((i__40772 < count__40771)){
var path = chunk__40770.cljs$core$IIndexed$_nth$arity$2(null,i__40772);
if(clojure.string.ends_with_QMARK_(path,"css")){
var seq__40882_41079 = cljs.core.seq(cljs.core.array_seq.cljs$core$IFn$_invoke$arity$1(document.querySelectorAll("link[rel=\"stylesheet\"]")));
var chunk__40886_41080 = null;
var count__40887_41081 = (0);
var i__40888_41082 = (0);
while(true){
if((i__40888_41082 < count__40887_41081)){
var node_41083 = chunk__40886_41080.cljs$core$IIndexed$_nth$arity$2(null,i__40888_41082);
if(cljs.core.not(node_41083.shadow$old)){
var path_match_41084 = shadow.cljs.devtools.client.browser.match_paths(node_41083.getAttribute("href"),path);
if(cljs.core.truth_(path_match_41084)){
var new_link_41085 = (function (){var G__40916 = node_41083.cloneNode(true);
G__40916.setAttribute("href",[cljs.core.str.cljs$core$IFn$_invoke$arity$1(path_match_41084),"?r=",cljs.core.str.cljs$core$IFn$_invoke$arity$1(cljs.core.rand.cljs$core$IFn$_invoke$arity$0())].join(''));

return G__40916;
})();
(node_41083.shadow$old = true);

(new_link_41085.onload = ((function (seq__40882_41079,chunk__40886_41080,count__40887_41081,i__40888_41082,seq__40768,chunk__40770,count__40771,i__40772,new_link_41085,path_match_41084,node_41083,path,map__40767,map__40767__$1,msg,updates,reload_info){
return (function (e){
var seq__40917_41086 = cljs.core.seq(cljs.core.get_in.cljs$core$IFn$_invoke$arity$2(msg,new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Keyword(null,"reload-info","reload-info",1648088086),new cljs.core.Keyword(null,"asset-load","asset-load",-1925902322)], null)));
var chunk__40919_41087 = null;
var count__40920_41088 = (0);
var i__40921_41089 = (0);
while(true){
if((i__40921_41089 < count__40920_41088)){
var map__40925_41090 = chunk__40919_41087.cljs$core$IIndexed$_nth$arity$2(null,i__40921_41089);
var map__40925_41091__$1 = cljs.core.__destructure_map(map__40925_41090);
var task_41092 = map__40925_41091__$1;
var fn_str_41093 = cljs.core.get.cljs$core$IFn$_invoke$arity$2(map__40925_41091__$1,new cljs.core.Keyword(null,"fn-str","fn-str",-1348506402));
var fn_sym_41094 = cljs.core.get.cljs$core$IFn$_invoke$arity$2(map__40925_41091__$1,new cljs.core.Keyword(null,"fn-sym","fn-sym",1423988510));
var fn_obj_41095 = goog.getObjectByName(fn_str_41093,$CLJS);
shadow.cljs.devtools.client.browser.devtools_msg(["call ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(fn_sym_41094)].join(''));

(fn_obj_41095.cljs$core$IFn$_invoke$arity$2 ? fn_obj_41095.cljs$core$IFn$_invoke$arity$2(path,new_link_41085) : fn_obj_41095.call(null,path,new_link_41085));


var G__41096 = seq__40917_41086;
var G__41097 = chunk__40919_41087;
var G__41098 = count__40920_41088;
var G__41099 = (i__40921_41089 + (1));
seq__40917_41086 = G__41096;
chunk__40919_41087 = G__41097;
count__40920_41088 = G__41098;
i__40921_41089 = G__41099;
continue;
} else {
var temp__5804__auto___41100 = cljs.core.seq(seq__40917_41086);
if(temp__5804__auto___41100){
var seq__40917_41101__$1 = temp__5804__auto___41100;
if(cljs.core.chunked_seq_QMARK_(seq__40917_41101__$1)){
var c__5568__auto___41102 = cljs.core.chunk_first(seq__40917_41101__$1);
var G__41103 = cljs.core.chunk_rest(seq__40917_41101__$1);
var G__41104 = c__5568__auto___41102;
var G__41105 = cljs.core.count(c__5568__auto___41102);
var G__41106 = (0);
seq__40917_41086 = G__41103;
chunk__40919_41087 = G__41104;
count__40920_41088 = G__41105;
i__40921_41089 = G__41106;
continue;
} else {
var map__40926_41107 = cljs.core.first(seq__40917_41101__$1);
var map__40926_41108__$1 = cljs.core.__destructure_map(map__40926_41107);
var task_41109 = map__40926_41108__$1;
var fn_str_41110 = cljs.core.get.cljs$core$IFn$_invoke$arity$2(map__40926_41108__$1,new cljs.core.Keyword(null,"fn-str","fn-str",-1348506402));
var fn_sym_41111 = cljs.core.get.cljs$core$IFn$_invoke$arity$2(map__40926_41108__$1,new cljs.core.Keyword(null,"fn-sym","fn-sym",1423988510));
var fn_obj_41112 = goog.getObjectByName(fn_str_41110,$CLJS);
shadow.cljs.devtools.client.browser.devtools_msg(["call ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(fn_sym_41111)].join(''));

(fn_obj_41112.cljs$core$IFn$_invoke$arity$2 ? fn_obj_41112.cljs$core$IFn$_invoke$arity$2(path,new_link_41085) : fn_obj_41112.call(null,path,new_link_41085));


var G__41113 = cljs.core.next(seq__40917_41101__$1);
var G__41114 = null;
var G__41115 = (0);
var G__41116 = (0);
seq__40917_41086 = G__41113;
chunk__40919_41087 = G__41114;
count__40920_41088 = G__41115;
i__40921_41089 = G__41116;
continue;
}
} else {
}
}
break;
}

return goog.dom.removeNode(node_41083);
});})(seq__40882_41079,chunk__40886_41080,count__40887_41081,i__40888_41082,seq__40768,chunk__40770,count__40771,i__40772,new_link_41085,path_match_41084,node_41083,path,map__40767,map__40767__$1,msg,updates,reload_info))
);

shadow.cljs.devtools.client.browser.devtools_msg.cljs$core$IFn$_invoke$arity$variadic("load CSS",cljs.core.prim_seq.cljs$core$IFn$_invoke$arity$2([path_match_41084], 0));

goog.dom.insertSiblingAfter(new_link_41085,node_41083);


var G__41117 = seq__40882_41079;
var G__41118 = chunk__40886_41080;
var G__41119 = count__40887_41081;
var G__41120 = (i__40888_41082 + (1));
seq__40882_41079 = G__41117;
chunk__40886_41080 = G__41118;
count__40887_41081 = G__41119;
i__40888_41082 = G__41120;
continue;
} else {
var G__41121 = seq__40882_41079;
var G__41122 = chunk__40886_41080;
var G__41123 = count__40887_41081;
var G__41124 = (i__40888_41082 + (1));
seq__40882_41079 = G__41121;
chunk__40886_41080 = G__41122;
count__40887_41081 = G__41123;
i__40888_41082 = G__41124;
continue;
}
} else {
var G__41125 = seq__40882_41079;
var G__41126 = chunk__40886_41080;
var G__41127 = count__40887_41081;
var G__41128 = (i__40888_41082 + (1));
seq__40882_41079 = G__41125;
chunk__40886_41080 = G__41126;
count__40887_41081 = G__41127;
i__40888_41082 = G__41128;
continue;
}
} else {
var temp__5804__auto___41129 = cljs.core.seq(seq__40882_41079);
if(temp__5804__auto___41129){
var seq__40882_41130__$1 = temp__5804__auto___41129;
if(cljs.core.chunked_seq_QMARK_(seq__40882_41130__$1)){
var c__5568__auto___41131 = cljs.core.chunk_first(seq__40882_41130__$1);
var G__41132 = cljs.core.chunk_rest(seq__40882_41130__$1);
var G__41133 = c__5568__auto___41131;
var G__41134 = cljs.core.count(c__5568__auto___41131);
var G__41135 = (0);
seq__40882_41079 = G__41132;
chunk__40886_41080 = G__41133;
count__40887_41081 = G__41134;
i__40888_41082 = G__41135;
continue;
} else {
var node_41136 = cljs.core.first(seq__40882_41130__$1);
if(cljs.core.not(node_41136.shadow$old)){
var path_match_41137 = shadow.cljs.devtools.client.browser.match_paths(node_41136.getAttribute("href"),path);
if(cljs.core.truth_(path_match_41137)){
var new_link_41138 = (function (){var G__40927 = node_41136.cloneNode(true);
G__40927.setAttribute("href",[cljs.core.str.cljs$core$IFn$_invoke$arity$1(path_match_41137),"?r=",cljs.core.str.cljs$core$IFn$_invoke$arity$1(cljs.core.rand.cljs$core$IFn$_invoke$arity$0())].join(''));

return G__40927;
})();
(node_41136.shadow$old = true);

(new_link_41138.onload = ((function (seq__40882_41079,chunk__40886_41080,count__40887_41081,i__40888_41082,seq__40768,chunk__40770,count__40771,i__40772,new_link_41138,path_match_41137,node_41136,seq__40882_41130__$1,temp__5804__auto___41129,path,map__40767,map__40767__$1,msg,updates,reload_info){
return (function (e){
var seq__40928_41139 = cljs.core.seq(cljs.core.get_in.cljs$core$IFn$_invoke$arity$2(msg,new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Keyword(null,"reload-info","reload-info",1648088086),new cljs.core.Keyword(null,"asset-load","asset-load",-1925902322)], null)));
var chunk__40930_41140 = null;
var count__40931_41141 = (0);
var i__40932_41142 = (0);
while(true){
if((i__40932_41142 < count__40931_41141)){
var map__40936_41143 = chunk__40930_41140.cljs$core$IIndexed$_nth$arity$2(null,i__40932_41142);
var map__40936_41144__$1 = cljs.core.__destructure_map(map__40936_41143);
var task_41145 = map__40936_41144__$1;
var fn_str_41146 = cljs.core.get.cljs$core$IFn$_invoke$arity$2(map__40936_41144__$1,new cljs.core.Keyword(null,"fn-str","fn-str",-1348506402));
var fn_sym_41147 = cljs.core.get.cljs$core$IFn$_invoke$arity$2(map__40936_41144__$1,new cljs.core.Keyword(null,"fn-sym","fn-sym",1423988510));
var fn_obj_41148 = goog.getObjectByName(fn_str_41146,$CLJS);
shadow.cljs.devtools.client.browser.devtools_msg(["call ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(fn_sym_41147)].join(''));

(fn_obj_41148.cljs$core$IFn$_invoke$arity$2 ? fn_obj_41148.cljs$core$IFn$_invoke$arity$2(path,new_link_41138) : fn_obj_41148.call(null,path,new_link_41138));


var G__41149 = seq__40928_41139;
var G__41150 = chunk__40930_41140;
var G__41151 = count__40931_41141;
var G__41152 = (i__40932_41142 + (1));
seq__40928_41139 = G__41149;
chunk__40930_41140 = G__41150;
count__40931_41141 = G__41151;
i__40932_41142 = G__41152;
continue;
} else {
var temp__5804__auto___41153__$1 = cljs.core.seq(seq__40928_41139);
if(temp__5804__auto___41153__$1){
var seq__40928_41154__$1 = temp__5804__auto___41153__$1;
if(cljs.core.chunked_seq_QMARK_(seq__40928_41154__$1)){
var c__5568__auto___41155 = cljs.core.chunk_first(seq__40928_41154__$1);
var G__41156 = cljs.core.chunk_rest(seq__40928_41154__$1);
var G__41157 = c__5568__auto___41155;
var G__41158 = cljs.core.count(c__5568__auto___41155);
var G__41159 = (0);
seq__40928_41139 = G__41156;
chunk__40930_41140 = G__41157;
count__40931_41141 = G__41158;
i__40932_41142 = G__41159;
continue;
} else {
var map__40937_41160 = cljs.core.first(seq__40928_41154__$1);
var map__40937_41161__$1 = cljs.core.__destructure_map(map__40937_41160);
var task_41162 = map__40937_41161__$1;
var fn_str_41163 = cljs.core.get.cljs$core$IFn$_invoke$arity$2(map__40937_41161__$1,new cljs.core.Keyword(null,"fn-str","fn-str",-1348506402));
var fn_sym_41164 = cljs.core.get.cljs$core$IFn$_invoke$arity$2(map__40937_41161__$1,new cljs.core.Keyword(null,"fn-sym","fn-sym",1423988510));
var fn_obj_41165 = goog.getObjectByName(fn_str_41163,$CLJS);
shadow.cljs.devtools.client.browser.devtools_msg(["call ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(fn_sym_41164)].join(''));

(fn_obj_41165.cljs$core$IFn$_invoke$arity$2 ? fn_obj_41165.cljs$core$IFn$_invoke$arity$2(path,new_link_41138) : fn_obj_41165.call(null,path,new_link_41138));


var G__41166 = cljs.core.next(seq__40928_41154__$1);
var G__41167 = null;
var G__41168 = (0);
var G__41169 = (0);
seq__40928_41139 = G__41166;
chunk__40930_41140 = G__41167;
count__40931_41141 = G__41168;
i__40932_41142 = G__41169;
continue;
}
} else {
}
}
break;
}

return goog.dom.removeNode(node_41136);
});})(seq__40882_41079,chunk__40886_41080,count__40887_41081,i__40888_41082,seq__40768,chunk__40770,count__40771,i__40772,new_link_41138,path_match_41137,node_41136,seq__40882_41130__$1,temp__5804__auto___41129,path,map__40767,map__40767__$1,msg,updates,reload_info))
);

shadow.cljs.devtools.client.browser.devtools_msg.cljs$core$IFn$_invoke$arity$variadic("load CSS",cljs.core.prim_seq.cljs$core$IFn$_invoke$arity$2([path_match_41137], 0));

goog.dom.insertSiblingAfter(new_link_41138,node_41136);


var G__41170 = cljs.core.next(seq__40882_41130__$1);
var G__41171 = null;
var G__41172 = (0);
var G__41173 = (0);
seq__40882_41079 = G__41170;
chunk__40886_41080 = G__41171;
count__40887_41081 = G__41172;
i__40888_41082 = G__41173;
continue;
} else {
var G__41174 = cljs.core.next(seq__40882_41130__$1);
var G__41175 = null;
var G__41176 = (0);
var G__41177 = (0);
seq__40882_41079 = G__41174;
chunk__40886_41080 = G__41175;
count__40887_41081 = G__41176;
i__40888_41082 = G__41177;
continue;
}
} else {
var G__41178 = cljs.core.next(seq__40882_41130__$1);
var G__41179 = null;
var G__41180 = (0);
var G__41181 = (0);
seq__40882_41079 = G__41178;
chunk__40886_41080 = G__41179;
count__40887_41081 = G__41180;
i__40888_41082 = G__41181;
continue;
}
}
} else {
}
}
break;
}


var G__41182 = seq__40768;
var G__41183 = chunk__40770;
var G__41184 = count__40771;
var G__41185 = (i__40772 + (1));
seq__40768 = G__41182;
chunk__40770 = G__41183;
count__40771 = G__41184;
i__40772 = G__41185;
continue;
} else {
var G__41186 = seq__40768;
var G__41187 = chunk__40770;
var G__41188 = count__40771;
var G__41189 = (i__40772 + (1));
seq__40768 = G__41186;
chunk__40770 = G__41187;
count__40771 = G__41188;
i__40772 = G__41189;
continue;
}
} else {
var temp__5804__auto__ = cljs.core.seq(seq__40768);
if(temp__5804__auto__){
var seq__40768__$1 = temp__5804__auto__;
if(cljs.core.chunked_seq_QMARK_(seq__40768__$1)){
var c__5568__auto__ = cljs.core.chunk_first(seq__40768__$1);
var G__41190 = cljs.core.chunk_rest(seq__40768__$1);
var G__41191 = c__5568__auto__;
var G__41192 = cljs.core.count(c__5568__auto__);
var G__41193 = (0);
seq__40768 = G__41190;
chunk__40770 = G__41191;
count__40771 = G__41192;
i__40772 = G__41193;
continue;
} else {
var path = cljs.core.first(seq__40768__$1);
if(clojure.string.ends_with_QMARK_(path,"css")){
var seq__40938_41194 = cljs.core.seq(cljs.core.array_seq.cljs$core$IFn$_invoke$arity$1(document.querySelectorAll("link[rel=\"stylesheet\"]")));
var chunk__40942_41195 = null;
var count__40943_41196 = (0);
var i__40944_41197 = (0);
while(true){
if((i__40944_41197 < count__40943_41196)){
var node_41198 = chunk__40942_41195.cljs$core$IIndexed$_nth$arity$2(null,i__40944_41197);
if(cljs.core.not(node_41198.shadow$old)){
var path_match_41199 = shadow.cljs.devtools.client.browser.match_paths(node_41198.getAttribute("href"),path);
if(cljs.core.truth_(path_match_41199)){
var new_link_41200 = (function (){var G__40970 = node_41198.cloneNode(true);
G__40970.setAttribute("href",[cljs.core.str.cljs$core$IFn$_invoke$arity$1(path_match_41199),"?r=",cljs.core.str.cljs$core$IFn$_invoke$arity$1(cljs.core.rand.cljs$core$IFn$_invoke$arity$0())].join(''));

return G__40970;
})();
(node_41198.shadow$old = true);

(new_link_41200.onload = ((function (seq__40938_41194,chunk__40942_41195,count__40943_41196,i__40944_41197,seq__40768,chunk__40770,count__40771,i__40772,new_link_41200,path_match_41199,node_41198,path,seq__40768__$1,temp__5804__auto__,map__40767,map__40767__$1,msg,updates,reload_info){
return (function (e){
var seq__40971_41201 = cljs.core.seq(cljs.core.get_in.cljs$core$IFn$_invoke$arity$2(msg,new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Keyword(null,"reload-info","reload-info",1648088086),new cljs.core.Keyword(null,"asset-load","asset-load",-1925902322)], null)));
var chunk__40973_41202 = null;
var count__40974_41203 = (0);
var i__40975_41204 = (0);
while(true){
if((i__40975_41204 < count__40974_41203)){
var map__40979_41205 = chunk__40973_41202.cljs$core$IIndexed$_nth$arity$2(null,i__40975_41204);
var map__40979_41206__$1 = cljs.core.__destructure_map(map__40979_41205);
var task_41207 = map__40979_41206__$1;
var fn_str_41208 = cljs.core.get.cljs$core$IFn$_invoke$arity$2(map__40979_41206__$1,new cljs.core.Keyword(null,"fn-str","fn-str",-1348506402));
var fn_sym_41209 = cljs.core.get.cljs$core$IFn$_invoke$arity$2(map__40979_41206__$1,new cljs.core.Keyword(null,"fn-sym","fn-sym",1423988510));
var fn_obj_41210 = goog.getObjectByName(fn_str_41208,$CLJS);
shadow.cljs.devtools.client.browser.devtools_msg(["call ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(fn_sym_41209)].join(''));

(fn_obj_41210.cljs$core$IFn$_invoke$arity$2 ? fn_obj_41210.cljs$core$IFn$_invoke$arity$2(path,new_link_41200) : fn_obj_41210.call(null,path,new_link_41200));


var G__41211 = seq__40971_41201;
var G__41212 = chunk__40973_41202;
var G__41213 = count__40974_41203;
var G__41214 = (i__40975_41204 + (1));
seq__40971_41201 = G__41211;
chunk__40973_41202 = G__41212;
count__40974_41203 = G__41213;
i__40975_41204 = G__41214;
continue;
} else {
var temp__5804__auto___41215__$1 = cljs.core.seq(seq__40971_41201);
if(temp__5804__auto___41215__$1){
var seq__40971_41216__$1 = temp__5804__auto___41215__$1;
if(cljs.core.chunked_seq_QMARK_(seq__40971_41216__$1)){
var c__5568__auto___41217 = cljs.core.chunk_first(seq__40971_41216__$1);
var G__41218 = cljs.core.chunk_rest(seq__40971_41216__$1);
var G__41219 = c__5568__auto___41217;
var G__41220 = cljs.core.count(c__5568__auto___41217);
var G__41221 = (0);
seq__40971_41201 = G__41218;
chunk__40973_41202 = G__41219;
count__40974_41203 = G__41220;
i__40975_41204 = G__41221;
continue;
} else {
var map__40980_41222 = cljs.core.first(seq__40971_41216__$1);
var map__40980_41223__$1 = cljs.core.__destructure_map(map__40980_41222);
var task_41224 = map__40980_41223__$1;
var fn_str_41225 = cljs.core.get.cljs$core$IFn$_invoke$arity$2(map__40980_41223__$1,new cljs.core.Keyword(null,"fn-str","fn-str",-1348506402));
var fn_sym_41226 = cljs.core.get.cljs$core$IFn$_invoke$arity$2(map__40980_41223__$1,new cljs.core.Keyword(null,"fn-sym","fn-sym",1423988510));
var fn_obj_41227 = goog.getObjectByName(fn_str_41225,$CLJS);
shadow.cljs.devtools.client.browser.devtools_msg(["call ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(fn_sym_41226)].join(''));

(fn_obj_41227.cljs$core$IFn$_invoke$arity$2 ? fn_obj_41227.cljs$core$IFn$_invoke$arity$2(path,new_link_41200) : fn_obj_41227.call(null,path,new_link_41200));


var G__41228 = cljs.core.next(seq__40971_41216__$1);
var G__41229 = null;
var G__41230 = (0);
var G__41231 = (0);
seq__40971_41201 = G__41228;
chunk__40973_41202 = G__41229;
count__40974_41203 = G__41230;
i__40975_41204 = G__41231;
continue;
}
} else {
}
}
break;
}

return goog.dom.removeNode(node_41198);
});})(seq__40938_41194,chunk__40942_41195,count__40943_41196,i__40944_41197,seq__40768,chunk__40770,count__40771,i__40772,new_link_41200,path_match_41199,node_41198,path,seq__40768__$1,temp__5804__auto__,map__40767,map__40767__$1,msg,updates,reload_info))
);

shadow.cljs.devtools.client.browser.devtools_msg.cljs$core$IFn$_invoke$arity$variadic("load CSS",cljs.core.prim_seq.cljs$core$IFn$_invoke$arity$2([path_match_41199], 0));

goog.dom.insertSiblingAfter(new_link_41200,node_41198);


var G__41232 = seq__40938_41194;
var G__41233 = chunk__40942_41195;
var G__41234 = count__40943_41196;
var G__41235 = (i__40944_41197 + (1));
seq__40938_41194 = G__41232;
chunk__40942_41195 = G__41233;
count__40943_41196 = G__41234;
i__40944_41197 = G__41235;
continue;
} else {
var G__41236 = seq__40938_41194;
var G__41237 = chunk__40942_41195;
var G__41238 = count__40943_41196;
var G__41239 = (i__40944_41197 + (1));
seq__40938_41194 = G__41236;
chunk__40942_41195 = G__41237;
count__40943_41196 = G__41238;
i__40944_41197 = G__41239;
continue;
}
} else {
var G__41240 = seq__40938_41194;
var G__41241 = chunk__40942_41195;
var G__41242 = count__40943_41196;
var G__41243 = (i__40944_41197 + (1));
seq__40938_41194 = G__41240;
chunk__40942_41195 = G__41241;
count__40943_41196 = G__41242;
i__40944_41197 = G__41243;
continue;
}
} else {
var temp__5804__auto___41244__$1 = cljs.core.seq(seq__40938_41194);
if(temp__5804__auto___41244__$1){
var seq__40938_41245__$1 = temp__5804__auto___41244__$1;
if(cljs.core.chunked_seq_QMARK_(seq__40938_41245__$1)){
var c__5568__auto___41246 = cljs.core.chunk_first(seq__40938_41245__$1);
var G__41247 = cljs.core.chunk_rest(seq__40938_41245__$1);
var G__41248 = c__5568__auto___41246;
var G__41249 = cljs.core.count(c__5568__auto___41246);
var G__41250 = (0);
seq__40938_41194 = G__41247;
chunk__40942_41195 = G__41248;
count__40943_41196 = G__41249;
i__40944_41197 = G__41250;
continue;
} else {
var node_41251 = cljs.core.first(seq__40938_41245__$1);
if(cljs.core.not(node_41251.shadow$old)){
var path_match_41252 = shadow.cljs.devtools.client.browser.match_paths(node_41251.getAttribute("href"),path);
if(cljs.core.truth_(path_match_41252)){
var new_link_41253 = (function (){var G__40981 = node_41251.cloneNode(true);
G__40981.setAttribute("href",[cljs.core.str.cljs$core$IFn$_invoke$arity$1(path_match_41252),"?r=",cljs.core.str.cljs$core$IFn$_invoke$arity$1(cljs.core.rand.cljs$core$IFn$_invoke$arity$0())].join(''));

return G__40981;
})();
(node_41251.shadow$old = true);

(new_link_41253.onload = ((function (seq__40938_41194,chunk__40942_41195,count__40943_41196,i__40944_41197,seq__40768,chunk__40770,count__40771,i__40772,new_link_41253,path_match_41252,node_41251,seq__40938_41245__$1,temp__5804__auto___41244__$1,path,seq__40768__$1,temp__5804__auto__,map__40767,map__40767__$1,msg,updates,reload_info){
return (function (e){
var seq__40982_41254 = cljs.core.seq(cljs.core.get_in.cljs$core$IFn$_invoke$arity$2(msg,new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Keyword(null,"reload-info","reload-info",1648088086),new cljs.core.Keyword(null,"asset-load","asset-load",-1925902322)], null)));
var chunk__40984_41255 = null;
var count__40985_41256 = (0);
var i__40986_41257 = (0);
while(true){
if((i__40986_41257 < count__40985_41256)){
var map__40990_41258 = chunk__40984_41255.cljs$core$IIndexed$_nth$arity$2(null,i__40986_41257);
var map__40990_41259__$1 = cljs.core.__destructure_map(map__40990_41258);
var task_41260 = map__40990_41259__$1;
var fn_str_41261 = cljs.core.get.cljs$core$IFn$_invoke$arity$2(map__40990_41259__$1,new cljs.core.Keyword(null,"fn-str","fn-str",-1348506402));
var fn_sym_41262 = cljs.core.get.cljs$core$IFn$_invoke$arity$2(map__40990_41259__$1,new cljs.core.Keyword(null,"fn-sym","fn-sym",1423988510));
var fn_obj_41263 = goog.getObjectByName(fn_str_41261,$CLJS);
shadow.cljs.devtools.client.browser.devtools_msg(["call ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(fn_sym_41262)].join(''));

(fn_obj_41263.cljs$core$IFn$_invoke$arity$2 ? fn_obj_41263.cljs$core$IFn$_invoke$arity$2(path,new_link_41253) : fn_obj_41263.call(null,path,new_link_41253));


var G__41264 = seq__40982_41254;
var G__41265 = chunk__40984_41255;
var G__41266 = count__40985_41256;
var G__41267 = (i__40986_41257 + (1));
seq__40982_41254 = G__41264;
chunk__40984_41255 = G__41265;
count__40985_41256 = G__41266;
i__40986_41257 = G__41267;
continue;
} else {
var temp__5804__auto___41268__$2 = cljs.core.seq(seq__40982_41254);
if(temp__5804__auto___41268__$2){
var seq__40982_41269__$1 = temp__5804__auto___41268__$2;
if(cljs.core.chunked_seq_QMARK_(seq__40982_41269__$1)){
var c__5568__auto___41270 = cljs.core.chunk_first(seq__40982_41269__$1);
var G__41271 = cljs.core.chunk_rest(seq__40982_41269__$1);
var G__41272 = c__5568__auto___41270;
var G__41273 = cljs.core.count(c__5568__auto___41270);
var G__41274 = (0);
seq__40982_41254 = G__41271;
chunk__40984_41255 = G__41272;
count__40985_41256 = G__41273;
i__40986_41257 = G__41274;
continue;
} else {
var map__40991_41275 = cljs.core.first(seq__40982_41269__$1);
var map__40991_41276__$1 = cljs.core.__destructure_map(map__40991_41275);
var task_41277 = map__40991_41276__$1;
var fn_str_41278 = cljs.core.get.cljs$core$IFn$_invoke$arity$2(map__40991_41276__$1,new cljs.core.Keyword(null,"fn-str","fn-str",-1348506402));
var fn_sym_41279 = cljs.core.get.cljs$core$IFn$_invoke$arity$2(map__40991_41276__$1,new cljs.core.Keyword(null,"fn-sym","fn-sym",1423988510));
var fn_obj_41280 = goog.getObjectByName(fn_str_41278,$CLJS);
shadow.cljs.devtools.client.browser.devtools_msg(["call ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(fn_sym_41279)].join(''));

(fn_obj_41280.cljs$core$IFn$_invoke$arity$2 ? fn_obj_41280.cljs$core$IFn$_invoke$arity$2(path,new_link_41253) : fn_obj_41280.call(null,path,new_link_41253));


var G__41281 = cljs.core.next(seq__40982_41269__$1);
var G__41282 = null;
var G__41283 = (0);
var G__41284 = (0);
seq__40982_41254 = G__41281;
chunk__40984_41255 = G__41282;
count__40985_41256 = G__41283;
i__40986_41257 = G__41284;
continue;
}
} else {
}
}
break;
}

return goog.dom.removeNode(node_41251);
});})(seq__40938_41194,chunk__40942_41195,count__40943_41196,i__40944_41197,seq__40768,chunk__40770,count__40771,i__40772,new_link_41253,path_match_41252,node_41251,seq__40938_41245__$1,temp__5804__auto___41244__$1,path,seq__40768__$1,temp__5804__auto__,map__40767,map__40767__$1,msg,updates,reload_info))
);

shadow.cljs.devtools.client.browser.devtools_msg.cljs$core$IFn$_invoke$arity$variadic("load CSS",cljs.core.prim_seq.cljs$core$IFn$_invoke$arity$2([path_match_41252], 0));

goog.dom.insertSiblingAfter(new_link_41253,node_41251);


var G__41285 = cljs.core.next(seq__40938_41245__$1);
var G__41286 = null;
var G__41287 = (0);
var G__41288 = (0);
seq__40938_41194 = G__41285;
chunk__40942_41195 = G__41286;
count__40943_41196 = G__41287;
i__40944_41197 = G__41288;
continue;
} else {
var G__41289 = cljs.core.next(seq__40938_41245__$1);
var G__41290 = null;
var G__41291 = (0);
var G__41292 = (0);
seq__40938_41194 = G__41289;
chunk__40942_41195 = G__41290;
count__40943_41196 = G__41291;
i__40944_41197 = G__41292;
continue;
}
} else {
var G__41293 = cljs.core.next(seq__40938_41245__$1);
var G__41294 = null;
var G__41295 = (0);
var G__41296 = (0);
seq__40938_41194 = G__41293;
chunk__40942_41195 = G__41294;
count__40943_41196 = G__41295;
i__40944_41197 = G__41296;
continue;
}
}
} else {
}
}
break;
}


var G__41297 = cljs.core.next(seq__40768__$1);
var G__41298 = null;
var G__41299 = (0);
var G__41300 = (0);
seq__40768 = G__41297;
chunk__40770 = G__41298;
count__40771 = G__41299;
i__40772 = G__41300;
continue;
} else {
var G__41301 = cljs.core.next(seq__40768__$1);
var G__41302 = null;
var G__41303 = (0);
var G__41304 = (0);
seq__40768 = G__41301;
chunk__40770 = G__41302;
count__40771 = G__41303;
i__40772 = G__41304;
continue;
}
}
} else {
return null;
}
}
break;
}
});
shadow.cljs.devtools.client.browser.global_eval = (function shadow$cljs$devtools$client$browser$global_eval(js){
if(cljs.core.not_EQ_.cljs$core$IFn$_invoke$arity$2("undefined",typeof(module))){
return eval(js);
} else {
return (0,eval)(js);;
}
});
shadow.cljs.devtools.client.browser.runtime_info = (((typeof SHADOW_CONFIG !== 'undefined'))?shadow.json.to_clj.cljs$core$IFn$_invoke$arity$1(SHADOW_CONFIG):null);
shadow.cljs.devtools.client.browser.client_info = cljs.core.merge.cljs$core$IFn$_invoke$arity$variadic(cljs.core.prim_seq.cljs$core$IFn$_invoke$arity$2([shadow.cljs.devtools.client.browser.runtime_info,new cljs.core.PersistentArrayMap(null, 3, [new cljs.core.Keyword(null,"host","host",-1558485167),(cljs.core.truth_(goog.global.document)?new cljs.core.Keyword(null,"browser","browser",828191719):new cljs.core.Keyword(null,"browser-worker","browser-worker",1638998282)),new cljs.core.Keyword(null,"user-agent","user-agent",1220426212),[(cljs.core.truth_(goog.userAgent.OPERA)?"Opera":(cljs.core.truth_(goog.userAgent.product.CHROME)?"Chrome":(cljs.core.truth_(goog.userAgent.IE)?"MSIE":(cljs.core.truth_(goog.userAgent.EDGE)?"Edge":(cljs.core.truth_(goog.userAgent.GECKO)?"Firefox":(cljs.core.truth_(goog.userAgent.SAFARI)?"Safari":(cljs.core.truth_(goog.userAgent.WEBKIT)?"Webkit":null)))))))," ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(goog.userAgent.VERSION)," [",cljs.core.str.cljs$core$IFn$_invoke$arity$1(goog.userAgent.PLATFORM),"]"].join(''),new cljs.core.Keyword(null,"dom","dom",-1236537922),(!((goog.global.document == null)))], null)], 0));
if((typeof shadow !== 'undefined') && (typeof shadow.cljs !== 'undefined') && (typeof shadow.cljs.devtools !== 'undefined') && (typeof shadow.cljs.devtools.client !== 'undefined') && (typeof shadow.cljs.devtools.client.browser !== 'undefined') && (typeof shadow.cljs.devtools.client.browser.ws_was_welcome_ref !== 'undefined')){
} else {
shadow.cljs.devtools.client.browser.ws_was_welcome_ref = cljs.core.atom.cljs$core$IFn$_invoke$arity$1(false);
}
if(((shadow.cljs.devtools.client.env.enabled) && ((shadow.cljs.devtools.client.env.worker_client_id > (0))))){
(shadow.cljs.devtools.client.shared.Runtime.prototype.shadow$remote$runtime$api$IEvalJS$ = cljs.core.PROTOCOL_SENTINEL);

(shadow.cljs.devtools.client.shared.Runtime.prototype.shadow$remote$runtime$api$IEvalJS$_js_eval$arity$2 = (function (this$,code){
var this$__$1 = this;
return shadow.cljs.devtools.client.browser.global_eval(code);
}));

(shadow.cljs.devtools.client.shared.Runtime.prototype.shadow$cljs$devtools$client$shared$IHostSpecific$ = cljs.core.PROTOCOL_SENTINEL);

(shadow.cljs.devtools.client.shared.Runtime.prototype.shadow$cljs$devtools$client$shared$IHostSpecific$do_invoke$arity$3 = (function (this$,ns,p__40992){
var map__40993 = p__40992;
var map__40993__$1 = cljs.core.__destructure_map(map__40993);
var js = cljs.core.get.cljs$core$IFn$_invoke$arity$2(map__40993__$1,new cljs.core.Keyword(null,"js","js",1768080579));
var this$__$1 = this;
return shadow.cljs.devtools.client.browser.global_eval(js);
}));

(shadow.cljs.devtools.client.shared.Runtime.prototype.shadow$cljs$devtools$client$shared$IHostSpecific$do_repl_init$arity$4 = (function (runtime,p__40994,done,error){
var map__40995 = p__40994;
var map__40995__$1 = cljs.core.__destructure_map(map__40995);
var repl_sources = cljs.core.get.cljs$core$IFn$_invoke$arity$2(map__40995__$1,new cljs.core.Keyword(null,"repl-sources","repl-sources",723867535));
var runtime__$1 = this;
return shadow.cljs.devtools.client.shared.load_sources(runtime__$1,cljs.core.into.cljs$core$IFn$_invoke$arity$2(cljs.core.PersistentVector.EMPTY,cljs.core.remove.cljs$core$IFn$_invoke$arity$2(shadow.cljs.devtools.client.env.src_is_loaded_QMARK_,repl_sources)),(function (sources){
shadow.cljs.devtools.client.browser.do_js_load(sources);

return (done.cljs$core$IFn$_invoke$arity$0 ? done.cljs$core$IFn$_invoke$arity$0() : done.call(null));
}));
}));

(shadow.cljs.devtools.client.shared.Runtime.prototype.shadow$cljs$devtools$client$shared$IHostSpecific$do_repl_require$arity$4 = (function (runtime,p__40996,done,error){
var map__40997 = p__40996;
var map__40997__$1 = cljs.core.__destructure_map(map__40997);
var msg = map__40997__$1;
var sources = cljs.core.get.cljs$core$IFn$_invoke$arity$2(map__40997__$1,new cljs.core.Keyword(null,"sources","sources",-321166424));
var reload_namespaces = cljs.core.get.cljs$core$IFn$_invoke$arity$2(map__40997__$1,new cljs.core.Keyword(null,"reload-namespaces","reload-namespaces",250210134));
var js_requires = cljs.core.get.cljs$core$IFn$_invoke$arity$2(map__40997__$1,new cljs.core.Keyword(null,"js-requires","js-requires",-1311472051));
var runtime__$1 = this;
var sources_to_load = cljs.core.into.cljs$core$IFn$_invoke$arity$2(cljs.core.PersistentVector.EMPTY,cljs.core.remove.cljs$core$IFn$_invoke$arity$2((function (p__40998){
var map__40999 = p__40998;
var map__40999__$1 = cljs.core.__destructure_map(map__40999);
var src = map__40999__$1;
var provides = cljs.core.get.cljs$core$IFn$_invoke$arity$2(map__40999__$1,new cljs.core.Keyword(null,"provides","provides",-1634397992));
var and__5043__auto__ = shadow.cljs.devtools.client.env.src_is_loaded_QMARK_(src);
if(cljs.core.truth_(and__5043__auto__)){
return cljs.core.not(cljs.core.some(reload_namespaces,provides));
} else {
return and__5043__auto__;
}
}),sources));
if(cljs.core.not(cljs.core.seq(sources_to_load))){
var G__41000 = cljs.core.PersistentVector.EMPTY;
return (done.cljs$core$IFn$_invoke$arity$1 ? done.cljs$core$IFn$_invoke$arity$1(G__41000) : done.call(null,G__41000));
} else {
return shadow.remote.runtime.shared.call.cljs$core$IFn$_invoke$arity$3(runtime__$1,new cljs.core.PersistentArrayMap(null, 3, [new cljs.core.Keyword(null,"op","op",-1882987955),new cljs.core.Keyword(null,"cljs-load-sources","cljs-load-sources",-1458295962),new cljs.core.Keyword(null,"to","to",192099007),shadow.cljs.devtools.client.env.worker_client_id,new cljs.core.Keyword(null,"sources","sources",-321166424),cljs.core.into.cljs$core$IFn$_invoke$arity$3(cljs.core.PersistentVector.EMPTY,cljs.core.map.cljs$core$IFn$_invoke$arity$1(new cljs.core.Keyword(null,"resource-id","resource-id",-1308422582)),sources_to_load)], null),new cljs.core.PersistentArrayMap(null, 1, [new cljs.core.Keyword(null,"cljs-sources","cljs-sources",31121610),(function (p__41001){
var map__41002 = p__41001;
var map__41002__$1 = cljs.core.__destructure_map(map__41002);
var msg__$1 = map__41002__$1;
var sources__$1 = cljs.core.get.cljs$core$IFn$_invoke$arity$2(map__41002__$1,new cljs.core.Keyword(null,"sources","sources",-321166424));
try{shadow.cljs.devtools.client.browser.do_js_load(sources__$1);

if(cljs.core.seq(js_requires)){
shadow.cljs.devtools.client.browser.do_js_requires(js_requires);
} else {
}

return (done.cljs$core$IFn$_invoke$arity$1 ? done.cljs$core$IFn$_invoke$arity$1(sources_to_load) : done.call(null,sources_to_load));
}catch (e41003){var ex = e41003;
return (error.cljs$core$IFn$_invoke$arity$1 ? error.cljs$core$IFn$_invoke$arity$1(ex) : error.call(null,ex));
}})], null));
}
}));

shadow.cljs.devtools.client.shared.add_plugin_BANG_(new cljs.core.Keyword("shadow.cljs.devtools.client.browser","client","shadow.cljs.devtools.client.browser/client",-1461019282),cljs.core.PersistentHashSet.EMPTY,(function (p__41004){
var map__41005 = p__41004;
var map__41005__$1 = cljs.core.__destructure_map(map__41005);
var env = map__41005__$1;
var runtime = cljs.core.get.cljs$core$IFn$_invoke$arity$2(map__41005__$1,new cljs.core.Keyword(null,"runtime","runtime",-1331573996));
var svc = new cljs.core.PersistentArrayMap(null, 1, [new cljs.core.Keyword(null,"runtime","runtime",-1331573996),runtime], null);
shadow.remote.runtime.api.add_extension(runtime,new cljs.core.Keyword("shadow.cljs.devtools.client.browser","client","shadow.cljs.devtools.client.browser/client",-1461019282),new cljs.core.PersistentArrayMap(null, 4, [new cljs.core.Keyword(null,"on-welcome","on-welcome",1895317125),(function (){
cljs.core.reset_BANG_(shadow.cljs.devtools.client.browser.ws_was_welcome_ref,true);

shadow.cljs.devtools.client.hud.connection_error_clear_BANG_();

shadow.cljs.devtools.client.env.patch_goog_BANG_();

return shadow.cljs.devtools.client.browser.devtools_msg(["#",cljs.core.str.cljs$core$IFn$_invoke$arity$1(new cljs.core.Keyword(null,"client-id","client-id",-464622140).cljs$core$IFn$_invoke$arity$1(cljs.core.deref(new cljs.core.Keyword(null,"state-ref","state-ref",2127874952).cljs$core$IFn$_invoke$arity$1(runtime))))," ready!"].join(''));
}),new cljs.core.Keyword(null,"on-disconnect","on-disconnect",-809021814),(function (e){
if(cljs.core.truth_(cljs.core.deref(shadow.cljs.devtools.client.browser.ws_was_welcome_ref))){
shadow.cljs.devtools.client.hud.connection_error("The Websocket connection was closed!");

return cljs.core.reset_BANG_(shadow.cljs.devtools.client.browser.ws_was_welcome_ref,false);
} else {
return null;
}
}),new cljs.core.Keyword(null,"on-reconnect","on-reconnect",1239988702),(function (e){
return shadow.cljs.devtools.client.hud.connection_error("Reconnecting ...");
}),new cljs.core.Keyword(null,"ops","ops",1237330063),new cljs.core.PersistentArrayMap(null, 7, [new cljs.core.Keyword(null,"access-denied","access-denied",959449406),(function (msg){
cljs.core.reset_BANG_(shadow.cljs.devtools.client.browser.ws_was_welcome_ref,false);

return shadow.cljs.devtools.client.hud.connection_error(["Stale Output! Your loaded JS was not produced by the running shadow-cljs instance."," Is the watch for this build running?"].join(''));
}),new cljs.core.Keyword(null,"cljs-asset-update","cljs-asset-update",1224093028),(function (msg){
return shadow.cljs.devtools.client.browser.handle_asset_update(msg);
}),new cljs.core.Keyword(null,"cljs-build-configure","cljs-build-configure",-2089891268),(function (msg){
return null;
}),new cljs.core.Keyword(null,"cljs-build-start","cljs-build-start",-725781241),(function (msg){
shadow.cljs.devtools.client.hud.hud_hide();

shadow.cljs.devtools.client.hud.load_start();

return shadow.cljs.devtools.client.env.run_custom_notify_BANG_(cljs.core.assoc.cljs$core$IFn$_invoke$arity$3(msg,new cljs.core.Keyword(null,"type","type",1174270348),new cljs.core.Keyword(null,"build-start","build-start",-959649480)));
}),new cljs.core.Keyword(null,"cljs-build-complete","cljs-build-complete",273626153),(function (msg){
var msg__$1 = shadow.cljs.devtools.client.env.add_warnings_to_info(msg);
shadow.cljs.devtools.client.hud.connection_error_clear_BANG_();

shadow.cljs.devtools.client.hud.hud_warnings(msg__$1);

shadow.cljs.devtools.client.browser.handle_build_complete(runtime,msg__$1);

return shadow.cljs.devtools.client.env.run_custom_notify_BANG_(cljs.core.assoc.cljs$core$IFn$_invoke$arity$3(msg__$1,new cljs.core.Keyword(null,"type","type",1174270348),new cljs.core.Keyword(null,"build-complete","build-complete",-501868472)));
}),new cljs.core.Keyword(null,"cljs-build-failure","cljs-build-failure",1718154990),(function (msg){
shadow.cljs.devtools.client.hud.load_end();

shadow.cljs.devtools.client.hud.hud_error(msg);

return shadow.cljs.devtools.client.env.run_custom_notify_BANG_(cljs.core.assoc.cljs$core$IFn$_invoke$arity$3(msg,new cljs.core.Keyword(null,"type","type",1174270348),new cljs.core.Keyword(null,"build-failure","build-failure",-2107487466)));
}),new cljs.core.Keyword("shadow.cljs.devtools.client.env","worker-notify","shadow.cljs.devtools.client.env/worker-notify",-1456820670),(function (p__41006){
var map__41007 = p__41006;
var map__41007__$1 = cljs.core.__destructure_map(map__41007);
var event_op = cljs.core.get.cljs$core$IFn$_invoke$arity$2(map__41007__$1,new cljs.core.Keyword(null,"event-op","event-op",200358057));
var client_id = cljs.core.get.cljs$core$IFn$_invoke$arity$2(map__41007__$1,new cljs.core.Keyword(null,"client-id","client-id",-464622140));
if(((cljs.core._EQ_.cljs$core$IFn$_invoke$arity$2(new cljs.core.Keyword(null,"client-disconnect","client-disconnect",640227957),event_op)) && (cljs.core._EQ_.cljs$core$IFn$_invoke$arity$2(client_id,shadow.cljs.devtools.client.env.worker_client_id)))){
shadow.cljs.devtools.client.hud.connection_error_clear_BANG_();

return shadow.cljs.devtools.client.hud.connection_error("The watch for this build was stopped!");
} else {
if(cljs.core._EQ_.cljs$core$IFn$_invoke$arity$2(new cljs.core.Keyword(null,"client-connect","client-connect",-1113973888),event_op)){
shadow.cljs.devtools.client.hud.connection_error_clear_BANG_();

return shadow.cljs.devtools.client.hud.connection_error("The watch for this build was restarted. Reload required!");
} else {
return null;
}
}
})], null)], null));

return svc;
}),(function (p__41008){
var map__41009 = p__41008;
var map__41009__$1 = cljs.core.__destructure_map(map__41009);
var svc = map__41009__$1;
var runtime = cljs.core.get.cljs$core$IFn$_invoke$arity$2(map__41009__$1,new cljs.core.Keyword(null,"runtime","runtime",-1331573996));
return shadow.remote.runtime.api.del_extension(runtime,new cljs.core.Keyword("shadow.cljs.devtools.client.browser","client","shadow.cljs.devtools.client.browser/client",-1461019282));
}));

shadow.cljs.devtools.client.shared.init_runtime_BANG_(shadow.cljs.devtools.client.browser.client_info,shadow.cljs.devtools.client.websocket.start,shadow.cljs.devtools.client.websocket.send,shadow.cljs.devtools.client.websocket.stop);
} else {
}

//# sourceMappingURL=shadow.cljs.devtools.client.browser.js.map
