import "./cljs_env.js";
import "./cljs.core.js";
import "./shadow.remote.runtime.api.js";
import "./shadow.remote.runtime.shared.js";
import "./shadow.remote.runtime.obj_support.js";
goog.provide('shadow.remote.runtime.tap_support');
shadow.remote.runtime.tap_support.tap_subscribe = (function shadow$remote$runtime$tap_support$tap_subscribe(p__40488,p__40489){
var map__40490 = p__40488;
var map__40490__$1 = cljs.core.__destructure_map(map__40490);
var svc = map__40490__$1;
var subs_ref = cljs.core.get.cljs$core$IFn$_invoke$arity$2(map__40490__$1,new cljs.core.Keyword(null,"subs-ref","subs-ref",-1355989911));
var obj_support = cljs.core.get.cljs$core$IFn$_invoke$arity$2(map__40490__$1,new cljs.core.Keyword(null,"obj-support","obj-support",1522559229));
var runtime = cljs.core.get.cljs$core$IFn$_invoke$arity$2(map__40490__$1,new cljs.core.Keyword(null,"runtime","runtime",-1331573996));
var map__40491 = p__40489;
var map__40491__$1 = cljs.core.__destructure_map(map__40491);
var msg = map__40491__$1;
var from = cljs.core.get.cljs$core$IFn$_invoke$arity$2(map__40491__$1,new cljs.core.Keyword(null,"from","from",1815293044));
var summary = cljs.core.get.cljs$core$IFn$_invoke$arity$2(map__40491__$1,new cljs.core.Keyword(null,"summary","summary",380847952));
var history__$1 = cljs.core.get.cljs$core$IFn$_invoke$arity$2(map__40491__$1,new cljs.core.Keyword(null,"history","history",-247395220));
var num = cljs.core.get.cljs$core$IFn$_invoke$arity$3(map__40491__$1,new cljs.core.Keyword(null,"num","num",1985240673),(10));
cljs.core.swap_BANG_.cljs$core$IFn$_invoke$arity$4(subs_ref,cljs.core.assoc,from,msg);

if(cljs.core.truth_(history__$1)){
return shadow.remote.runtime.shared.reply(runtime,msg,new cljs.core.PersistentArrayMap(null, 2, [new cljs.core.Keyword(null,"op","op",-1882987955),new cljs.core.Keyword(null,"tap-subscribed","tap-subscribed",-1882247432),new cljs.core.Keyword(null,"history","history",-247395220),cljs.core.into.cljs$core$IFn$_invoke$arity$2(cljs.core.PersistentVector.EMPTY,cljs.core.map.cljs$core$IFn$_invoke$arity$2((function (oid){
return new cljs.core.PersistentArrayMap(null, 2, [new cljs.core.Keyword(null,"oid","oid",-768692334),oid,new cljs.core.Keyword(null,"summary","summary",380847952),shadow.remote.runtime.obj_support.obj_describe_STAR_(obj_support,oid)], null);
}),shadow.remote.runtime.obj_support.get_tap_history(obj_support,num)))], null));
} else {
return null;
}
});
shadow.remote.runtime.tap_support.tap_unsubscribe = (function shadow$remote$runtime$tap_support$tap_unsubscribe(p__40492,p__40493){
var map__40494 = p__40492;
var map__40494__$1 = cljs.core.__destructure_map(map__40494);
var subs_ref = cljs.core.get.cljs$core$IFn$_invoke$arity$2(map__40494__$1,new cljs.core.Keyword(null,"subs-ref","subs-ref",-1355989911));
var map__40495 = p__40493;
var map__40495__$1 = cljs.core.__destructure_map(map__40495);
var from = cljs.core.get.cljs$core$IFn$_invoke$arity$2(map__40495__$1,new cljs.core.Keyword(null,"from","from",1815293044));
return cljs.core.swap_BANG_.cljs$core$IFn$_invoke$arity$3(subs_ref,cljs.core.dissoc,from);
});
shadow.remote.runtime.tap_support.request_tap_history = (function shadow$remote$runtime$tap_support$request_tap_history(p__40501,p__40502){
var map__40503 = p__40501;
var map__40503__$1 = cljs.core.__destructure_map(map__40503);
var obj_support = cljs.core.get.cljs$core$IFn$_invoke$arity$2(map__40503__$1,new cljs.core.Keyword(null,"obj-support","obj-support",1522559229));
var runtime = cljs.core.get.cljs$core$IFn$_invoke$arity$2(map__40503__$1,new cljs.core.Keyword(null,"runtime","runtime",-1331573996));
var map__40504 = p__40502;
var map__40504__$1 = cljs.core.__destructure_map(map__40504);
var msg = map__40504__$1;
var num = cljs.core.get.cljs$core$IFn$_invoke$arity$3(map__40504__$1,new cljs.core.Keyword(null,"num","num",1985240673),(10));
var tap_ids = shadow.remote.runtime.obj_support.get_tap_history(obj_support,num);
return shadow.remote.runtime.shared.reply(runtime,msg,new cljs.core.PersistentArrayMap(null, 2, [new cljs.core.Keyword(null,"op","op",-1882987955),new cljs.core.Keyword(null,"tap-history","tap-history",-282803347),new cljs.core.Keyword(null,"oids","oids",-1580877688),tap_ids], null));
});
shadow.remote.runtime.tap_support.tool_disconnect = (function shadow$remote$runtime$tap_support$tool_disconnect(p__40508,tid){
var map__40509 = p__40508;
var map__40509__$1 = cljs.core.__destructure_map(map__40509);
var svc = map__40509__$1;
var subs_ref = cljs.core.get.cljs$core$IFn$_invoke$arity$2(map__40509__$1,new cljs.core.Keyword(null,"subs-ref","subs-ref",-1355989911));
return cljs.core.swap_BANG_.cljs$core$IFn$_invoke$arity$3(subs_ref,cljs.core.dissoc,tid);
});
shadow.remote.runtime.tap_support.start = (function shadow$remote$runtime$tap_support$start(runtime,obj_support){
var subs_ref = cljs.core.atom.cljs$core$IFn$_invoke$arity$1(cljs.core.PersistentArrayMap.EMPTY);
var tap_fn = (function shadow$remote$runtime$tap_support$start_$_runtime_tap(obj){
if((!((obj == null)))){
var oid = shadow.remote.runtime.obj_support.register(obj_support,obj,new cljs.core.PersistentArrayMap(null, 1, [new cljs.core.Keyword(null,"from","from",1815293044),new cljs.core.Keyword(null,"tap","tap",-1086702463)], null));
var seq__40518 = cljs.core.seq(cljs.core.deref(subs_ref));
var chunk__40519 = null;
var count__40520 = (0);
var i__40521 = (0);
while(true){
if((i__40521 < count__40520)){
var vec__40533 = chunk__40519.cljs$core$IIndexed$_nth$arity$2(null,i__40521);
var tid = cljs.core.nth.cljs$core$IFn$_invoke$arity$3(vec__40533,(0),null);
var tap_config = cljs.core.nth.cljs$core$IFn$_invoke$arity$3(vec__40533,(1),null);
shadow.remote.runtime.api.relay_msg(runtime,new cljs.core.PersistentArrayMap(null, 3, [new cljs.core.Keyword(null,"op","op",-1882987955),new cljs.core.Keyword(null,"tap","tap",-1086702463),new cljs.core.Keyword(null,"to","to",192099007),tid,new cljs.core.Keyword(null,"oid","oid",-768692334),oid], null));


var G__40546 = seq__40518;
var G__40547 = chunk__40519;
var G__40548 = count__40520;
var G__40549 = (i__40521 + (1));
seq__40518 = G__40546;
chunk__40519 = G__40547;
count__40520 = G__40548;
i__40521 = G__40549;
continue;
} else {
var temp__5804__auto__ = cljs.core.seq(seq__40518);
if(temp__5804__auto__){
var seq__40518__$1 = temp__5804__auto__;
if(cljs.core.chunked_seq_QMARK_(seq__40518__$1)){
var c__5568__auto__ = cljs.core.chunk_first(seq__40518__$1);
var G__40550 = cljs.core.chunk_rest(seq__40518__$1);
var G__40551 = c__5568__auto__;
var G__40552 = cljs.core.count(c__5568__auto__);
var G__40553 = (0);
seq__40518 = G__40550;
chunk__40519 = G__40551;
count__40520 = G__40552;
i__40521 = G__40553;
continue;
} else {
var vec__40538 = cljs.core.first(seq__40518__$1);
var tid = cljs.core.nth.cljs$core$IFn$_invoke$arity$3(vec__40538,(0),null);
var tap_config = cljs.core.nth.cljs$core$IFn$_invoke$arity$3(vec__40538,(1),null);
shadow.remote.runtime.api.relay_msg(runtime,new cljs.core.PersistentArrayMap(null, 3, [new cljs.core.Keyword(null,"op","op",-1882987955),new cljs.core.Keyword(null,"tap","tap",-1086702463),new cljs.core.Keyword(null,"to","to",192099007),tid,new cljs.core.Keyword(null,"oid","oid",-768692334),oid], null));


var G__40554 = cljs.core.next(seq__40518__$1);
var G__40555 = null;
var G__40556 = (0);
var G__40557 = (0);
seq__40518 = G__40554;
chunk__40519 = G__40555;
count__40520 = G__40556;
i__40521 = G__40557;
continue;
}
} else {
return null;
}
}
break;
}
} else {
return null;
}
});
var svc = new cljs.core.PersistentArrayMap(null, 4, [new cljs.core.Keyword(null,"runtime","runtime",-1331573996),runtime,new cljs.core.Keyword(null,"obj-support","obj-support",1522559229),obj_support,new cljs.core.Keyword(null,"tap-fn","tap-fn",1573556461),tap_fn,new cljs.core.Keyword(null,"subs-ref","subs-ref",-1355989911),subs_ref], null);
shadow.remote.runtime.api.add_extension(runtime,new cljs.core.Keyword("shadow.remote.runtime.tap-support","ext","shadow.remote.runtime.tap-support/ext",1019069674),new cljs.core.PersistentArrayMap(null, 2, [new cljs.core.Keyword(null,"ops","ops",1237330063),new cljs.core.PersistentArrayMap(null, 3, [new cljs.core.Keyword(null,"tap-subscribe","tap-subscribe",411179050),(function (p1__40512_SHARP_){
return shadow.remote.runtime.tap_support.tap_subscribe(svc,p1__40512_SHARP_);
}),new cljs.core.Keyword(null,"tap-unsubscribe","tap-unsubscribe",1183890755),(function (p1__40513_SHARP_){
return shadow.remote.runtime.tap_support.tap_unsubscribe(svc,p1__40513_SHARP_);
}),new cljs.core.Keyword(null,"request-tap-history","request-tap-history",-670837812),(function (p1__40514_SHARP_){
return shadow.remote.runtime.tap_support.request_tap_history(svc,p1__40514_SHARP_);
})], null),new cljs.core.Keyword(null,"on-tool-disconnect","on-tool-disconnect",693464366),(function (p1__40515_SHARP_){
return shadow.remote.runtime.tap_support.tool_disconnect(svc,p1__40515_SHARP_);
})], null));

cljs.core.add_tap(tap_fn);

return svc;
});
shadow.remote.runtime.tap_support.stop = (function shadow$remote$runtime$tap_support$stop(p__40541){
var map__40542 = p__40541;
var map__40542__$1 = cljs.core.__destructure_map(map__40542);
var svc = map__40542__$1;
var tap_fn = cljs.core.get.cljs$core$IFn$_invoke$arity$2(map__40542__$1,new cljs.core.Keyword(null,"tap-fn","tap-fn",1573556461));
var runtime = cljs.core.get.cljs$core$IFn$_invoke$arity$2(map__40542__$1,new cljs.core.Keyword(null,"runtime","runtime",-1331573996));
cljs.core.remove_tap(tap_fn);

return shadow.remote.runtime.api.del_extension(runtime,new cljs.core.Keyword("shadow.remote.runtime.tap-support","ext","shadow.remote.runtime.tap-support/ext",1019069674));
});

//# sourceMappingURL=shadow.remote.runtime.tap_support.js.map
