import "./cljs_env.js";
import "./cljs.core.js";
import "./cljs.core.async.impl.protocols.js";
import "./cljs.core.async.impl.channels.js";
import "./cljs.core.async.impl.buffers.js";
import "./cljs.core.async.impl.timers.js";
import "./cljs.core.async.impl.dispatch.js";
import "./cljs.core.async.impl.ioc_helpers.js";
import "./goog.array.array.js";
goog.provide('cljs.core.async');
goog.scope(function(){
  cljs.core.async.goog$module$goog$array = goog.module.get('goog.array');
});

/**
* @constructor
 * @implements {cljs.core.async.impl.protocols.Handler}
 * @implements {cljs.core.IMeta}
 * @implements {cljs.core.IWithMeta}
*/
cljs.core.async.t_cljs$core$async33480 = (function (f,blockable,meta33481){
this.f = f;
this.blockable = blockable;
this.meta33481 = meta33481;
this.cljs$lang$protocol_mask$partition0$ = 393216;
this.cljs$lang$protocol_mask$partition1$ = 0;
});
(cljs.core.async.t_cljs$core$async33480.prototype.cljs$core$IWithMeta$_with_meta$arity$2 = (function (_33482,meta33481__$1){
var self__ = this;
var _33482__$1 = this;
return (new cljs.core.async.t_cljs$core$async33480(self__.f,self__.blockable,meta33481__$1));
}));

(cljs.core.async.t_cljs$core$async33480.prototype.cljs$core$IMeta$_meta$arity$1 = (function (_33482){
var self__ = this;
var _33482__$1 = this;
return self__.meta33481;
}));

(cljs.core.async.t_cljs$core$async33480.prototype.cljs$core$async$impl$protocols$Handler$ = cljs.core.PROTOCOL_SENTINEL);

(cljs.core.async.t_cljs$core$async33480.prototype.cljs$core$async$impl$protocols$Handler$active_QMARK_$arity$1 = (function (_){
var self__ = this;
var ___$1 = this;
return true;
}));

(cljs.core.async.t_cljs$core$async33480.prototype.cljs$core$async$impl$protocols$Handler$blockable_QMARK_$arity$1 = (function (_){
var self__ = this;
var ___$1 = this;
return self__.blockable;
}));

(cljs.core.async.t_cljs$core$async33480.prototype.cljs$core$async$impl$protocols$Handler$commit$arity$1 = (function (_){
var self__ = this;
var ___$1 = this;
return self__.f;
}));

(cljs.core.async.t_cljs$core$async33480.getBasis = (function (){
return new cljs.core.PersistentVector(null, 3, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Symbol(null,"f","f",43394975,null),new cljs.core.Symbol(null,"blockable","blockable",-28395259,null),new cljs.core.Symbol(null,"meta33481","meta33481",1909387096,null)], null);
}));

(cljs.core.async.t_cljs$core$async33480.cljs$lang$type = true);

(cljs.core.async.t_cljs$core$async33480.cljs$lang$ctorStr = "cljs.core.async/t_cljs$core$async33480");

(cljs.core.async.t_cljs$core$async33480.cljs$lang$ctorPrWriter = (function (this__5330__auto__,writer__5331__auto__,opt__5332__auto__){
return cljs.core._write(writer__5331__auto__,"cljs.core.async/t_cljs$core$async33480");
}));

/**
 * Positional factory function for cljs.core.async/t_cljs$core$async33480.
 */
cljs.core.async.__GT_t_cljs$core$async33480 = (function cljs$core$async$__GT_t_cljs$core$async33480(f,blockable,meta33481){
return (new cljs.core.async.t_cljs$core$async33480(f,blockable,meta33481));
});


cljs.core.async.fn_handler = (function cljs$core$async$fn_handler(var_args){
var G__33461 = arguments.length;
switch (G__33461) {
case 1:
return cljs.core.async.fn_handler.cljs$core$IFn$_invoke$arity$1((arguments[(0)]));

break;
case 2:
return cljs.core.async.fn_handler.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
default:
throw (new Error(["Invalid arity: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(arguments.length)].join('')));

}
});

(cljs.core.async.fn_handler.cljs$core$IFn$_invoke$arity$1 = (function (f){
return cljs.core.async.fn_handler.cljs$core$IFn$_invoke$arity$2(f,true);
}));

(cljs.core.async.fn_handler.cljs$core$IFn$_invoke$arity$2 = (function (f,blockable){
return (new cljs.core.async.t_cljs$core$async33480(f,blockable,cljs.core.PersistentArrayMap.EMPTY));
}));

(cljs.core.async.fn_handler.cljs$lang$maxFixedArity = 2);

/**
 * Returns a fixed buffer of size n. When full, puts will block/park.
 */
cljs.core.async.buffer = (function cljs$core$async$buffer(n){
return cljs.core.async.impl.buffers.fixed_buffer(n);
});
/**
 * Returns a buffer of size n. When full, puts will complete but
 *   val will be dropped (no transfer).
 */
cljs.core.async.dropping_buffer = (function cljs$core$async$dropping_buffer(n){
return cljs.core.async.impl.buffers.dropping_buffer(n);
});
/**
 * Returns a buffer of size n. When full, puts will complete, and be
 *   buffered, but oldest elements in buffer will be dropped (not
 *   transferred).
 */
cljs.core.async.sliding_buffer = (function cljs$core$async$sliding_buffer(n){
return cljs.core.async.impl.buffers.sliding_buffer(n);
});
/**
 * Returns true if a channel created with buff will never block. That is to say,
 * puts into this buffer will never cause the buffer to be full. 
 */
cljs.core.async.unblocking_buffer_QMARK_ = (function cljs$core$async$unblocking_buffer_QMARK_(buff){
if((!((buff == null)))){
if(((false) || ((cljs.core.PROTOCOL_SENTINEL === buff.cljs$core$async$impl$protocols$UnblockingBuffer$)))){
return true;
} else {
if((!buff.cljs$lang$protocol_mask$partition$)){
return cljs.core.native_satisfies_QMARK_(cljs.core.async.impl.protocols.UnblockingBuffer,buff);
} else {
return false;
}
}
} else {
return cljs.core.native_satisfies_QMARK_(cljs.core.async.impl.protocols.UnblockingBuffer,buff);
}
});
/**
 * Creates a channel with an optional buffer, an optional transducer (like (map f),
 *   (filter p) etc or a composition thereof), and an optional exception handler.
 *   If buf-or-n is a number, will create and use a fixed buffer of that size. If a
 *   transducer is supplied a buffer must be specified. ex-handler must be a
 *   fn of one argument - if an exception occurs during transformation it will be called
 *   with the thrown value as an argument, and any non-nil return value will be placed
 *   in the channel.
 */
cljs.core.async.chan = (function cljs$core$async$chan(var_args){
var G__33526 = arguments.length;
switch (G__33526) {
case 0:
return cljs.core.async.chan.cljs$core$IFn$_invoke$arity$0();

break;
case 1:
return cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1((arguments[(0)]));

break;
case 2:
return cljs.core.async.chan.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
case 3:
return cljs.core.async.chan.cljs$core$IFn$_invoke$arity$3((arguments[(0)]),(arguments[(1)]),(arguments[(2)]));

break;
default:
throw (new Error(["Invalid arity: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(arguments.length)].join('')));

}
});

(cljs.core.async.chan.cljs$core$IFn$_invoke$arity$0 = (function (){
return cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1(null);
}));

(cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1 = (function (buf_or_n){
return cljs.core.async.chan.cljs$core$IFn$_invoke$arity$3(buf_or_n,null,null);
}));

(cljs.core.async.chan.cljs$core$IFn$_invoke$arity$2 = (function (buf_or_n,xform){
return cljs.core.async.chan.cljs$core$IFn$_invoke$arity$3(buf_or_n,xform,null);
}));

(cljs.core.async.chan.cljs$core$IFn$_invoke$arity$3 = (function (buf_or_n,xform,ex_handler){
var buf_or_n__$1 = ((cljs.core._EQ_.cljs$core$IFn$_invoke$arity$2(buf_or_n,(0)))?null:buf_or_n);
if(cljs.core.truth_(xform)){
if(cljs.core.truth_(buf_or_n__$1)){
} else {
throw (new Error(["Assert failed: ","buffer must be supplied when transducer is","\n","buf-or-n"].join('')));
}
} else {
}

return cljs.core.async.impl.channels.chan.cljs$core$IFn$_invoke$arity$3(((typeof buf_or_n__$1 === 'number')?cljs.core.async.buffer(buf_or_n__$1):buf_or_n__$1),xform,ex_handler);
}));

(cljs.core.async.chan.cljs$lang$maxFixedArity = 3);

/**
 * Creates a promise channel with an optional transducer, and an optional
 *   exception-handler. A promise channel can take exactly one value that consumers
 *   will receive. Once full, puts complete but val is dropped (no transfer).
 *   Consumers will block until either a value is placed in the channel or the
 *   channel is closed. See chan for the semantics of xform and ex-handler.
 */
cljs.core.async.promise_chan = (function cljs$core$async$promise_chan(var_args){
var G__33542 = arguments.length;
switch (G__33542) {
case 0:
return cljs.core.async.promise_chan.cljs$core$IFn$_invoke$arity$0();

break;
case 1:
return cljs.core.async.promise_chan.cljs$core$IFn$_invoke$arity$1((arguments[(0)]));

break;
case 2:
return cljs.core.async.promise_chan.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
default:
throw (new Error(["Invalid arity: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(arguments.length)].join('')));

}
});

(cljs.core.async.promise_chan.cljs$core$IFn$_invoke$arity$0 = (function (){
return cljs.core.async.promise_chan.cljs$core$IFn$_invoke$arity$1(null);
}));

(cljs.core.async.promise_chan.cljs$core$IFn$_invoke$arity$1 = (function (xform){
return cljs.core.async.promise_chan.cljs$core$IFn$_invoke$arity$2(xform,null);
}));

(cljs.core.async.promise_chan.cljs$core$IFn$_invoke$arity$2 = (function (xform,ex_handler){
return cljs.core.async.chan.cljs$core$IFn$_invoke$arity$3(cljs.core.async.impl.buffers.promise_buffer(),xform,ex_handler);
}));

(cljs.core.async.promise_chan.cljs$lang$maxFixedArity = 2);

/**
 * Returns a channel that will close after msecs
 */
cljs.core.async.timeout = (function cljs$core$async$timeout(msecs){
return cljs.core.async.impl.timers.timeout(msecs);
});
/**
 * takes a val from port. Must be called inside a (go ...) block. Will
 *   return nil if closed. Will park if nothing is available.
 *   Returns true unless port is already closed
 */
cljs.core.async._LT__BANG_ = (function cljs$core$async$_LT__BANG_(port){
throw (new Error("<! used not in (go ...) block"));
});
/**
 * Asynchronously takes a val from port, passing to fn1. Will pass nil
 * if closed. If on-caller? (default true) is true, and value is
 * immediately available, will call fn1 on calling thread.
 * Returns nil.
 */
cljs.core.async.take_BANG_ = (function cljs$core$async$take_BANG_(var_args){
var G__33563 = arguments.length;
switch (G__33563) {
case 2:
return cljs.core.async.take_BANG_.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
case 3:
return cljs.core.async.take_BANG_.cljs$core$IFn$_invoke$arity$3((arguments[(0)]),(arguments[(1)]),(arguments[(2)]));

break;
default:
throw (new Error(["Invalid arity: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(arguments.length)].join('')));

}
});

(cljs.core.async.take_BANG_.cljs$core$IFn$_invoke$arity$2 = (function (port,fn1){
return cljs.core.async.take_BANG_.cljs$core$IFn$_invoke$arity$3(port,fn1,true);
}));

(cljs.core.async.take_BANG_.cljs$core$IFn$_invoke$arity$3 = (function (port,fn1,on_caller_QMARK_){
var ret = cljs.core.async.impl.protocols.take_BANG_(port,cljs.core.async.fn_handler.cljs$core$IFn$_invoke$arity$1(fn1));
if(cljs.core.truth_(ret)){
var val_36415 = cljs.core.deref(ret);
if(cljs.core.truth_(on_caller_QMARK_)){
(fn1.cljs$core$IFn$_invoke$arity$1 ? fn1.cljs$core$IFn$_invoke$arity$1(val_36415) : fn1.call(null,val_36415));
} else {
cljs.core.async.impl.dispatch.run((function (){
return (fn1.cljs$core$IFn$_invoke$arity$1 ? fn1.cljs$core$IFn$_invoke$arity$1(val_36415) : fn1.call(null,val_36415));
}));
}
} else {
}

return null;
}));

(cljs.core.async.take_BANG_.cljs$lang$maxFixedArity = 3);

cljs.core.async.nop = (function cljs$core$async$nop(_){
return null;
});
cljs.core.async.fhnop = cljs.core.async.fn_handler.cljs$core$IFn$_invoke$arity$1(cljs.core.async.nop);
/**
 * puts a val into port. nil values are not allowed. Must be called
 *   inside a (go ...) block. Will park if no buffer space is available.
 *   Returns true unless port is already closed.
 */
cljs.core.async._GT__BANG_ = (function cljs$core$async$_GT__BANG_(port,val){
throw (new Error(">! used not in (go ...) block"));
});
/**
 * Asynchronously puts a val into port, calling fn1 (if supplied) when
 * complete. nil values are not allowed. Will throw if closed. If
 * on-caller? (default true) is true, and the put is immediately
 * accepted, will call fn1 on calling thread.  Returns nil.
 */
cljs.core.async.put_BANG_ = (function cljs$core$async$put_BANG_(var_args){
var G__33578 = arguments.length;
switch (G__33578) {
case 2:
return cljs.core.async.put_BANG_.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
case 3:
return cljs.core.async.put_BANG_.cljs$core$IFn$_invoke$arity$3((arguments[(0)]),(arguments[(1)]),(arguments[(2)]));

break;
case 4:
return cljs.core.async.put_BANG_.cljs$core$IFn$_invoke$arity$4((arguments[(0)]),(arguments[(1)]),(arguments[(2)]),(arguments[(3)]));

break;
default:
throw (new Error(["Invalid arity: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(arguments.length)].join('')));

}
});

(cljs.core.async.put_BANG_.cljs$core$IFn$_invoke$arity$2 = (function (port,val){
var temp__5802__auto__ = cljs.core.async.impl.protocols.put_BANG_(port,val,cljs.core.async.fhnop);
if(cljs.core.truth_(temp__5802__auto__)){
var ret = temp__5802__auto__;
return cljs.core.deref(ret);
} else {
return true;
}
}));

(cljs.core.async.put_BANG_.cljs$core$IFn$_invoke$arity$3 = (function (port,val,fn1){
return cljs.core.async.put_BANG_.cljs$core$IFn$_invoke$arity$4(port,val,fn1,true);
}));

(cljs.core.async.put_BANG_.cljs$core$IFn$_invoke$arity$4 = (function (port,val,fn1,on_caller_QMARK_){
var temp__5802__auto__ = cljs.core.async.impl.protocols.put_BANG_(port,val,cljs.core.async.fn_handler.cljs$core$IFn$_invoke$arity$1(fn1));
if(cljs.core.truth_(temp__5802__auto__)){
var retb = temp__5802__auto__;
var ret = cljs.core.deref(retb);
if(cljs.core.truth_(on_caller_QMARK_)){
(fn1.cljs$core$IFn$_invoke$arity$1 ? fn1.cljs$core$IFn$_invoke$arity$1(ret) : fn1.call(null,ret));
} else {
cljs.core.async.impl.dispatch.run((function (){
return (fn1.cljs$core$IFn$_invoke$arity$1 ? fn1.cljs$core$IFn$_invoke$arity$1(ret) : fn1.call(null,ret));
}));
}

return ret;
} else {
return true;
}
}));

(cljs.core.async.put_BANG_.cljs$lang$maxFixedArity = 4);

cljs.core.async.close_BANG_ = (function cljs$core$async$close_BANG_(port){
return cljs.core.async.impl.protocols.close_BANG_(port);
});
cljs.core.async.random_array = (function cljs$core$async$random_array(n){
var a = (new Array(n));
var n__5636__auto___36425 = n;
var x_36426 = (0);
while(true){
if((x_36426 < n__5636__auto___36425)){
(a[x_36426] = x_36426);

var G__36427 = (x_36426 + (1));
x_36426 = G__36427;
continue;
} else {
}
break;
}

cljs.core.async.goog$module$goog$array.shuffle(a);

return a;
});

/**
* @constructor
 * @implements {cljs.core.async.impl.protocols.Handler}
 * @implements {cljs.core.IMeta}
 * @implements {cljs.core.IWithMeta}
*/
cljs.core.async.t_cljs$core$async33621 = (function (flag,meta33622){
this.flag = flag;
this.meta33622 = meta33622;
this.cljs$lang$protocol_mask$partition0$ = 393216;
this.cljs$lang$protocol_mask$partition1$ = 0;
});
(cljs.core.async.t_cljs$core$async33621.prototype.cljs$core$IWithMeta$_with_meta$arity$2 = (function (_33623,meta33622__$1){
var self__ = this;
var _33623__$1 = this;
return (new cljs.core.async.t_cljs$core$async33621(self__.flag,meta33622__$1));
}));

(cljs.core.async.t_cljs$core$async33621.prototype.cljs$core$IMeta$_meta$arity$1 = (function (_33623){
var self__ = this;
var _33623__$1 = this;
return self__.meta33622;
}));

(cljs.core.async.t_cljs$core$async33621.prototype.cljs$core$async$impl$protocols$Handler$ = cljs.core.PROTOCOL_SENTINEL);

(cljs.core.async.t_cljs$core$async33621.prototype.cljs$core$async$impl$protocols$Handler$active_QMARK_$arity$1 = (function (_){
var self__ = this;
var ___$1 = this;
return cljs.core.deref(self__.flag);
}));

(cljs.core.async.t_cljs$core$async33621.prototype.cljs$core$async$impl$protocols$Handler$blockable_QMARK_$arity$1 = (function (_){
var self__ = this;
var ___$1 = this;
return true;
}));

(cljs.core.async.t_cljs$core$async33621.prototype.cljs$core$async$impl$protocols$Handler$commit$arity$1 = (function (_){
var self__ = this;
var ___$1 = this;
cljs.core.reset_BANG_(self__.flag,null);

return true;
}));

(cljs.core.async.t_cljs$core$async33621.getBasis = (function (){
return new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Symbol(null,"flag","flag",-1565787888,null),new cljs.core.Symbol(null,"meta33622","meta33622",953146531,null)], null);
}));

(cljs.core.async.t_cljs$core$async33621.cljs$lang$type = true);

(cljs.core.async.t_cljs$core$async33621.cljs$lang$ctorStr = "cljs.core.async/t_cljs$core$async33621");

(cljs.core.async.t_cljs$core$async33621.cljs$lang$ctorPrWriter = (function (this__5330__auto__,writer__5331__auto__,opt__5332__auto__){
return cljs.core._write(writer__5331__auto__,"cljs.core.async/t_cljs$core$async33621");
}));

/**
 * Positional factory function for cljs.core.async/t_cljs$core$async33621.
 */
cljs.core.async.__GT_t_cljs$core$async33621 = (function cljs$core$async$__GT_t_cljs$core$async33621(flag,meta33622){
return (new cljs.core.async.t_cljs$core$async33621(flag,meta33622));
});


cljs.core.async.alt_flag = (function cljs$core$async$alt_flag(){
var flag = cljs.core.atom.cljs$core$IFn$_invoke$arity$1(true);
return (new cljs.core.async.t_cljs$core$async33621(flag,cljs.core.PersistentArrayMap.EMPTY));
});

/**
* @constructor
 * @implements {cljs.core.async.impl.protocols.Handler}
 * @implements {cljs.core.IMeta}
 * @implements {cljs.core.IWithMeta}
*/
cljs.core.async.t_cljs$core$async33624 = (function (flag,cb,meta33625){
this.flag = flag;
this.cb = cb;
this.meta33625 = meta33625;
this.cljs$lang$protocol_mask$partition0$ = 393216;
this.cljs$lang$protocol_mask$partition1$ = 0;
});
(cljs.core.async.t_cljs$core$async33624.prototype.cljs$core$IWithMeta$_with_meta$arity$2 = (function (_33626,meta33625__$1){
var self__ = this;
var _33626__$1 = this;
return (new cljs.core.async.t_cljs$core$async33624(self__.flag,self__.cb,meta33625__$1));
}));

(cljs.core.async.t_cljs$core$async33624.prototype.cljs$core$IMeta$_meta$arity$1 = (function (_33626){
var self__ = this;
var _33626__$1 = this;
return self__.meta33625;
}));

(cljs.core.async.t_cljs$core$async33624.prototype.cljs$core$async$impl$protocols$Handler$ = cljs.core.PROTOCOL_SENTINEL);

(cljs.core.async.t_cljs$core$async33624.prototype.cljs$core$async$impl$protocols$Handler$active_QMARK_$arity$1 = (function (_){
var self__ = this;
var ___$1 = this;
return cljs.core.async.impl.protocols.active_QMARK_(self__.flag);
}));

(cljs.core.async.t_cljs$core$async33624.prototype.cljs$core$async$impl$protocols$Handler$blockable_QMARK_$arity$1 = (function (_){
var self__ = this;
var ___$1 = this;
return true;
}));

(cljs.core.async.t_cljs$core$async33624.prototype.cljs$core$async$impl$protocols$Handler$commit$arity$1 = (function (_){
var self__ = this;
var ___$1 = this;
cljs.core.async.impl.protocols.commit(self__.flag);

return self__.cb;
}));

(cljs.core.async.t_cljs$core$async33624.getBasis = (function (){
return new cljs.core.PersistentVector(null, 3, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Symbol(null,"flag","flag",-1565787888,null),new cljs.core.Symbol(null,"cb","cb",-2064487928,null),new cljs.core.Symbol(null,"meta33625","meta33625",76291497,null)], null);
}));

(cljs.core.async.t_cljs$core$async33624.cljs$lang$type = true);

(cljs.core.async.t_cljs$core$async33624.cljs$lang$ctorStr = "cljs.core.async/t_cljs$core$async33624");

(cljs.core.async.t_cljs$core$async33624.cljs$lang$ctorPrWriter = (function (this__5330__auto__,writer__5331__auto__,opt__5332__auto__){
return cljs.core._write(writer__5331__auto__,"cljs.core.async/t_cljs$core$async33624");
}));

/**
 * Positional factory function for cljs.core.async/t_cljs$core$async33624.
 */
cljs.core.async.__GT_t_cljs$core$async33624 = (function cljs$core$async$__GT_t_cljs$core$async33624(flag,cb,meta33625){
return (new cljs.core.async.t_cljs$core$async33624(flag,cb,meta33625));
});


cljs.core.async.alt_handler = (function cljs$core$async$alt_handler(flag,cb){
return (new cljs.core.async.t_cljs$core$async33624(flag,cb,cljs.core.PersistentArrayMap.EMPTY));
});
/**
 * returns derefable [val port] if immediate, nil if enqueued
 */
cljs.core.async.do_alts = (function cljs$core$async$do_alts(fret,ports,opts){
if((cljs.core.count(ports) > (0))){
} else {
throw (new Error(["Assert failed: ","alts must have at least one channel operation","\n","(pos? (count ports))"].join('')));
}

var flag = cljs.core.async.alt_flag();
var n = cljs.core.count(ports);
var idxs = cljs.core.async.random_array(n);
var priority = new cljs.core.Keyword(null,"priority","priority",1431093715).cljs$core$IFn$_invoke$arity$1(opts);
var ret = (function (){var i = (0);
while(true){
if((i < n)){
var idx = (cljs.core.truth_(priority)?i:(idxs[i]));
var port = cljs.core.nth.cljs$core$IFn$_invoke$arity$2(ports,idx);
var wport = ((cljs.core.vector_QMARK_(port))?(port.cljs$core$IFn$_invoke$arity$1 ? port.cljs$core$IFn$_invoke$arity$1((0)) : port.call(null,(0))):null);
var vbox = (cljs.core.truth_(wport)?(function (){var val = (port.cljs$core$IFn$_invoke$arity$1 ? port.cljs$core$IFn$_invoke$arity$1((1)) : port.call(null,(1)));
return cljs.core.async.impl.protocols.put_BANG_(wport,val,cljs.core.async.alt_handler(flag,((function (i,val,idx,port,wport,flag,n,idxs,priority){
return (function (p1__33639_SHARP_){
var G__33641 = new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [p1__33639_SHARP_,wport], null);
return (fret.cljs$core$IFn$_invoke$arity$1 ? fret.cljs$core$IFn$_invoke$arity$1(G__33641) : fret.call(null,G__33641));
});})(i,val,idx,port,wport,flag,n,idxs,priority))
));
})():cljs.core.async.impl.protocols.take_BANG_(port,cljs.core.async.alt_handler(flag,((function (i,idx,port,wport,flag,n,idxs,priority){
return (function (p1__33640_SHARP_){
var G__33642 = new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [p1__33640_SHARP_,port], null);
return (fret.cljs$core$IFn$_invoke$arity$1 ? fret.cljs$core$IFn$_invoke$arity$1(G__33642) : fret.call(null,G__33642));
});})(i,idx,port,wport,flag,n,idxs,priority))
)));
if(cljs.core.truth_(vbox)){
return cljs.core.async.impl.channels.box(new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [cljs.core.deref(vbox),(function (){var or__5045__auto__ = wport;
if(cljs.core.truth_(or__5045__auto__)){
return or__5045__auto__;
} else {
return port;
}
})()], null));
} else {
var G__36434 = (i + (1));
i = G__36434;
continue;
}
} else {
return null;
}
break;
}
})();
var or__5045__auto__ = ret;
if(cljs.core.truth_(or__5045__auto__)){
return or__5045__auto__;
} else {
if(cljs.core.contains_QMARK_(opts,new cljs.core.Keyword(null,"default","default",-1987822328))){
var temp__5804__auto__ = (function (){var and__5043__auto__ = flag.cljs$core$async$impl$protocols$Handler$active_QMARK_$arity$1(null);
if(cljs.core.truth_(and__5043__auto__)){
return flag.cljs$core$async$impl$protocols$Handler$commit$arity$1(null);
} else {
return and__5043__auto__;
}
})();
if(cljs.core.truth_(temp__5804__auto__)){
var got = temp__5804__auto__;
return cljs.core.async.impl.channels.box(new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Keyword(null,"default","default",-1987822328).cljs$core$IFn$_invoke$arity$1(opts),new cljs.core.Keyword(null,"default","default",-1987822328)], null));
} else {
return null;
}
} else {
return null;
}
}
});
/**
 * Completes at most one of several channel operations. Must be called
 * inside a (go ...) block. ports is a vector of channel endpoints,
 * which can be either a channel to take from or a vector of
 *   [channel-to-put-to val-to-put], in any combination. Takes will be
 *   made as if by <!, and puts will be made as if by >!. Unless
 *   the :priority option is true, if more than one port operation is
 *   ready a non-deterministic choice will be made. If no operation is
 *   ready and a :default value is supplied, [default-val :default] will
 *   be returned, otherwise alts! will park until the first operation to
 *   become ready completes. Returns [val port] of the completed
 *   operation, where val is the value taken for takes, and a
 *   boolean (true unless already closed, as per put!) for puts.
 * 
 *   opts are passed as :key val ... Supported options:
 * 
 *   :default val - the value to use if none of the operations are immediately ready
 *   :priority true - (default nil) when true, the operations will be tried in order.
 * 
 *   Note: there is no guarantee that the port exps or val exprs will be
 *   used, nor in what order should they be, so they should not be
 *   depended upon for side effects.
 */
cljs.core.async.alts_BANG_ = (function cljs$core$async$alts_BANG_(var_args){
var args__5775__auto__ = [];
var len__5769__auto___36437 = arguments.length;
var i__5770__auto___36438 = (0);
while(true){
if((i__5770__auto___36438 < len__5769__auto___36437)){
args__5775__auto__.push((arguments[i__5770__auto___36438]));

var G__36439 = (i__5770__auto___36438 + (1));
i__5770__auto___36438 = G__36439;
continue;
} else {
}
break;
}

var argseq__5776__auto__ = ((((1) < args__5775__auto__.length))?(new cljs.core.IndexedSeq(args__5775__auto__.slice((1)),(0),null)):null);
return cljs.core.async.alts_BANG_.cljs$core$IFn$_invoke$arity$variadic((arguments[(0)]),argseq__5776__auto__);
});

(cljs.core.async.alts_BANG_.cljs$core$IFn$_invoke$arity$variadic = (function (ports,p__33645){
var map__33646 = p__33645;
var map__33646__$1 = cljs.core.__destructure_map(map__33646);
var opts = map__33646__$1;
throw (new Error("alts! used not in (go ...) block"));
}));

(cljs.core.async.alts_BANG_.cljs$lang$maxFixedArity = (1));

/** @this {Function} */
(cljs.core.async.alts_BANG_.cljs$lang$applyTo = (function (seq33643){
var G__33644 = cljs.core.first(seq33643);
var seq33643__$1 = cljs.core.next(seq33643);
var self__5754__auto__ = this;
return self__5754__auto__.cljs$core$IFn$_invoke$arity$variadic(G__33644,seq33643__$1);
}));

/**
 * Puts a val into port if it's possible to do so immediately.
 *   nil values are not allowed. Never blocks. Returns true if offer succeeds.
 */
cljs.core.async.offer_BANG_ = (function cljs$core$async$offer_BANG_(port,val){
var ret = cljs.core.async.impl.protocols.put_BANG_(port,val,cljs.core.async.fn_handler.cljs$core$IFn$_invoke$arity$2(cljs.core.async.nop,false));
if(cljs.core.truth_(ret)){
return cljs.core.deref(ret);
} else {
return null;
}
});
/**
 * Takes a val from port if it's possible to do so immediately.
 *   Never blocks. Returns value if successful, nil otherwise.
 */
cljs.core.async.poll_BANG_ = (function cljs$core$async$poll_BANG_(port){
var ret = cljs.core.async.impl.protocols.take_BANG_(port,cljs.core.async.fn_handler.cljs$core$IFn$_invoke$arity$2(cljs.core.async.nop,false));
if(cljs.core.truth_(ret)){
return cljs.core.deref(ret);
} else {
return null;
}
});
/**
 * Takes elements from the from channel and supplies them to the to
 * channel. By default, the to channel will be closed when the from
 * channel closes, but can be determined by the close?  parameter. Will
 * stop consuming the from channel if the to channel closes
 */
cljs.core.async.pipe = (function cljs$core$async$pipe(var_args){
var G__33651 = arguments.length;
switch (G__33651) {
case 2:
return cljs.core.async.pipe.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
case 3:
return cljs.core.async.pipe.cljs$core$IFn$_invoke$arity$3((arguments[(0)]),(arguments[(1)]),(arguments[(2)]));

break;
default:
throw (new Error(["Invalid arity: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(arguments.length)].join('')));

}
});

(cljs.core.async.pipe.cljs$core$IFn$_invoke$arity$2 = (function (from,to){
return cljs.core.async.pipe.cljs$core$IFn$_invoke$arity$3(from,to,true);
}));

(cljs.core.async.pipe.cljs$core$IFn$_invoke$arity$3 = (function (from,to,close_QMARK_){
var c__33371__auto___36443 = cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1((1));
cljs.core.async.impl.dispatch.run((function (){
var f__33372__auto__ = (function (){var switch__33218__auto__ = (function (state_33694){
var state_val_33695 = (state_33694[(1)]);
if((state_val_33695 === (7))){
var inst_33685 = (state_33694[(2)]);
var state_33694__$1 = state_33694;
var statearr_33711_36448 = state_33694__$1;
(statearr_33711_36448[(2)] = inst_33685);

(statearr_33711_36448[(1)] = (3));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_33695 === (1))){
var state_33694__$1 = state_33694;
var statearr_33713_36449 = state_33694__$1;
(statearr_33713_36449[(2)] = null);

(statearr_33713_36449[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_33695 === (4))){
var inst_33665 = (state_33694[(7)]);
var inst_33665__$1 = (state_33694[(2)]);
var inst_33668 = (inst_33665__$1 == null);
var state_33694__$1 = (function (){var statearr_33719 = state_33694;
(statearr_33719[(7)] = inst_33665__$1);

return statearr_33719;
})();
if(cljs.core.truth_(inst_33668)){
var statearr_33721_36455 = state_33694__$1;
(statearr_33721_36455[(1)] = (5));

} else {
var statearr_33722_36456 = state_33694__$1;
(statearr_33722_36456[(1)] = (6));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_33695 === (13))){
var state_33694__$1 = state_33694;
var statearr_33728_36457 = state_33694__$1;
(statearr_33728_36457[(2)] = null);

(statearr_33728_36457[(1)] = (14));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_33695 === (6))){
var inst_33665 = (state_33694[(7)]);
var state_33694__$1 = state_33694;
return cljs.core.async.impl.ioc_helpers.put_BANG_(state_33694__$1,(11),to,inst_33665);
} else {
if((state_val_33695 === (3))){
var inst_33689 = (state_33694[(2)]);
var state_33694__$1 = state_33694;
return cljs.core.async.impl.ioc_helpers.return_chan(state_33694__$1,inst_33689);
} else {
if((state_val_33695 === (12))){
var state_33694__$1 = state_33694;
var statearr_33743_36458 = state_33694__$1;
(statearr_33743_36458[(2)] = null);

(statearr_33743_36458[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_33695 === (2))){
var state_33694__$1 = state_33694;
return cljs.core.async.impl.ioc_helpers.take_BANG_(state_33694__$1,(4),from);
} else {
if((state_val_33695 === (11))){
var inst_33677 = (state_33694[(2)]);
var state_33694__$1 = state_33694;
if(cljs.core.truth_(inst_33677)){
var statearr_33745_36459 = state_33694__$1;
(statearr_33745_36459[(1)] = (12));

} else {
var statearr_33748_36460 = state_33694__$1;
(statearr_33748_36460[(1)] = (13));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_33695 === (9))){
var state_33694__$1 = state_33694;
var statearr_33750_36462 = state_33694__$1;
(statearr_33750_36462[(2)] = null);

(statearr_33750_36462[(1)] = (10));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_33695 === (5))){
var state_33694__$1 = state_33694;
if(cljs.core.truth_(close_QMARK_)){
var statearr_33754_36463 = state_33694__$1;
(statearr_33754_36463[(1)] = (8));

} else {
var statearr_33755_36464 = state_33694__$1;
(statearr_33755_36464[(1)] = (9));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_33695 === (14))){
var inst_33683 = (state_33694[(2)]);
var state_33694__$1 = state_33694;
var statearr_33757_36465 = state_33694__$1;
(statearr_33757_36465[(2)] = inst_33683);

(statearr_33757_36465[(1)] = (7));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_33695 === (10))){
var inst_33674 = (state_33694[(2)]);
var state_33694__$1 = state_33694;
var statearr_33761_36466 = state_33694__$1;
(statearr_33761_36466[(2)] = inst_33674);

(statearr_33761_36466[(1)] = (7));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_33695 === (8))){
var inst_33671 = cljs.core.async.close_BANG_(to);
var state_33694__$1 = state_33694;
var statearr_33766_36468 = state_33694__$1;
(statearr_33766_36468[(2)] = inst_33671);

(statearr_33766_36468[(1)] = (10));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
return null;
}
}
}
}
}
}
}
}
}
}
}
}
}
}
});
return (function() {
var cljs$core$async$state_machine__33219__auto__ = null;
var cljs$core$async$state_machine__33219__auto____0 = (function (){
var statearr_33771 = [null,null,null,null,null,null,null,null];
(statearr_33771[(0)] = cljs$core$async$state_machine__33219__auto__);

(statearr_33771[(1)] = (1));

return statearr_33771;
});
var cljs$core$async$state_machine__33219__auto____1 = (function (state_33694){
while(true){
var ret_value__33220__auto__ = (function (){try{while(true){
var result__33221__auto__ = switch__33218__auto__(state_33694);
if(cljs.core.keyword_identical_QMARK_(result__33221__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
continue;
} else {
return result__33221__auto__;
}
break;
}
}catch (e33772){var ex__33222__auto__ = e33772;
var statearr_33773_36470 = state_33694;
(statearr_33773_36470[(2)] = ex__33222__auto__);


if(cljs.core.seq((state_33694[(4)]))){
var statearr_33774_36471 = state_33694;
(statearr_33774_36471[(1)] = cljs.core.first((state_33694[(4)])));

} else {
throw ex__33222__auto__;
}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
}})();
if(cljs.core.keyword_identical_QMARK_(ret_value__33220__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
var G__36472 = state_33694;
state_33694 = G__36472;
continue;
} else {
return ret_value__33220__auto__;
}
break;
}
});
cljs$core$async$state_machine__33219__auto__ = function(state_33694){
switch(arguments.length){
case 0:
return cljs$core$async$state_machine__33219__auto____0.call(this);
case 1:
return cljs$core$async$state_machine__33219__auto____1.call(this,state_33694);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
cljs$core$async$state_machine__33219__auto__.cljs$core$IFn$_invoke$arity$0 = cljs$core$async$state_machine__33219__auto____0;
cljs$core$async$state_machine__33219__auto__.cljs$core$IFn$_invoke$arity$1 = cljs$core$async$state_machine__33219__auto____1;
return cljs$core$async$state_machine__33219__auto__;
})()
})();
var state__33373__auto__ = (function (){var statearr_33775 = f__33372__auto__();
(statearr_33775[(6)] = c__33371__auto___36443);

return statearr_33775;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped(state__33373__auto__);
}));


return to;
}));

(cljs.core.async.pipe.cljs$lang$maxFixedArity = 3);

cljs.core.async.pipeline_STAR_ = (function cljs$core$async$pipeline_STAR_(n,to,xf,from,close_QMARK_,ex_handler,type){
if((n > (0))){
} else {
throw (new Error("Assert failed: (pos? n)"));
}

var jobs = cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1(n);
var results = cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1(n);
var process__$1 = (function (p__33776){
var vec__33777 = p__33776;
var v = cljs.core.nth.cljs$core$IFn$_invoke$arity$3(vec__33777,(0),null);
var p = cljs.core.nth.cljs$core$IFn$_invoke$arity$3(vec__33777,(1),null);
var job = vec__33777;
if((job == null)){
cljs.core.async.close_BANG_(results);

return null;
} else {
var res = cljs.core.async.chan.cljs$core$IFn$_invoke$arity$3((1),xf,ex_handler);
var c__33371__auto___36475 = cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1((1));
cljs.core.async.impl.dispatch.run((function (){
var f__33372__auto__ = (function (){var switch__33218__auto__ = (function (state_33789){
var state_val_33790 = (state_33789[(1)]);
if((state_val_33790 === (1))){
var state_33789__$1 = state_33789;
return cljs.core.async.impl.ioc_helpers.put_BANG_(state_33789__$1,(2),res,v);
} else {
if((state_val_33790 === (2))){
var inst_33786 = (state_33789[(2)]);
var inst_33787 = cljs.core.async.close_BANG_(res);
var state_33789__$1 = (function (){var statearr_33795 = state_33789;
(statearr_33795[(7)] = inst_33786);

return statearr_33795;
})();
return cljs.core.async.impl.ioc_helpers.return_chan(state_33789__$1,inst_33787);
} else {
return null;
}
}
});
return (function() {
var cljs$core$async$pipeline_STAR__$_state_machine__33219__auto__ = null;
var cljs$core$async$pipeline_STAR__$_state_machine__33219__auto____0 = (function (){
var statearr_33796 = [null,null,null,null,null,null,null,null];
(statearr_33796[(0)] = cljs$core$async$pipeline_STAR__$_state_machine__33219__auto__);

(statearr_33796[(1)] = (1));

return statearr_33796;
});
var cljs$core$async$pipeline_STAR__$_state_machine__33219__auto____1 = (function (state_33789){
while(true){
var ret_value__33220__auto__ = (function (){try{while(true){
var result__33221__auto__ = switch__33218__auto__(state_33789);
if(cljs.core.keyword_identical_QMARK_(result__33221__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
continue;
} else {
return result__33221__auto__;
}
break;
}
}catch (e33800){var ex__33222__auto__ = e33800;
var statearr_33801_36478 = state_33789;
(statearr_33801_36478[(2)] = ex__33222__auto__);


if(cljs.core.seq((state_33789[(4)]))){
var statearr_33802_36479 = state_33789;
(statearr_33802_36479[(1)] = cljs.core.first((state_33789[(4)])));

} else {
throw ex__33222__auto__;
}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
}})();
if(cljs.core.keyword_identical_QMARK_(ret_value__33220__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
var G__36481 = state_33789;
state_33789 = G__36481;
continue;
} else {
return ret_value__33220__auto__;
}
break;
}
});
cljs$core$async$pipeline_STAR__$_state_machine__33219__auto__ = function(state_33789){
switch(arguments.length){
case 0:
return cljs$core$async$pipeline_STAR__$_state_machine__33219__auto____0.call(this);
case 1:
return cljs$core$async$pipeline_STAR__$_state_machine__33219__auto____1.call(this,state_33789);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
cljs$core$async$pipeline_STAR__$_state_machine__33219__auto__.cljs$core$IFn$_invoke$arity$0 = cljs$core$async$pipeline_STAR__$_state_machine__33219__auto____0;
cljs$core$async$pipeline_STAR__$_state_machine__33219__auto__.cljs$core$IFn$_invoke$arity$1 = cljs$core$async$pipeline_STAR__$_state_machine__33219__auto____1;
return cljs$core$async$pipeline_STAR__$_state_machine__33219__auto__;
})()
})();
var state__33373__auto__ = (function (){var statearr_33803 = f__33372__auto__();
(statearr_33803[(6)] = c__33371__auto___36475);

return statearr_33803;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped(state__33373__auto__);
}));


cljs.core.async.put_BANG_.cljs$core$IFn$_invoke$arity$2(p,res);

return true;
}
});
var async = (function (p__33806){
var vec__33807 = p__33806;
var v = cljs.core.nth.cljs$core$IFn$_invoke$arity$3(vec__33807,(0),null);
var p = cljs.core.nth.cljs$core$IFn$_invoke$arity$3(vec__33807,(1),null);
var job = vec__33807;
if((job == null)){
cljs.core.async.close_BANG_(results);

return null;
} else {
var res = cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1((1));
(xf.cljs$core$IFn$_invoke$arity$2 ? xf.cljs$core$IFn$_invoke$arity$2(v,res) : xf.call(null,v,res));

cljs.core.async.put_BANG_.cljs$core$IFn$_invoke$arity$2(p,res);

return true;
}
});
var n__5636__auto___36487 = n;
var __36488 = (0);
while(true){
if((__36488 < n__5636__auto___36487)){
var G__33817_36489 = type;
var G__33817_36490__$1 = (((G__33817_36489 instanceof cljs.core.Keyword))?G__33817_36489.fqn:null);
switch (G__33817_36490__$1) {
case "compute":
var c__33371__auto___36493 = cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1((1));
cljs.core.async.impl.dispatch.run(((function (__36488,c__33371__auto___36493,G__33817_36489,G__33817_36490__$1,n__5636__auto___36487,jobs,results,process__$1,async){
return (function (){
var f__33372__auto__ = (function (){var switch__33218__auto__ = ((function (__36488,c__33371__auto___36493,G__33817_36489,G__33817_36490__$1,n__5636__auto___36487,jobs,results,process__$1,async){
return (function (state_33830){
var state_val_33831 = (state_33830[(1)]);
if((state_val_33831 === (1))){
var state_33830__$1 = state_33830;
var statearr_33832_36496 = state_33830__$1;
(statearr_33832_36496[(2)] = null);

(statearr_33832_36496[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_33831 === (2))){
var state_33830__$1 = state_33830;
return cljs.core.async.impl.ioc_helpers.take_BANG_(state_33830__$1,(4),jobs);
} else {
if((state_val_33831 === (3))){
var inst_33828 = (state_33830[(2)]);
var state_33830__$1 = state_33830;
return cljs.core.async.impl.ioc_helpers.return_chan(state_33830__$1,inst_33828);
} else {
if((state_val_33831 === (4))){
var inst_33820 = (state_33830[(2)]);
var inst_33821 = process__$1(inst_33820);
var state_33830__$1 = state_33830;
if(cljs.core.truth_(inst_33821)){
var statearr_33833_36499 = state_33830__$1;
(statearr_33833_36499[(1)] = (5));

} else {
var statearr_33834_36501 = state_33830__$1;
(statearr_33834_36501[(1)] = (6));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_33831 === (5))){
var state_33830__$1 = state_33830;
var statearr_33835_36502 = state_33830__$1;
(statearr_33835_36502[(2)] = null);

(statearr_33835_36502[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_33831 === (6))){
var state_33830__$1 = state_33830;
var statearr_33836_36503 = state_33830__$1;
(statearr_33836_36503[(2)] = null);

(statearr_33836_36503[(1)] = (7));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_33831 === (7))){
var inst_33826 = (state_33830[(2)]);
var state_33830__$1 = state_33830;
var statearr_33837_36504 = state_33830__$1;
(statearr_33837_36504[(2)] = inst_33826);

(statearr_33837_36504[(1)] = (3));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
return null;
}
}
}
}
}
}
}
});})(__36488,c__33371__auto___36493,G__33817_36489,G__33817_36490__$1,n__5636__auto___36487,jobs,results,process__$1,async))
;
return ((function (__36488,switch__33218__auto__,c__33371__auto___36493,G__33817_36489,G__33817_36490__$1,n__5636__auto___36487,jobs,results,process__$1,async){
return (function() {
var cljs$core$async$pipeline_STAR__$_state_machine__33219__auto__ = null;
var cljs$core$async$pipeline_STAR__$_state_machine__33219__auto____0 = (function (){
var statearr_33841 = [null,null,null,null,null,null,null];
(statearr_33841[(0)] = cljs$core$async$pipeline_STAR__$_state_machine__33219__auto__);

(statearr_33841[(1)] = (1));

return statearr_33841;
});
var cljs$core$async$pipeline_STAR__$_state_machine__33219__auto____1 = (function (state_33830){
while(true){
var ret_value__33220__auto__ = (function (){try{while(true){
var result__33221__auto__ = switch__33218__auto__(state_33830);
if(cljs.core.keyword_identical_QMARK_(result__33221__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
continue;
} else {
return result__33221__auto__;
}
break;
}
}catch (e33842){var ex__33222__auto__ = e33842;
var statearr_33846_36507 = state_33830;
(statearr_33846_36507[(2)] = ex__33222__auto__);


if(cljs.core.seq((state_33830[(4)]))){
var statearr_33847_36510 = state_33830;
(statearr_33847_36510[(1)] = cljs.core.first((state_33830[(4)])));

} else {
throw ex__33222__auto__;
}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
}})();
if(cljs.core.keyword_identical_QMARK_(ret_value__33220__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
var G__36511 = state_33830;
state_33830 = G__36511;
continue;
} else {
return ret_value__33220__auto__;
}
break;
}
});
cljs$core$async$pipeline_STAR__$_state_machine__33219__auto__ = function(state_33830){
switch(arguments.length){
case 0:
return cljs$core$async$pipeline_STAR__$_state_machine__33219__auto____0.call(this);
case 1:
return cljs$core$async$pipeline_STAR__$_state_machine__33219__auto____1.call(this,state_33830);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
cljs$core$async$pipeline_STAR__$_state_machine__33219__auto__.cljs$core$IFn$_invoke$arity$0 = cljs$core$async$pipeline_STAR__$_state_machine__33219__auto____0;
cljs$core$async$pipeline_STAR__$_state_machine__33219__auto__.cljs$core$IFn$_invoke$arity$1 = cljs$core$async$pipeline_STAR__$_state_machine__33219__auto____1;
return cljs$core$async$pipeline_STAR__$_state_machine__33219__auto__;
})()
;})(__36488,switch__33218__auto__,c__33371__auto___36493,G__33817_36489,G__33817_36490__$1,n__5636__auto___36487,jobs,results,process__$1,async))
})();
var state__33373__auto__ = (function (){var statearr_33854 = f__33372__auto__();
(statearr_33854[(6)] = c__33371__auto___36493);

return statearr_33854;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped(state__33373__auto__);
});})(__36488,c__33371__auto___36493,G__33817_36489,G__33817_36490__$1,n__5636__auto___36487,jobs,results,process__$1,async))
);


break;
case "async":
var c__33371__auto___36514 = cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1((1));
cljs.core.async.impl.dispatch.run(((function (__36488,c__33371__auto___36514,G__33817_36489,G__33817_36490__$1,n__5636__auto___36487,jobs,results,process__$1,async){
return (function (){
var f__33372__auto__ = (function (){var switch__33218__auto__ = ((function (__36488,c__33371__auto___36514,G__33817_36489,G__33817_36490__$1,n__5636__auto___36487,jobs,results,process__$1,async){
return (function (state_33867){
var state_val_33868 = (state_33867[(1)]);
if((state_val_33868 === (1))){
var state_33867__$1 = state_33867;
var statearr_33872_36516 = state_33867__$1;
(statearr_33872_36516[(2)] = null);

(statearr_33872_36516[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_33868 === (2))){
var state_33867__$1 = state_33867;
return cljs.core.async.impl.ioc_helpers.take_BANG_(state_33867__$1,(4),jobs);
} else {
if((state_val_33868 === (3))){
var inst_33865 = (state_33867[(2)]);
var state_33867__$1 = state_33867;
return cljs.core.async.impl.ioc_helpers.return_chan(state_33867__$1,inst_33865);
} else {
if((state_val_33868 === (4))){
var inst_33857 = (state_33867[(2)]);
var inst_33858 = async(inst_33857);
var state_33867__$1 = state_33867;
if(cljs.core.truth_(inst_33858)){
var statearr_33873_36518 = state_33867__$1;
(statearr_33873_36518[(1)] = (5));

} else {
var statearr_33874_36519 = state_33867__$1;
(statearr_33874_36519[(1)] = (6));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_33868 === (5))){
var state_33867__$1 = state_33867;
var statearr_33875_36520 = state_33867__$1;
(statearr_33875_36520[(2)] = null);

(statearr_33875_36520[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_33868 === (6))){
var state_33867__$1 = state_33867;
var statearr_33876_36521 = state_33867__$1;
(statearr_33876_36521[(2)] = null);

(statearr_33876_36521[(1)] = (7));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_33868 === (7))){
var inst_33863 = (state_33867[(2)]);
var state_33867__$1 = state_33867;
var statearr_33877_36522 = state_33867__$1;
(statearr_33877_36522[(2)] = inst_33863);

(statearr_33877_36522[(1)] = (3));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
return null;
}
}
}
}
}
}
}
});})(__36488,c__33371__auto___36514,G__33817_36489,G__33817_36490__$1,n__5636__auto___36487,jobs,results,process__$1,async))
;
return ((function (__36488,switch__33218__auto__,c__33371__auto___36514,G__33817_36489,G__33817_36490__$1,n__5636__auto___36487,jobs,results,process__$1,async){
return (function() {
var cljs$core$async$pipeline_STAR__$_state_machine__33219__auto__ = null;
var cljs$core$async$pipeline_STAR__$_state_machine__33219__auto____0 = (function (){
var statearr_33878 = [null,null,null,null,null,null,null];
(statearr_33878[(0)] = cljs$core$async$pipeline_STAR__$_state_machine__33219__auto__);

(statearr_33878[(1)] = (1));

return statearr_33878;
});
var cljs$core$async$pipeline_STAR__$_state_machine__33219__auto____1 = (function (state_33867){
while(true){
var ret_value__33220__auto__ = (function (){try{while(true){
var result__33221__auto__ = switch__33218__auto__(state_33867);
if(cljs.core.keyword_identical_QMARK_(result__33221__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
continue;
} else {
return result__33221__auto__;
}
break;
}
}catch (e33879){var ex__33222__auto__ = e33879;
var statearr_33880_36532 = state_33867;
(statearr_33880_36532[(2)] = ex__33222__auto__);


if(cljs.core.seq((state_33867[(4)]))){
var statearr_33881_36533 = state_33867;
(statearr_33881_36533[(1)] = cljs.core.first((state_33867[(4)])));

} else {
throw ex__33222__auto__;
}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
}})();
if(cljs.core.keyword_identical_QMARK_(ret_value__33220__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
var G__36537 = state_33867;
state_33867 = G__36537;
continue;
} else {
return ret_value__33220__auto__;
}
break;
}
});
cljs$core$async$pipeline_STAR__$_state_machine__33219__auto__ = function(state_33867){
switch(arguments.length){
case 0:
return cljs$core$async$pipeline_STAR__$_state_machine__33219__auto____0.call(this);
case 1:
return cljs$core$async$pipeline_STAR__$_state_machine__33219__auto____1.call(this,state_33867);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
cljs$core$async$pipeline_STAR__$_state_machine__33219__auto__.cljs$core$IFn$_invoke$arity$0 = cljs$core$async$pipeline_STAR__$_state_machine__33219__auto____0;
cljs$core$async$pipeline_STAR__$_state_machine__33219__auto__.cljs$core$IFn$_invoke$arity$1 = cljs$core$async$pipeline_STAR__$_state_machine__33219__auto____1;
return cljs$core$async$pipeline_STAR__$_state_machine__33219__auto__;
})()
;})(__36488,switch__33218__auto__,c__33371__auto___36514,G__33817_36489,G__33817_36490__$1,n__5636__auto___36487,jobs,results,process__$1,async))
})();
var state__33373__auto__ = (function (){var statearr_33882 = f__33372__auto__();
(statearr_33882[(6)] = c__33371__auto___36514);

return statearr_33882;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped(state__33373__auto__);
});})(__36488,c__33371__auto___36514,G__33817_36489,G__33817_36490__$1,n__5636__auto___36487,jobs,results,process__$1,async))
);


break;
default:
throw (new Error(["No matching clause: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(G__33817_36490__$1)].join('')));

}

var G__36545 = (__36488 + (1));
__36488 = G__36545;
continue;
} else {
}
break;
}

var c__33371__auto___36552 = cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1((1));
cljs.core.async.impl.dispatch.run((function (){
var f__33372__auto__ = (function (){var switch__33218__auto__ = (function (state_33910){
var state_val_33911 = (state_33910[(1)]);
if((state_val_33911 === (7))){
var inst_33903 = (state_33910[(2)]);
var state_33910__$1 = state_33910;
var statearr_33912_36565 = state_33910__$1;
(statearr_33912_36565[(2)] = inst_33903);

(statearr_33912_36565[(1)] = (3));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_33911 === (1))){
var state_33910__$1 = state_33910;
var statearr_33913_36571 = state_33910__$1;
(statearr_33913_36571[(2)] = null);

(statearr_33913_36571[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_33911 === (4))){
var inst_33886 = (state_33910[(7)]);
var inst_33886__$1 = (state_33910[(2)]);
var inst_33887 = (inst_33886__$1 == null);
var state_33910__$1 = (function (){var statearr_33914 = state_33910;
(statearr_33914[(7)] = inst_33886__$1);

return statearr_33914;
})();
if(cljs.core.truth_(inst_33887)){
var statearr_33915_36588 = state_33910__$1;
(statearr_33915_36588[(1)] = (5));

} else {
var statearr_33916_36589 = state_33910__$1;
(statearr_33916_36589[(1)] = (6));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_33911 === (6))){
var inst_33886 = (state_33910[(7)]);
var inst_33891 = (state_33910[(8)]);
var inst_33891__$1 = cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1((1));
var inst_33893 = cljs.core.PersistentVector.EMPTY_NODE;
var inst_33895 = [inst_33886,inst_33891__$1];
var inst_33896 = (new cljs.core.PersistentVector(null,2,(5),inst_33893,inst_33895,null));
var state_33910__$1 = (function (){var statearr_33917 = state_33910;
(statearr_33917[(8)] = inst_33891__$1);

return statearr_33917;
})();
return cljs.core.async.impl.ioc_helpers.put_BANG_(state_33910__$1,(8),jobs,inst_33896);
} else {
if((state_val_33911 === (3))){
var inst_33908 = (state_33910[(2)]);
var state_33910__$1 = state_33910;
return cljs.core.async.impl.ioc_helpers.return_chan(state_33910__$1,inst_33908);
} else {
if((state_val_33911 === (2))){
var state_33910__$1 = state_33910;
return cljs.core.async.impl.ioc_helpers.take_BANG_(state_33910__$1,(4),from);
} else {
if((state_val_33911 === (9))){
var inst_33900 = (state_33910[(2)]);
var state_33910__$1 = (function (){var statearr_33922 = state_33910;
(statearr_33922[(9)] = inst_33900);

return statearr_33922;
})();
var statearr_33923_36596 = state_33910__$1;
(statearr_33923_36596[(2)] = null);

(statearr_33923_36596[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_33911 === (5))){
var inst_33889 = cljs.core.async.close_BANG_(jobs);
var state_33910__$1 = state_33910;
var statearr_33924_36600 = state_33910__$1;
(statearr_33924_36600[(2)] = inst_33889);

(statearr_33924_36600[(1)] = (7));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_33911 === (8))){
var inst_33891 = (state_33910[(8)]);
var inst_33898 = (state_33910[(2)]);
var state_33910__$1 = (function (){var statearr_33931 = state_33910;
(statearr_33931[(10)] = inst_33898);

return statearr_33931;
})();
return cljs.core.async.impl.ioc_helpers.put_BANG_(state_33910__$1,(9),results,inst_33891);
} else {
return null;
}
}
}
}
}
}
}
}
}
});
return (function() {
var cljs$core$async$pipeline_STAR__$_state_machine__33219__auto__ = null;
var cljs$core$async$pipeline_STAR__$_state_machine__33219__auto____0 = (function (){
var statearr_33932 = [null,null,null,null,null,null,null,null,null,null,null];
(statearr_33932[(0)] = cljs$core$async$pipeline_STAR__$_state_machine__33219__auto__);

(statearr_33932[(1)] = (1));

return statearr_33932;
});
var cljs$core$async$pipeline_STAR__$_state_machine__33219__auto____1 = (function (state_33910){
while(true){
var ret_value__33220__auto__ = (function (){try{while(true){
var result__33221__auto__ = switch__33218__auto__(state_33910);
if(cljs.core.keyword_identical_QMARK_(result__33221__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
continue;
} else {
return result__33221__auto__;
}
break;
}
}catch (e33933){var ex__33222__auto__ = e33933;
var statearr_33934_36601 = state_33910;
(statearr_33934_36601[(2)] = ex__33222__auto__);


if(cljs.core.seq((state_33910[(4)]))){
var statearr_33935_36602 = state_33910;
(statearr_33935_36602[(1)] = cljs.core.first((state_33910[(4)])));

} else {
throw ex__33222__auto__;
}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
}})();
if(cljs.core.keyword_identical_QMARK_(ret_value__33220__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
var G__36604 = state_33910;
state_33910 = G__36604;
continue;
} else {
return ret_value__33220__auto__;
}
break;
}
});
cljs$core$async$pipeline_STAR__$_state_machine__33219__auto__ = function(state_33910){
switch(arguments.length){
case 0:
return cljs$core$async$pipeline_STAR__$_state_machine__33219__auto____0.call(this);
case 1:
return cljs$core$async$pipeline_STAR__$_state_machine__33219__auto____1.call(this,state_33910);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
cljs$core$async$pipeline_STAR__$_state_machine__33219__auto__.cljs$core$IFn$_invoke$arity$0 = cljs$core$async$pipeline_STAR__$_state_machine__33219__auto____0;
cljs$core$async$pipeline_STAR__$_state_machine__33219__auto__.cljs$core$IFn$_invoke$arity$1 = cljs$core$async$pipeline_STAR__$_state_machine__33219__auto____1;
return cljs$core$async$pipeline_STAR__$_state_machine__33219__auto__;
})()
})();
var state__33373__auto__ = (function (){var statearr_33936 = f__33372__auto__();
(statearr_33936[(6)] = c__33371__auto___36552);

return statearr_33936;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped(state__33373__auto__);
}));


var c__33371__auto__ = cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1((1));
cljs.core.async.impl.dispatch.run((function (){
var f__33372__auto__ = (function (){var switch__33218__auto__ = (function (state_33979){
var state_val_33980 = (state_33979[(1)]);
if((state_val_33980 === (7))){
var inst_33975 = (state_33979[(2)]);
var state_33979__$1 = state_33979;
var statearr_33983_36610 = state_33979__$1;
(statearr_33983_36610[(2)] = inst_33975);

(statearr_33983_36610[(1)] = (3));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_33980 === (20))){
var state_33979__$1 = state_33979;
var statearr_33985_36611 = state_33979__$1;
(statearr_33985_36611[(2)] = null);

(statearr_33985_36611[(1)] = (21));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_33980 === (1))){
var state_33979__$1 = state_33979;
var statearr_33995_36614 = state_33979__$1;
(statearr_33995_36614[(2)] = null);

(statearr_33995_36614[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_33980 === (4))){
var inst_33939 = (state_33979[(7)]);
var inst_33939__$1 = (state_33979[(2)]);
var inst_33940 = (inst_33939__$1 == null);
var state_33979__$1 = (function (){var statearr_34003 = state_33979;
(statearr_34003[(7)] = inst_33939__$1);

return statearr_34003;
})();
if(cljs.core.truth_(inst_33940)){
var statearr_34004_36616 = state_33979__$1;
(statearr_34004_36616[(1)] = (5));

} else {
var statearr_34005_36617 = state_33979__$1;
(statearr_34005_36617[(1)] = (6));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_33980 === (15))){
var inst_33953 = (state_33979[(8)]);
var state_33979__$1 = state_33979;
return cljs.core.async.impl.ioc_helpers.put_BANG_(state_33979__$1,(18),to,inst_33953);
} else {
if((state_val_33980 === (21))){
var inst_33970 = (state_33979[(2)]);
var state_33979__$1 = state_33979;
var statearr_34014_36619 = state_33979__$1;
(statearr_34014_36619[(2)] = inst_33970);

(statearr_34014_36619[(1)] = (13));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_33980 === (13))){
var inst_33972 = (state_33979[(2)]);
var state_33979__$1 = (function (){var statearr_34019 = state_33979;
(statearr_34019[(9)] = inst_33972);

return statearr_34019;
})();
var statearr_34022_36620 = state_33979__$1;
(statearr_34022_36620[(2)] = null);

(statearr_34022_36620[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_33980 === (6))){
var inst_33939 = (state_33979[(7)]);
var state_33979__$1 = state_33979;
return cljs.core.async.impl.ioc_helpers.take_BANG_(state_33979__$1,(11),inst_33939);
} else {
if((state_val_33980 === (17))){
var inst_33964 = (state_33979[(2)]);
var state_33979__$1 = state_33979;
if(cljs.core.truth_(inst_33964)){
var statearr_34025_36622 = state_33979__$1;
(statearr_34025_36622[(1)] = (19));

} else {
var statearr_34027_36623 = state_33979__$1;
(statearr_34027_36623[(1)] = (20));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_33980 === (3))){
var inst_33977 = (state_33979[(2)]);
var state_33979__$1 = state_33979;
return cljs.core.async.impl.ioc_helpers.return_chan(state_33979__$1,inst_33977);
} else {
if((state_val_33980 === (12))){
var inst_33949 = (state_33979[(10)]);
var state_33979__$1 = state_33979;
return cljs.core.async.impl.ioc_helpers.take_BANG_(state_33979__$1,(14),inst_33949);
} else {
if((state_val_33980 === (2))){
var state_33979__$1 = state_33979;
return cljs.core.async.impl.ioc_helpers.take_BANG_(state_33979__$1,(4),results);
} else {
if((state_val_33980 === (19))){
var state_33979__$1 = state_33979;
var statearr_34040_36631 = state_33979__$1;
(statearr_34040_36631[(2)] = null);

(statearr_34040_36631[(1)] = (12));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_33980 === (11))){
var inst_33949 = (state_33979[(2)]);
var state_33979__$1 = (function (){var statearr_34042 = state_33979;
(statearr_34042[(10)] = inst_33949);

return statearr_34042;
})();
var statearr_34050_36632 = state_33979__$1;
(statearr_34050_36632[(2)] = null);

(statearr_34050_36632[(1)] = (12));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_33980 === (9))){
var state_33979__$1 = state_33979;
var statearr_34052_36633 = state_33979__$1;
(statearr_34052_36633[(2)] = null);

(statearr_34052_36633[(1)] = (10));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_33980 === (5))){
var state_33979__$1 = state_33979;
if(cljs.core.truth_(close_QMARK_)){
var statearr_34060_36634 = state_33979__$1;
(statearr_34060_36634[(1)] = (8));

} else {
var statearr_34063_36635 = state_33979__$1;
(statearr_34063_36635[(1)] = (9));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_33980 === (14))){
var inst_33956 = (state_33979[(11)]);
var inst_33953 = (state_33979[(8)]);
var inst_33953__$1 = (state_33979[(2)]);
var inst_33955 = (inst_33953__$1 == null);
var inst_33956__$1 = cljs.core.not(inst_33955);
var state_33979__$1 = (function (){var statearr_34065 = state_33979;
(statearr_34065[(11)] = inst_33956__$1);

(statearr_34065[(8)] = inst_33953__$1);

return statearr_34065;
})();
if(inst_33956__$1){
var statearr_34070_36639 = state_33979__$1;
(statearr_34070_36639[(1)] = (15));

} else {
var statearr_34072_36640 = state_33979__$1;
(statearr_34072_36640[(1)] = (16));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_33980 === (16))){
var inst_33956 = (state_33979[(11)]);
var state_33979__$1 = state_33979;
var statearr_34078_36645 = state_33979__$1;
(statearr_34078_36645[(2)] = inst_33956);

(statearr_34078_36645[(1)] = (17));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_33980 === (10))){
var inst_33946 = (state_33979[(2)]);
var state_33979__$1 = state_33979;
var statearr_34082_36648 = state_33979__$1;
(statearr_34082_36648[(2)] = inst_33946);

(statearr_34082_36648[(1)] = (7));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_33980 === (18))){
var inst_33961 = (state_33979[(2)]);
var state_33979__$1 = state_33979;
var statearr_34092_36649 = state_33979__$1;
(statearr_34092_36649[(2)] = inst_33961);

(statearr_34092_36649[(1)] = (17));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_33980 === (8))){
var inst_33943 = cljs.core.async.close_BANG_(to);
var state_33979__$1 = state_33979;
var statearr_34100_36651 = state_33979__$1;
(statearr_34100_36651[(2)] = inst_33943);

(statearr_34100_36651[(1)] = (10));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
return null;
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
});
return (function() {
var cljs$core$async$pipeline_STAR__$_state_machine__33219__auto__ = null;
var cljs$core$async$pipeline_STAR__$_state_machine__33219__auto____0 = (function (){
var statearr_34117 = [null,null,null,null,null,null,null,null,null,null,null,null];
(statearr_34117[(0)] = cljs$core$async$pipeline_STAR__$_state_machine__33219__auto__);

(statearr_34117[(1)] = (1));

return statearr_34117;
});
var cljs$core$async$pipeline_STAR__$_state_machine__33219__auto____1 = (function (state_33979){
while(true){
var ret_value__33220__auto__ = (function (){try{while(true){
var result__33221__auto__ = switch__33218__auto__(state_33979);
if(cljs.core.keyword_identical_QMARK_(result__33221__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
continue;
} else {
return result__33221__auto__;
}
break;
}
}catch (e34118){var ex__33222__auto__ = e34118;
var statearr_34119_36655 = state_33979;
(statearr_34119_36655[(2)] = ex__33222__auto__);


if(cljs.core.seq((state_33979[(4)]))){
var statearr_34120_36658 = state_33979;
(statearr_34120_36658[(1)] = cljs.core.first((state_33979[(4)])));

} else {
throw ex__33222__auto__;
}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
}})();
if(cljs.core.keyword_identical_QMARK_(ret_value__33220__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
var G__36659 = state_33979;
state_33979 = G__36659;
continue;
} else {
return ret_value__33220__auto__;
}
break;
}
});
cljs$core$async$pipeline_STAR__$_state_machine__33219__auto__ = function(state_33979){
switch(arguments.length){
case 0:
return cljs$core$async$pipeline_STAR__$_state_machine__33219__auto____0.call(this);
case 1:
return cljs$core$async$pipeline_STAR__$_state_machine__33219__auto____1.call(this,state_33979);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
cljs$core$async$pipeline_STAR__$_state_machine__33219__auto__.cljs$core$IFn$_invoke$arity$0 = cljs$core$async$pipeline_STAR__$_state_machine__33219__auto____0;
cljs$core$async$pipeline_STAR__$_state_machine__33219__auto__.cljs$core$IFn$_invoke$arity$1 = cljs$core$async$pipeline_STAR__$_state_machine__33219__auto____1;
return cljs$core$async$pipeline_STAR__$_state_machine__33219__auto__;
})()
})();
var state__33373__auto__ = (function (){var statearr_34121 = f__33372__auto__();
(statearr_34121[(6)] = c__33371__auto__);

return statearr_34121;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped(state__33373__auto__);
}));

return c__33371__auto__;
});
/**
 * Takes elements from the from channel and supplies them to the to
 *   channel, subject to the async function af, with parallelism n. af
 *   must be a function of two arguments, the first an input value and
 *   the second a channel on which to place the result(s). The
 *   presumption is that af will return immediately, having launched some
 *   asynchronous operation whose completion/callback will put results on
 *   the channel, then close! it. Outputs will be returned in order
 *   relative to the inputs. By default, the to channel will be closed
 *   when the from channel closes, but can be determined by the close?
 *   parameter. Will stop consuming the from channel if the to channel
 *   closes. See also pipeline, pipeline-blocking.
 */
cljs.core.async.pipeline_async = (function cljs$core$async$pipeline_async(var_args){
var G__34129 = arguments.length;
switch (G__34129) {
case 4:
return cljs.core.async.pipeline_async.cljs$core$IFn$_invoke$arity$4((arguments[(0)]),(arguments[(1)]),(arguments[(2)]),(arguments[(3)]));

break;
case 5:
return cljs.core.async.pipeline_async.cljs$core$IFn$_invoke$arity$5((arguments[(0)]),(arguments[(1)]),(arguments[(2)]),(arguments[(3)]),(arguments[(4)]));

break;
default:
throw (new Error(["Invalid arity: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(arguments.length)].join('')));

}
});

(cljs.core.async.pipeline_async.cljs$core$IFn$_invoke$arity$4 = (function (n,to,af,from){
return cljs.core.async.pipeline_async.cljs$core$IFn$_invoke$arity$5(n,to,af,from,true);
}));

(cljs.core.async.pipeline_async.cljs$core$IFn$_invoke$arity$5 = (function (n,to,af,from,close_QMARK_){
return cljs.core.async.pipeline_STAR_(n,to,af,from,close_QMARK_,null,new cljs.core.Keyword(null,"async","async",1050769601));
}));

(cljs.core.async.pipeline_async.cljs$lang$maxFixedArity = 5);

/**
 * Takes elements from the from channel and supplies them to the to
 *   channel, subject to the transducer xf, with parallelism n. Because
 *   it is parallel, the transducer will be applied independently to each
 *   element, not across elements, and may produce zero or more outputs
 *   per input.  Outputs will be returned in order relative to the
 *   inputs. By default, the to channel will be closed when the from
 *   channel closes, but can be determined by the close?  parameter. Will
 *   stop consuming the from channel if the to channel closes.
 * 
 *   Note this is supplied for API compatibility with the Clojure version.
 *   Values of N > 1 will not result in actual concurrency in a
 *   single-threaded runtime.
 */
cljs.core.async.pipeline = (function cljs$core$async$pipeline(var_args){
var G__34188 = arguments.length;
switch (G__34188) {
case 4:
return cljs.core.async.pipeline.cljs$core$IFn$_invoke$arity$4((arguments[(0)]),(arguments[(1)]),(arguments[(2)]),(arguments[(3)]));

break;
case 5:
return cljs.core.async.pipeline.cljs$core$IFn$_invoke$arity$5((arguments[(0)]),(arguments[(1)]),(arguments[(2)]),(arguments[(3)]),(arguments[(4)]));

break;
case 6:
return cljs.core.async.pipeline.cljs$core$IFn$_invoke$arity$6((arguments[(0)]),(arguments[(1)]),(arguments[(2)]),(arguments[(3)]),(arguments[(4)]),(arguments[(5)]));

break;
default:
throw (new Error(["Invalid arity: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(arguments.length)].join('')));

}
});

(cljs.core.async.pipeline.cljs$core$IFn$_invoke$arity$4 = (function (n,to,xf,from){
return cljs.core.async.pipeline.cljs$core$IFn$_invoke$arity$5(n,to,xf,from,true);
}));

(cljs.core.async.pipeline.cljs$core$IFn$_invoke$arity$5 = (function (n,to,xf,from,close_QMARK_){
return cljs.core.async.pipeline.cljs$core$IFn$_invoke$arity$6(n,to,xf,from,close_QMARK_,null);
}));

(cljs.core.async.pipeline.cljs$core$IFn$_invoke$arity$6 = (function (n,to,xf,from,close_QMARK_,ex_handler){
return cljs.core.async.pipeline_STAR_(n,to,xf,from,close_QMARK_,ex_handler,new cljs.core.Keyword(null,"compute","compute",1555393130));
}));

(cljs.core.async.pipeline.cljs$lang$maxFixedArity = 6);

/**
 * Takes a predicate and a source channel and returns a vector of two
 *   channels, the first of which will contain the values for which the
 *   predicate returned true, the second those for which it returned
 *   false.
 * 
 *   The out channels will be unbuffered by default, or two buf-or-ns can
 *   be supplied. The channels will close after the source channel has
 *   closed.
 */
cljs.core.async.split = (function cljs$core$async$split(var_args){
var G__34196 = arguments.length;
switch (G__34196) {
case 2:
return cljs.core.async.split.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
case 4:
return cljs.core.async.split.cljs$core$IFn$_invoke$arity$4((arguments[(0)]),(arguments[(1)]),(arguments[(2)]),(arguments[(3)]));

break;
default:
throw (new Error(["Invalid arity: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(arguments.length)].join('')));

}
});

(cljs.core.async.split.cljs$core$IFn$_invoke$arity$2 = (function (p,ch){
return cljs.core.async.split.cljs$core$IFn$_invoke$arity$4(p,ch,null,null);
}));

(cljs.core.async.split.cljs$core$IFn$_invoke$arity$4 = (function (p,ch,t_buf_or_n,f_buf_or_n){
var tc = cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1(t_buf_or_n);
var fc = cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1(f_buf_or_n);
var c__33371__auto___36677 = cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1((1));
cljs.core.async.impl.dispatch.run((function (){
var f__33372__auto__ = (function (){var switch__33218__auto__ = (function (state_34250){
var state_val_34251 = (state_34250[(1)]);
if((state_val_34251 === (7))){
var inst_34242 = (state_34250[(2)]);
var state_34250__$1 = state_34250;
var statearr_34253_36678 = state_34250__$1;
(statearr_34253_36678[(2)] = inst_34242);

(statearr_34253_36678[(1)] = (3));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_34251 === (1))){
var state_34250__$1 = state_34250;
var statearr_34254_36682 = state_34250__$1;
(statearr_34254_36682[(2)] = null);

(statearr_34254_36682[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_34251 === (4))){
var inst_34215 = (state_34250[(7)]);
var inst_34215__$1 = (state_34250[(2)]);
var inst_34220 = (inst_34215__$1 == null);
var state_34250__$1 = (function (){var statearr_34255 = state_34250;
(statearr_34255[(7)] = inst_34215__$1);

return statearr_34255;
})();
if(cljs.core.truth_(inst_34220)){
var statearr_34259_36683 = state_34250__$1;
(statearr_34259_36683[(1)] = (5));

} else {
var statearr_34261_36684 = state_34250__$1;
(statearr_34261_36684[(1)] = (6));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_34251 === (13))){
var state_34250__$1 = state_34250;
var statearr_34262_36685 = state_34250__$1;
(statearr_34262_36685[(2)] = null);

(statearr_34262_36685[(1)] = (14));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_34251 === (6))){
var inst_34215 = (state_34250[(7)]);
var inst_34229 = (p.cljs$core$IFn$_invoke$arity$1 ? p.cljs$core$IFn$_invoke$arity$1(inst_34215) : p.call(null,inst_34215));
var state_34250__$1 = state_34250;
if(cljs.core.truth_(inst_34229)){
var statearr_34263_36689 = state_34250__$1;
(statearr_34263_36689[(1)] = (9));

} else {
var statearr_34264_36690 = state_34250__$1;
(statearr_34264_36690[(1)] = (10));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_34251 === (3))){
var inst_34244 = (state_34250[(2)]);
var state_34250__$1 = state_34250;
return cljs.core.async.impl.ioc_helpers.return_chan(state_34250__$1,inst_34244);
} else {
if((state_val_34251 === (12))){
var state_34250__$1 = state_34250;
var statearr_34265_36692 = state_34250__$1;
(statearr_34265_36692[(2)] = null);

(statearr_34265_36692[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_34251 === (2))){
var state_34250__$1 = state_34250;
return cljs.core.async.impl.ioc_helpers.take_BANG_(state_34250__$1,(4),ch);
} else {
if((state_val_34251 === (11))){
var inst_34215 = (state_34250[(7)]);
var inst_34233 = (state_34250[(2)]);
var state_34250__$1 = state_34250;
return cljs.core.async.impl.ioc_helpers.put_BANG_(state_34250__$1,(8),inst_34233,inst_34215);
} else {
if((state_val_34251 === (9))){
var state_34250__$1 = state_34250;
var statearr_34270_36693 = state_34250__$1;
(statearr_34270_36693[(2)] = tc);

(statearr_34270_36693[(1)] = (11));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_34251 === (5))){
var inst_34226 = cljs.core.async.close_BANG_(tc);
var inst_34227 = cljs.core.async.close_BANG_(fc);
var state_34250__$1 = (function (){var statearr_34271 = state_34250;
(statearr_34271[(8)] = inst_34226);

return statearr_34271;
})();
var statearr_34272_36695 = state_34250__$1;
(statearr_34272_36695[(2)] = inst_34227);

(statearr_34272_36695[(1)] = (7));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_34251 === (14))){
var inst_34240 = (state_34250[(2)]);
var state_34250__$1 = state_34250;
var statearr_34273_36698 = state_34250__$1;
(statearr_34273_36698[(2)] = inst_34240);

(statearr_34273_36698[(1)] = (7));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_34251 === (10))){
var state_34250__$1 = state_34250;
var statearr_34275_36699 = state_34250__$1;
(statearr_34275_36699[(2)] = fc);

(statearr_34275_36699[(1)] = (11));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_34251 === (8))){
var inst_34235 = (state_34250[(2)]);
var state_34250__$1 = state_34250;
if(cljs.core.truth_(inst_34235)){
var statearr_34276_36700 = state_34250__$1;
(statearr_34276_36700[(1)] = (12));

} else {
var statearr_34277_36701 = state_34250__$1;
(statearr_34277_36701[(1)] = (13));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
return null;
}
}
}
}
}
}
}
}
}
}
}
}
}
}
});
return (function() {
var cljs$core$async$state_machine__33219__auto__ = null;
var cljs$core$async$state_machine__33219__auto____0 = (function (){
var statearr_34278 = [null,null,null,null,null,null,null,null,null];
(statearr_34278[(0)] = cljs$core$async$state_machine__33219__auto__);

(statearr_34278[(1)] = (1));

return statearr_34278;
});
var cljs$core$async$state_machine__33219__auto____1 = (function (state_34250){
while(true){
var ret_value__33220__auto__ = (function (){try{while(true){
var result__33221__auto__ = switch__33218__auto__(state_34250);
if(cljs.core.keyword_identical_QMARK_(result__33221__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
continue;
} else {
return result__33221__auto__;
}
break;
}
}catch (e34279){var ex__33222__auto__ = e34279;
var statearr_34280_36703 = state_34250;
(statearr_34280_36703[(2)] = ex__33222__auto__);


if(cljs.core.seq((state_34250[(4)]))){
var statearr_34281_36705 = state_34250;
(statearr_34281_36705[(1)] = cljs.core.first((state_34250[(4)])));

} else {
throw ex__33222__auto__;
}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
}})();
if(cljs.core.keyword_identical_QMARK_(ret_value__33220__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
var G__36706 = state_34250;
state_34250 = G__36706;
continue;
} else {
return ret_value__33220__auto__;
}
break;
}
});
cljs$core$async$state_machine__33219__auto__ = function(state_34250){
switch(arguments.length){
case 0:
return cljs$core$async$state_machine__33219__auto____0.call(this);
case 1:
return cljs$core$async$state_machine__33219__auto____1.call(this,state_34250);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
cljs$core$async$state_machine__33219__auto__.cljs$core$IFn$_invoke$arity$0 = cljs$core$async$state_machine__33219__auto____0;
cljs$core$async$state_machine__33219__auto__.cljs$core$IFn$_invoke$arity$1 = cljs$core$async$state_machine__33219__auto____1;
return cljs$core$async$state_machine__33219__auto__;
})()
})();
var state__33373__auto__ = (function (){var statearr_34282 = f__33372__auto__();
(statearr_34282[(6)] = c__33371__auto___36677);

return statearr_34282;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped(state__33373__auto__);
}));


return new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [tc,fc], null);
}));

(cljs.core.async.split.cljs$lang$maxFixedArity = 4);

/**
 * f should be a function of 2 arguments. Returns a channel containing
 *   the single result of applying f to init and the first item from the
 *   channel, then applying f to that result and the 2nd item, etc. If
 *   the channel closes without yielding items, returns init and f is not
 *   called. ch must close before reduce produces a result.
 */
cljs.core.async.reduce = (function cljs$core$async$reduce(f,init,ch){
var c__33371__auto__ = cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1((1));
cljs.core.async.impl.dispatch.run((function (){
var f__33372__auto__ = (function (){var switch__33218__auto__ = (function (state_34307){
var state_val_34308 = (state_34307[(1)]);
if((state_val_34308 === (7))){
var inst_34303 = (state_34307[(2)]);
var state_34307__$1 = state_34307;
var statearr_34309_36708 = state_34307__$1;
(statearr_34309_36708[(2)] = inst_34303);

(statearr_34309_36708[(1)] = (3));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_34308 === (1))){
var inst_34286 = init;
var inst_34287 = inst_34286;
var state_34307__$1 = (function (){var statearr_34310 = state_34307;
(statearr_34310[(7)] = inst_34287);

return statearr_34310;
})();
var statearr_34312_36709 = state_34307__$1;
(statearr_34312_36709[(2)] = null);

(statearr_34312_36709[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_34308 === (4))){
var inst_34290 = (state_34307[(8)]);
var inst_34290__$1 = (state_34307[(2)]);
var inst_34291 = (inst_34290__$1 == null);
var state_34307__$1 = (function (){var statearr_34313 = state_34307;
(statearr_34313[(8)] = inst_34290__$1);

return statearr_34313;
})();
if(cljs.core.truth_(inst_34291)){
var statearr_34314_36711 = state_34307__$1;
(statearr_34314_36711[(1)] = (5));

} else {
var statearr_34315_36712 = state_34307__$1;
(statearr_34315_36712[(1)] = (6));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_34308 === (6))){
var inst_34294 = (state_34307[(9)]);
var inst_34287 = (state_34307[(7)]);
var inst_34290 = (state_34307[(8)]);
var inst_34294__$1 = (f.cljs$core$IFn$_invoke$arity$2 ? f.cljs$core$IFn$_invoke$arity$2(inst_34287,inst_34290) : f.call(null,inst_34287,inst_34290));
var inst_34295 = cljs.core.reduced_QMARK_(inst_34294__$1);
var state_34307__$1 = (function (){var statearr_34317 = state_34307;
(statearr_34317[(9)] = inst_34294__$1);

return statearr_34317;
})();
if(inst_34295){
var statearr_34318_36714 = state_34307__$1;
(statearr_34318_36714[(1)] = (8));

} else {
var statearr_34319_36715 = state_34307__$1;
(statearr_34319_36715[(1)] = (9));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_34308 === (3))){
var inst_34305 = (state_34307[(2)]);
var state_34307__$1 = state_34307;
return cljs.core.async.impl.ioc_helpers.return_chan(state_34307__$1,inst_34305);
} else {
if((state_val_34308 === (2))){
var state_34307__$1 = state_34307;
return cljs.core.async.impl.ioc_helpers.take_BANG_(state_34307__$1,(4),ch);
} else {
if((state_val_34308 === (9))){
var inst_34294 = (state_34307[(9)]);
var inst_34287 = inst_34294;
var state_34307__$1 = (function (){var statearr_34320 = state_34307;
(statearr_34320[(7)] = inst_34287);

return statearr_34320;
})();
var statearr_34321_36717 = state_34307__$1;
(statearr_34321_36717[(2)] = null);

(statearr_34321_36717[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_34308 === (5))){
var inst_34287 = (state_34307[(7)]);
var state_34307__$1 = state_34307;
var statearr_34331_36718 = state_34307__$1;
(statearr_34331_36718[(2)] = inst_34287);

(statearr_34331_36718[(1)] = (7));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_34308 === (10))){
var inst_34301 = (state_34307[(2)]);
var state_34307__$1 = state_34307;
var statearr_34333_36719 = state_34307__$1;
(statearr_34333_36719[(2)] = inst_34301);

(statearr_34333_36719[(1)] = (7));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_34308 === (8))){
var inst_34294 = (state_34307[(9)]);
var inst_34297 = cljs.core.deref(inst_34294);
var state_34307__$1 = state_34307;
var statearr_34334_36721 = state_34307__$1;
(statearr_34334_36721[(2)] = inst_34297);

(statearr_34334_36721[(1)] = (10));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
return null;
}
}
}
}
}
}
}
}
}
}
});
return (function() {
var cljs$core$async$reduce_$_state_machine__33219__auto__ = null;
var cljs$core$async$reduce_$_state_machine__33219__auto____0 = (function (){
var statearr_34335 = [null,null,null,null,null,null,null,null,null,null];
(statearr_34335[(0)] = cljs$core$async$reduce_$_state_machine__33219__auto__);

(statearr_34335[(1)] = (1));

return statearr_34335;
});
var cljs$core$async$reduce_$_state_machine__33219__auto____1 = (function (state_34307){
while(true){
var ret_value__33220__auto__ = (function (){try{while(true){
var result__33221__auto__ = switch__33218__auto__(state_34307);
if(cljs.core.keyword_identical_QMARK_(result__33221__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
continue;
} else {
return result__33221__auto__;
}
break;
}
}catch (e34336){var ex__33222__auto__ = e34336;
var statearr_34337_36723 = state_34307;
(statearr_34337_36723[(2)] = ex__33222__auto__);


if(cljs.core.seq((state_34307[(4)]))){
var statearr_34338_36725 = state_34307;
(statearr_34338_36725[(1)] = cljs.core.first((state_34307[(4)])));

} else {
throw ex__33222__auto__;
}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
}})();
if(cljs.core.keyword_identical_QMARK_(ret_value__33220__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
var G__36726 = state_34307;
state_34307 = G__36726;
continue;
} else {
return ret_value__33220__auto__;
}
break;
}
});
cljs$core$async$reduce_$_state_machine__33219__auto__ = function(state_34307){
switch(arguments.length){
case 0:
return cljs$core$async$reduce_$_state_machine__33219__auto____0.call(this);
case 1:
return cljs$core$async$reduce_$_state_machine__33219__auto____1.call(this,state_34307);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
cljs$core$async$reduce_$_state_machine__33219__auto__.cljs$core$IFn$_invoke$arity$0 = cljs$core$async$reduce_$_state_machine__33219__auto____0;
cljs$core$async$reduce_$_state_machine__33219__auto__.cljs$core$IFn$_invoke$arity$1 = cljs$core$async$reduce_$_state_machine__33219__auto____1;
return cljs$core$async$reduce_$_state_machine__33219__auto__;
})()
})();
var state__33373__auto__ = (function (){var statearr_34339 = f__33372__auto__();
(statearr_34339[(6)] = c__33371__auto__);

return statearr_34339;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped(state__33373__auto__);
}));

return c__33371__auto__;
});
/**
 * async/reduces a channel with a transformation (xform f).
 *   Returns a channel containing the result.  ch must close before
 *   transduce produces a result.
 */
cljs.core.async.transduce = (function cljs$core$async$transduce(xform,f,init,ch){
var f__$1 = (xform.cljs$core$IFn$_invoke$arity$1 ? xform.cljs$core$IFn$_invoke$arity$1(f) : xform.call(null,f));
var c__33371__auto__ = cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1((1));
cljs.core.async.impl.dispatch.run((function (){
var f__33372__auto__ = (function (){var switch__33218__auto__ = (function (state_34346){
var state_val_34347 = (state_34346[(1)]);
if((state_val_34347 === (1))){
var inst_34340 = cljs.core.async.reduce(f__$1,init,ch);
var state_34346__$1 = state_34346;
return cljs.core.async.impl.ioc_helpers.take_BANG_(state_34346__$1,(2),inst_34340);
} else {
if((state_val_34347 === (2))){
var inst_34342 = (state_34346[(2)]);
var inst_34344 = (f__$1.cljs$core$IFn$_invoke$arity$1 ? f__$1.cljs$core$IFn$_invoke$arity$1(inst_34342) : f__$1.call(null,inst_34342));
var state_34346__$1 = state_34346;
return cljs.core.async.impl.ioc_helpers.return_chan(state_34346__$1,inst_34344);
} else {
return null;
}
}
});
return (function() {
var cljs$core$async$transduce_$_state_machine__33219__auto__ = null;
var cljs$core$async$transduce_$_state_machine__33219__auto____0 = (function (){
var statearr_34357 = [null,null,null,null,null,null,null];
(statearr_34357[(0)] = cljs$core$async$transduce_$_state_machine__33219__auto__);

(statearr_34357[(1)] = (1));

return statearr_34357;
});
var cljs$core$async$transduce_$_state_machine__33219__auto____1 = (function (state_34346){
while(true){
var ret_value__33220__auto__ = (function (){try{while(true){
var result__33221__auto__ = switch__33218__auto__(state_34346);
if(cljs.core.keyword_identical_QMARK_(result__33221__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
continue;
} else {
return result__33221__auto__;
}
break;
}
}catch (e34358){var ex__33222__auto__ = e34358;
var statearr_34359_36730 = state_34346;
(statearr_34359_36730[(2)] = ex__33222__auto__);


if(cljs.core.seq((state_34346[(4)]))){
var statearr_34360_36731 = state_34346;
(statearr_34360_36731[(1)] = cljs.core.first((state_34346[(4)])));

} else {
throw ex__33222__auto__;
}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
}})();
if(cljs.core.keyword_identical_QMARK_(ret_value__33220__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
var G__36733 = state_34346;
state_34346 = G__36733;
continue;
} else {
return ret_value__33220__auto__;
}
break;
}
});
cljs$core$async$transduce_$_state_machine__33219__auto__ = function(state_34346){
switch(arguments.length){
case 0:
return cljs$core$async$transduce_$_state_machine__33219__auto____0.call(this);
case 1:
return cljs$core$async$transduce_$_state_machine__33219__auto____1.call(this,state_34346);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
cljs$core$async$transduce_$_state_machine__33219__auto__.cljs$core$IFn$_invoke$arity$0 = cljs$core$async$transduce_$_state_machine__33219__auto____0;
cljs$core$async$transduce_$_state_machine__33219__auto__.cljs$core$IFn$_invoke$arity$1 = cljs$core$async$transduce_$_state_machine__33219__auto____1;
return cljs$core$async$transduce_$_state_machine__33219__auto__;
})()
})();
var state__33373__auto__ = (function (){var statearr_34361 = f__33372__auto__();
(statearr_34361[(6)] = c__33371__auto__);

return statearr_34361;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped(state__33373__auto__);
}));

return c__33371__auto__;
});
/**
 * Puts the contents of coll into the supplied channel.
 * 
 *   By default the channel will be closed after the items are copied,
 *   but can be determined by the close? parameter.
 * 
 *   Returns a channel which will close after the items are copied.
 */
cljs.core.async.onto_chan_BANG_ = (function cljs$core$async$onto_chan_BANG_(var_args){
var G__34368 = arguments.length;
switch (G__34368) {
case 2:
return cljs.core.async.onto_chan_BANG_.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
case 3:
return cljs.core.async.onto_chan_BANG_.cljs$core$IFn$_invoke$arity$3((arguments[(0)]),(arguments[(1)]),(arguments[(2)]));

break;
default:
throw (new Error(["Invalid arity: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(arguments.length)].join('')));

}
});

(cljs.core.async.onto_chan_BANG_.cljs$core$IFn$_invoke$arity$2 = (function (ch,coll){
return cljs.core.async.onto_chan_BANG_.cljs$core$IFn$_invoke$arity$3(ch,coll,true);
}));

(cljs.core.async.onto_chan_BANG_.cljs$core$IFn$_invoke$arity$3 = (function (ch,coll,close_QMARK_){
var c__33371__auto__ = cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1((1));
cljs.core.async.impl.dispatch.run((function (){
var f__33372__auto__ = (function (){var switch__33218__auto__ = (function (state_34404){
var state_val_34406 = (state_34404[(1)]);
if((state_val_34406 === (7))){
var inst_34384 = (state_34404[(2)]);
var state_34404__$1 = state_34404;
var statearr_34409_36737 = state_34404__$1;
(statearr_34409_36737[(2)] = inst_34384);

(statearr_34409_36737[(1)] = (6));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_34406 === (1))){
var inst_34378 = cljs.core.seq(coll);
var inst_34379 = inst_34378;
var state_34404__$1 = (function (){var statearr_34411 = state_34404;
(statearr_34411[(7)] = inst_34379);

return statearr_34411;
})();
var statearr_34412_36738 = state_34404__$1;
(statearr_34412_36738[(2)] = null);

(statearr_34412_36738[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_34406 === (4))){
var inst_34379 = (state_34404[(7)]);
var inst_34382 = cljs.core.first(inst_34379);
var state_34404__$1 = state_34404;
return cljs.core.async.impl.ioc_helpers.put_BANG_(state_34404__$1,(7),ch,inst_34382);
} else {
if((state_val_34406 === (13))){
var inst_34397 = (state_34404[(2)]);
var state_34404__$1 = state_34404;
var statearr_34417_36739 = state_34404__$1;
(statearr_34417_36739[(2)] = inst_34397);

(statearr_34417_36739[(1)] = (10));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_34406 === (6))){
var inst_34387 = (state_34404[(2)]);
var state_34404__$1 = state_34404;
if(cljs.core.truth_(inst_34387)){
var statearr_34419_36740 = state_34404__$1;
(statearr_34419_36740[(1)] = (8));

} else {
var statearr_34420_36741 = state_34404__$1;
(statearr_34420_36741[(1)] = (9));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_34406 === (3))){
var inst_34401 = (state_34404[(2)]);
var state_34404__$1 = state_34404;
return cljs.core.async.impl.ioc_helpers.return_chan(state_34404__$1,inst_34401);
} else {
if((state_val_34406 === (12))){
var state_34404__$1 = state_34404;
var statearr_34425_36742 = state_34404__$1;
(statearr_34425_36742[(2)] = null);

(statearr_34425_36742[(1)] = (13));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_34406 === (2))){
var inst_34379 = (state_34404[(7)]);
var state_34404__$1 = state_34404;
if(cljs.core.truth_(inst_34379)){
var statearr_34427_36743 = state_34404__$1;
(statearr_34427_36743[(1)] = (4));

} else {
var statearr_34428_36744 = state_34404__$1;
(statearr_34428_36744[(1)] = (5));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_34406 === (11))){
var inst_34394 = cljs.core.async.close_BANG_(ch);
var state_34404__$1 = state_34404;
var statearr_34431_36745 = state_34404__$1;
(statearr_34431_36745[(2)] = inst_34394);

(statearr_34431_36745[(1)] = (13));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_34406 === (9))){
var state_34404__$1 = state_34404;
if(cljs.core.truth_(close_QMARK_)){
var statearr_34432_36746 = state_34404__$1;
(statearr_34432_36746[(1)] = (11));

} else {
var statearr_34435_36747 = state_34404__$1;
(statearr_34435_36747[(1)] = (12));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_34406 === (5))){
var inst_34379 = (state_34404[(7)]);
var state_34404__$1 = state_34404;
var statearr_34436_36748 = state_34404__$1;
(statearr_34436_36748[(2)] = inst_34379);

(statearr_34436_36748[(1)] = (6));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_34406 === (10))){
var inst_34399 = (state_34404[(2)]);
var state_34404__$1 = state_34404;
var statearr_34437_36749 = state_34404__$1;
(statearr_34437_36749[(2)] = inst_34399);

(statearr_34437_36749[(1)] = (3));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_34406 === (8))){
var inst_34379 = (state_34404[(7)]);
var inst_34389 = cljs.core.next(inst_34379);
var inst_34379__$1 = inst_34389;
var state_34404__$1 = (function (){var statearr_34438 = state_34404;
(statearr_34438[(7)] = inst_34379__$1);

return statearr_34438;
})();
var statearr_34439_36751 = state_34404__$1;
(statearr_34439_36751[(2)] = null);

(statearr_34439_36751[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
return null;
}
}
}
}
}
}
}
}
}
}
}
}
}
});
return (function() {
var cljs$core$async$state_machine__33219__auto__ = null;
var cljs$core$async$state_machine__33219__auto____0 = (function (){
var statearr_34441 = [null,null,null,null,null,null,null,null];
(statearr_34441[(0)] = cljs$core$async$state_machine__33219__auto__);

(statearr_34441[(1)] = (1));

return statearr_34441;
});
var cljs$core$async$state_machine__33219__auto____1 = (function (state_34404){
while(true){
var ret_value__33220__auto__ = (function (){try{while(true){
var result__33221__auto__ = switch__33218__auto__(state_34404);
if(cljs.core.keyword_identical_QMARK_(result__33221__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
continue;
} else {
return result__33221__auto__;
}
break;
}
}catch (e34444){var ex__33222__auto__ = e34444;
var statearr_34445_36754 = state_34404;
(statearr_34445_36754[(2)] = ex__33222__auto__);


if(cljs.core.seq((state_34404[(4)]))){
var statearr_34446_36758 = state_34404;
(statearr_34446_36758[(1)] = cljs.core.first((state_34404[(4)])));

} else {
throw ex__33222__auto__;
}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
}})();
if(cljs.core.keyword_identical_QMARK_(ret_value__33220__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
var G__36759 = state_34404;
state_34404 = G__36759;
continue;
} else {
return ret_value__33220__auto__;
}
break;
}
});
cljs$core$async$state_machine__33219__auto__ = function(state_34404){
switch(arguments.length){
case 0:
return cljs$core$async$state_machine__33219__auto____0.call(this);
case 1:
return cljs$core$async$state_machine__33219__auto____1.call(this,state_34404);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
cljs$core$async$state_machine__33219__auto__.cljs$core$IFn$_invoke$arity$0 = cljs$core$async$state_machine__33219__auto____0;
cljs$core$async$state_machine__33219__auto__.cljs$core$IFn$_invoke$arity$1 = cljs$core$async$state_machine__33219__auto____1;
return cljs$core$async$state_machine__33219__auto__;
})()
})();
var state__33373__auto__ = (function (){var statearr_34448 = f__33372__auto__();
(statearr_34448[(6)] = c__33371__auto__);

return statearr_34448;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped(state__33373__auto__);
}));

return c__33371__auto__;
}));

(cljs.core.async.onto_chan_BANG_.cljs$lang$maxFixedArity = 3);

/**
 * Creates and returns a channel which contains the contents of coll,
 *   closing when exhausted.
 */
cljs.core.async.to_chan_BANG_ = (function cljs$core$async$to_chan_BANG_(coll){
var ch = cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1(cljs.core.bounded_count((100),coll));
cljs.core.async.onto_chan_BANG_.cljs$core$IFn$_invoke$arity$2(ch,coll);

return ch;
});
/**
 * Deprecated - use onto-chan!
 */
cljs.core.async.onto_chan = (function cljs$core$async$onto_chan(var_args){
var G__34459 = arguments.length;
switch (G__34459) {
case 2:
return cljs.core.async.onto_chan.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
case 3:
return cljs.core.async.onto_chan.cljs$core$IFn$_invoke$arity$3((arguments[(0)]),(arguments[(1)]),(arguments[(2)]));

break;
default:
throw (new Error(["Invalid arity: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(arguments.length)].join('')));

}
});

(cljs.core.async.onto_chan.cljs$core$IFn$_invoke$arity$2 = (function (ch,coll){
return cljs.core.async.onto_chan_BANG_.cljs$core$IFn$_invoke$arity$3(ch,coll,true);
}));

(cljs.core.async.onto_chan.cljs$core$IFn$_invoke$arity$3 = (function (ch,coll,close_QMARK_){
return cljs.core.async.onto_chan_BANG_.cljs$core$IFn$_invoke$arity$3(ch,coll,close_QMARK_);
}));

(cljs.core.async.onto_chan.cljs$lang$maxFixedArity = 3);

/**
 * Deprecated - use to-chan!
 */
cljs.core.async.to_chan = (function cljs$core$async$to_chan(coll){
return cljs.core.async.to_chan_BANG_(coll);
});

/**
 * @interface
 */
cljs.core.async.Mux = function(){};

var cljs$core$async$Mux$muxch_STAR_$dyn_36770 = (function (_){
var x__5393__auto__ = (((_ == null))?null:_);
var m__5394__auto__ = (cljs.core.async.muxch_STAR_[goog.typeOf(x__5393__auto__)]);
if((!((m__5394__auto__ == null)))){
return (m__5394__auto__.cljs$core$IFn$_invoke$arity$1 ? m__5394__auto__.cljs$core$IFn$_invoke$arity$1(_) : m__5394__auto__.call(null,_));
} else {
var m__5392__auto__ = (cljs.core.async.muxch_STAR_["_"]);
if((!((m__5392__auto__ == null)))){
return (m__5392__auto__.cljs$core$IFn$_invoke$arity$1 ? m__5392__auto__.cljs$core$IFn$_invoke$arity$1(_) : m__5392__auto__.call(null,_));
} else {
throw cljs.core.missing_protocol("Mux.muxch*",_);
}
}
});
cljs.core.async.muxch_STAR_ = (function cljs$core$async$muxch_STAR_(_){
if((((!((_ == null)))) && ((!((_.cljs$core$async$Mux$muxch_STAR_$arity$1 == null)))))){
return _.cljs$core$async$Mux$muxch_STAR_$arity$1(_);
} else {
return cljs$core$async$Mux$muxch_STAR_$dyn_36770(_);
}
});


/**
 * @interface
 */
cljs.core.async.Mult = function(){};

var cljs$core$async$Mult$tap_STAR_$dyn_36771 = (function (m,ch,close_QMARK_){
var x__5393__auto__ = (((m == null))?null:m);
var m__5394__auto__ = (cljs.core.async.tap_STAR_[goog.typeOf(x__5393__auto__)]);
if((!((m__5394__auto__ == null)))){
return (m__5394__auto__.cljs$core$IFn$_invoke$arity$3 ? m__5394__auto__.cljs$core$IFn$_invoke$arity$3(m,ch,close_QMARK_) : m__5394__auto__.call(null,m,ch,close_QMARK_));
} else {
var m__5392__auto__ = (cljs.core.async.tap_STAR_["_"]);
if((!((m__5392__auto__ == null)))){
return (m__5392__auto__.cljs$core$IFn$_invoke$arity$3 ? m__5392__auto__.cljs$core$IFn$_invoke$arity$3(m,ch,close_QMARK_) : m__5392__auto__.call(null,m,ch,close_QMARK_));
} else {
throw cljs.core.missing_protocol("Mult.tap*",m);
}
}
});
cljs.core.async.tap_STAR_ = (function cljs$core$async$tap_STAR_(m,ch,close_QMARK_){
if((((!((m == null)))) && ((!((m.cljs$core$async$Mult$tap_STAR_$arity$3 == null)))))){
return m.cljs$core$async$Mult$tap_STAR_$arity$3(m,ch,close_QMARK_);
} else {
return cljs$core$async$Mult$tap_STAR_$dyn_36771(m,ch,close_QMARK_);
}
});

var cljs$core$async$Mult$untap_STAR_$dyn_36772 = (function (m,ch){
var x__5393__auto__ = (((m == null))?null:m);
var m__5394__auto__ = (cljs.core.async.untap_STAR_[goog.typeOf(x__5393__auto__)]);
if((!((m__5394__auto__ == null)))){
return (m__5394__auto__.cljs$core$IFn$_invoke$arity$2 ? m__5394__auto__.cljs$core$IFn$_invoke$arity$2(m,ch) : m__5394__auto__.call(null,m,ch));
} else {
var m__5392__auto__ = (cljs.core.async.untap_STAR_["_"]);
if((!((m__5392__auto__ == null)))){
return (m__5392__auto__.cljs$core$IFn$_invoke$arity$2 ? m__5392__auto__.cljs$core$IFn$_invoke$arity$2(m,ch) : m__5392__auto__.call(null,m,ch));
} else {
throw cljs.core.missing_protocol("Mult.untap*",m);
}
}
});
cljs.core.async.untap_STAR_ = (function cljs$core$async$untap_STAR_(m,ch){
if((((!((m == null)))) && ((!((m.cljs$core$async$Mult$untap_STAR_$arity$2 == null)))))){
return m.cljs$core$async$Mult$untap_STAR_$arity$2(m,ch);
} else {
return cljs$core$async$Mult$untap_STAR_$dyn_36772(m,ch);
}
});

var cljs$core$async$Mult$untap_all_STAR_$dyn_36773 = (function (m){
var x__5393__auto__ = (((m == null))?null:m);
var m__5394__auto__ = (cljs.core.async.untap_all_STAR_[goog.typeOf(x__5393__auto__)]);
if((!((m__5394__auto__ == null)))){
return (m__5394__auto__.cljs$core$IFn$_invoke$arity$1 ? m__5394__auto__.cljs$core$IFn$_invoke$arity$1(m) : m__5394__auto__.call(null,m));
} else {
var m__5392__auto__ = (cljs.core.async.untap_all_STAR_["_"]);
if((!((m__5392__auto__ == null)))){
return (m__5392__auto__.cljs$core$IFn$_invoke$arity$1 ? m__5392__auto__.cljs$core$IFn$_invoke$arity$1(m) : m__5392__auto__.call(null,m));
} else {
throw cljs.core.missing_protocol("Mult.untap-all*",m);
}
}
});
cljs.core.async.untap_all_STAR_ = (function cljs$core$async$untap_all_STAR_(m){
if((((!((m == null)))) && ((!((m.cljs$core$async$Mult$untap_all_STAR_$arity$1 == null)))))){
return m.cljs$core$async$Mult$untap_all_STAR_$arity$1(m);
} else {
return cljs$core$async$Mult$untap_all_STAR_$dyn_36773(m);
}
});


/**
* @constructor
 * @implements {cljs.core.async.Mult}
 * @implements {cljs.core.IMeta}
 * @implements {cljs.core.async.Mux}
 * @implements {cljs.core.IWithMeta}
*/
cljs.core.async.t_cljs$core$async34484 = (function (ch,cs,meta34485){
this.ch = ch;
this.cs = cs;
this.meta34485 = meta34485;
this.cljs$lang$protocol_mask$partition0$ = 393216;
this.cljs$lang$protocol_mask$partition1$ = 0;
});
(cljs.core.async.t_cljs$core$async34484.prototype.cljs$core$IWithMeta$_with_meta$arity$2 = (function (_34486,meta34485__$1){
var self__ = this;
var _34486__$1 = this;
return (new cljs.core.async.t_cljs$core$async34484(self__.ch,self__.cs,meta34485__$1));
}));

(cljs.core.async.t_cljs$core$async34484.prototype.cljs$core$IMeta$_meta$arity$1 = (function (_34486){
var self__ = this;
var _34486__$1 = this;
return self__.meta34485;
}));

(cljs.core.async.t_cljs$core$async34484.prototype.cljs$core$async$Mux$ = cljs.core.PROTOCOL_SENTINEL);

(cljs.core.async.t_cljs$core$async34484.prototype.cljs$core$async$Mux$muxch_STAR_$arity$1 = (function (_){
var self__ = this;
var ___$1 = this;
return self__.ch;
}));

(cljs.core.async.t_cljs$core$async34484.prototype.cljs$core$async$Mult$ = cljs.core.PROTOCOL_SENTINEL);

(cljs.core.async.t_cljs$core$async34484.prototype.cljs$core$async$Mult$tap_STAR_$arity$3 = (function (_,ch__$1,close_QMARK_){
var self__ = this;
var ___$1 = this;
cljs.core.swap_BANG_.cljs$core$IFn$_invoke$arity$4(self__.cs,cljs.core.assoc,ch__$1,close_QMARK_);

return null;
}));

(cljs.core.async.t_cljs$core$async34484.prototype.cljs$core$async$Mult$untap_STAR_$arity$2 = (function (_,ch__$1){
var self__ = this;
var ___$1 = this;
cljs.core.swap_BANG_.cljs$core$IFn$_invoke$arity$3(self__.cs,cljs.core.dissoc,ch__$1);

return null;
}));

(cljs.core.async.t_cljs$core$async34484.prototype.cljs$core$async$Mult$untap_all_STAR_$arity$1 = (function (_){
var self__ = this;
var ___$1 = this;
cljs.core.reset_BANG_(self__.cs,cljs.core.PersistentArrayMap.EMPTY);

return null;
}));

(cljs.core.async.t_cljs$core$async34484.getBasis = (function (){
return new cljs.core.PersistentVector(null, 3, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Symbol(null,"ch","ch",1085813622,null),new cljs.core.Symbol(null,"cs","cs",-117024463,null),new cljs.core.Symbol(null,"meta34485","meta34485",-1283429427,null)], null);
}));

(cljs.core.async.t_cljs$core$async34484.cljs$lang$type = true);

(cljs.core.async.t_cljs$core$async34484.cljs$lang$ctorStr = "cljs.core.async/t_cljs$core$async34484");

(cljs.core.async.t_cljs$core$async34484.cljs$lang$ctorPrWriter = (function (this__5330__auto__,writer__5331__auto__,opt__5332__auto__){
return cljs.core._write(writer__5331__auto__,"cljs.core.async/t_cljs$core$async34484");
}));

/**
 * Positional factory function for cljs.core.async/t_cljs$core$async34484.
 */
cljs.core.async.__GT_t_cljs$core$async34484 = (function cljs$core$async$__GT_t_cljs$core$async34484(ch,cs,meta34485){
return (new cljs.core.async.t_cljs$core$async34484(ch,cs,meta34485));
});


/**
 * Creates and returns a mult(iple) of the supplied channel. Channels
 *   containing copies of the channel can be created with 'tap', and
 *   detached with 'untap'.
 * 
 *   Each item is distributed to all taps in parallel and synchronously,
 *   i.e. each tap must accept before the next item is distributed. Use
 *   buffering/windowing to prevent slow taps from holding up the mult.
 * 
 *   Items received when there are no taps get dropped.
 * 
 *   If a tap puts to a closed channel, it will be removed from the mult.
 */
cljs.core.async.mult = (function cljs$core$async$mult(ch){
var cs = cljs.core.atom.cljs$core$IFn$_invoke$arity$1(cljs.core.PersistentArrayMap.EMPTY);
var m = (new cljs.core.async.t_cljs$core$async34484(ch,cs,cljs.core.PersistentArrayMap.EMPTY));
var dchan = cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1((1));
var dctr = cljs.core.atom.cljs$core$IFn$_invoke$arity$1(null);
var done = (function (_){
if((cljs.core.swap_BANG_.cljs$core$IFn$_invoke$arity$2(dctr,cljs.core.dec) === (0))){
return cljs.core.async.put_BANG_.cljs$core$IFn$_invoke$arity$2(dchan,true);
} else {
return null;
}
});
var c__33371__auto___36782 = cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1((1));
cljs.core.async.impl.dispatch.run((function (){
var f__33372__auto__ = (function (){var switch__33218__auto__ = (function (state_34632){
var state_val_34633 = (state_34632[(1)]);
if((state_val_34633 === (7))){
var inst_34628 = (state_34632[(2)]);
var state_34632__$1 = state_34632;
var statearr_34638_36783 = state_34632__$1;
(statearr_34638_36783[(2)] = inst_34628);

(statearr_34638_36783[(1)] = (3));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_34633 === (20))){
var inst_34531 = (state_34632[(7)]);
var inst_34544 = cljs.core.first(inst_34531);
var inst_34545 = cljs.core.nth.cljs$core$IFn$_invoke$arity$3(inst_34544,(0),null);
var inst_34546 = cljs.core.nth.cljs$core$IFn$_invoke$arity$3(inst_34544,(1),null);
var state_34632__$1 = (function (){var statearr_34639 = state_34632;
(statearr_34639[(8)] = inst_34545);

return statearr_34639;
})();
if(cljs.core.truth_(inst_34546)){
var statearr_34641_36791 = state_34632__$1;
(statearr_34641_36791[(1)] = (22));

} else {
var statearr_34645_36792 = state_34632__$1;
(statearr_34645_36792[(1)] = (23));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_34633 === (27))){
var inst_34574 = (state_34632[(9)]);
var inst_34576 = (state_34632[(10)]);
var inst_34497 = (state_34632[(11)]);
var inst_34582 = (state_34632[(12)]);
var inst_34582__$1 = cljs.core._nth(inst_34574,inst_34576);
var inst_34583 = cljs.core.async.put_BANG_.cljs$core$IFn$_invoke$arity$3(inst_34582__$1,inst_34497,done);
var state_34632__$1 = (function (){var statearr_34646 = state_34632;
(statearr_34646[(12)] = inst_34582__$1);

return statearr_34646;
})();
if(cljs.core.truth_(inst_34583)){
var statearr_34648_36803 = state_34632__$1;
(statearr_34648_36803[(1)] = (30));

} else {
var statearr_34649_36804 = state_34632__$1;
(statearr_34649_36804[(1)] = (31));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_34633 === (1))){
var state_34632__$1 = state_34632;
var statearr_34651_36805 = state_34632__$1;
(statearr_34651_36805[(2)] = null);

(statearr_34651_36805[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_34633 === (24))){
var inst_34531 = (state_34632[(7)]);
var inst_34551 = (state_34632[(2)]);
var inst_34552 = cljs.core.next(inst_34531);
var inst_34507 = inst_34552;
var inst_34508 = null;
var inst_34509 = (0);
var inst_34510 = (0);
var state_34632__$1 = (function (){var statearr_34652 = state_34632;
(statearr_34652[(13)] = inst_34507);

(statearr_34652[(14)] = inst_34509);

(statearr_34652[(15)] = inst_34510);

(statearr_34652[(16)] = inst_34551);

(statearr_34652[(17)] = inst_34508);

return statearr_34652;
})();
var statearr_34653_36806 = state_34632__$1;
(statearr_34653_36806[(2)] = null);

(statearr_34653_36806[(1)] = (8));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_34633 === (39))){
var state_34632__$1 = state_34632;
var statearr_34660_36807 = state_34632__$1;
(statearr_34660_36807[(2)] = null);

(statearr_34660_36807[(1)] = (41));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_34633 === (4))){
var inst_34497 = (state_34632[(11)]);
var inst_34497__$1 = (state_34632[(2)]);
var inst_34498 = (inst_34497__$1 == null);
var state_34632__$1 = (function (){var statearr_34662 = state_34632;
(statearr_34662[(11)] = inst_34497__$1);

return statearr_34662;
})();
if(cljs.core.truth_(inst_34498)){
var statearr_34663_36808 = state_34632__$1;
(statearr_34663_36808[(1)] = (5));

} else {
var statearr_34664_36809 = state_34632__$1;
(statearr_34664_36809[(1)] = (6));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_34633 === (15))){
var inst_34507 = (state_34632[(13)]);
var inst_34509 = (state_34632[(14)]);
var inst_34510 = (state_34632[(15)]);
var inst_34508 = (state_34632[(17)]);
var inst_34527 = (state_34632[(2)]);
var inst_34528 = (inst_34510 + (1));
var tmp34654 = inst_34507;
var tmp34655 = inst_34509;
var tmp34656 = inst_34508;
var inst_34507__$1 = tmp34654;
var inst_34508__$1 = tmp34656;
var inst_34509__$1 = tmp34655;
var inst_34510__$1 = inst_34528;
var state_34632__$1 = (function (){var statearr_34667 = state_34632;
(statearr_34667[(13)] = inst_34507__$1);

(statearr_34667[(14)] = inst_34509__$1);

(statearr_34667[(18)] = inst_34527);

(statearr_34667[(15)] = inst_34510__$1);

(statearr_34667[(17)] = inst_34508__$1);

return statearr_34667;
})();
var statearr_34668_36810 = state_34632__$1;
(statearr_34668_36810[(2)] = null);

(statearr_34668_36810[(1)] = (8));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_34633 === (21))){
var inst_34555 = (state_34632[(2)]);
var state_34632__$1 = state_34632;
var statearr_34677_36811 = state_34632__$1;
(statearr_34677_36811[(2)] = inst_34555);

(statearr_34677_36811[(1)] = (18));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_34633 === (31))){
var inst_34582 = (state_34632[(12)]);
var inst_34586 = m.cljs$core$async$Mult$untap_STAR_$arity$2(null,inst_34582);
var state_34632__$1 = state_34632;
var statearr_34679_36812 = state_34632__$1;
(statearr_34679_36812[(2)] = inst_34586);

(statearr_34679_36812[(1)] = (32));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_34633 === (32))){
var inst_34574 = (state_34632[(9)]);
var inst_34576 = (state_34632[(10)]);
var inst_34573 = (state_34632[(19)]);
var inst_34575 = (state_34632[(20)]);
var inst_34588 = (state_34632[(2)]);
var inst_34589 = (inst_34576 + (1));
var tmp34671 = inst_34574;
var tmp34672 = inst_34573;
var tmp34673 = inst_34575;
var inst_34573__$1 = tmp34672;
var inst_34574__$1 = tmp34671;
var inst_34575__$1 = tmp34673;
var inst_34576__$1 = inst_34589;
var state_34632__$1 = (function (){var statearr_34680 = state_34632;
(statearr_34680[(21)] = inst_34588);

(statearr_34680[(9)] = inst_34574__$1);

(statearr_34680[(10)] = inst_34576__$1);

(statearr_34680[(19)] = inst_34573__$1);

(statearr_34680[(20)] = inst_34575__$1);

return statearr_34680;
})();
var statearr_34681_36813 = state_34632__$1;
(statearr_34681_36813[(2)] = null);

(statearr_34681_36813[(1)] = (25));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_34633 === (40))){
var inst_34601 = (state_34632[(22)]);
var inst_34605 = m.cljs$core$async$Mult$untap_STAR_$arity$2(null,inst_34601);
var state_34632__$1 = state_34632;
var statearr_34685_36814 = state_34632__$1;
(statearr_34685_36814[(2)] = inst_34605);

(statearr_34685_36814[(1)] = (41));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_34633 === (33))){
var inst_34592 = (state_34632[(23)]);
var inst_34594 = cljs.core.chunked_seq_QMARK_(inst_34592);
var state_34632__$1 = state_34632;
if(inst_34594){
var statearr_34687_36815 = state_34632__$1;
(statearr_34687_36815[(1)] = (36));

} else {
var statearr_34688_36816 = state_34632__$1;
(statearr_34688_36816[(1)] = (37));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_34633 === (13))){
var inst_34521 = (state_34632[(24)]);
var inst_34524 = cljs.core.async.close_BANG_(inst_34521);
var state_34632__$1 = state_34632;
var statearr_34692_36817 = state_34632__$1;
(statearr_34692_36817[(2)] = inst_34524);

(statearr_34692_36817[(1)] = (15));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_34633 === (22))){
var inst_34545 = (state_34632[(8)]);
var inst_34548 = cljs.core.async.close_BANG_(inst_34545);
var state_34632__$1 = state_34632;
var statearr_34697_36818 = state_34632__$1;
(statearr_34697_36818[(2)] = inst_34548);

(statearr_34697_36818[(1)] = (24));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_34633 === (36))){
var inst_34592 = (state_34632[(23)]);
var inst_34596 = cljs.core.chunk_first(inst_34592);
var inst_34597 = cljs.core.chunk_rest(inst_34592);
var inst_34598 = cljs.core.count(inst_34596);
var inst_34573 = inst_34597;
var inst_34574 = inst_34596;
var inst_34575 = inst_34598;
var inst_34576 = (0);
var state_34632__$1 = (function (){var statearr_34699 = state_34632;
(statearr_34699[(9)] = inst_34574);

(statearr_34699[(10)] = inst_34576);

(statearr_34699[(19)] = inst_34573);

(statearr_34699[(20)] = inst_34575);

return statearr_34699;
})();
var statearr_34701_36819 = state_34632__$1;
(statearr_34701_36819[(2)] = null);

(statearr_34701_36819[(1)] = (25));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_34633 === (41))){
var inst_34592 = (state_34632[(23)]);
var inst_34607 = (state_34632[(2)]);
var inst_34608 = cljs.core.next(inst_34592);
var inst_34573 = inst_34608;
var inst_34574 = null;
var inst_34575 = (0);
var inst_34576 = (0);
var state_34632__$1 = (function (){var statearr_34704 = state_34632;
(statearr_34704[(9)] = inst_34574);

(statearr_34704[(10)] = inst_34576);

(statearr_34704[(25)] = inst_34607);

(statearr_34704[(19)] = inst_34573);

(statearr_34704[(20)] = inst_34575);

return statearr_34704;
})();
var statearr_34706_36826 = state_34632__$1;
(statearr_34706_36826[(2)] = null);

(statearr_34706_36826[(1)] = (25));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_34633 === (43))){
var state_34632__$1 = state_34632;
var statearr_34709_36827 = state_34632__$1;
(statearr_34709_36827[(2)] = null);

(statearr_34709_36827[(1)] = (44));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_34633 === (29))){
var inst_34616 = (state_34632[(2)]);
var state_34632__$1 = state_34632;
var statearr_34711_36828 = state_34632__$1;
(statearr_34711_36828[(2)] = inst_34616);

(statearr_34711_36828[(1)] = (26));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_34633 === (44))){
var inst_34625 = (state_34632[(2)]);
var state_34632__$1 = (function (){var statearr_34715 = state_34632;
(statearr_34715[(26)] = inst_34625);

return statearr_34715;
})();
var statearr_34716_36829 = state_34632__$1;
(statearr_34716_36829[(2)] = null);

(statearr_34716_36829[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_34633 === (6))){
var inst_34565 = (state_34632[(27)]);
var inst_34564 = cljs.core.deref(cs);
var inst_34565__$1 = cljs.core.keys(inst_34564);
var inst_34566 = cljs.core.count(inst_34565__$1);
var inst_34567 = cljs.core.reset_BANG_(dctr,inst_34566);
var inst_34572 = cljs.core.seq(inst_34565__$1);
var inst_34573 = inst_34572;
var inst_34574 = null;
var inst_34575 = (0);
var inst_34576 = (0);
var state_34632__$1 = (function (){var statearr_34724 = state_34632;
(statearr_34724[(28)] = inst_34567);

(statearr_34724[(9)] = inst_34574);

(statearr_34724[(10)] = inst_34576);

(statearr_34724[(27)] = inst_34565__$1);

(statearr_34724[(19)] = inst_34573);

(statearr_34724[(20)] = inst_34575);

return statearr_34724;
})();
var statearr_34725_36833 = state_34632__$1;
(statearr_34725_36833[(2)] = null);

(statearr_34725_36833[(1)] = (25));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_34633 === (28))){
var inst_34573 = (state_34632[(19)]);
var inst_34592 = (state_34632[(23)]);
var inst_34592__$1 = cljs.core.seq(inst_34573);
var state_34632__$1 = (function (){var statearr_34726 = state_34632;
(statearr_34726[(23)] = inst_34592__$1);

return statearr_34726;
})();
if(inst_34592__$1){
var statearr_34727_36834 = state_34632__$1;
(statearr_34727_36834[(1)] = (33));

} else {
var statearr_34728_36835 = state_34632__$1;
(statearr_34728_36835[(1)] = (34));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_34633 === (25))){
var inst_34576 = (state_34632[(10)]);
var inst_34575 = (state_34632[(20)]);
var inst_34579 = (inst_34576 < inst_34575);
var inst_34580 = inst_34579;
var state_34632__$1 = state_34632;
if(cljs.core.truth_(inst_34580)){
var statearr_34739_36836 = state_34632__$1;
(statearr_34739_36836[(1)] = (27));

} else {
var statearr_34740_36837 = state_34632__$1;
(statearr_34740_36837[(1)] = (28));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_34633 === (34))){
var state_34632__$1 = state_34632;
var statearr_34741_36838 = state_34632__$1;
(statearr_34741_36838[(2)] = null);

(statearr_34741_36838[(1)] = (35));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_34633 === (17))){
var state_34632__$1 = state_34632;
var statearr_34742_36839 = state_34632__$1;
(statearr_34742_36839[(2)] = null);

(statearr_34742_36839[(1)] = (18));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_34633 === (3))){
var inst_34630 = (state_34632[(2)]);
var state_34632__$1 = state_34632;
return cljs.core.async.impl.ioc_helpers.return_chan(state_34632__$1,inst_34630);
} else {
if((state_val_34633 === (12))){
var inst_34560 = (state_34632[(2)]);
var state_34632__$1 = state_34632;
var statearr_34743_36840 = state_34632__$1;
(statearr_34743_36840[(2)] = inst_34560);

(statearr_34743_36840[(1)] = (9));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_34633 === (2))){
var state_34632__$1 = state_34632;
return cljs.core.async.impl.ioc_helpers.take_BANG_(state_34632__$1,(4),ch);
} else {
if((state_val_34633 === (23))){
var state_34632__$1 = state_34632;
var statearr_34745_36841 = state_34632__$1;
(statearr_34745_36841[(2)] = null);

(statearr_34745_36841[(1)] = (24));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_34633 === (35))){
var inst_34614 = (state_34632[(2)]);
var state_34632__$1 = state_34632;
var statearr_34749_36845 = state_34632__$1;
(statearr_34749_36845[(2)] = inst_34614);

(statearr_34749_36845[(1)] = (29));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_34633 === (19))){
var inst_34531 = (state_34632[(7)]);
var inst_34535 = cljs.core.chunk_first(inst_34531);
var inst_34536 = cljs.core.chunk_rest(inst_34531);
var inst_34537 = cljs.core.count(inst_34535);
var inst_34507 = inst_34536;
var inst_34508 = inst_34535;
var inst_34509 = inst_34537;
var inst_34510 = (0);
var state_34632__$1 = (function (){var statearr_34750 = state_34632;
(statearr_34750[(13)] = inst_34507);

(statearr_34750[(14)] = inst_34509);

(statearr_34750[(15)] = inst_34510);

(statearr_34750[(17)] = inst_34508);

return statearr_34750;
})();
var statearr_34751_36852 = state_34632__$1;
(statearr_34751_36852[(2)] = null);

(statearr_34751_36852[(1)] = (8));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_34633 === (11))){
var inst_34507 = (state_34632[(13)]);
var inst_34531 = (state_34632[(7)]);
var inst_34531__$1 = cljs.core.seq(inst_34507);
var state_34632__$1 = (function (){var statearr_34752 = state_34632;
(statearr_34752[(7)] = inst_34531__$1);

return statearr_34752;
})();
if(inst_34531__$1){
var statearr_34753_36854 = state_34632__$1;
(statearr_34753_36854[(1)] = (16));

} else {
var statearr_34754_36855 = state_34632__$1;
(statearr_34754_36855[(1)] = (17));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_34633 === (9))){
var inst_34562 = (state_34632[(2)]);
var state_34632__$1 = state_34632;
var statearr_34755_36856 = state_34632__$1;
(statearr_34755_36856[(2)] = inst_34562);

(statearr_34755_36856[(1)] = (7));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_34633 === (5))){
var inst_34505 = cljs.core.deref(cs);
var inst_34506 = cljs.core.seq(inst_34505);
var inst_34507 = inst_34506;
var inst_34508 = null;
var inst_34509 = (0);
var inst_34510 = (0);
var state_34632__$1 = (function (){var statearr_34756 = state_34632;
(statearr_34756[(13)] = inst_34507);

(statearr_34756[(14)] = inst_34509);

(statearr_34756[(15)] = inst_34510);

(statearr_34756[(17)] = inst_34508);

return statearr_34756;
})();
var statearr_34757_36857 = state_34632__$1;
(statearr_34757_36857[(2)] = null);

(statearr_34757_36857[(1)] = (8));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_34633 === (14))){
var state_34632__$1 = state_34632;
var statearr_34760_36858 = state_34632__$1;
(statearr_34760_36858[(2)] = null);

(statearr_34760_36858[(1)] = (15));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_34633 === (45))){
var inst_34622 = (state_34632[(2)]);
var state_34632__$1 = state_34632;
var statearr_34761_36859 = state_34632__$1;
(statearr_34761_36859[(2)] = inst_34622);

(statearr_34761_36859[(1)] = (44));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_34633 === (26))){
var inst_34565 = (state_34632[(27)]);
var inst_34618 = (state_34632[(2)]);
var inst_34619 = cljs.core.seq(inst_34565);
var state_34632__$1 = (function (){var statearr_34762 = state_34632;
(statearr_34762[(29)] = inst_34618);

return statearr_34762;
})();
if(inst_34619){
var statearr_34765_36861 = state_34632__$1;
(statearr_34765_36861[(1)] = (42));

} else {
var statearr_34768_36862 = state_34632__$1;
(statearr_34768_36862[(1)] = (43));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_34633 === (16))){
var inst_34531 = (state_34632[(7)]);
var inst_34533 = cljs.core.chunked_seq_QMARK_(inst_34531);
var state_34632__$1 = state_34632;
if(inst_34533){
var statearr_34771_36863 = state_34632__$1;
(statearr_34771_36863[(1)] = (19));

} else {
var statearr_34773_36864 = state_34632__$1;
(statearr_34773_36864[(1)] = (20));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_34633 === (38))){
var inst_34611 = (state_34632[(2)]);
var state_34632__$1 = state_34632;
var statearr_34775_36865 = state_34632__$1;
(statearr_34775_36865[(2)] = inst_34611);

(statearr_34775_36865[(1)] = (35));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_34633 === (30))){
var state_34632__$1 = state_34632;
var statearr_34776_36868 = state_34632__$1;
(statearr_34776_36868[(2)] = null);

(statearr_34776_36868[(1)] = (32));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_34633 === (10))){
var inst_34510 = (state_34632[(15)]);
var inst_34508 = (state_34632[(17)]);
var inst_34520 = cljs.core._nth(inst_34508,inst_34510);
var inst_34521 = cljs.core.nth.cljs$core$IFn$_invoke$arity$3(inst_34520,(0),null);
var inst_34522 = cljs.core.nth.cljs$core$IFn$_invoke$arity$3(inst_34520,(1),null);
var state_34632__$1 = (function (){var statearr_34778 = state_34632;
(statearr_34778[(24)] = inst_34521);

return statearr_34778;
})();
if(cljs.core.truth_(inst_34522)){
var statearr_34779_36873 = state_34632__$1;
(statearr_34779_36873[(1)] = (13));

} else {
var statearr_34780_36874 = state_34632__$1;
(statearr_34780_36874[(1)] = (14));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_34633 === (18))){
var inst_34558 = (state_34632[(2)]);
var state_34632__$1 = state_34632;
var statearr_34781_36875 = state_34632__$1;
(statearr_34781_36875[(2)] = inst_34558);

(statearr_34781_36875[(1)] = (12));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_34633 === (42))){
var state_34632__$1 = state_34632;
return cljs.core.async.impl.ioc_helpers.take_BANG_(state_34632__$1,(45),dchan);
} else {
if((state_val_34633 === (37))){
var inst_34601 = (state_34632[(22)]);
var inst_34497 = (state_34632[(11)]);
var inst_34592 = (state_34632[(23)]);
var inst_34601__$1 = cljs.core.first(inst_34592);
var inst_34602 = cljs.core.async.put_BANG_.cljs$core$IFn$_invoke$arity$3(inst_34601__$1,inst_34497,done);
var state_34632__$1 = (function (){var statearr_34783 = state_34632;
(statearr_34783[(22)] = inst_34601__$1);

return statearr_34783;
})();
if(cljs.core.truth_(inst_34602)){
var statearr_34784_36878 = state_34632__$1;
(statearr_34784_36878[(1)] = (39));

} else {
var statearr_34786_36879 = state_34632__$1;
(statearr_34786_36879[(1)] = (40));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_34633 === (8))){
var inst_34509 = (state_34632[(14)]);
var inst_34510 = (state_34632[(15)]);
var inst_34514 = (inst_34510 < inst_34509);
var inst_34515 = inst_34514;
var state_34632__$1 = state_34632;
if(cljs.core.truth_(inst_34515)){
var statearr_34791_36880 = state_34632__$1;
(statearr_34791_36880[(1)] = (10));

} else {
var statearr_34792_36881 = state_34632__$1;
(statearr_34792_36881[(1)] = (11));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
return null;
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
});
return (function() {
var cljs$core$async$mult_$_state_machine__33219__auto__ = null;
var cljs$core$async$mult_$_state_machine__33219__auto____0 = (function (){
var statearr_34794 = [null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null];
(statearr_34794[(0)] = cljs$core$async$mult_$_state_machine__33219__auto__);

(statearr_34794[(1)] = (1));

return statearr_34794;
});
var cljs$core$async$mult_$_state_machine__33219__auto____1 = (function (state_34632){
while(true){
var ret_value__33220__auto__ = (function (){try{while(true){
var result__33221__auto__ = switch__33218__auto__(state_34632);
if(cljs.core.keyword_identical_QMARK_(result__33221__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
continue;
} else {
return result__33221__auto__;
}
break;
}
}catch (e34796){var ex__33222__auto__ = e34796;
var statearr_34797_36887 = state_34632;
(statearr_34797_36887[(2)] = ex__33222__auto__);


if(cljs.core.seq((state_34632[(4)]))){
var statearr_34798_36892 = state_34632;
(statearr_34798_36892[(1)] = cljs.core.first((state_34632[(4)])));

} else {
throw ex__33222__auto__;
}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
}})();
if(cljs.core.keyword_identical_QMARK_(ret_value__33220__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
var G__36898 = state_34632;
state_34632 = G__36898;
continue;
} else {
return ret_value__33220__auto__;
}
break;
}
});
cljs$core$async$mult_$_state_machine__33219__auto__ = function(state_34632){
switch(arguments.length){
case 0:
return cljs$core$async$mult_$_state_machine__33219__auto____0.call(this);
case 1:
return cljs$core$async$mult_$_state_machine__33219__auto____1.call(this,state_34632);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
cljs$core$async$mult_$_state_machine__33219__auto__.cljs$core$IFn$_invoke$arity$0 = cljs$core$async$mult_$_state_machine__33219__auto____0;
cljs$core$async$mult_$_state_machine__33219__auto__.cljs$core$IFn$_invoke$arity$1 = cljs$core$async$mult_$_state_machine__33219__auto____1;
return cljs$core$async$mult_$_state_machine__33219__auto__;
})()
})();
var state__33373__auto__ = (function (){var statearr_34799 = f__33372__auto__();
(statearr_34799[(6)] = c__33371__auto___36782);

return statearr_34799;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped(state__33373__auto__);
}));


return m;
});
/**
 * Copies the mult source onto the supplied channel.
 * 
 *   By default the channel will be closed when the source closes,
 *   but can be determined by the close? parameter.
 */
cljs.core.async.tap = (function cljs$core$async$tap(var_args){
var G__34809 = arguments.length;
switch (G__34809) {
case 2:
return cljs.core.async.tap.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
case 3:
return cljs.core.async.tap.cljs$core$IFn$_invoke$arity$3((arguments[(0)]),(arguments[(1)]),(arguments[(2)]));

break;
default:
throw (new Error(["Invalid arity: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(arguments.length)].join('')));

}
});

(cljs.core.async.tap.cljs$core$IFn$_invoke$arity$2 = (function (mult,ch){
return cljs.core.async.tap.cljs$core$IFn$_invoke$arity$3(mult,ch,true);
}));

(cljs.core.async.tap.cljs$core$IFn$_invoke$arity$3 = (function (mult,ch,close_QMARK_){
cljs.core.async.tap_STAR_(mult,ch,close_QMARK_);

return ch;
}));

(cljs.core.async.tap.cljs$lang$maxFixedArity = 3);

/**
 * Disconnects a target channel from a mult
 */
cljs.core.async.untap = (function cljs$core$async$untap(mult,ch){
return cljs.core.async.untap_STAR_(mult,ch);
});
/**
 * Disconnects all target channels from a mult
 */
cljs.core.async.untap_all = (function cljs$core$async$untap_all(mult){
return cljs.core.async.untap_all_STAR_(mult);
});

/**
 * @interface
 */
cljs.core.async.Mix = function(){};

var cljs$core$async$Mix$admix_STAR_$dyn_36906 = (function (m,ch){
var x__5393__auto__ = (((m == null))?null:m);
var m__5394__auto__ = (cljs.core.async.admix_STAR_[goog.typeOf(x__5393__auto__)]);
if((!((m__5394__auto__ == null)))){
return (m__5394__auto__.cljs$core$IFn$_invoke$arity$2 ? m__5394__auto__.cljs$core$IFn$_invoke$arity$2(m,ch) : m__5394__auto__.call(null,m,ch));
} else {
var m__5392__auto__ = (cljs.core.async.admix_STAR_["_"]);
if((!((m__5392__auto__ == null)))){
return (m__5392__auto__.cljs$core$IFn$_invoke$arity$2 ? m__5392__auto__.cljs$core$IFn$_invoke$arity$2(m,ch) : m__5392__auto__.call(null,m,ch));
} else {
throw cljs.core.missing_protocol("Mix.admix*",m);
}
}
});
cljs.core.async.admix_STAR_ = (function cljs$core$async$admix_STAR_(m,ch){
if((((!((m == null)))) && ((!((m.cljs$core$async$Mix$admix_STAR_$arity$2 == null)))))){
return m.cljs$core$async$Mix$admix_STAR_$arity$2(m,ch);
} else {
return cljs$core$async$Mix$admix_STAR_$dyn_36906(m,ch);
}
});

var cljs$core$async$Mix$unmix_STAR_$dyn_36907 = (function (m,ch){
var x__5393__auto__ = (((m == null))?null:m);
var m__5394__auto__ = (cljs.core.async.unmix_STAR_[goog.typeOf(x__5393__auto__)]);
if((!((m__5394__auto__ == null)))){
return (m__5394__auto__.cljs$core$IFn$_invoke$arity$2 ? m__5394__auto__.cljs$core$IFn$_invoke$arity$2(m,ch) : m__5394__auto__.call(null,m,ch));
} else {
var m__5392__auto__ = (cljs.core.async.unmix_STAR_["_"]);
if((!((m__5392__auto__ == null)))){
return (m__5392__auto__.cljs$core$IFn$_invoke$arity$2 ? m__5392__auto__.cljs$core$IFn$_invoke$arity$2(m,ch) : m__5392__auto__.call(null,m,ch));
} else {
throw cljs.core.missing_protocol("Mix.unmix*",m);
}
}
});
cljs.core.async.unmix_STAR_ = (function cljs$core$async$unmix_STAR_(m,ch){
if((((!((m == null)))) && ((!((m.cljs$core$async$Mix$unmix_STAR_$arity$2 == null)))))){
return m.cljs$core$async$Mix$unmix_STAR_$arity$2(m,ch);
} else {
return cljs$core$async$Mix$unmix_STAR_$dyn_36907(m,ch);
}
});

var cljs$core$async$Mix$unmix_all_STAR_$dyn_36908 = (function (m){
var x__5393__auto__ = (((m == null))?null:m);
var m__5394__auto__ = (cljs.core.async.unmix_all_STAR_[goog.typeOf(x__5393__auto__)]);
if((!((m__5394__auto__ == null)))){
return (m__5394__auto__.cljs$core$IFn$_invoke$arity$1 ? m__5394__auto__.cljs$core$IFn$_invoke$arity$1(m) : m__5394__auto__.call(null,m));
} else {
var m__5392__auto__ = (cljs.core.async.unmix_all_STAR_["_"]);
if((!((m__5392__auto__ == null)))){
return (m__5392__auto__.cljs$core$IFn$_invoke$arity$1 ? m__5392__auto__.cljs$core$IFn$_invoke$arity$1(m) : m__5392__auto__.call(null,m));
} else {
throw cljs.core.missing_protocol("Mix.unmix-all*",m);
}
}
});
cljs.core.async.unmix_all_STAR_ = (function cljs$core$async$unmix_all_STAR_(m){
if((((!((m == null)))) && ((!((m.cljs$core$async$Mix$unmix_all_STAR_$arity$1 == null)))))){
return m.cljs$core$async$Mix$unmix_all_STAR_$arity$1(m);
} else {
return cljs$core$async$Mix$unmix_all_STAR_$dyn_36908(m);
}
});

var cljs$core$async$Mix$toggle_STAR_$dyn_36912 = (function (m,state_map){
var x__5393__auto__ = (((m == null))?null:m);
var m__5394__auto__ = (cljs.core.async.toggle_STAR_[goog.typeOf(x__5393__auto__)]);
if((!((m__5394__auto__ == null)))){
return (m__5394__auto__.cljs$core$IFn$_invoke$arity$2 ? m__5394__auto__.cljs$core$IFn$_invoke$arity$2(m,state_map) : m__5394__auto__.call(null,m,state_map));
} else {
var m__5392__auto__ = (cljs.core.async.toggle_STAR_["_"]);
if((!((m__5392__auto__ == null)))){
return (m__5392__auto__.cljs$core$IFn$_invoke$arity$2 ? m__5392__auto__.cljs$core$IFn$_invoke$arity$2(m,state_map) : m__5392__auto__.call(null,m,state_map));
} else {
throw cljs.core.missing_protocol("Mix.toggle*",m);
}
}
});
cljs.core.async.toggle_STAR_ = (function cljs$core$async$toggle_STAR_(m,state_map){
if((((!((m == null)))) && ((!((m.cljs$core$async$Mix$toggle_STAR_$arity$2 == null)))))){
return m.cljs$core$async$Mix$toggle_STAR_$arity$2(m,state_map);
} else {
return cljs$core$async$Mix$toggle_STAR_$dyn_36912(m,state_map);
}
});

var cljs$core$async$Mix$solo_mode_STAR_$dyn_36913 = (function (m,mode){
var x__5393__auto__ = (((m == null))?null:m);
var m__5394__auto__ = (cljs.core.async.solo_mode_STAR_[goog.typeOf(x__5393__auto__)]);
if((!((m__5394__auto__ == null)))){
return (m__5394__auto__.cljs$core$IFn$_invoke$arity$2 ? m__5394__auto__.cljs$core$IFn$_invoke$arity$2(m,mode) : m__5394__auto__.call(null,m,mode));
} else {
var m__5392__auto__ = (cljs.core.async.solo_mode_STAR_["_"]);
if((!((m__5392__auto__ == null)))){
return (m__5392__auto__.cljs$core$IFn$_invoke$arity$2 ? m__5392__auto__.cljs$core$IFn$_invoke$arity$2(m,mode) : m__5392__auto__.call(null,m,mode));
} else {
throw cljs.core.missing_protocol("Mix.solo-mode*",m);
}
}
});
cljs.core.async.solo_mode_STAR_ = (function cljs$core$async$solo_mode_STAR_(m,mode){
if((((!((m == null)))) && ((!((m.cljs$core$async$Mix$solo_mode_STAR_$arity$2 == null)))))){
return m.cljs$core$async$Mix$solo_mode_STAR_$arity$2(m,mode);
} else {
return cljs$core$async$Mix$solo_mode_STAR_$dyn_36913(m,mode);
}
});

cljs.core.async.ioc_alts_BANG_ = (function cljs$core$async$ioc_alts_BANG_(var_args){
var args__5775__auto__ = [];
var len__5769__auto___36914 = arguments.length;
var i__5770__auto___36918 = (0);
while(true){
if((i__5770__auto___36918 < len__5769__auto___36914)){
args__5775__auto__.push((arguments[i__5770__auto___36918]));

var G__36919 = (i__5770__auto___36918 + (1));
i__5770__auto___36918 = G__36919;
continue;
} else {
}
break;
}

var argseq__5776__auto__ = ((((3) < args__5775__auto__.length))?(new cljs.core.IndexedSeq(args__5775__auto__.slice((3)),(0),null)):null);
return cljs.core.async.ioc_alts_BANG_.cljs$core$IFn$_invoke$arity$variadic((arguments[(0)]),(arguments[(1)]),(arguments[(2)]),argseq__5776__auto__);
});

(cljs.core.async.ioc_alts_BANG_.cljs$core$IFn$_invoke$arity$variadic = (function (state,cont_block,ports,p__34855){
var map__34856 = p__34855;
var map__34856__$1 = cljs.core.__destructure_map(map__34856);
var opts = map__34856__$1;
var statearr_34857_36920 = state;
(statearr_34857_36920[(1)] = cont_block);


var temp__5804__auto__ = cljs.core.async.do_alts((function (val){
var statearr_34859_36922 = state;
(statearr_34859_36922[(2)] = val);


return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped(state);
}),ports,opts);
if(cljs.core.truth_(temp__5804__auto__)){
var cb = temp__5804__auto__;
var statearr_34861_36923 = state;
(statearr_34861_36923[(2)] = cljs.core.deref(cb));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
return null;
}
}));

(cljs.core.async.ioc_alts_BANG_.cljs$lang$maxFixedArity = (3));

/** @this {Function} */
(cljs.core.async.ioc_alts_BANG_.cljs$lang$applyTo = (function (seq34849){
var G__34850 = cljs.core.first(seq34849);
var seq34849__$1 = cljs.core.next(seq34849);
var G__34851 = cljs.core.first(seq34849__$1);
var seq34849__$2 = cljs.core.next(seq34849__$1);
var G__34852 = cljs.core.first(seq34849__$2);
var seq34849__$3 = cljs.core.next(seq34849__$2);
var self__5754__auto__ = this;
return self__5754__auto__.cljs$core$IFn$_invoke$arity$variadic(G__34850,G__34851,G__34852,seq34849__$3);
}));


/**
* @constructor
 * @implements {cljs.core.IMeta}
 * @implements {cljs.core.async.Mix}
 * @implements {cljs.core.async.Mux}
 * @implements {cljs.core.IWithMeta}
*/
cljs.core.async.t_cljs$core$async34870 = (function (change,solo_mode,pick,cs,calc_state,out,changed,solo_modes,attrs,meta34871){
this.change = change;
this.solo_mode = solo_mode;
this.pick = pick;
this.cs = cs;
this.calc_state = calc_state;
this.out = out;
this.changed = changed;
this.solo_modes = solo_modes;
this.attrs = attrs;
this.meta34871 = meta34871;
this.cljs$lang$protocol_mask$partition0$ = 393216;
this.cljs$lang$protocol_mask$partition1$ = 0;
});
(cljs.core.async.t_cljs$core$async34870.prototype.cljs$core$IWithMeta$_with_meta$arity$2 = (function (_34872,meta34871__$1){
var self__ = this;
var _34872__$1 = this;
return (new cljs.core.async.t_cljs$core$async34870(self__.change,self__.solo_mode,self__.pick,self__.cs,self__.calc_state,self__.out,self__.changed,self__.solo_modes,self__.attrs,meta34871__$1));
}));

(cljs.core.async.t_cljs$core$async34870.prototype.cljs$core$IMeta$_meta$arity$1 = (function (_34872){
var self__ = this;
var _34872__$1 = this;
return self__.meta34871;
}));

(cljs.core.async.t_cljs$core$async34870.prototype.cljs$core$async$Mux$ = cljs.core.PROTOCOL_SENTINEL);

(cljs.core.async.t_cljs$core$async34870.prototype.cljs$core$async$Mux$muxch_STAR_$arity$1 = (function (_){
var self__ = this;
var ___$1 = this;
return self__.out;
}));

(cljs.core.async.t_cljs$core$async34870.prototype.cljs$core$async$Mix$ = cljs.core.PROTOCOL_SENTINEL);

(cljs.core.async.t_cljs$core$async34870.prototype.cljs$core$async$Mix$admix_STAR_$arity$2 = (function (_,ch){
var self__ = this;
var ___$1 = this;
cljs.core.swap_BANG_.cljs$core$IFn$_invoke$arity$4(self__.cs,cljs.core.assoc,ch,cljs.core.PersistentArrayMap.EMPTY);

return (self__.changed.cljs$core$IFn$_invoke$arity$0 ? self__.changed.cljs$core$IFn$_invoke$arity$0() : self__.changed.call(null));
}));

(cljs.core.async.t_cljs$core$async34870.prototype.cljs$core$async$Mix$unmix_STAR_$arity$2 = (function (_,ch){
var self__ = this;
var ___$1 = this;
cljs.core.swap_BANG_.cljs$core$IFn$_invoke$arity$3(self__.cs,cljs.core.dissoc,ch);

return (self__.changed.cljs$core$IFn$_invoke$arity$0 ? self__.changed.cljs$core$IFn$_invoke$arity$0() : self__.changed.call(null));
}));

(cljs.core.async.t_cljs$core$async34870.prototype.cljs$core$async$Mix$unmix_all_STAR_$arity$1 = (function (_){
var self__ = this;
var ___$1 = this;
cljs.core.reset_BANG_(self__.cs,cljs.core.PersistentArrayMap.EMPTY);

return (self__.changed.cljs$core$IFn$_invoke$arity$0 ? self__.changed.cljs$core$IFn$_invoke$arity$0() : self__.changed.call(null));
}));

(cljs.core.async.t_cljs$core$async34870.prototype.cljs$core$async$Mix$toggle_STAR_$arity$2 = (function (_,state_map){
var self__ = this;
var ___$1 = this;
cljs.core.swap_BANG_.cljs$core$IFn$_invoke$arity$3(self__.cs,cljs.core.partial.cljs$core$IFn$_invoke$arity$2(cljs.core.merge_with,cljs.core.merge),state_map);

return (self__.changed.cljs$core$IFn$_invoke$arity$0 ? self__.changed.cljs$core$IFn$_invoke$arity$0() : self__.changed.call(null));
}));

(cljs.core.async.t_cljs$core$async34870.prototype.cljs$core$async$Mix$solo_mode_STAR_$arity$2 = (function (_,mode){
var self__ = this;
var ___$1 = this;
if(cljs.core.truth_((self__.solo_modes.cljs$core$IFn$_invoke$arity$1 ? self__.solo_modes.cljs$core$IFn$_invoke$arity$1(mode) : self__.solo_modes.call(null,mode)))){
} else {
throw (new Error(["Assert failed: ",["mode must be one of: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(self__.solo_modes)].join(''),"\n","(solo-modes mode)"].join('')));
}

cljs.core.reset_BANG_(self__.solo_mode,mode);

return (self__.changed.cljs$core$IFn$_invoke$arity$0 ? self__.changed.cljs$core$IFn$_invoke$arity$0() : self__.changed.call(null));
}));

(cljs.core.async.t_cljs$core$async34870.getBasis = (function (){
return new cljs.core.PersistentVector(null, 10, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Symbol(null,"change","change",477485025,null),new cljs.core.Symbol(null,"solo-mode","solo-mode",2031788074,null),new cljs.core.Symbol(null,"pick","pick",1300068175,null),new cljs.core.Symbol(null,"cs","cs",-117024463,null),new cljs.core.Symbol(null,"calc-state","calc-state",-349968968,null),new cljs.core.Symbol(null,"out","out",729986010,null),new cljs.core.Symbol(null,"changed","changed",-2083710852,null),new cljs.core.Symbol(null,"solo-modes","solo-modes",882180540,null),new cljs.core.Symbol(null,"attrs","attrs",-450137186,null),new cljs.core.Symbol(null,"meta34871","meta34871",1894095610,null)], null);
}));

(cljs.core.async.t_cljs$core$async34870.cljs$lang$type = true);

(cljs.core.async.t_cljs$core$async34870.cljs$lang$ctorStr = "cljs.core.async/t_cljs$core$async34870");

(cljs.core.async.t_cljs$core$async34870.cljs$lang$ctorPrWriter = (function (this__5330__auto__,writer__5331__auto__,opt__5332__auto__){
return cljs.core._write(writer__5331__auto__,"cljs.core.async/t_cljs$core$async34870");
}));

/**
 * Positional factory function for cljs.core.async/t_cljs$core$async34870.
 */
cljs.core.async.__GT_t_cljs$core$async34870 = (function cljs$core$async$__GT_t_cljs$core$async34870(change,solo_mode,pick,cs,calc_state,out,changed,solo_modes,attrs,meta34871){
return (new cljs.core.async.t_cljs$core$async34870(change,solo_mode,pick,cs,calc_state,out,changed,solo_modes,attrs,meta34871));
});


/**
 * Creates and returns a mix of one or more input channels which will
 *   be put on the supplied out channel. Input sources can be added to
 *   the mix with 'admix', and removed with 'unmix'. A mix supports
 *   soloing, muting and pausing multiple inputs atomically using
 *   'toggle', and can solo using either muting or pausing as determined
 *   by 'solo-mode'.
 * 
 *   Each channel can have zero or more boolean modes set via 'toggle':
 * 
 *   :solo - when true, only this (ond other soloed) channel(s) will appear
 *        in the mix output channel. :mute and :pause states of soloed
 *        channels are ignored. If solo-mode is :mute, non-soloed
 *        channels are muted, if :pause, non-soloed channels are
 *        paused.
 * 
 *   :mute - muted channels will have their contents consumed but not included in the mix
 *   :pause - paused channels will not have their contents consumed (and thus also not included in the mix)
 */
cljs.core.async.mix = (function cljs$core$async$mix(out){
var cs = cljs.core.atom.cljs$core$IFn$_invoke$arity$1(cljs.core.PersistentArrayMap.EMPTY);
var solo_modes = new cljs.core.PersistentHashSet(null, new cljs.core.PersistentArrayMap(null, 2, [new cljs.core.Keyword(null,"pause","pause",-2095325672),null,new cljs.core.Keyword(null,"mute","mute",1151223646),null], null), null);
var attrs = cljs.core.conj.cljs$core$IFn$_invoke$arity$2(solo_modes,new cljs.core.Keyword(null,"solo","solo",-316350075));
var solo_mode = cljs.core.atom.cljs$core$IFn$_invoke$arity$1(new cljs.core.Keyword(null,"mute","mute",1151223646));
var change = cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1(cljs.core.async.sliding_buffer((1)));
var changed = (function (){
return cljs.core.async.put_BANG_.cljs$core$IFn$_invoke$arity$2(change,true);
});
var pick = (function (attr,chs){
return cljs.core.reduce_kv((function (ret,c,v){
if(cljs.core.truth_((attr.cljs$core$IFn$_invoke$arity$1 ? attr.cljs$core$IFn$_invoke$arity$1(v) : attr.call(null,v)))){
return cljs.core.conj.cljs$core$IFn$_invoke$arity$2(ret,c);
} else {
return ret;
}
}),cljs.core.PersistentHashSet.EMPTY,chs);
});
var calc_state = (function (){
var chs = cljs.core.deref(cs);
var mode = cljs.core.deref(solo_mode);
var solos = pick(new cljs.core.Keyword(null,"solo","solo",-316350075),chs);
var pauses = pick(new cljs.core.Keyword(null,"pause","pause",-2095325672),chs);
return new cljs.core.PersistentArrayMap(null, 3, [new cljs.core.Keyword(null,"solos","solos",1441458643),solos,new cljs.core.Keyword(null,"mutes","mutes",1068806309),pick(new cljs.core.Keyword(null,"mute","mute",1151223646),chs),new cljs.core.Keyword(null,"reads","reads",-1215067361),cljs.core.conj.cljs$core$IFn$_invoke$arity$2(((((cljs.core._EQ_.cljs$core$IFn$_invoke$arity$2(mode,new cljs.core.Keyword(null,"pause","pause",-2095325672))) && ((!(cljs.core.empty_QMARK_(solos))))))?cljs.core.vec(solos):cljs.core.vec(cljs.core.remove.cljs$core$IFn$_invoke$arity$2(pauses,cljs.core.keys(chs)))),change)], null);
});
var m = (new cljs.core.async.t_cljs$core$async34870(change,solo_mode,pick,cs,calc_state,out,changed,solo_modes,attrs,cljs.core.PersistentArrayMap.EMPTY));
var c__33371__auto___36936 = cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1((1));
cljs.core.async.impl.dispatch.run((function (){
var f__33372__auto__ = (function (){var switch__33218__auto__ = (function (state_34989){
var state_val_34990 = (state_34989[(1)]);
if((state_val_34990 === (7))){
var inst_34949 = (state_34989[(2)]);
var state_34989__$1 = state_34989;
if(cljs.core.truth_(inst_34949)){
var statearr_34991_36937 = state_34989__$1;
(statearr_34991_36937[(1)] = (8));

} else {
var statearr_34992_36938 = state_34989__$1;
(statearr_34992_36938[(1)] = (9));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_34990 === (20))){
var inst_34938 = (state_34989[(7)]);
var state_34989__$1 = state_34989;
return cljs.core.async.impl.ioc_helpers.put_BANG_(state_34989__$1,(23),out,inst_34938);
} else {
if((state_val_34990 === (1))){
var inst_34903 = calc_state();
var inst_34904 = cljs.core.__destructure_map(inst_34903);
var inst_34905 = cljs.core.get.cljs$core$IFn$_invoke$arity$2(inst_34904,new cljs.core.Keyword(null,"solos","solos",1441458643));
var inst_34906 = cljs.core.get.cljs$core$IFn$_invoke$arity$2(inst_34904,new cljs.core.Keyword(null,"mutes","mutes",1068806309));
var inst_34907 = cljs.core.get.cljs$core$IFn$_invoke$arity$2(inst_34904,new cljs.core.Keyword(null,"reads","reads",-1215067361));
var inst_34910 = inst_34903;
var state_34989__$1 = (function (){var statearr_34994 = state_34989;
(statearr_34994[(8)] = inst_34905);

(statearr_34994[(9)] = inst_34910);

(statearr_34994[(10)] = inst_34906);

(statearr_34994[(11)] = inst_34907);

return statearr_34994;
})();
var statearr_34995_36939 = state_34989__$1;
(statearr_34995_36939[(2)] = null);

(statearr_34995_36939[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_34990 === (24))){
var inst_34913 = (state_34989[(12)]);
var inst_34910 = inst_34913;
var state_34989__$1 = (function (){var statearr_34996 = state_34989;
(statearr_34996[(9)] = inst_34910);

return statearr_34996;
})();
var statearr_34999_36940 = state_34989__$1;
(statearr_34999_36940[(2)] = null);

(statearr_34999_36940[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_34990 === (4))){
var inst_34944 = (state_34989[(13)]);
var inst_34938 = (state_34989[(7)]);
var inst_34933 = (state_34989[(2)]);
var inst_34938__$1 = cljs.core.nth.cljs$core$IFn$_invoke$arity$3(inst_34933,(0),null);
var inst_34943 = cljs.core.nth.cljs$core$IFn$_invoke$arity$3(inst_34933,(1),null);
var inst_34944__$1 = (inst_34938__$1 == null);
var state_34989__$1 = (function (){var statearr_35000 = state_34989;
(statearr_35000[(13)] = inst_34944__$1);

(statearr_35000[(14)] = inst_34943);

(statearr_35000[(7)] = inst_34938__$1);

return statearr_35000;
})();
if(cljs.core.truth_(inst_34944__$1)){
var statearr_35001_36941 = state_34989__$1;
(statearr_35001_36941[(1)] = (5));

} else {
var statearr_35002_36942 = state_34989__$1;
(statearr_35002_36942[(1)] = (6));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_34990 === (15))){
var inst_34914 = (state_34989[(15)]);
var inst_34963 = (state_34989[(16)]);
var inst_34963__$1 = cljs.core.empty_QMARK_(inst_34914);
var state_34989__$1 = (function (){var statearr_35003 = state_34989;
(statearr_35003[(16)] = inst_34963__$1);

return statearr_35003;
})();
if(inst_34963__$1){
var statearr_35005_36943 = state_34989__$1;
(statearr_35005_36943[(1)] = (17));

} else {
var statearr_35006_36944 = state_34989__$1;
(statearr_35006_36944[(1)] = (18));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_34990 === (21))){
var inst_34913 = (state_34989[(12)]);
var inst_34910 = inst_34913;
var state_34989__$1 = (function (){var statearr_35008 = state_34989;
(statearr_35008[(9)] = inst_34910);

return statearr_35008;
})();
var statearr_35009_36945 = state_34989__$1;
(statearr_35009_36945[(2)] = null);

(statearr_35009_36945[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_34990 === (13))){
var inst_34956 = (state_34989[(2)]);
var inst_34957 = calc_state();
var inst_34910 = inst_34957;
var state_34989__$1 = (function (){var statearr_35010 = state_34989;
(statearr_35010[(17)] = inst_34956);

(statearr_35010[(9)] = inst_34910);

return statearr_35010;
})();
var statearr_35011_36948 = state_34989__$1;
(statearr_35011_36948[(2)] = null);

(statearr_35011_36948[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_34990 === (22))){
var inst_34983 = (state_34989[(2)]);
var state_34989__$1 = state_34989;
var statearr_35012_36949 = state_34989__$1;
(statearr_35012_36949[(2)] = inst_34983);

(statearr_35012_36949[(1)] = (10));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_34990 === (6))){
var inst_34943 = (state_34989[(14)]);
var inst_34947 = cljs.core._EQ_.cljs$core$IFn$_invoke$arity$2(inst_34943,change);
var state_34989__$1 = state_34989;
var statearr_35013_36952 = state_34989__$1;
(statearr_35013_36952[(2)] = inst_34947);

(statearr_35013_36952[(1)] = (7));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_34990 === (25))){
var state_34989__$1 = state_34989;
var statearr_35014_36979 = state_34989__$1;
(statearr_35014_36979[(2)] = null);

(statearr_35014_36979[(1)] = (26));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_34990 === (17))){
var inst_34915 = (state_34989[(18)]);
var inst_34943 = (state_34989[(14)]);
var inst_34965 = (inst_34915.cljs$core$IFn$_invoke$arity$1 ? inst_34915.cljs$core$IFn$_invoke$arity$1(inst_34943) : inst_34915.call(null,inst_34943));
var inst_34966 = cljs.core.not(inst_34965);
var state_34989__$1 = state_34989;
var statearr_35018_36980 = state_34989__$1;
(statearr_35018_36980[(2)] = inst_34966);

(statearr_35018_36980[(1)] = (19));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_34990 === (3))){
var inst_34987 = (state_34989[(2)]);
var state_34989__$1 = state_34989;
return cljs.core.async.impl.ioc_helpers.return_chan(state_34989__$1,inst_34987);
} else {
if((state_val_34990 === (12))){
var state_34989__$1 = state_34989;
var statearr_35023_36981 = state_34989__$1;
(statearr_35023_36981[(2)] = null);

(statearr_35023_36981[(1)] = (13));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_34990 === (2))){
var inst_34913 = (state_34989[(12)]);
var inst_34910 = (state_34989[(9)]);
var inst_34913__$1 = cljs.core.__destructure_map(inst_34910);
var inst_34914 = cljs.core.get.cljs$core$IFn$_invoke$arity$2(inst_34913__$1,new cljs.core.Keyword(null,"solos","solos",1441458643));
var inst_34915 = cljs.core.get.cljs$core$IFn$_invoke$arity$2(inst_34913__$1,new cljs.core.Keyword(null,"mutes","mutes",1068806309));
var inst_34916 = cljs.core.get.cljs$core$IFn$_invoke$arity$2(inst_34913__$1,new cljs.core.Keyword(null,"reads","reads",-1215067361));
var state_34989__$1 = (function (){var statearr_35025 = state_34989;
(statearr_35025[(15)] = inst_34914);

(statearr_35025[(12)] = inst_34913__$1);

(statearr_35025[(18)] = inst_34915);

return statearr_35025;
})();
return cljs.core.async.ioc_alts_BANG_(state_34989__$1,(4),inst_34916);
} else {
if((state_val_34990 === (23))){
var inst_34974 = (state_34989[(2)]);
var state_34989__$1 = state_34989;
if(cljs.core.truth_(inst_34974)){
var statearr_35026_36982 = state_34989__$1;
(statearr_35026_36982[(1)] = (24));

} else {
var statearr_35027_36983 = state_34989__$1;
(statearr_35027_36983[(1)] = (25));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_34990 === (19))){
var inst_34969 = (state_34989[(2)]);
var state_34989__$1 = state_34989;
var statearr_35030_36986 = state_34989__$1;
(statearr_35030_36986[(2)] = inst_34969);

(statearr_35030_36986[(1)] = (16));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_34990 === (11))){
var inst_34943 = (state_34989[(14)]);
var inst_34953 = cljs.core.swap_BANG_.cljs$core$IFn$_invoke$arity$3(cs,cljs.core.dissoc,inst_34943);
var state_34989__$1 = state_34989;
var statearr_35031_36989 = state_34989__$1;
(statearr_35031_36989[(2)] = inst_34953);

(statearr_35031_36989[(1)] = (13));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_34990 === (9))){
var inst_34914 = (state_34989[(15)]);
var inst_34960 = (state_34989[(19)]);
var inst_34943 = (state_34989[(14)]);
var inst_34960__$1 = (inst_34914.cljs$core$IFn$_invoke$arity$1 ? inst_34914.cljs$core$IFn$_invoke$arity$1(inst_34943) : inst_34914.call(null,inst_34943));
var state_34989__$1 = (function (){var statearr_35032 = state_34989;
(statearr_35032[(19)] = inst_34960__$1);

return statearr_35032;
})();
if(cljs.core.truth_(inst_34960__$1)){
var statearr_35033_36990 = state_34989__$1;
(statearr_35033_36990[(1)] = (14));

} else {
var statearr_35034_36991 = state_34989__$1;
(statearr_35034_36991[(1)] = (15));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_34990 === (5))){
var inst_34944 = (state_34989[(13)]);
var state_34989__$1 = state_34989;
var statearr_35035_36992 = state_34989__$1;
(statearr_35035_36992[(2)] = inst_34944);

(statearr_35035_36992[(1)] = (7));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_34990 === (14))){
var inst_34960 = (state_34989[(19)]);
var state_34989__$1 = state_34989;
var statearr_35036_36993 = state_34989__$1;
(statearr_35036_36993[(2)] = inst_34960);

(statearr_35036_36993[(1)] = (16));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_34990 === (26))){
var inst_34979 = (state_34989[(2)]);
var state_34989__$1 = state_34989;
var statearr_35037_36995 = state_34989__$1;
(statearr_35037_36995[(2)] = inst_34979);

(statearr_35037_36995[(1)] = (22));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_34990 === (16))){
var inst_34971 = (state_34989[(2)]);
var state_34989__$1 = state_34989;
if(cljs.core.truth_(inst_34971)){
var statearr_35038_36997 = state_34989__$1;
(statearr_35038_36997[(1)] = (20));

} else {
var statearr_35039_36998 = state_34989__$1;
(statearr_35039_36998[(1)] = (21));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_34990 === (10))){
var inst_34985 = (state_34989[(2)]);
var state_34989__$1 = state_34989;
var statearr_35040_37000 = state_34989__$1;
(statearr_35040_37000[(2)] = inst_34985);

(statearr_35040_37000[(1)] = (3));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_34990 === (18))){
var inst_34963 = (state_34989[(16)]);
var state_34989__$1 = state_34989;
var statearr_35041_37001 = state_34989__$1;
(statearr_35041_37001[(2)] = inst_34963);

(statearr_35041_37001[(1)] = (19));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_34990 === (8))){
var inst_34938 = (state_34989[(7)]);
var inst_34951 = (inst_34938 == null);
var state_34989__$1 = state_34989;
if(cljs.core.truth_(inst_34951)){
var statearr_35043_37002 = state_34989__$1;
(statearr_35043_37002[(1)] = (11));

} else {
var statearr_35044_37007 = state_34989__$1;
(statearr_35044_37007[(1)] = (12));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
return null;
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
});
return (function() {
var cljs$core$async$mix_$_state_machine__33219__auto__ = null;
var cljs$core$async$mix_$_state_machine__33219__auto____0 = (function (){
var statearr_35045 = [null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null];
(statearr_35045[(0)] = cljs$core$async$mix_$_state_machine__33219__auto__);

(statearr_35045[(1)] = (1));

return statearr_35045;
});
var cljs$core$async$mix_$_state_machine__33219__auto____1 = (function (state_34989){
while(true){
var ret_value__33220__auto__ = (function (){try{while(true){
var result__33221__auto__ = switch__33218__auto__(state_34989);
if(cljs.core.keyword_identical_QMARK_(result__33221__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
continue;
} else {
return result__33221__auto__;
}
break;
}
}catch (e35046){var ex__33222__auto__ = e35046;
var statearr_35047_37010 = state_34989;
(statearr_35047_37010[(2)] = ex__33222__auto__);


if(cljs.core.seq((state_34989[(4)]))){
var statearr_35048_37011 = state_34989;
(statearr_35048_37011[(1)] = cljs.core.first((state_34989[(4)])));

} else {
throw ex__33222__auto__;
}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
}})();
if(cljs.core.keyword_identical_QMARK_(ret_value__33220__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
var G__37016 = state_34989;
state_34989 = G__37016;
continue;
} else {
return ret_value__33220__auto__;
}
break;
}
});
cljs$core$async$mix_$_state_machine__33219__auto__ = function(state_34989){
switch(arguments.length){
case 0:
return cljs$core$async$mix_$_state_machine__33219__auto____0.call(this);
case 1:
return cljs$core$async$mix_$_state_machine__33219__auto____1.call(this,state_34989);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
cljs$core$async$mix_$_state_machine__33219__auto__.cljs$core$IFn$_invoke$arity$0 = cljs$core$async$mix_$_state_machine__33219__auto____0;
cljs$core$async$mix_$_state_machine__33219__auto__.cljs$core$IFn$_invoke$arity$1 = cljs$core$async$mix_$_state_machine__33219__auto____1;
return cljs$core$async$mix_$_state_machine__33219__auto__;
})()
})();
var state__33373__auto__ = (function (){var statearr_35049 = f__33372__auto__();
(statearr_35049[(6)] = c__33371__auto___36936);

return statearr_35049;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped(state__33373__auto__);
}));


return m;
});
/**
 * Adds ch as an input to the mix
 */
cljs.core.async.admix = (function cljs$core$async$admix(mix,ch){
return cljs.core.async.admix_STAR_(mix,ch);
});
/**
 * Removes ch as an input to the mix
 */
cljs.core.async.unmix = (function cljs$core$async$unmix(mix,ch){
return cljs.core.async.unmix_STAR_(mix,ch);
});
/**
 * removes all inputs from the mix
 */
cljs.core.async.unmix_all = (function cljs$core$async$unmix_all(mix){
return cljs.core.async.unmix_all_STAR_(mix);
});
/**
 * Atomically sets the state(s) of one or more channels in a mix. The
 *   state map is a map of channels -> channel-state-map. A
 *   channel-state-map is a map of attrs -> boolean, where attr is one or
 *   more of :mute, :pause or :solo. Any states supplied are merged with
 *   the current state.
 * 
 *   Note that channels can be added to a mix via toggle, which can be
 *   used to add channels in a particular (e.g. paused) state.
 */
cljs.core.async.toggle = (function cljs$core$async$toggle(mix,state_map){
return cljs.core.async.toggle_STAR_(mix,state_map);
});
/**
 * Sets the solo mode of the mix. mode must be one of :mute or :pause
 */
cljs.core.async.solo_mode = (function cljs$core$async$solo_mode(mix,mode){
return cljs.core.async.solo_mode_STAR_(mix,mode);
});

/**
 * @interface
 */
cljs.core.async.Pub = function(){};

var cljs$core$async$Pub$sub_STAR_$dyn_37017 = (function (p,v,ch,close_QMARK_){
var x__5393__auto__ = (((p == null))?null:p);
var m__5394__auto__ = (cljs.core.async.sub_STAR_[goog.typeOf(x__5393__auto__)]);
if((!((m__5394__auto__ == null)))){
return (m__5394__auto__.cljs$core$IFn$_invoke$arity$4 ? m__5394__auto__.cljs$core$IFn$_invoke$arity$4(p,v,ch,close_QMARK_) : m__5394__auto__.call(null,p,v,ch,close_QMARK_));
} else {
var m__5392__auto__ = (cljs.core.async.sub_STAR_["_"]);
if((!((m__5392__auto__ == null)))){
return (m__5392__auto__.cljs$core$IFn$_invoke$arity$4 ? m__5392__auto__.cljs$core$IFn$_invoke$arity$4(p,v,ch,close_QMARK_) : m__5392__auto__.call(null,p,v,ch,close_QMARK_));
} else {
throw cljs.core.missing_protocol("Pub.sub*",p);
}
}
});
cljs.core.async.sub_STAR_ = (function cljs$core$async$sub_STAR_(p,v,ch,close_QMARK_){
if((((!((p == null)))) && ((!((p.cljs$core$async$Pub$sub_STAR_$arity$4 == null)))))){
return p.cljs$core$async$Pub$sub_STAR_$arity$4(p,v,ch,close_QMARK_);
} else {
return cljs$core$async$Pub$sub_STAR_$dyn_37017(p,v,ch,close_QMARK_);
}
});

var cljs$core$async$Pub$unsub_STAR_$dyn_37025 = (function (p,v,ch){
var x__5393__auto__ = (((p == null))?null:p);
var m__5394__auto__ = (cljs.core.async.unsub_STAR_[goog.typeOf(x__5393__auto__)]);
if((!((m__5394__auto__ == null)))){
return (m__5394__auto__.cljs$core$IFn$_invoke$arity$3 ? m__5394__auto__.cljs$core$IFn$_invoke$arity$3(p,v,ch) : m__5394__auto__.call(null,p,v,ch));
} else {
var m__5392__auto__ = (cljs.core.async.unsub_STAR_["_"]);
if((!((m__5392__auto__ == null)))){
return (m__5392__auto__.cljs$core$IFn$_invoke$arity$3 ? m__5392__auto__.cljs$core$IFn$_invoke$arity$3(p,v,ch) : m__5392__auto__.call(null,p,v,ch));
} else {
throw cljs.core.missing_protocol("Pub.unsub*",p);
}
}
});
cljs.core.async.unsub_STAR_ = (function cljs$core$async$unsub_STAR_(p,v,ch){
if((((!((p == null)))) && ((!((p.cljs$core$async$Pub$unsub_STAR_$arity$3 == null)))))){
return p.cljs$core$async$Pub$unsub_STAR_$arity$3(p,v,ch);
} else {
return cljs$core$async$Pub$unsub_STAR_$dyn_37025(p,v,ch);
}
});

var cljs$core$async$Pub$unsub_all_STAR_$dyn_37026 = (function() {
var G__37027 = null;
var G__37027__1 = (function (p){
var x__5393__auto__ = (((p == null))?null:p);
var m__5394__auto__ = (cljs.core.async.unsub_all_STAR_[goog.typeOf(x__5393__auto__)]);
if((!((m__5394__auto__ == null)))){
return (m__5394__auto__.cljs$core$IFn$_invoke$arity$1 ? m__5394__auto__.cljs$core$IFn$_invoke$arity$1(p) : m__5394__auto__.call(null,p));
} else {
var m__5392__auto__ = (cljs.core.async.unsub_all_STAR_["_"]);
if((!((m__5392__auto__ == null)))){
return (m__5392__auto__.cljs$core$IFn$_invoke$arity$1 ? m__5392__auto__.cljs$core$IFn$_invoke$arity$1(p) : m__5392__auto__.call(null,p));
} else {
throw cljs.core.missing_protocol("Pub.unsub-all*",p);
}
}
});
var G__37027__2 = (function (p,v){
var x__5393__auto__ = (((p == null))?null:p);
var m__5394__auto__ = (cljs.core.async.unsub_all_STAR_[goog.typeOf(x__5393__auto__)]);
if((!((m__5394__auto__ == null)))){
return (m__5394__auto__.cljs$core$IFn$_invoke$arity$2 ? m__5394__auto__.cljs$core$IFn$_invoke$arity$2(p,v) : m__5394__auto__.call(null,p,v));
} else {
var m__5392__auto__ = (cljs.core.async.unsub_all_STAR_["_"]);
if((!((m__5392__auto__ == null)))){
return (m__5392__auto__.cljs$core$IFn$_invoke$arity$2 ? m__5392__auto__.cljs$core$IFn$_invoke$arity$2(p,v) : m__5392__auto__.call(null,p,v));
} else {
throw cljs.core.missing_protocol("Pub.unsub-all*",p);
}
}
});
G__37027 = function(p,v){
switch(arguments.length){
case 1:
return G__37027__1.call(this,p);
case 2:
return G__37027__2.call(this,p,v);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
G__37027.cljs$core$IFn$_invoke$arity$1 = G__37027__1;
G__37027.cljs$core$IFn$_invoke$arity$2 = G__37027__2;
return G__37027;
})()
;
cljs.core.async.unsub_all_STAR_ = (function cljs$core$async$unsub_all_STAR_(var_args){
var G__35065 = arguments.length;
switch (G__35065) {
case 1:
return cljs.core.async.unsub_all_STAR_.cljs$core$IFn$_invoke$arity$1((arguments[(0)]));

break;
case 2:
return cljs.core.async.unsub_all_STAR_.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
default:
throw (new Error(["Invalid arity: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(arguments.length)].join('')));

}
});

(cljs.core.async.unsub_all_STAR_.cljs$core$IFn$_invoke$arity$1 = (function (p){
if((((!((p == null)))) && ((!((p.cljs$core$async$Pub$unsub_all_STAR_$arity$1 == null)))))){
return p.cljs$core$async$Pub$unsub_all_STAR_$arity$1(p);
} else {
return cljs$core$async$Pub$unsub_all_STAR_$dyn_37026(p);
}
}));

(cljs.core.async.unsub_all_STAR_.cljs$core$IFn$_invoke$arity$2 = (function (p,v){
if((((!((p == null)))) && ((!((p.cljs$core$async$Pub$unsub_all_STAR_$arity$2 == null)))))){
return p.cljs$core$async$Pub$unsub_all_STAR_$arity$2(p,v);
} else {
return cljs$core$async$Pub$unsub_all_STAR_$dyn_37026(p,v);
}
}));

(cljs.core.async.unsub_all_STAR_.cljs$lang$maxFixedArity = 2);



/**
* @constructor
 * @implements {cljs.core.async.Pub}
 * @implements {cljs.core.IMeta}
 * @implements {cljs.core.async.Mux}
 * @implements {cljs.core.IWithMeta}
*/
cljs.core.async.t_cljs$core$async35085 = (function (ch,topic_fn,buf_fn,mults,ensure_mult,meta35086){
this.ch = ch;
this.topic_fn = topic_fn;
this.buf_fn = buf_fn;
this.mults = mults;
this.ensure_mult = ensure_mult;
this.meta35086 = meta35086;
this.cljs$lang$protocol_mask$partition0$ = 393216;
this.cljs$lang$protocol_mask$partition1$ = 0;
});
(cljs.core.async.t_cljs$core$async35085.prototype.cljs$core$IWithMeta$_with_meta$arity$2 = (function (_35087,meta35086__$1){
var self__ = this;
var _35087__$1 = this;
return (new cljs.core.async.t_cljs$core$async35085(self__.ch,self__.topic_fn,self__.buf_fn,self__.mults,self__.ensure_mult,meta35086__$1));
}));

(cljs.core.async.t_cljs$core$async35085.prototype.cljs$core$IMeta$_meta$arity$1 = (function (_35087){
var self__ = this;
var _35087__$1 = this;
return self__.meta35086;
}));

(cljs.core.async.t_cljs$core$async35085.prototype.cljs$core$async$Mux$ = cljs.core.PROTOCOL_SENTINEL);

(cljs.core.async.t_cljs$core$async35085.prototype.cljs$core$async$Mux$muxch_STAR_$arity$1 = (function (_){
var self__ = this;
var ___$1 = this;
return self__.ch;
}));

(cljs.core.async.t_cljs$core$async35085.prototype.cljs$core$async$Pub$ = cljs.core.PROTOCOL_SENTINEL);

(cljs.core.async.t_cljs$core$async35085.prototype.cljs$core$async$Pub$sub_STAR_$arity$4 = (function (p,topic,ch__$1,close_QMARK_){
var self__ = this;
var p__$1 = this;
var m = (self__.ensure_mult.cljs$core$IFn$_invoke$arity$1 ? self__.ensure_mult.cljs$core$IFn$_invoke$arity$1(topic) : self__.ensure_mult.call(null,topic));
return cljs.core.async.tap.cljs$core$IFn$_invoke$arity$3(m,ch__$1,close_QMARK_);
}));

(cljs.core.async.t_cljs$core$async35085.prototype.cljs$core$async$Pub$unsub_STAR_$arity$3 = (function (p,topic,ch__$1){
var self__ = this;
var p__$1 = this;
var temp__5804__auto__ = cljs.core.get.cljs$core$IFn$_invoke$arity$2(cljs.core.deref(self__.mults),topic);
if(cljs.core.truth_(temp__5804__auto__)){
var m = temp__5804__auto__;
return cljs.core.async.untap(m,ch__$1);
} else {
return null;
}
}));

(cljs.core.async.t_cljs$core$async35085.prototype.cljs$core$async$Pub$unsub_all_STAR_$arity$1 = (function (_){
var self__ = this;
var ___$1 = this;
return cljs.core.reset_BANG_(self__.mults,cljs.core.PersistentArrayMap.EMPTY);
}));

(cljs.core.async.t_cljs$core$async35085.prototype.cljs$core$async$Pub$unsub_all_STAR_$arity$2 = (function (_,topic){
var self__ = this;
var ___$1 = this;
return cljs.core.swap_BANG_.cljs$core$IFn$_invoke$arity$3(self__.mults,cljs.core.dissoc,topic);
}));

(cljs.core.async.t_cljs$core$async35085.getBasis = (function (){
return new cljs.core.PersistentVector(null, 6, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Symbol(null,"ch","ch",1085813622,null),new cljs.core.Symbol(null,"topic-fn","topic-fn",-862449736,null),new cljs.core.Symbol(null,"buf-fn","buf-fn",-1200281591,null),new cljs.core.Symbol(null,"mults","mults",-461114485,null),new cljs.core.Symbol(null,"ensure-mult","ensure-mult",1796584816,null),new cljs.core.Symbol(null,"meta35086","meta35086",1843676583,null)], null);
}));

(cljs.core.async.t_cljs$core$async35085.cljs$lang$type = true);

(cljs.core.async.t_cljs$core$async35085.cljs$lang$ctorStr = "cljs.core.async/t_cljs$core$async35085");

(cljs.core.async.t_cljs$core$async35085.cljs$lang$ctorPrWriter = (function (this__5330__auto__,writer__5331__auto__,opt__5332__auto__){
return cljs.core._write(writer__5331__auto__,"cljs.core.async/t_cljs$core$async35085");
}));

/**
 * Positional factory function for cljs.core.async/t_cljs$core$async35085.
 */
cljs.core.async.__GT_t_cljs$core$async35085 = (function cljs$core$async$__GT_t_cljs$core$async35085(ch,topic_fn,buf_fn,mults,ensure_mult,meta35086){
return (new cljs.core.async.t_cljs$core$async35085(ch,topic_fn,buf_fn,mults,ensure_mult,meta35086));
});


/**
 * Creates and returns a pub(lication) of the supplied channel,
 *   partitioned into topics by the topic-fn. topic-fn will be applied to
 *   each value on the channel and the result will determine the 'topic'
 *   on which that value will be put. Channels can be subscribed to
 *   receive copies of topics using 'sub', and unsubscribed using
 *   'unsub'. Each topic will be handled by an internal mult on a
 *   dedicated channel. By default these internal channels are
 *   unbuffered, but a buf-fn can be supplied which, given a topic,
 *   creates a buffer with desired properties.
 * 
 *   Each item is distributed to all subs in parallel and synchronously,
 *   i.e. each sub must accept before the next item is distributed. Use
 *   buffering/windowing to prevent slow subs from holding up the pub.
 * 
 *   Items received when there are no matching subs get dropped.
 * 
 *   Note that if buf-fns are used then each topic is handled
 *   asynchronously, i.e. if a channel is subscribed to more than one
 *   topic it should not expect them to be interleaved identically with
 *   the source.
 */
cljs.core.async.pub = (function cljs$core$async$pub(var_args){
var G__35070 = arguments.length;
switch (G__35070) {
case 2:
return cljs.core.async.pub.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
case 3:
return cljs.core.async.pub.cljs$core$IFn$_invoke$arity$3((arguments[(0)]),(arguments[(1)]),(arguments[(2)]));

break;
default:
throw (new Error(["Invalid arity: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(arguments.length)].join('')));

}
});

(cljs.core.async.pub.cljs$core$IFn$_invoke$arity$2 = (function (ch,topic_fn){
return cljs.core.async.pub.cljs$core$IFn$_invoke$arity$3(ch,topic_fn,cljs.core.constantly(null));
}));

(cljs.core.async.pub.cljs$core$IFn$_invoke$arity$3 = (function (ch,topic_fn,buf_fn){
var mults = cljs.core.atom.cljs$core$IFn$_invoke$arity$1(cljs.core.PersistentArrayMap.EMPTY);
var ensure_mult = (function (topic){
var or__5045__auto__ = cljs.core.get.cljs$core$IFn$_invoke$arity$2(cljs.core.deref(mults),topic);
if(cljs.core.truth_(or__5045__auto__)){
return or__5045__auto__;
} else {
return cljs.core.get.cljs$core$IFn$_invoke$arity$2(cljs.core.swap_BANG_.cljs$core$IFn$_invoke$arity$2(mults,(function (p1__35067_SHARP_){
if(cljs.core.truth_((p1__35067_SHARP_.cljs$core$IFn$_invoke$arity$1 ? p1__35067_SHARP_.cljs$core$IFn$_invoke$arity$1(topic) : p1__35067_SHARP_.call(null,topic)))){
return p1__35067_SHARP_;
} else {
return cljs.core.assoc.cljs$core$IFn$_invoke$arity$3(p1__35067_SHARP_,topic,cljs.core.async.mult(cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1((buf_fn.cljs$core$IFn$_invoke$arity$1 ? buf_fn.cljs$core$IFn$_invoke$arity$1(topic) : buf_fn.call(null,topic)))));
}
})),topic);
}
});
var p = (new cljs.core.async.t_cljs$core$async35085(ch,topic_fn,buf_fn,mults,ensure_mult,cljs.core.PersistentArrayMap.EMPTY));
var c__33371__auto___37047 = cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1((1));
cljs.core.async.impl.dispatch.run((function (){
var f__33372__auto__ = (function (){var switch__33218__auto__ = (function (state_35192){
var state_val_35193 = (state_35192[(1)]);
if((state_val_35193 === (7))){
var inst_35181 = (state_35192[(2)]);
var state_35192__$1 = state_35192;
var statearr_35198_37049 = state_35192__$1;
(statearr_35198_37049[(2)] = inst_35181);

(statearr_35198_37049[(1)] = (3));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_35193 === (20))){
var state_35192__$1 = state_35192;
var statearr_35201_37050 = state_35192__$1;
(statearr_35201_37050[(2)] = null);

(statearr_35201_37050[(1)] = (21));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_35193 === (1))){
var state_35192__$1 = state_35192;
var statearr_35202_37051 = state_35192__$1;
(statearr_35202_37051[(2)] = null);

(statearr_35202_37051[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_35193 === (24))){
var inst_35162 = (state_35192[(7)]);
var inst_35173 = cljs.core.swap_BANG_.cljs$core$IFn$_invoke$arity$3(mults,cljs.core.dissoc,inst_35162);
var state_35192__$1 = state_35192;
var statearr_35205_37052 = state_35192__$1;
(statearr_35205_37052[(2)] = inst_35173);

(statearr_35205_37052[(1)] = (25));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_35193 === (4))){
var inst_35098 = (state_35192[(8)]);
var inst_35098__$1 = (state_35192[(2)]);
var inst_35100 = (inst_35098__$1 == null);
var state_35192__$1 = (function (){var statearr_35206 = state_35192;
(statearr_35206[(8)] = inst_35098__$1);

return statearr_35206;
})();
if(cljs.core.truth_(inst_35100)){
var statearr_35207_37053 = state_35192__$1;
(statearr_35207_37053[(1)] = (5));

} else {
var statearr_35208_37054 = state_35192__$1;
(statearr_35208_37054[(1)] = (6));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_35193 === (15))){
var inst_35156 = (state_35192[(2)]);
var state_35192__$1 = state_35192;
var statearr_35211_37060 = state_35192__$1;
(statearr_35211_37060[(2)] = inst_35156);

(statearr_35211_37060[(1)] = (12));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_35193 === (21))){
var inst_35178 = (state_35192[(2)]);
var state_35192__$1 = (function (){var statearr_35212 = state_35192;
(statearr_35212[(9)] = inst_35178);

return statearr_35212;
})();
var statearr_35213_37061 = state_35192__$1;
(statearr_35213_37061[(2)] = null);

(statearr_35213_37061[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_35193 === (13))){
var inst_35133 = (state_35192[(10)]);
var inst_35135 = cljs.core.chunked_seq_QMARK_(inst_35133);
var state_35192__$1 = state_35192;
if(inst_35135){
var statearr_35215_37062 = state_35192__$1;
(statearr_35215_37062[(1)] = (16));

} else {
var statearr_35216_37063 = state_35192__$1;
(statearr_35216_37063[(1)] = (17));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_35193 === (22))){
var inst_35170 = (state_35192[(2)]);
var state_35192__$1 = state_35192;
if(cljs.core.truth_(inst_35170)){
var statearr_35217_37064 = state_35192__$1;
(statearr_35217_37064[(1)] = (23));

} else {
var statearr_35218_37065 = state_35192__$1;
(statearr_35218_37065[(1)] = (24));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_35193 === (6))){
var inst_35162 = (state_35192[(7)]);
var inst_35098 = (state_35192[(8)]);
var inst_35166 = (state_35192[(11)]);
var inst_35162__$1 = (topic_fn.cljs$core$IFn$_invoke$arity$1 ? topic_fn.cljs$core$IFn$_invoke$arity$1(inst_35098) : topic_fn.call(null,inst_35098));
var inst_35165 = cljs.core.deref(mults);
var inst_35166__$1 = cljs.core.get.cljs$core$IFn$_invoke$arity$2(inst_35165,inst_35162__$1);
var state_35192__$1 = (function (){var statearr_35219 = state_35192;
(statearr_35219[(7)] = inst_35162__$1);

(statearr_35219[(11)] = inst_35166__$1);

return statearr_35219;
})();
if(cljs.core.truth_(inst_35166__$1)){
var statearr_35220_37066 = state_35192__$1;
(statearr_35220_37066[(1)] = (19));

} else {
var statearr_35221_37067 = state_35192__$1;
(statearr_35221_37067[(1)] = (20));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_35193 === (25))){
var inst_35175 = (state_35192[(2)]);
var state_35192__$1 = state_35192;
var statearr_35222_37069 = state_35192__$1;
(statearr_35222_37069[(2)] = inst_35175);

(statearr_35222_37069[(1)] = (21));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_35193 === (17))){
var inst_35133 = (state_35192[(10)]);
var inst_35147 = cljs.core.first(inst_35133);
var inst_35148 = cljs.core.async.muxch_STAR_(inst_35147);
var inst_35149 = cljs.core.async.close_BANG_(inst_35148);
var inst_35150 = cljs.core.next(inst_35133);
var inst_35112 = inst_35150;
var inst_35113 = null;
var inst_35114 = (0);
var inst_35115 = (0);
var state_35192__$1 = (function (){var statearr_35223 = state_35192;
(statearr_35223[(12)] = inst_35113);

(statearr_35223[(13)] = inst_35149);

(statearr_35223[(14)] = inst_35115);

(statearr_35223[(15)] = inst_35112);

(statearr_35223[(16)] = inst_35114);

return statearr_35223;
})();
var statearr_35224_37070 = state_35192__$1;
(statearr_35224_37070[(2)] = null);

(statearr_35224_37070[(1)] = (8));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_35193 === (3))){
var inst_35183 = (state_35192[(2)]);
var state_35192__$1 = state_35192;
return cljs.core.async.impl.ioc_helpers.return_chan(state_35192__$1,inst_35183);
} else {
if((state_val_35193 === (12))){
var inst_35158 = (state_35192[(2)]);
var state_35192__$1 = state_35192;
var statearr_35226_37071 = state_35192__$1;
(statearr_35226_37071[(2)] = inst_35158);

(statearr_35226_37071[(1)] = (9));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_35193 === (2))){
var state_35192__$1 = state_35192;
return cljs.core.async.impl.ioc_helpers.take_BANG_(state_35192__$1,(4),ch);
} else {
if((state_val_35193 === (23))){
var state_35192__$1 = state_35192;
var statearr_35227_37072 = state_35192__$1;
(statearr_35227_37072[(2)] = null);

(statearr_35227_37072[(1)] = (25));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_35193 === (19))){
var inst_35098 = (state_35192[(8)]);
var inst_35166 = (state_35192[(11)]);
var inst_35168 = cljs.core.async.muxch_STAR_(inst_35166);
var state_35192__$1 = state_35192;
return cljs.core.async.impl.ioc_helpers.put_BANG_(state_35192__$1,(22),inst_35168,inst_35098);
} else {
if((state_val_35193 === (11))){
var inst_35133 = (state_35192[(10)]);
var inst_35112 = (state_35192[(15)]);
var inst_35133__$1 = cljs.core.seq(inst_35112);
var state_35192__$1 = (function (){var statearr_35230 = state_35192;
(statearr_35230[(10)] = inst_35133__$1);

return statearr_35230;
})();
if(inst_35133__$1){
var statearr_35231_37077 = state_35192__$1;
(statearr_35231_37077[(1)] = (13));

} else {
var statearr_35232_37078 = state_35192__$1;
(statearr_35232_37078[(1)] = (14));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_35193 === (9))){
var inst_35160 = (state_35192[(2)]);
var state_35192__$1 = state_35192;
var statearr_35233_37079 = state_35192__$1;
(statearr_35233_37079[(2)] = inst_35160);

(statearr_35233_37079[(1)] = (7));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_35193 === (5))){
var inst_35109 = cljs.core.deref(mults);
var inst_35110 = cljs.core.vals(inst_35109);
var inst_35111 = cljs.core.seq(inst_35110);
var inst_35112 = inst_35111;
var inst_35113 = null;
var inst_35114 = (0);
var inst_35115 = (0);
var state_35192__$1 = (function (){var statearr_35234 = state_35192;
(statearr_35234[(12)] = inst_35113);

(statearr_35234[(14)] = inst_35115);

(statearr_35234[(15)] = inst_35112);

(statearr_35234[(16)] = inst_35114);

return statearr_35234;
})();
var statearr_35235_37080 = state_35192__$1;
(statearr_35235_37080[(2)] = null);

(statearr_35235_37080[(1)] = (8));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_35193 === (14))){
var state_35192__$1 = state_35192;
var statearr_35239_37081 = state_35192__$1;
(statearr_35239_37081[(2)] = null);

(statearr_35239_37081[(1)] = (15));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_35193 === (16))){
var inst_35133 = (state_35192[(10)]);
var inst_35139 = cljs.core.chunk_first(inst_35133);
var inst_35141 = cljs.core.chunk_rest(inst_35133);
var inst_35142 = cljs.core.count(inst_35139);
var inst_35112 = inst_35141;
var inst_35113 = inst_35139;
var inst_35114 = inst_35142;
var inst_35115 = (0);
var state_35192__$1 = (function (){var statearr_35240 = state_35192;
(statearr_35240[(12)] = inst_35113);

(statearr_35240[(14)] = inst_35115);

(statearr_35240[(15)] = inst_35112);

(statearr_35240[(16)] = inst_35114);

return statearr_35240;
})();
var statearr_35241_37086 = state_35192__$1;
(statearr_35241_37086[(2)] = null);

(statearr_35241_37086[(1)] = (8));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_35193 === (10))){
var inst_35113 = (state_35192[(12)]);
var inst_35115 = (state_35192[(14)]);
var inst_35112 = (state_35192[(15)]);
var inst_35114 = (state_35192[(16)]);
var inst_35120 = cljs.core._nth(inst_35113,inst_35115);
var inst_35121 = cljs.core.async.muxch_STAR_(inst_35120);
var inst_35122 = cljs.core.async.close_BANG_(inst_35121);
var inst_35123 = (inst_35115 + (1));
var tmp35236 = inst_35113;
var tmp35237 = inst_35112;
var tmp35238 = inst_35114;
var inst_35112__$1 = tmp35237;
var inst_35113__$1 = tmp35236;
var inst_35114__$1 = tmp35238;
var inst_35115__$1 = inst_35123;
var state_35192__$1 = (function (){var statearr_35242 = state_35192;
(statearr_35242[(17)] = inst_35122);

(statearr_35242[(12)] = inst_35113__$1);

(statearr_35242[(14)] = inst_35115__$1);

(statearr_35242[(15)] = inst_35112__$1);

(statearr_35242[(16)] = inst_35114__$1);

return statearr_35242;
})();
var statearr_35243_37087 = state_35192__$1;
(statearr_35243_37087[(2)] = null);

(statearr_35243_37087[(1)] = (8));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_35193 === (18))){
var inst_35153 = (state_35192[(2)]);
var state_35192__$1 = state_35192;
var statearr_35245_37088 = state_35192__$1;
(statearr_35245_37088[(2)] = inst_35153);

(statearr_35245_37088[(1)] = (15));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_35193 === (8))){
var inst_35115 = (state_35192[(14)]);
var inst_35114 = (state_35192[(16)]);
var inst_35117 = (inst_35115 < inst_35114);
var inst_35118 = inst_35117;
var state_35192__$1 = state_35192;
if(cljs.core.truth_(inst_35118)){
var statearr_35251_37089 = state_35192__$1;
(statearr_35251_37089[(1)] = (10));

} else {
var statearr_35252_37090 = state_35192__$1;
(statearr_35252_37090[(1)] = (11));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
return null;
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
});
return (function() {
var cljs$core$async$state_machine__33219__auto__ = null;
var cljs$core$async$state_machine__33219__auto____0 = (function (){
var statearr_35255 = [null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null];
(statearr_35255[(0)] = cljs$core$async$state_machine__33219__auto__);

(statearr_35255[(1)] = (1));

return statearr_35255;
});
var cljs$core$async$state_machine__33219__auto____1 = (function (state_35192){
while(true){
var ret_value__33220__auto__ = (function (){try{while(true){
var result__33221__auto__ = switch__33218__auto__(state_35192);
if(cljs.core.keyword_identical_QMARK_(result__33221__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
continue;
} else {
return result__33221__auto__;
}
break;
}
}catch (e35256){var ex__33222__auto__ = e35256;
var statearr_35257_37091 = state_35192;
(statearr_35257_37091[(2)] = ex__33222__auto__);


if(cljs.core.seq((state_35192[(4)]))){
var statearr_35258_37092 = state_35192;
(statearr_35258_37092[(1)] = cljs.core.first((state_35192[(4)])));

} else {
throw ex__33222__auto__;
}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
}})();
if(cljs.core.keyword_identical_QMARK_(ret_value__33220__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
var G__37093 = state_35192;
state_35192 = G__37093;
continue;
} else {
return ret_value__33220__auto__;
}
break;
}
});
cljs$core$async$state_machine__33219__auto__ = function(state_35192){
switch(arguments.length){
case 0:
return cljs$core$async$state_machine__33219__auto____0.call(this);
case 1:
return cljs$core$async$state_machine__33219__auto____1.call(this,state_35192);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
cljs$core$async$state_machine__33219__auto__.cljs$core$IFn$_invoke$arity$0 = cljs$core$async$state_machine__33219__auto____0;
cljs$core$async$state_machine__33219__auto__.cljs$core$IFn$_invoke$arity$1 = cljs$core$async$state_machine__33219__auto____1;
return cljs$core$async$state_machine__33219__auto__;
})()
})();
var state__33373__auto__ = (function (){var statearr_35261 = f__33372__auto__();
(statearr_35261[(6)] = c__33371__auto___37047);

return statearr_35261;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped(state__33373__auto__);
}));


return p;
}));

(cljs.core.async.pub.cljs$lang$maxFixedArity = 3);

/**
 * Subscribes a channel to a topic of a pub.
 * 
 *   By default the channel will be closed when the source closes,
 *   but can be determined by the close? parameter.
 */
cljs.core.async.sub = (function cljs$core$async$sub(var_args){
var G__35271 = arguments.length;
switch (G__35271) {
case 3:
return cljs.core.async.sub.cljs$core$IFn$_invoke$arity$3((arguments[(0)]),(arguments[(1)]),(arguments[(2)]));

break;
case 4:
return cljs.core.async.sub.cljs$core$IFn$_invoke$arity$4((arguments[(0)]),(arguments[(1)]),(arguments[(2)]),(arguments[(3)]));

break;
default:
throw (new Error(["Invalid arity: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(arguments.length)].join('')));

}
});

(cljs.core.async.sub.cljs$core$IFn$_invoke$arity$3 = (function (p,topic,ch){
return cljs.core.async.sub.cljs$core$IFn$_invoke$arity$4(p,topic,ch,true);
}));

(cljs.core.async.sub.cljs$core$IFn$_invoke$arity$4 = (function (p,topic,ch,close_QMARK_){
return cljs.core.async.sub_STAR_(p,topic,ch,close_QMARK_);
}));

(cljs.core.async.sub.cljs$lang$maxFixedArity = 4);

/**
 * Unsubscribes a channel from a topic of a pub
 */
cljs.core.async.unsub = (function cljs$core$async$unsub(p,topic,ch){
return cljs.core.async.unsub_STAR_(p,topic,ch);
});
/**
 * Unsubscribes all channels from a pub, or a topic of a pub
 */
cljs.core.async.unsub_all = (function cljs$core$async$unsub_all(var_args){
var G__35286 = arguments.length;
switch (G__35286) {
case 1:
return cljs.core.async.unsub_all.cljs$core$IFn$_invoke$arity$1((arguments[(0)]));

break;
case 2:
return cljs.core.async.unsub_all.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
default:
throw (new Error(["Invalid arity: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(arguments.length)].join('')));

}
});

(cljs.core.async.unsub_all.cljs$core$IFn$_invoke$arity$1 = (function (p){
return cljs.core.async.unsub_all_STAR_(p);
}));

(cljs.core.async.unsub_all.cljs$core$IFn$_invoke$arity$2 = (function (p,topic){
return cljs.core.async.unsub_all_STAR_(p,topic);
}));

(cljs.core.async.unsub_all.cljs$lang$maxFixedArity = 2);

/**
 * Takes a function and a collection of source channels, and returns a
 *   channel which contains the values produced by applying f to the set
 *   of first items taken from each source channel, followed by applying
 *   f to the set of second items from each channel, until any one of the
 *   channels is closed, at which point the output channel will be
 *   closed. The returned channel will be unbuffered by default, or a
 *   buf-or-n can be supplied
 */
cljs.core.async.map = (function cljs$core$async$map(var_args){
var G__35309 = arguments.length;
switch (G__35309) {
case 2:
return cljs.core.async.map.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
case 3:
return cljs.core.async.map.cljs$core$IFn$_invoke$arity$3((arguments[(0)]),(arguments[(1)]),(arguments[(2)]));

break;
default:
throw (new Error(["Invalid arity: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(arguments.length)].join('')));

}
});

(cljs.core.async.map.cljs$core$IFn$_invoke$arity$2 = (function (f,chs){
return cljs.core.async.map.cljs$core$IFn$_invoke$arity$3(f,chs,null);
}));

(cljs.core.async.map.cljs$core$IFn$_invoke$arity$3 = (function (f,chs,buf_or_n){
var chs__$1 = cljs.core.vec(chs);
var out = cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1(buf_or_n);
var cnt = cljs.core.count(chs__$1);
var rets = cljs.core.object_array.cljs$core$IFn$_invoke$arity$1(cnt);
var dchan = cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1((1));
var dctr = cljs.core.atom.cljs$core$IFn$_invoke$arity$1(null);
var done = cljs.core.mapv.cljs$core$IFn$_invoke$arity$2((function (i){
return (function (ret){
(rets[i] = ret);

if((cljs.core.swap_BANG_.cljs$core$IFn$_invoke$arity$2(dctr,cljs.core.dec) === (0))){
return cljs.core.async.put_BANG_.cljs$core$IFn$_invoke$arity$2(dchan,rets.slice((0)));
} else {
return null;
}
});
}),cljs.core.range.cljs$core$IFn$_invoke$arity$1(cnt));
if((cnt === (0))){
cljs.core.async.close_BANG_(out);
} else {
var c__33371__auto___37102 = cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1((1));
cljs.core.async.impl.dispatch.run((function (){
var f__33372__auto__ = (function (){var switch__33218__auto__ = (function (state_35386){
var state_val_35387 = (state_35386[(1)]);
if((state_val_35387 === (7))){
var state_35386__$1 = state_35386;
var statearr_35399_37104 = state_35386__$1;
(statearr_35399_37104[(2)] = null);

(statearr_35399_37104[(1)] = (8));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_35387 === (1))){
var state_35386__$1 = state_35386;
var statearr_35400_37105 = state_35386__$1;
(statearr_35400_37105[(2)] = null);

(statearr_35400_37105[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_35387 === (4))){
var inst_35337 = (state_35386[(7)]);
var inst_35338 = (state_35386[(8)]);
var inst_35340 = (inst_35338 < inst_35337);
var state_35386__$1 = state_35386;
if(cljs.core.truth_(inst_35340)){
var statearr_35407_37106 = state_35386__$1;
(statearr_35407_37106[(1)] = (6));

} else {
var statearr_35412_37107 = state_35386__$1;
(statearr_35412_37107[(1)] = (7));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_35387 === (15))){
var inst_35369 = (state_35386[(9)]);
var inst_35375 = cljs.core.apply.cljs$core$IFn$_invoke$arity$2(f,inst_35369);
var state_35386__$1 = state_35386;
return cljs.core.async.impl.ioc_helpers.put_BANG_(state_35386__$1,(17),out,inst_35375);
} else {
if((state_val_35387 === (13))){
var inst_35369 = (state_35386[(9)]);
var inst_35369__$1 = (state_35386[(2)]);
var inst_35370 = cljs.core.some(cljs.core.nil_QMARK_,inst_35369__$1);
var state_35386__$1 = (function (){var statearr_35416 = state_35386;
(statearr_35416[(9)] = inst_35369__$1);

return statearr_35416;
})();
if(cljs.core.truth_(inst_35370)){
var statearr_35417_37112 = state_35386__$1;
(statearr_35417_37112[(1)] = (14));

} else {
var statearr_35418_37113 = state_35386__$1;
(statearr_35418_37113[(1)] = (15));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_35387 === (6))){
var state_35386__$1 = state_35386;
var statearr_35421_37114 = state_35386__$1;
(statearr_35421_37114[(2)] = null);

(statearr_35421_37114[(1)] = (9));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_35387 === (17))){
var inst_35377 = (state_35386[(2)]);
var state_35386__$1 = (function (){var statearr_35427 = state_35386;
(statearr_35427[(10)] = inst_35377);

return statearr_35427;
})();
var statearr_35430_37127 = state_35386__$1;
(statearr_35430_37127[(2)] = null);

(statearr_35430_37127[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_35387 === (3))){
var inst_35382 = (state_35386[(2)]);
var state_35386__$1 = state_35386;
return cljs.core.async.impl.ioc_helpers.return_chan(state_35386__$1,inst_35382);
} else {
if((state_val_35387 === (12))){
var _ = (function (){var statearr_35434 = state_35386;
(statearr_35434[(4)] = cljs.core.rest((state_35386[(4)])));

return statearr_35434;
})();
var state_35386__$1 = state_35386;
var ex35423 = (state_35386__$1[(2)]);
var statearr_35437_37130 = state_35386__$1;
(statearr_35437_37130[(5)] = ex35423);


if((ex35423 instanceof Object)){
var statearr_35442_37131 = state_35386__$1;
(statearr_35442_37131[(1)] = (11));

(statearr_35442_37131[(5)] = null);

} else {
throw ex35423;

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_35387 === (2))){
var inst_35334 = cljs.core.reset_BANG_(dctr,cnt);
var inst_35337 = cnt;
var inst_35338 = (0);
var state_35386__$1 = (function (){var statearr_35444 = state_35386;
(statearr_35444[(11)] = inst_35334);

(statearr_35444[(7)] = inst_35337);

(statearr_35444[(8)] = inst_35338);

return statearr_35444;
})();
var statearr_35445_37132 = state_35386__$1;
(statearr_35445_37132[(2)] = null);

(statearr_35445_37132[(1)] = (4));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_35387 === (11))){
var inst_35347 = (state_35386[(2)]);
var inst_35348 = cljs.core.swap_BANG_.cljs$core$IFn$_invoke$arity$2(dctr,cljs.core.dec);
var state_35386__$1 = (function (){var statearr_35446 = state_35386;
(statearr_35446[(12)] = inst_35347);

return statearr_35446;
})();
var statearr_35447_37133 = state_35386__$1;
(statearr_35447_37133[(2)] = inst_35348);

(statearr_35447_37133[(1)] = (10));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_35387 === (9))){
var inst_35338 = (state_35386[(8)]);
var _ = (function (){var statearr_35448 = state_35386;
(statearr_35448[(4)] = cljs.core.cons((12),(state_35386[(4)])));

return statearr_35448;
})();
var inst_35354 = (chs__$1.cljs$core$IFn$_invoke$arity$1 ? chs__$1.cljs$core$IFn$_invoke$arity$1(inst_35338) : chs__$1.call(null,inst_35338));
var inst_35355 = (done.cljs$core$IFn$_invoke$arity$1 ? done.cljs$core$IFn$_invoke$arity$1(inst_35338) : done.call(null,inst_35338));
var inst_35356 = cljs.core.async.take_BANG_.cljs$core$IFn$_invoke$arity$2(inst_35354,inst_35355);
var ___$1 = (function (){var statearr_35449 = state_35386;
(statearr_35449[(4)] = cljs.core.rest((state_35386[(4)])));

return statearr_35449;
})();
var state_35386__$1 = state_35386;
var statearr_35451_37134 = state_35386__$1;
(statearr_35451_37134[(2)] = inst_35356);

(statearr_35451_37134[(1)] = (10));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_35387 === (5))){
var inst_35366 = (state_35386[(2)]);
var state_35386__$1 = (function (){var statearr_35452 = state_35386;
(statearr_35452[(13)] = inst_35366);

return statearr_35452;
})();
return cljs.core.async.impl.ioc_helpers.take_BANG_(state_35386__$1,(13),dchan);
} else {
if((state_val_35387 === (14))){
var inst_35372 = cljs.core.async.close_BANG_(out);
var state_35386__$1 = state_35386;
var statearr_35454_37135 = state_35386__$1;
(statearr_35454_37135[(2)] = inst_35372);

(statearr_35454_37135[(1)] = (16));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_35387 === (16))){
var inst_35380 = (state_35386[(2)]);
var state_35386__$1 = state_35386;
var statearr_35457_37136 = state_35386__$1;
(statearr_35457_37136[(2)] = inst_35380);

(statearr_35457_37136[(1)] = (3));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_35387 === (10))){
var inst_35338 = (state_35386[(8)]);
var inst_35359 = (state_35386[(2)]);
var inst_35360 = (inst_35338 + (1));
var inst_35338__$1 = inst_35360;
var state_35386__$1 = (function (){var statearr_35461 = state_35386;
(statearr_35461[(14)] = inst_35359);

(statearr_35461[(8)] = inst_35338__$1);

return statearr_35461;
})();
var statearr_35464_37137 = state_35386__$1;
(statearr_35464_37137[(2)] = null);

(statearr_35464_37137[(1)] = (4));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_35387 === (8))){
var inst_35364 = (state_35386[(2)]);
var state_35386__$1 = state_35386;
var statearr_35471_37140 = state_35386__$1;
(statearr_35471_37140[(2)] = inst_35364);

(statearr_35471_37140[(1)] = (5));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
return null;
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
});
return (function() {
var cljs$core$async$state_machine__33219__auto__ = null;
var cljs$core$async$state_machine__33219__auto____0 = (function (){
var statearr_35480 = [null,null,null,null,null,null,null,null,null,null,null,null,null,null,null];
(statearr_35480[(0)] = cljs$core$async$state_machine__33219__auto__);

(statearr_35480[(1)] = (1));

return statearr_35480;
});
var cljs$core$async$state_machine__33219__auto____1 = (function (state_35386){
while(true){
var ret_value__33220__auto__ = (function (){try{while(true){
var result__33221__auto__ = switch__33218__auto__(state_35386);
if(cljs.core.keyword_identical_QMARK_(result__33221__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
continue;
} else {
return result__33221__auto__;
}
break;
}
}catch (e35491){var ex__33222__auto__ = e35491;
var statearr_35495_37144 = state_35386;
(statearr_35495_37144[(2)] = ex__33222__auto__);


if(cljs.core.seq((state_35386[(4)]))){
var statearr_35496_37146 = state_35386;
(statearr_35496_37146[(1)] = cljs.core.first((state_35386[(4)])));

} else {
throw ex__33222__auto__;
}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
}})();
if(cljs.core.keyword_identical_QMARK_(ret_value__33220__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
var G__37147 = state_35386;
state_35386 = G__37147;
continue;
} else {
return ret_value__33220__auto__;
}
break;
}
});
cljs$core$async$state_machine__33219__auto__ = function(state_35386){
switch(arguments.length){
case 0:
return cljs$core$async$state_machine__33219__auto____0.call(this);
case 1:
return cljs$core$async$state_machine__33219__auto____1.call(this,state_35386);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
cljs$core$async$state_machine__33219__auto__.cljs$core$IFn$_invoke$arity$0 = cljs$core$async$state_machine__33219__auto____0;
cljs$core$async$state_machine__33219__auto__.cljs$core$IFn$_invoke$arity$1 = cljs$core$async$state_machine__33219__auto____1;
return cljs$core$async$state_machine__33219__auto__;
})()
})();
var state__33373__auto__ = (function (){var statearr_35497 = f__33372__auto__();
(statearr_35497[(6)] = c__33371__auto___37102);

return statearr_35497;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped(state__33373__auto__);
}));

}

return out;
}));

(cljs.core.async.map.cljs$lang$maxFixedArity = 3);

/**
 * Takes a collection of source channels and returns a channel which
 *   contains all values taken from them. The returned channel will be
 *   unbuffered by default, or a buf-or-n can be supplied. The channel
 *   will close after all the source channels have closed.
 */
cljs.core.async.merge = (function cljs$core$async$merge(var_args){
var G__35501 = arguments.length;
switch (G__35501) {
case 1:
return cljs.core.async.merge.cljs$core$IFn$_invoke$arity$1((arguments[(0)]));

break;
case 2:
return cljs.core.async.merge.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
default:
throw (new Error(["Invalid arity: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(arguments.length)].join('')));

}
});

(cljs.core.async.merge.cljs$core$IFn$_invoke$arity$1 = (function (chs){
return cljs.core.async.merge.cljs$core$IFn$_invoke$arity$2(chs,null);
}));

(cljs.core.async.merge.cljs$core$IFn$_invoke$arity$2 = (function (chs,buf_or_n){
var out = cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1(buf_or_n);
var c__33371__auto___37149 = cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1((1));
cljs.core.async.impl.dispatch.run((function (){
var f__33372__auto__ = (function (){var switch__33218__auto__ = (function (state_35546){
var state_val_35547 = (state_35546[(1)]);
if((state_val_35547 === (7))){
var inst_35524 = (state_35546[(7)]);
var inst_35523 = (state_35546[(8)]);
var inst_35523__$1 = (state_35546[(2)]);
var inst_35524__$1 = cljs.core.nth.cljs$core$IFn$_invoke$arity$3(inst_35523__$1,(0),null);
var inst_35525 = cljs.core.nth.cljs$core$IFn$_invoke$arity$3(inst_35523__$1,(1),null);
var inst_35526 = (inst_35524__$1 == null);
var state_35546__$1 = (function (){var statearr_35551 = state_35546;
(statearr_35551[(7)] = inst_35524__$1);

(statearr_35551[(9)] = inst_35525);

(statearr_35551[(8)] = inst_35523__$1);

return statearr_35551;
})();
if(cljs.core.truth_(inst_35526)){
var statearr_35552_37150 = state_35546__$1;
(statearr_35552_37150[(1)] = (8));

} else {
var statearr_35553_37151 = state_35546__$1;
(statearr_35553_37151[(1)] = (9));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_35547 === (1))){
var inst_35505 = cljs.core.vec(chs);
var inst_35506 = inst_35505;
var state_35546__$1 = (function (){var statearr_35557 = state_35546;
(statearr_35557[(10)] = inst_35506);

return statearr_35557;
})();
var statearr_35558_37153 = state_35546__$1;
(statearr_35558_37153[(2)] = null);

(statearr_35558_37153[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_35547 === (4))){
var inst_35506 = (state_35546[(10)]);
var state_35546__$1 = state_35546;
return cljs.core.async.ioc_alts_BANG_(state_35546__$1,(7),inst_35506);
} else {
if((state_val_35547 === (6))){
var inst_35542 = (state_35546[(2)]);
var state_35546__$1 = state_35546;
var statearr_35560_37154 = state_35546__$1;
(statearr_35560_37154[(2)] = inst_35542);

(statearr_35560_37154[(1)] = (3));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_35547 === (3))){
var inst_35544 = (state_35546[(2)]);
var state_35546__$1 = state_35546;
return cljs.core.async.impl.ioc_helpers.return_chan(state_35546__$1,inst_35544);
} else {
if((state_val_35547 === (2))){
var inst_35506 = (state_35546[(10)]);
var inst_35514 = cljs.core.count(inst_35506);
var inst_35515 = (inst_35514 > (0));
var state_35546__$1 = state_35546;
if(cljs.core.truth_(inst_35515)){
var statearr_35565_37156 = state_35546__$1;
(statearr_35565_37156[(1)] = (4));

} else {
var statearr_35566_37160 = state_35546__$1;
(statearr_35566_37160[(1)] = (5));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_35547 === (11))){
var inst_35506 = (state_35546[(10)]);
var inst_35534 = (state_35546[(2)]);
var tmp35561 = inst_35506;
var inst_35506__$1 = tmp35561;
var state_35546__$1 = (function (){var statearr_35572 = state_35546;
(statearr_35572[(10)] = inst_35506__$1);

(statearr_35572[(11)] = inst_35534);

return statearr_35572;
})();
var statearr_35573_37161 = state_35546__$1;
(statearr_35573_37161[(2)] = null);

(statearr_35573_37161[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_35547 === (9))){
var inst_35524 = (state_35546[(7)]);
var state_35546__$1 = state_35546;
return cljs.core.async.impl.ioc_helpers.put_BANG_(state_35546__$1,(11),out,inst_35524);
} else {
if((state_val_35547 === (5))){
var inst_35540 = cljs.core.async.close_BANG_(out);
var state_35546__$1 = state_35546;
var statearr_35582_37164 = state_35546__$1;
(statearr_35582_37164[(2)] = inst_35540);

(statearr_35582_37164[(1)] = (6));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_35547 === (10))){
var inst_35537 = (state_35546[(2)]);
var state_35546__$1 = state_35546;
var statearr_35583_37167 = state_35546__$1;
(statearr_35583_37167[(2)] = inst_35537);

(statearr_35583_37167[(1)] = (6));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_35547 === (8))){
var inst_35524 = (state_35546[(7)]);
var inst_35525 = (state_35546[(9)]);
var inst_35506 = (state_35546[(10)]);
var inst_35523 = (state_35546[(8)]);
var inst_35528 = (function (){var cs = inst_35506;
var vec__35517 = inst_35523;
var v = inst_35524;
var c = inst_35525;
return (function (p1__35498_SHARP_){
return cljs.core.not_EQ_.cljs$core$IFn$_invoke$arity$2(c,p1__35498_SHARP_);
});
})();
var inst_35529 = cljs.core.filterv(inst_35528,inst_35506);
var inst_35506__$1 = inst_35529;
var state_35546__$1 = (function (){var statearr_35584 = state_35546;
(statearr_35584[(10)] = inst_35506__$1);

return statearr_35584;
})();
var statearr_35589_37169 = state_35546__$1;
(statearr_35589_37169[(2)] = null);

(statearr_35589_37169[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
return null;
}
}
}
}
}
}
}
}
}
}
}
});
return (function() {
var cljs$core$async$state_machine__33219__auto__ = null;
var cljs$core$async$state_machine__33219__auto____0 = (function (){
var statearr_35590 = [null,null,null,null,null,null,null,null,null,null,null,null];
(statearr_35590[(0)] = cljs$core$async$state_machine__33219__auto__);

(statearr_35590[(1)] = (1));

return statearr_35590;
});
var cljs$core$async$state_machine__33219__auto____1 = (function (state_35546){
while(true){
var ret_value__33220__auto__ = (function (){try{while(true){
var result__33221__auto__ = switch__33218__auto__(state_35546);
if(cljs.core.keyword_identical_QMARK_(result__33221__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
continue;
} else {
return result__33221__auto__;
}
break;
}
}catch (e35591){var ex__33222__auto__ = e35591;
var statearr_35592_37170 = state_35546;
(statearr_35592_37170[(2)] = ex__33222__auto__);


if(cljs.core.seq((state_35546[(4)]))){
var statearr_35593_37171 = state_35546;
(statearr_35593_37171[(1)] = cljs.core.first((state_35546[(4)])));

} else {
throw ex__33222__auto__;
}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
}})();
if(cljs.core.keyword_identical_QMARK_(ret_value__33220__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
var G__37172 = state_35546;
state_35546 = G__37172;
continue;
} else {
return ret_value__33220__auto__;
}
break;
}
});
cljs$core$async$state_machine__33219__auto__ = function(state_35546){
switch(arguments.length){
case 0:
return cljs$core$async$state_machine__33219__auto____0.call(this);
case 1:
return cljs$core$async$state_machine__33219__auto____1.call(this,state_35546);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
cljs$core$async$state_machine__33219__auto__.cljs$core$IFn$_invoke$arity$0 = cljs$core$async$state_machine__33219__auto____0;
cljs$core$async$state_machine__33219__auto__.cljs$core$IFn$_invoke$arity$1 = cljs$core$async$state_machine__33219__auto____1;
return cljs$core$async$state_machine__33219__auto__;
})()
})();
var state__33373__auto__ = (function (){var statearr_35603 = f__33372__auto__();
(statearr_35603[(6)] = c__33371__auto___37149);

return statearr_35603;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped(state__33373__auto__);
}));


return out;
}));

(cljs.core.async.merge.cljs$lang$maxFixedArity = 2);

/**
 * Returns a channel containing the single (collection) result of the
 *   items taken from the channel conjoined to the supplied
 *   collection. ch must close before into produces a result.
 */
cljs.core.async.into = (function cljs$core$async$into(coll,ch){
return cljs.core.async.reduce(cljs.core.conj,coll,ch);
});
/**
 * Returns a channel that will return, at most, n items from ch. After n items
 * have been returned, or ch has been closed, the return chanel will close.
 * 
 *   The output channel is unbuffered by default, unless buf-or-n is given.
 */
cljs.core.async.take = (function cljs$core$async$take(var_args){
var G__35612 = arguments.length;
switch (G__35612) {
case 2:
return cljs.core.async.take.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
case 3:
return cljs.core.async.take.cljs$core$IFn$_invoke$arity$3((arguments[(0)]),(arguments[(1)]),(arguments[(2)]));

break;
default:
throw (new Error(["Invalid arity: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(arguments.length)].join('')));

}
});

(cljs.core.async.take.cljs$core$IFn$_invoke$arity$2 = (function (n,ch){
return cljs.core.async.take.cljs$core$IFn$_invoke$arity$3(n,ch,null);
}));

(cljs.core.async.take.cljs$core$IFn$_invoke$arity$3 = (function (n,ch,buf_or_n){
var out = cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1(buf_or_n);
var c__33371__auto___37175 = cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1((1));
cljs.core.async.impl.dispatch.run((function (){
var f__33372__auto__ = (function (){var switch__33218__auto__ = (function (state_35655){
var state_val_35656 = (state_35655[(1)]);
if((state_val_35656 === (7))){
var inst_35633 = (state_35655[(7)]);
var inst_35633__$1 = (state_35655[(2)]);
var inst_35634 = (inst_35633__$1 == null);
var inst_35635 = cljs.core.not(inst_35634);
var state_35655__$1 = (function (){var statearr_35660 = state_35655;
(statearr_35660[(7)] = inst_35633__$1);

return statearr_35660;
})();
if(inst_35635){
var statearr_35661_37176 = state_35655__$1;
(statearr_35661_37176[(1)] = (8));

} else {
var statearr_35662_37177 = state_35655__$1;
(statearr_35662_37177[(1)] = (9));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_35656 === (1))){
var inst_35628 = (0);
var state_35655__$1 = (function (){var statearr_35663 = state_35655;
(statearr_35663[(8)] = inst_35628);

return statearr_35663;
})();
var statearr_35664_37178 = state_35655__$1;
(statearr_35664_37178[(2)] = null);

(statearr_35664_37178[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_35656 === (4))){
var state_35655__$1 = state_35655;
return cljs.core.async.impl.ioc_helpers.take_BANG_(state_35655__$1,(7),ch);
} else {
if((state_val_35656 === (6))){
var inst_35650 = (state_35655[(2)]);
var state_35655__$1 = state_35655;
var statearr_35668_37180 = state_35655__$1;
(statearr_35668_37180[(2)] = inst_35650);

(statearr_35668_37180[(1)] = (3));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_35656 === (3))){
var inst_35652 = (state_35655[(2)]);
var inst_35653 = cljs.core.async.close_BANG_(out);
var state_35655__$1 = (function (){var statearr_35669 = state_35655;
(statearr_35669[(9)] = inst_35652);

return statearr_35669;
})();
return cljs.core.async.impl.ioc_helpers.return_chan(state_35655__$1,inst_35653);
} else {
if((state_val_35656 === (2))){
var inst_35628 = (state_35655[(8)]);
var inst_35630 = (inst_35628 < n);
var state_35655__$1 = state_35655;
if(cljs.core.truth_(inst_35630)){
var statearr_35670_37184 = state_35655__$1;
(statearr_35670_37184[(1)] = (4));

} else {
var statearr_35671_37185 = state_35655__$1;
(statearr_35671_37185[(1)] = (5));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_35656 === (11))){
var inst_35628 = (state_35655[(8)]);
var inst_35638 = (state_35655[(2)]);
var inst_35639 = (inst_35628 + (1));
var inst_35628__$1 = inst_35639;
var state_35655__$1 = (function (){var statearr_35673 = state_35655;
(statearr_35673[(10)] = inst_35638);

(statearr_35673[(8)] = inst_35628__$1);

return statearr_35673;
})();
var statearr_35674_37186 = state_35655__$1;
(statearr_35674_37186[(2)] = null);

(statearr_35674_37186[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_35656 === (9))){
var state_35655__$1 = state_35655;
var statearr_35675_37187 = state_35655__$1;
(statearr_35675_37187[(2)] = null);

(statearr_35675_37187[(1)] = (10));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_35656 === (5))){
var state_35655__$1 = state_35655;
var statearr_35676_37188 = state_35655__$1;
(statearr_35676_37188[(2)] = null);

(statearr_35676_37188[(1)] = (6));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_35656 === (10))){
var inst_35643 = (state_35655[(2)]);
var state_35655__$1 = state_35655;
var statearr_35677_37189 = state_35655__$1;
(statearr_35677_37189[(2)] = inst_35643);

(statearr_35677_37189[(1)] = (6));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_35656 === (8))){
var inst_35633 = (state_35655[(7)]);
var state_35655__$1 = state_35655;
return cljs.core.async.impl.ioc_helpers.put_BANG_(state_35655__$1,(11),out,inst_35633);
} else {
return null;
}
}
}
}
}
}
}
}
}
}
}
});
return (function() {
var cljs$core$async$state_machine__33219__auto__ = null;
var cljs$core$async$state_machine__33219__auto____0 = (function (){
var statearr_35680 = [null,null,null,null,null,null,null,null,null,null,null];
(statearr_35680[(0)] = cljs$core$async$state_machine__33219__auto__);

(statearr_35680[(1)] = (1));

return statearr_35680;
});
var cljs$core$async$state_machine__33219__auto____1 = (function (state_35655){
while(true){
var ret_value__33220__auto__ = (function (){try{while(true){
var result__33221__auto__ = switch__33218__auto__(state_35655);
if(cljs.core.keyword_identical_QMARK_(result__33221__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
continue;
} else {
return result__33221__auto__;
}
break;
}
}catch (e35681){var ex__33222__auto__ = e35681;
var statearr_35683_37191 = state_35655;
(statearr_35683_37191[(2)] = ex__33222__auto__);


if(cljs.core.seq((state_35655[(4)]))){
var statearr_35684_37192 = state_35655;
(statearr_35684_37192[(1)] = cljs.core.first((state_35655[(4)])));

} else {
throw ex__33222__auto__;
}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
}})();
if(cljs.core.keyword_identical_QMARK_(ret_value__33220__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
var G__37196 = state_35655;
state_35655 = G__37196;
continue;
} else {
return ret_value__33220__auto__;
}
break;
}
});
cljs$core$async$state_machine__33219__auto__ = function(state_35655){
switch(arguments.length){
case 0:
return cljs$core$async$state_machine__33219__auto____0.call(this);
case 1:
return cljs$core$async$state_machine__33219__auto____1.call(this,state_35655);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
cljs$core$async$state_machine__33219__auto__.cljs$core$IFn$_invoke$arity$0 = cljs$core$async$state_machine__33219__auto____0;
cljs$core$async$state_machine__33219__auto__.cljs$core$IFn$_invoke$arity$1 = cljs$core$async$state_machine__33219__auto____1;
return cljs$core$async$state_machine__33219__auto__;
})()
})();
var state__33373__auto__ = (function (){var statearr_35685 = f__33372__auto__();
(statearr_35685[(6)] = c__33371__auto___37175);

return statearr_35685;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped(state__33373__auto__);
}));


return out;
}));

(cljs.core.async.take.cljs$lang$maxFixedArity = 3);


/**
* @constructor
 * @implements {cljs.core.async.impl.protocols.Handler}
 * @implements {cljs.core.IMeta}
 * @implements {cljs.core.IWithMeta}
*/
cljs.core.async.t_cljs$core$async35691 = (function (f,ch,meta35688,_,fn1,meta35692){
this.f = f;
this.ch = ch;
this.meta35688 = meta35688;
this._ = _;
this.fn1 = fn1;
this.meta35692 = meta35692;
this.cljs$lang$protocol_mask$partition0$ = 393216;
this.cljs$lang$protocol_mask$partition1$ = 0;
});
(cljs.core.async.t_cljs$core$async35691.prototype.cljs$core$IWithMeta$_with_meta$arity$2 = (function (_35693,meta35692__$1){
var self__ = this;
var _35693__$1 = this;
return (new cljs.core.async.t_cljs$core$async35691(self__.f,self__.ch,self__.meta35688,self__._,self__.fn1,meta35692__$1));
}));

(cljs.core.async.t_cljs$core$async35691.prototype.cljs$core$IMeta$_meta$arity$1 = (function (_35693){
var self__ = this;
var _35693__$1 = this;
return self__.meta35692;
}));

(cljs.core.async.t_cljs$core$async35691.prototype.cljs$core$async$impl$protocols$Handler$ = cljs.core.PROTOCOL_SENTINEL);

(cljs.core.async.t_cljs$core$async35691.prototype.cljs$core$async$impl$protocols$Handler$active_QMARK_$arity$1 = (function (___$1){
var self__ = this;
var ___$2 = this;
return cljs.core.async.impl.protocols.active_QMARK_(self__.fn1);
}));

(cljs.core.async.t_cljs$core$async35691.prototype.cljs$core$async$impl$protocols$Handler$blockable_QMARK_$arity$1 = (function (___$1){
var self__ = this;
var ___$2 = this;
return true;
}));

(cljs.core.async.t_cljs$core$async35691.prototype.cljs$core$async$impl$protocols$Handler$commit$arity$1 = (function (___$1){
var self__ = this;
var ___$2 = this;
var f1 = cljs.core.async.impl.protocols.commit(self__.fn1);
return (function (p1__35686_SHARP_){
var G__35694 = (((p1__35686_SHARP_ == null))?null:(self__.f.cljs$core$IFn$_invoke$arity$1 ? self__.f.cljs$core$IFn$_invoke$arity$1(p1__35686_SHARP_) : self__.f.call(null,p1__35686_SHARP_)));
return (f1.cljs$core$IFn$_invoke$arity$1 ? f1.cljs$core$IFn$_invoke$arity$1(G__35694) : f1.call(null,G__35694));
});
}));

(cljs.core.async.t_cljs$core$async35691.getBasis = (function (){
return new cljs.core.PersistentVector(null, 6, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Symbol(null,"f","f",43394975,null),new cljs.core.Symbol(null,"ch","ch",1085813622,null),new cljs.core.Symbol(null,"meta35688","meta35688",-1375982909,null),cljs.core.with_meta(new cljs.core.Symbol(null,"_","_",-1201019570,null),new cljs.core.PersistentArrayMap(null, 1, [new cljs.core.Keyword(null,"tag","tag",-1290361223),new cljs.core.Symbol("cljs.core.async","t_cljs$core$async35687","cljs.core.async/t_cljs$core$async35687",-729834282,null)], null)),new cljs.core.Symbol(null,"fn1","fn1",895834444,null),new cljs.core.Symbol(null,"meta35692","meta35692",-15714286,null)], null);
}));

(cljs.core.async.t_cljs$core$async35691.cljs$lang$type = true);

(cljs.core.async.t_cljs$core$async35691.cljs$lang$ctorStr = "cljs.core.async/t_cljs$core$async35691");

(cljs.core.async.t_cljs$core$async35691.cljs$lang$ctorPrWriter = (function (this__5330__auto__,writer__5331__auto__,opt__5332__auto__){
return cljs.core._write(writer__5331__auto__,"cljs.core.async/t_cljs$core$async35691");
}));

/**
 * Positional factory function for cljs.core.async/t_cljs$core$async35691.
 */
cljs.core.async.__GT_t_cljs$core$async35691 = (function cljs$core$async$__GT_t_cljs$core$async35691(f,ch,meta35688,_,fn1,meta35692){
return (new cljs.core.async.t_cljs$core$async35691(f,ch,meta35688,_,fn1,meta35692));
});



/**
* @constructor
 * @implements {cljs.core.async.impl.protocols.Channel}
 * @implements {cljs.core.async.impl.protocols.WritePort}
 * @implements {cljs.core.async.impl.protocols.ReadPort}
 * @implements {cljs.core.IMeta}
 * @implements {cljs.core.IWithMeta}
*/
cljs.core.async.t_cljs$core$async35687 = (function (f,ch,meta35688){
this.f = f;
this.ch = ch;
this.meta35688 = meta35688;
this.cljs$lang$protocol_mask$partition0$ = 393216;
this.cljs$lang$protocol_mask$partition1$ = 0;
});
(cljs.core.async.t_cljs$core$async35687.prototype.cljs$core$IWithMeta$_with_meta$arity$2 = (function (_35689,meta35688__$1){
var self__ = this;
var _35689__$1 = this;
return (new cljs.core.async.t_cljs$core$async35687(self__.f,self__.ch,meta35688__$1));
}));

(cljs.core.async.t_cljs$core$async35687.prototype.cljs$core$IMeta$_meta$arity$1 = (function (_35689){
var self__ = this;
var _35689__$1 = this;
return self__.meta35688;
}));

(cljs.core.async.t_cljs$core$async35687.prototype.cljs$core$async$impl$protocols$Channel$ = cljs.core.PROTOCOL_SENTINEL);

(cljs.core.async.t_cljs$core$async35687.prototype.cljs$core$async$impl$protocols$Channel$close_BANG_$arity$1 = (function (_){
var self__ = this;
var ___$1 = this;
return cljs.core.async.impl.protocols.close_BANG_(self__.ch);
}));

(cljs.core.async.t_cljs$core$async35687.prototype.cljs$core$async$impl$protocols$Channel$closed_QMARK_$arity$1 = (function (_){
var self__ = this;
var ___$1 = this;
return cljs.core.async.impl.protocols.closed_QMARK_(self__.ch);
}));

(cljs.core.async.t_cljs$core$async35687.prototype.cljs$core$async$impl$protocols$ReadPort$ = cljs.core.PROTOCOL_SENTINEL);

(cljs.core.async.t_cljs$core$async35687.prototype.cljs$core$async$impl$protocols$ReadPort$take_BANG_$arity$2 = (function (_,fn1){
var self__ = this;
var ___$1 = this;
var ret = cljs.core.async.impl.protocols.take_BANG_(self__.ch,(new cljs.core.async.t_cljs$core$async35691(self__.f,self__.ch,self__.meta35688,___$1,fn1,cljs.core.PersistentArrayMap.EMPTY)));
if(cljs.core.truth_((function (){var and__5043__auto__ = ret;
if(cljs.core.truth_(and__5043__auto__)){
return (!((cljs.core.deref(ret) == null)));
} else {
return and__5043__auto__;
}
})())){
return cljs.core.async.impl.channels.box((function (){var G__35696 = cljs.core.deref(ret);
return (self__.f.cljs$core$IFn$_invoke$arity$1 ? self__.f.cljs$core$IFn$_invoke$arity$1(G__35696) : self__.f.call(null,G__35696));
})());
} else {
return ret;
}
}));

(cljs.core.async.t_cljs$core$async35687.prototype.cljs$core$async$impl$protocols$WritePort$ = cljs.core.PROTOCOL_SENTINEL);

(cljs.core.async.t_cljs$core$async35687.prototype.cljs$core$async$impl$protocols$WritePort$put_BANG_$arity$3 = (function (_,val,fn1){
var self__ = this;
var ___$1 = this;
return cljs.core.async.impl.protocols.put_BANG_(self__.ch,val,fn1);
}));

(cljs.core.async.t_cljs$core$async35687.getBasis = (function (){
return new cljs.core.PersistentVector(null, 3, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Symbol(null,"f","f",43394975,null),new cljs.core.Symbol(null,"ch","ch",1085813622,null),new cljs.core.Symbol(null,"meta35688","meta35688",-1375982909,null)], null);
}));

(cljs.core.async.t_cljs$core$async35687.cljs$lang$type = true);

(cljs.core.async.t_cljs$core$async35687.cljs$lang$ctorStr = "cljs.core.async/t_cljs$core$async35687");

(cljs.core.async.t_cljs$core$async35687.cljs$lang$ctorPrWriter = (function (this__5330__auto__,writer__5331__auto__,opt__5332__auto__){
return cljs.core._write(writer__5331__auto__,"cljs.core.async/t_cljs$core$async35687");
}));

/**
 * Positional factory function for cljs.core.async/t_cljs$core$async35687.
 */
cljs.core.async.__GT_t_cljs$core$async35687 = (function cljs$core$async$__GT_t_cljs$core$async35687(f,ch,meta35688){
return (new cljs.core.async.t_cljs$core$async35687(f,ch,meta35688));
});


/**
 * Deprecated - this function will be removed. Use transducer instead
 */
cljs.core.async.map_LT_ = (function cljs$core$async$map_LT_(f,ch){
return (new cljs.core.async.t_cljs$core$async35687(f,ch,cljs.core.PersistentArrayMap.EMPTY));
});

/**
* @constructor
 * @implements {cljs.core.async.impl.protocols.Channel}
 * @implements {cljs.core.async.impl.protocols.WritePort}
 * @implements {cljs.core.async.impl.protocols.ReadPort}
 * @implements {cljs.core.IMeta}
 * @implements {cljs.core.IWithMeta}
*/
cljs.core.async.t_cljs$core$async35698 = (function (f,ch,meta35699){
this.f = f;
this.ch = ch;
this.meta35699 = meta35699;
this.cljs$lang$protocol_mask$partition0$ = 393216;
this.cljs$lang$protocol_mask$partition1$ = 0;
});
(cljs.core.async.t_cljs$core$async35698.prototype.cljs$core$IWithMeta$_with_meta$arity$2 = (function (_35700,meta35699__$1){
var self__ = this;
var _35700__$1 = this;
return (new cljs.core.async.t_cljs$core$async35698(self__.f,self__.ch,meta35699__$1));
}));

(cljs.core.async.t_cljs$core$async35698.prototype.cljs$core$IMeta$_meta$arity$1 = (function (_35700){
var self__ = this;
var _35700__$1 = this;
return self__.meta35699;
}));

(cljs.core.async.t_cljs$core$async35698.prototype.cljs$core$async$impl$protocols$Channel$ = cljs.core.PROTOCOL_SENTINEL);

(cljs.core.async.t_cljs$core$async35698.prototype.cljs$core$async$impl$protocols$Channel$close_BANG_$arity$1 = (function (_){
var self__ = this;
var ___$1 = this;
return cljs.core.async.impl.protocols.close_BANG_(self__.ch);
}));

(cljs.core.async.t_cljs$core$async35698.prototype.cljs$core$async$impl$protocols$ReadPort$ = cljs.core.PROTOCOL_SENTINEL);

(cljs.core.async.t_cljs$core$async35698.prototype.cljs$core$async$impl$protocols$ReadPort$take_BANG_$arity$2 = (function (_,fn1){
var self__ = this;
var ___$1 = this;
return cljs.core.async.impl.protocols.take_BANG_(self__.ch,fn1);
}));

(cljs.core.async.t_cljs$core$async35698.prototype.cljs$core$async$impl$protocols$WritePort$ = cljs.core.PROTOCOL_SENTINEL);

(cljs.core.async.t_cljs$core$async35698.prototype.cljs$core$async$impl$protocols$WritePort$put_BANG_$arity$3 = (function (_,val,fn1){
var self__ = this;
var ___$1 = this;
return cljs.core.async.impl.protocols.put_BANG_(self__.ch,(self__.f.cljs$core$IFn$_invoke$arity$1 ? self__.f.cljs$core$IFn$_invoke$arity$1(val) : self__.f.call(null,val)),fn1);
}));

(cljs.core.async.t_cljs$core$async35698.getBasis = (function (){
return new cljs.core.PersistentVector(null, 3, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Symbol(null,"f","f",43394975,null),new cljs.core.Symbol(null,"ch","ch",1085813622,null),new cljs.core.Symbol(null,"meta35699","meta35699",479794314,null)], null);
}));

(cljs.core.async.t_cljs$core$async35698.cljs$lang$type = true);

(cljs.core.async.t_cljs$core$async35698.cljs$lang$ctorStr = "cljs.core.async/t_cljs$core$async35698");

(cljs.core.async.t_cljs$core$async35698.cljs$lang$ctorPrWriter = (function (this__5330__auto__,writer__5331__auto__,opt__5332__auto__){
return cljs.core._write(writer__5331__auto__,"cljs.core.async/t_cljs$core$async35698");
}));

/**
 * Positional factory function for cljs.core.async/t_cljs$core$async35698.
 */
cljs.core.async.__GT_t_cljs$core$async35698 = (function cljs$core$async$__GT_t_cljs$core$async35698(f,ch,meta35699){
return (new cljs.core.async.t_cljs$core$async35698(f,ch,meta35699));
});


/**
 * Deprecated - this function will be removed. Use transducer instead
 */
cljs.core.async.map_GT_ = (function cljs$core$async$map_GT_(f,ch){
return (new cljs.core.async.t_cljs$core$async35698(f,ch,cljs.core.PersistentArrayMap.EMPTY));
});

/**
* @constructor
 * @implements {cljs.core.async.impl.protocols.Channel}
 * @implements {cljs.core.async.impl.protocols.WritePort}
 * @implements {cljs.core.async.impl.protocols.ReadPort}
 * @implements {cljs.core.IMeta}
 * @implements {cljs.core.IWithMeta}
*/
cljs.core.async.t_cljs$core$async35701 = (function (p,ch,meta35702){
this.p = p;
this.ch = ch;
this.meta35702 = meta35702;
this.cljs$lang$protocol_mask$partition0$ = 393216;
this.cljs$lang$protocol_mask$partition1$ = 0;
});
(cljs.core.async.t_cljs$core$async35701.prototype.cljs$core$IWithMeta$_with_meta$arity$2 = (function (_35703,meta35702__$1){
var self__ = this;
var _35703__$1 = this;
return (new cljs.core.async.t_cljs$core$async35701(self__.p,self__.ch,meta35702__$1));
}));

(cljs.core.async.t_cljs$core$async35701.prototype.cljs$core$IMeta$_meta$arity$1 = (function (_35703){
var self__ = this;
var _35703__$1 = this;
return self__.meta35702;
}));

(cljs.core.async.t_cljs$core$async35701.prototype.cljs$core$async$impl$protocols$Channel$ = cljs.core.PROTOCOL_SENTINEL);

(cljs.core.async.t_cljs$core$async35701.prototype.cljs$core$async$impl$protocols$Channel$close_BANG_$arity$1 = (function (_){
var self__ = this;
var ___$1 = this;
return cljs.core.async.impl.protocols.close_BANG_(self__.ch);
}));

(cljs.core.async.t_cljs$core$async35701.prototype.cljs$core$async$impl$protocols$Channel$closed_QMARK_$arity$1 = (function (_){
var self__ = this;
var ___$1 = this;
return cljs.core.async.impl.protocols.closed_QMARK_(self__.ch);
}));

(cljs.core.async.t_cljs$core$async35701.prototype.cljs$core$async$impl$protocols$ReadPort$ = cljs.core.PROTOCOL_SENTINEL);

(cljs.core.async.t_cljs$core$async35701.prototype.cljs$core$async$impl$protocols$ReadPort$take_BANG_$arity$2 = (function (_,fn1){
var self__ = this;
var ___$1 = this;
return cljs.core.async.impl.protocols.take_BANG_(self__.ch,fn1);
}));

(cljs.core.async.t_cljs$core$async35701.prototype.cljs$core$async$impl$protocols$WritePort$ = cljs.core.PROTOCOL_SENTINEL);

(cljs.core.async.t_cljs$core$async35701.prototype.cljs$core$async$impl$protocols$WritePort$put_BANG_$arity$3 = (function (_,val,fn1){
var self__ = this;
var ___$1 = this;
if(cljs.core.truth_((self__.p.cljs$core$IFn$_invoke$arity$1 ? self__.p.cljs$core$IFn$_invoke$arity$1(val) : self__.p.call(null,val)))){
return cljs.core.async.impl.protocols.put_BANG_(self__.ch,val,fn1);
} else {
return cljs.core.async.impl.channels.box(cljs.core.not(cljs.core.async.impl.protocols.closed_QMARK_(self__.ch)));
}
}));

(cljs.core.async.t_cljs$core$async35701.getBasis = (function (){
return new cljs.core.PersistentVector(null, 3, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Symbol(null,"p","p",1791580836,null),new cljs.core.Symbol(null,"ch","ch",1085813622,null),new cljs.core.Symbol(null,"meta35702","meta35702",-474809766,null)], null);
}));

(cljs.core.async.t_cljs$core$async35701.cljs$lang$type = true);

(cljs.core.async.t_cljs$core$async35701.cljs$lang$ctorStr = "cljs.core.async/t_cljs$core$async35701");

(cljs.core.async.t_cljs$core$async35701.cljs$lang$ctorPrWriter = (function (this__5330__auto__,writer__5331__auto__,opt__5332__auto__){
return cljs.core._write(writer__5331__auto__,"cljs.core.async/t_cljs$core$async35701");
}));

/**
 * Positional factory function for cljs.core.async/t_cljs$core$async35701.
 */
cljs.core.async.__GT_t_cljs$core$async35701 = (function cljs$core$async$__GT_t_cljs$core$async35701(p,ch,meta35702){
return (new cljs.core.async.t_cljs$core$async35701(p,ch,meta35702));
});


/**
 * Deprecated - this function will be removed. Use transducer instead
 */
cljs.core.async.filter_GT_ = (function cljs$core$async$filter_GT_(p,ch){
return (new cljs.core.async.t_cljs$core$async35701(p,ch,cljs.core.PersistentArrayMap.EMPTY));
});
/**
 * Deprecated - this function will be removed. Use transducer instead
 */
cljs.core.async.remove_GT_ = (function cljs$core$async$remove_GT_(p,ch){
return cljs.core.async.filter_GT_(cljs.core.complement(p),ch);
});
/**
 * Deprecated - this function will be removed. Use transducer instead
 */
cljs.core.async.filter_LT_ = (function cljs$core$async$filter_LT_(var_args){
var G__35722 = arguments.length;
switch (G__35722) {
case 2:
return cljs.core.async.filter_LT_.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
case 3:
return cljs.core.async.filter_LT_.cljs$core$IFn$_invoke$arity$3((arguments[(0)]),(arguments[(1)]),(arguments[(2)]));

break;
default:
throw (new Error(["Invalid arity: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(arguments.length)].join('')));

}
});

(cljs.core.async.filter_LT_.cljs$core$IFn$_invoke$arity$2 = (function (p,ch){
return cljs.core.async.filter_LT_.cljs$core$IFn$_invoke$arity$3(p,ch,null);
}));

(cljs.core.async.filter_LT_.cljs$core$IFn$_invoke$arity$3 = (function (p,ch,buf_or_n){
var out = cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1(buf_or_n);
var c__33371__auto___37209 = cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1((1));
cljs.core.async.impl.dispatch.run((function (){
var f__33372__auto__ = (function (){var switch__33218__auto__ = (function (state_35746){
var state_val_35747 = (state_35746[(1)]);
if((state_val_35747 === (7))){
var inst_35742 = (state_35746[(2)]);
var state_35746__$1 = state_35746;
var statearr_35754_37211 = state_35746__$1;
(statearr_35754_37211[(2)] = inst_35742);

(statearr_35754_37211[(1)] = (3));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_35747 === (1))){
var state_35746__$1 = state_35746;
var statearr_35755_37212 = state_35746__$1;
(statearr_35755_37212[(2)] = null);

(statearr_35755_37212[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_35747 === (4))){
var inst_35728 = (state_35746[(7)]);
var inst_35728__$1 = (state_35746[(2)]);
var inst_35729 = (inst_35728__$1 == null);
var state_35746__$1 = (function (){var statearr_35756 = state_35746;
(statearr_35756[(7)] = inst_35728__$1);

return statearr_35756;
})();
if(cljs.core.truth_(inst_35729)){
var statearr_35759_37213 = state_35746__$1;
(statearr_35759_37213[(1)] = (5));

} else {
var statearr_35762_37214 = state_35746__$1;
(statearr_35762_37214[(1)] = (6));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_35747 === (6))){
var inst_35728 = (state_35746[(7)]);
var inst_35733 = (p.cljs$core$IFn$_invoke$arity$1 ? p.cljs$core$IFn$_invoke$arity$1(inst_35728) : p.call(null,inst_35728));
var state_35746__$1 = state_35746;
if(cljs.core.truth_(inst_35733)){
var statearr_35767_37215 = state_35746__$1;
(statearr_35767_37215[(1)] = (8));

} else {
var statearr_35768_37216 = state_35746__$1;
(statearr_35768_37216[(1)] = (9));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_35747 === (3))){
var inst_35744 = (state_35746[(2)]);
var state_35746__$1 = state_35746;
return cljs.core.async.impl.ioc_helpers.return_chan(state_35746__$1,inst_35744);
} else {
if((state_val_35747 === (2))){
var state_35746__$1 = state_35746;
return cljs.core.async.impl.ioc_helpers.take_BANG_(state_35746__$1,(4),ch);
} else {
if((state_val_35747 === (11))){
var inst_35736 = (state_35746[(2)]);
var state_35746__$1 = state_35746;
var statearr_35769_37217 = state_35746__$1;
(statearr_35769_37217[(2)] = inst_35736);

(statearr_35769_37217[(1)] = (10));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_35747 === (9))){
var state_35746__$1 = state_35746;
var statearr_35771_37218 = state_35746__$1;
(statearr_35771_37218[(2)] = null);

(statearr_35771_37218[(1)] = (10));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_35747 === (5))){
var inst_35731 = cljs.core.async.close_BANG_(out);
var state_35746__$1 = state_35746;
var statearr_35774_37222 = state_35746__$1;
(statearr_35774_37222[(2)] = inst_35731);

(statearr_35774_37222[(1)] = (7));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_35747 === (10))){
var inst_35739 = (state_35746[(2)]);
var state_35746__$1 = (function (){var statearr_35781 = state_35746;
(statearr_35781[(8)] = inst_35739);

return statearr_35781;
})();
var statearr_35785_37223 = state_35746__$1;
(statearr_35785_37223[(2)] = null);

(statearr_35785_37223[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_35747 === (8))){
var inst_35728 = (state_35746[(7)]);
var state_35746__$1 = state_35746;
return cljs.core.async.impl.ioc_helpers.put_BANG_(state_35746__$1,(11),out,inst_35728);
} else {
return null;
}
}
}
}
}
}
}
}
}
}
}
});
return (function() {
var cljs$core$async$state_machine__33219__auto__ = null;
var cljs$core$async$state_machine__33219__auto____0 = (function (){
var statearr_35789 = [null,null,null,null,null,null,null,null,null];
(statearr_35789[(0)] = cljs$core$async$state_machine__33219__auto__);

(statearr_35789[(1)] = (1));

return statearr_35789;
});
var cljs$core$async$state_machine__33219__auto____1 = (function (state_35746){
while(true){
var ret_value__33220__auto__ = (function (){try{while(true){
var result__33221__auto__ = switch__33218__auto__(state_35746);
if(cljs.core.keyword_identical_QMARK_(result__33221__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
continue;
} else {
return result__33221__auto__;
}
break;
}
}catch (e35790){var ex__33222__auto__ = e35790;
var statearr_35791_37224 = state_35746;
(statearr_35791_37224[(2)] = ex__33222__auto__);


if(cljs.core.seq((state_35746[(4)]))){
var statearr_35793_37225 = state_35746;
(statearr_35793_37225[(1)] = cljs.core.first((state_35746[(4)])));

} else {
throw ex__33222__auto__;
}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
}})();
if(cljs.core.keyword_identical_QMARK_(ret_value__33220__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
var G__37226 = state_35746;
state_35746 = G__37226;
continue;
} else {
return ret_value__33220__auto__;
}
break;
}
});
cljs$core$async$state_machine__33219__auto__ = function(state_35746){
switch(arguments.length){
case 0:
return cljs$core$async$state_machine__33219__auto____0.call(this);
case 1:
return cljs$core$async$state_machine__33219__auto____1.call(this,state_35746);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
cljs$core$async$state_machine__33219__auto__.cljs$core$IFn$_invoke$arity$0 = cljs$core$async$state_machine__33219__auto____0;
cljs$core$async$state_machine__33219__auto__.cljs$core$IFn$_invoke$arity$1 = cljs$core$async$state_machine__33219__auto____1;
return cljs$core$async$state_machine__33219__auto__;
})()
})();
var state__33373__auto__ = (function (){var statearr_35800 = f__33372__auto__();
(statearr_35800[(6)] = c__33371__auto___37209);

return statearr_35800;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped(state__33373__auto__);
}));


return out;
}));

(cljs.core.async.filter_LT_.cljs$lang$maxFixedArity = 3);

/**
 * Deprecated - this function will be removed. Use transducer instead
 */
cljs.core.async.remove_LT_ = (function cljs$core$async$remove_LT_(var_args){
var G__35807 = arguments.length;
switch (G__35807) {
case 2:
return cljs.core.async.remove_LT_.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
case 3:
return cljs.core.async.remove_LT_.cljs$core$IFn$_invoke$arity$3((arguments[(0)]),(arguments[(1)]),(arguments[(2)]));

break;
default:
throw (new Error(["Invalid arity: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(arguments.length)].join('')));

}
});

(cljs.core.async.remove_LT_.cljs$core$IFn$_invoke$arity$2 = (function (p,ch){
return cljs.core.async.remove_LT_.cljs$core$IFn$_invoke$arity$3(p,ch,null);
}));

(cljs.core.async.remove_LT_.cljs$core$IFn$_invoke$arity$3 = (function (p,ch,buf_or_n){
return cljs.core.async.filter_LT_.cljs$core$IFn$_invoke$arity$3(cljs.core.complement(p),ch,buf_or_n);
}));

(cljs.core.async.remove_LT_.cljs$lang$maxFixedArity = 3);

cljs.core.async.mapcat_STAR_ = (function cljs$core$async$mapcat_STAR_(f,in$,out){
var c__33371__auto__ = cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1((1));
cljs.core.async.impl.dispatch.run((function (){
var f__33372__auto__ = (function (){var switch__33218__auto__ = (function (state_35878){
var state_val_35879 = (state_35878[(1)]);
if((state_val_35879 === (7))){
var inst_35873 = (state_35878[(2)]);
var state_35878__$1 = state_35878;
var statearr_35882_37228 = state_35878__$1;
(statearr_35882_37228[(2)] = inst_35873);

(statearr_35882_37228[(1)] = (3));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_35879 === (20))){
var inst_35842 = (state_35878[(7)]);
var inst_35853 = (state_35878[(2)]);
var inst_35855 = cljs.core.next(inst_35842);
var inst_35828 = inst_35855;
var inst_35829 = null;
var inst_35830 = (0);
var inst_35831 = (0);
var state_35878__$1 = (function (){var statearr_35883 = state_35878;
(statearr_35883[(8)] = inst_35829);

(statearr_35883[(9)] = inst_35831);

(statearr_35883[(10)] = inst_35828);

(statearr_35883[(11)] = inst_35830);

(statearr_35883[(12)] = inst_35853);

return statearr_35883;
})();
var statearr_35884_37229 = state_35878__$1;
(statearr_35884_37229[(2)] = null);

(statearr_35884_37229[(1)] = (8));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_35879 === (1))){
var state_35878__$1 = state_35878;
var statearr_35885_37230 = state_35878__$1;
(statearr_35885_37230[(2)] = null);

(statearr_35885_37230[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_35879 === (4))){
var inst_35817 = (state_35878[(13)]);
var inst_35817__$1 = (state_35878[(2)]);
var inst_35818 = (inst_35817__$1 == null);
var state_35878__$1 = (function (){var statearr_35886 = state_35878;
(statearr_35886[(13)] = inst_35817__$1);

return statearr_35886;
})();
if(cljs.core.truth_(inst_35818)){
var statearr_35887_37231 = state_35878__$1;
(statearr_35887_37231[(1)] = (5));

} else {
var statearr_35888_37232 = state_35878__$1;
(statearr_35888_37232[(1)] = (6));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_35879 === (15))){
var state_35878__$1 = state_35878;
var statearr_35892_37233 = state_35878__$1;
(statearr_35892_37233[(2)] = null);

(statearr_35892_37233[(1)] = (16));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_35879 === (21))){
var state_35878__$1 = state_35878;
var statearr_35895_37234 = state_35878__$1;
(statearr_35895_37234[(2)] = null);

(statearr_35895_37234[(1)] = (23));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_35879 === (13))){
var inst_35829 = (state_35878[(8)]);
var inst_35831 = (state_35878[(9)]);
var inst_35828 = (state_35878[(10)]);
var inst_35830 = (state_35878[(11)]);
var inst_35838 = (state_35878[(2)]);
var inst_35839 = (inst_35831 + (1));
var tmp35889 = inst_35829;
var tmp35890 = inst_35828;
var tmp35891 = inst_35830;
var inst_35828__$1 = tmp35890;
var inst_35829__$1 = tmp35889;
var inst_35830__$1 = tmp35891;
var inst_35831__$1 = inst_35839;
var state_35878__$1 = (function (){var statearr_35899 = state_35878;
(statearr_35899[(14)] = inst_35838);

(statearr_35899[(8)] = inst_35829__$1);

(statearr_35899[(9)] = inst_35831__$1);

(statearr_35899[(10)] = inst_35828__$1);

(statearr_35899[(11)] = inst_35830__$1);

return statearr_35899;
})();
var statearr_35901_37236 = state_35878__$1;
(statearr_35901_37236[(2)] = null);

(statearr_35901_37236[(1)] = (8));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_35879 === (22))){
var state_35878__$1 = state_35878;
var statearr_35902_37237 = state_35878__$1;
(statearr_35902_37237[(2)] = null);

(statearr_35902_37237[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_35879 === (6))){
var inst_35817 = (state_35878[(13)]);
var inst_35826 = (f.cljs$core$IFn$_invoke$arity$1 ? f.cljs$core$IFn$_invoke$arity$1(inst_35817) : f.call(null,inst_35817));
var inst_35827 = cljs.core.seq(inst_35826);
var inst_35828 = inst_35827;
var inst_35829 = null;
var inst_35830 = (0);
var inst_35831 = (0);
var state_35878__$1 = (function (){var statearr_35904 = state_35878;
(statearr_35904[(8)] = inst_35829);

(statearr_35904[(9)] = inst_35831);

(statearr_35904[(10)] = inst_35828);

(statearr_35904[(11)] = inst_35830);

return statearr_35904;
})();
var statearr_35905_37238 = state_35878__$1;
(statearr_35905_37238[(2)] = null);

(statearr_35905_37238[(1)] = (8));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_35879 === (17))){
var inst_35842 = (state_35878[(7)]);
var inst_35846 = cljs.core.chunk_first(inst_35842);
var inst_35847 = cljs.core.chunk_rest(inst_35842);
var inst_35848 = cljs.core.count(inst_35846);
var inst_35828 = inst_35847;
var inst_35829 = inst_35846;
var inst_35830 = inst_35848;
var inst_35831 = (0);
var state_35878__$1 = (function (){var statearr_35911 = state_35878;
(statearr_35911[(8)] = inst_35829);

(statearr_35911[(9)] = inst_35831);

(statearr_35911[(10)] = inst_35828);

(statearr_35911[(11)] = inst_35830);

return statearr_35911;
})();
var statearr_35912_37241 = state_35878__$1;
(statearr_35912_37241[(2)] = null);

(statearr_35912_37241[(1)] = (8));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_35879 === (3))){
var inst_35875 = (state_35878[(2)]);
var state_35878__$1 = state_35878;
return cljs.core.async.impl.ioc_helpers.return_chan(state_35878__$1,inst_35875);
} else {
if((state_val_35879 === (12))){
var inst_35863 = (state_35878[(2)]);
var state_35878__$1 = state_35878;
var statearr_35913_37242 = state_35878__$1;
(statearr_35913_37242[(2)] = inst_35863);

(statearr_35913_37242[(1)] = (9));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_35879 === (2))){
var state_35878__$1 = state_35878;
return cljs.core.async.impl.ioc_helpers.take_BANG_(state_35878__$1,(4),in$);
} else {
if((state_val_35879 === (23))){
var inst_35871 = (state_35878[(2)]);
var state_35878__$1 = state_35878;
var statearr_35926_37246 = state_35878__$1;
(statearr_35926_37246[(2)] = inst_35871);

(statearr_35926_37246[(1)] = (7));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_35879 === (19))){
var inst_35858 = (state_35878[(2)]);
var state_35878__$1 = state_35878;
var statearr_35927_37247 = state_35878__$1;
(statearr_35927_37247[(2)] = inst_35858);

(statearr_35927_37247[(1)] = (16));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_35879 === (11))){
var inst_35828 = (state_35878[(10)]);
var inst_35842 = (state_35878[(7)]);
var inst_35842__$1 = cljs.core.seq(inst_35828);
var state_35878__$1 = (function (){var statearr_35928 = state_35878;
(statearr_35928[(7)] = inst_35842__$1);

return statearr_35928;
})();
if(inst_35842__$1){
var statearr_35929_37248 = state_35878__$1;
(statearr_35929_37248[(1)] = (14));

} else {
var statearr_35930_37249 = state_35878__$1;
(statearr_35930_37249[(1)] = (15));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_35879 === (9))){
var inst_35865 = (state_35878[(2)]);
var inst_35866 = cljs.core.async.impl.protocols.closed_QMARK_(out);
var state_35878__$1 = (function (){var statearr_35931 = state_35878;
(statearr_35931[(15)] = inst_35865);

return statearr_35931;
})();
if(cljs.core.truth_(inst_35866)){
var statearr_35932_37250 = state_35878__$1;
(statearr_35932_37250[(1)] = (21));

} else {
var statearr_35933_37251 = state_35878__$1;
(statearr_35933_37251[(1)] = (22));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_35879 === (5))){
var inst_35820 = cljs.core.async.close_BANG_(out);
var state_35878__$1 = state_35878;
var statearr_35936_37252 = state_35878__$1;
(statearr_35936_37252[(2)] = inst_35820);

(statearr_35936_37252[(1)] = (7));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_35879 === (14))){
var inst_35842 = (state_35878[(7)]);
var inst_35844 = cljs.core.chunked_seq_QMARK_(inst_35842);
var state_35878__$1 = state_35878;
if(inst_35844){
var statearr_35937_37253 = state_35878__$1;
(statearr_35937_37253[(1)] = (17));

} else {
var statearr_35938_37254 = state_35878__$1;
(statearr_35938_37254[(1)] = (18));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_35879 === (16))){
var inst_35861 = (state_35878[(2)]);
var state_35878__$1 = state_35878;
var statearr_35939_37255 = state_35878__$1;
(statearr_35939_37255[(2)] = inst_35861);

(statearr_35939_37255[(1)] = (12));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_35879 === (10))){
var inst_35829 = (state_35878[(8)]);
var inst_35831 = (state_35878[(9)]);
var inst_35836 = cljs.core._nth(inst_35829,inst_35831);
var state_35878__$1 = state_35878;
return cljs.core.async.impl.ioc_helpers.put_BANG_(state_35878__$1,(13),out,inst_35836);
} else {
if((state_val_35879 === (18))){
var inst_35842 = (state_35878[(7)]);
var inst_35851 = cljs.core.first(inst_35842);
var state_35878__$1 = state_35878;
return cljs.core.async.impl.ioc_helpers.put_BANG_(state_35878__$1,(20),out,inst_35851);
} else {
if((state_val_35879 === (8))){
var inst_35831 = (state_35878[(9)]);
var inst_35830 = (state_35878[(11)]);
var inst_35833 = (inst_35831 < inst_35830);
var inst_35834 = inst_35833;
var state_35878__$1 = state_35878;
if(cljs.core.truth_(inst_35834)){
var statearr_35946_37256 = state_35878__$1;
(statearr_35946_37256[(1)] = (10));

} else {
var statearr_35948_37257 = state_35878__$1;
(statearr_35948_37257[(1)] = (11));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
return null;
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
});
return (function() {
var cljs$core$async$mapcat_STAR__$_state_machine__33219__auto__ = null;
var cljs$core$async$mapcat_STAR__$_state_machine__33219__auto____0 = (function (){
var statearr_35956 = [null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null];
(statearr_35956[(0)] = cljs$core$async$mapcat_STAR__$_state_machine__33219__auto__);

(statearr_35956[(1)] = (1));

return statearr_35956;
});
var cljs$core$async$mapcat_STAR__$_state_machine__33219__auto____1 = (function (state_35878){
while(true){
var ret_value__33220__auto__ = (function (){try{while(true){
var result__33221__auto__ = switch__33218__auto__(state_35878);
if(cljs.core.keyword_identical_QMARK_(result__33221__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
continue;
} else {
return result__33221__auto__;
}
break;
}
}catch (e35957){var ex__33222__auto__ = e35957;
var statearr_35958_37258 = state_35878;
(statearr_35958_37258[(2)] = ex__33222__auto__);


if(cljs.core.seq((state_35878[(4)]))){
var statearr_35960_37259 = state_35878;
(statearr_35960_37259[(1)] = cljs.core.first((state_35878[(4)])));

} else {
throw ex__33222__auto__;
}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
}})();
if(cljs.core.keyword_identical_QMARK_(ret_value__33220__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
var G__37260 = state_35878;
state_35878 = G__37260;
continue;
} else {
return ret_value__33220__auto__;
}
break;
}
});
cljs$core$async$mapcat_STAR__$_state_machine__33219__auto__ = function(state_35878){
switch(arguments.length){
case 0:
return cljs$core$async$mapcat_STAR__$_state_machine__33219__auto____0.call(this);
case 1:
return cljs$core$async$mapcat_STAR__$_state_machine__33219__auto____1.call(this,state_35878);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
cljs$core$async$mapcat_STAR__$_state_machine__33219__auto__.cljs$core$IFn$_invoke$arity$0 = cljs$core$async$mapcat_STAR__$_state_machine__33219__auto____0;
cljs$core$async$mapcat_STAR__$_state_machine__33219__auto__.cljs$core$IFn$_invoke$arity$1 = cljs$core$async$mapcat_STAR__$_state_machine__33219__auto____1;
return cljs$core$async$mapcat_STAR__$_state_machine__33219__auto__;
})()
})();
var state__33373__auto__ = (function (){var statearr_35962 = f__33372__auto__();
(statearr_35962[(6)] = c__33371__auto__);

return statearr_35962;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped(state__33373__auto__);
}));

return c__33371__auto__;
});
/**
 * Deprecated - this function will be removed. Use transducer instead
 */
cljs.core.async.mapcat_LT_ = (function cljs$core$async$mapcat_LT_(var_args){
var G__35969 = arguments.length;
switch (G__35969) {
case 2:
return cljs.core.async.mapcat_LT_.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
case 3:
return cljs.core.async.mapcat_LT_.cljs$core$IFn$_invoke$arity$3((arguments[(0)]),(arguments[(1)]),(arguments[(2)]));

break;
default:
throw (new Error(["Invalid arity: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(arguments.length)].join('')));

}
});

(cljs.core.async.mapcat_LT_.cljs$core$IFn$_invoke$arity$2 = (function (f,in$){
return cljs.core.async.mapcat_LT_.cljs$core$IFn$_invoke$arity$3(f,in$,null);
}));

(cljs.core.async.mapcat_LT_.cljs$core$IFn$_invoke$arity$3 = (function (f,in$,buf_or_n){
var out = cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1(buf_or_n);
cljs.core.async.mapcat_STAR_(f,in$,out);

return out;
}));

(cljs.core.async.mapcat_LT_.cljs$lang$maxFixedArity = 3);

/**
 * Deprecated - this function will be removed. Use transducer instead
 */
cljs.core.async.mapcat_GT_ = (function cljs$core$async$mapcat_GT_(var_args){
var G__35983 = arguments.length;
switch (G__35983) {
case 2:
return cljs.core.async.mapcat_GT_.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
case 3:
return cljs.core.async.mapcat_GT_.cljs$core$IFn$_invoke$arity$3((arguments[(0)]),(arguments[(1)]),(arguments[(2)]));

break;
default:
throw (new Error(["Invalid arity: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(arguments.length)].join('')));

}
});

(cljs.core.async.mapcat_GT_.cljs$core$IFn$_invoke$arity$2 = (function (f,out){
return cljs.core.async.mapcat_GT_.cljs$core$IFn$_invoke$arity$3(f,out,null);
}));

(cljs.core.async.mapcat_GT_.cljs$core$IFn$_invoke$arity$3 = (function (f,out,buf_or_n){
var in$ = cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1(buf_or_n);
cljs.core.async.mapcat_STAR_(f,in$,out);

return in$;
}));

(cljs.core.async.mapcat_GT_.cljs$lang$maxFixedArity = 3);

/**
 * Deprecated - this function will be removed. Use transducer instead
 */
cljs.core.async.unique = (function cljs$core$async$unique(var_args){
var G__35988 = arguments.length;
switch (G__35988) {
case 1:
return cljs.core.async.unique.cljs$core$IFn$_invoke$arity$1((arguments[(0)]));

break;
case 2:
return cljs.core.async.unique.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
default:
throw (new Error(["Invalid arity: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(arguments.length)].join('')));

}
});

(cljs.core.async.unique.cljs$core$IFn$_invoke$arity$1 = (function (ch){
return cljs.core.async.unique.cljs$core$IFn$_invoke$arity$2(ch,null);
}));

(cljs.core.async.unique.cljs$core$IFn$_invoke$arity$2 = (function (ch,buf_or_n){
var out = cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1(buf_or_n);
var c__33371__auto___37264 = cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1((1));
cljs.core.async.impl.dispatch.run((function (){
var f__33372__auto__ = (function (){var switch__33218__auto__ = (function (state_36024){
var state_val_36025 = (state_36024[(1)]);
if((state_val_36025 === (7))){
var inst_36018 = (state_36024[(2)]);
var state_36024__$1 = state_36024;
var statearr_36027_37265 = state_36024__$1;
(statearr_36027_37265[(2)] = inst_36018);

(statearr_36027_37265[(1)] = (3));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_36025 === (1))){
var inst_35997 = null;
var state_36024__$1 = (function (){var statearr_36028 = state_36024;
(statearr_36028[(7)] = inst_35997);

return statearr_36028;
})();
var statearr_36029_37266 = state_36024__$1;
(statearr_36029_37266[(2)] = null);

(statearr_36029_37266[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_36025 === (4))){
var inst_36001 = (state_36024[(8)]);
var inst_36001__$1 = (state_36024[(2)]);
var inst_36002 = (inst_36001__$1 == null);
var inst_36003 = cljs.core.not(inst_36002);
var state_36024__$1 = (function (){var statearr_36033 = state_36024;
(statearr_36033[(8)] = inst_36001__$1);

return statearr_36033;
})();
if(inst_36003){
var statearr_36034_37271 = state_36024__$1;
(statearr_36034_37271[(1)] = (5));

} else {
var statearr_36035_37272 = state_36024__$1;
(statearr_36035_37272[(1)] = (6));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_36025 === (6))){
var state_36024__$1 = state_36024;
var statearr_36039_37273 = state_36024__$1;
(statearr_36039_37273[(2)] = null);

(statearr_36039_37273[(1)] = (7));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_36025 === (3))){
var inst_36020 = (state_36024[(2)]);
var inst_36021 = cljs.core.async.close_BANG_(out);
var state_36024__$1 = (function (){var statearr_36042 = state_36024;
(statearr_36042[(9)] = inst_36020);

return statearr_36042;
})();
return cljs.core.async.impl.ioc_helpers.return_chan(state_36024__$1,inst_36021);
} else {
if((state_val_36025 === (2))){
var state_36024__$1 = state_36024;
return cljs.core.async.impl.ioc_helpers.take_BANG_(state_36024__$1,(4),ch);
} else {
if((state_val_36025 === (11))){
var inst_36001 = (state_36024[(8)]);
var inst_36011 = (state_36024[(2)]);
var inst_35997 = inst_36001;
var state_36024__$1 = (function (){var statearr_36045 = state_36024;
(statearr_36045[(7)] = inst_35997);

(statearr_36045[(10)] = inst_36011);

return statearr_36045;
})();
var statearr_36046_37274 = state_36024__$1;
(statearr_36046_37274[(2)] = null);

(statearr_36046_37274[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_36025 === (9))){
var inst_36001 = (state_36024[(8)]);
var state_36024__$1 = state_36024;
return cljs.core.async.impl.ioc_helpers.put_BANG_(state_36024__$1,(11),out,inst_36001);
} else {
if((state_val_36025 === (5))){
var inst_36001 = (state_36024[(8)]);
var inst_35997 = (state_36024[(7)]);
var inst_36005 = cljs.core._EQ_.cljs$core$IFn$_invoke$arity$2(inst_36001,inst_35997);
var state_36024__$1 = state_36024;
if(inst_36005){
var statearr_36055_37275 = state_36024__$1;
(statearr_36055_37275[(1)] = (8));

} else {
var statearr_36056_37276 = state_36024__$1;
(statearr_36056_37276[(1)] = (9));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_36025 === (10))){
var inst_36015 = (state_36024[(2)]);
var state_36024__$1 = state_36024;
var statearr_36057_37277 = state_36024__$1;
(statearr_36057_37277[(2)] = inst_36015);

(statearr_36057_37277[(1)] = (7));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_36025 === (8))){
var inst_35997 = (state_36024[(7)]);
var tmp36054 = inst_35997;
var inst_35997__$1 = tmp36054;
var state_36024__$1 = (function (){var statearr_36058 = state_36024;
(statearr_36058[(7)] = inst_35997__$1);

return statearr_36058;
})();
var statearr_36059_37278 = state_36024__$1;
(statearr_36059_37278[(2)] = null);

(statearr_36059_37278[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
return null;
}
}
}
}
}
}
}
}
}
}
}
});
return (function() {
var cljs$core$async$state_machine__33219__auto__ = null;
var cljs$core$async$state_machine__33219__auto____0 = (function (){
var statearr_36061 = [null,null,null,null,null,null,null,null,null,null,null];
(statearr_36061[(0)] = cljs$core$async$state_machine__33219__auto__);

(statearr_36061[(1)] = (1));

return statearr_36061;
});
var cljs$core$async$state_machine__33219__auto____1 = (function (state_36024){
while(true){
var ret_value__33220__auto__ = (function (){try{while(true){
var result__33221__auto__ = switch__33218__auto__(state_36024);
if(cljs.core.keyword_identical_QMARK_(result__33221__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
continue;
} else {
return result__33221__auto__;
}
break;
}
}catch (e36062){var ex__33222__auto__ = e36062;
var statearr_36065_37279 = state_36024;
(statearr_36065_37279[(2)] = ex__33222__auto__);


if(cljs.core.seq((state_36024[(4)]))){
var statearr_36066_37280 = state_36024;
(statearr_36066_37280[(1)] = cljs.core.first((state_36024[(4)])));

} else {
throw ex__33222__auto__;
}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
}})();
if(cljs.core.keyword_identical_QMARK_(ret_value__33220__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
var G__37281 = state_36024;
state_36024 = G__37281;
continue;
} else {
return ret_value__33220__auto__;
}
break;
}
});
cljs$core$async$state_machine__33219__auto__ = function(state_36024){
switch(arguments.length){
case 0:
return cljs$core$async$state_machine__33219__auto____0.call(this);
case 1:
return cljs$core$async$state_machine__33219__auto____1.call(this,state_36024);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
cljs$core$async$state_machine__33219__auto__.cljs$core$IFn$_invoke$arity$0 = cljs$core$async$state_machine__33219__auto____0;
cljs$core$async$state_machine__33219__auto__.cljs$core$IFn$_invoke$arity$1 = cljs$core$async$state_machine__33219__auto____1;
return cljs$core$async$state_machine__33219__auto__;
})()
})();
var state__33373__auto__ = (function (){var statearr_36068 = f__33372__auto__();
(statearr_36068[(6)] = c__33371__auto___37264);

return statearr_36068;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped(state__33373__auto__);
}));


return out;
}));

(cljs.core.async.unique.cljs$lang$maxFixedArity = 2);

/**
 * Deprecated - this function will be removed. Use transducer instead
 */
cljs.core.async.partition = (function cljs$core$async$partition(var_args){
var G__36071 = arguments.length;
switch (G__36071) {
case 2:
return cljs.core.async.partition.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
case 3:
return cljs.core.async.partition.cljs$core$IFn$_invoke$arity$3((arguments[(0)]),(arguments[(1)]),(arguments[(2)]));

break;
default:
throw (new Error(["Invalid arity: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(arguments.length)].join('')));

}
});

(cljs.core.async.partition.cljs$core$IFn$_invoke$arity$2 = (function (n,ch){
return cljs.core.async.partition.cljs$core$IFn$_invoke$arity$3(n,ch,null);
}));

(cljs.core.async.partition.cljs$core$IFn$_invoke$arity$3 = (function (n,ch,buf_or_n){
var out = cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1(buf_or_n);
var c__33371__auto___37290 = cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1((1));
cljs.core.async.impl.dispatch.run((function (){
var f__33372__auto__ = (function (){var switch__33218__auto__ = (function (state_36116){
var state_val_36117 = (state_36116[(1)]);
if((state_val_36117 === (7))){
var inst_36112 = (state_36116[(2)]);
var state_36116__$1 = state_36116;
var statearr_36121_37291 = state_36116__$1;
(statearr_36121_37291[(2)] = inst_36112);

(statearr_36121_37291[(1)] = (3));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_36117 === (1))){
var inst_36076 = (new Array(n));
var inst_36077 = inst_36076;
var inst_36078 = (0);
var state_36116__$1 = (function (){var statearr_36122 = state_36116;
(statearr_36122[(7)] = inst_36078);

(statearr_36122[(8)] = inst_36077);

return statearr_36122;
})();
var statearr_36123_37292 = state_36116__$1;
(statearr_36123_37292[(2)] = null);

(statearr_36123_37292[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_36117 === (4))){
var inst_36081 = (state_36116[(9)]);
var inst_36081__$1 = (state_36116[(2)]);
var inst_36082 = (inst_36081__$1 == null);
var inst_36083 = cljs.core.not(inst_36082);
var state_36116__$1 = (function (){var statearr_36124 = state_36116;
(statearr_36124[(9)] = inst_36081__$1);

return statearr_36124;
})();
if(inst_36083){
var statearr_36125_37294 = state_36116__$1;
(statearr_36125_37294[(1)] = (5));

} else {
var statearr_36127_37296 = state_36116__$1;
(statearr_36127_37296[(1)] = (6));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_36117 === (15))){
var inst_36106 = (state_36116[(2)]);
var state_36116__$1 = state_36116;
var statearr_36132_37297 = state_36116__$1;
(statearr_36132_37297[(2)] = inst_36106);

(statearr_36132_37297[(1)] = (14));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_36117 === (13))){
var state_36116__$1 = state_36116;
var statearr_36133_37299 = state_36116__$1;
(statearr_36133_37299[(2)] = null);

(statearr_36133_37299[(1)] = (14));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_36117 === (6))){
var inst_36078 = (state_36116[(7)]);
var inst_36102 = (inst_36078 > (0));
var state_36116__$1 = state_36116;
if(cljs.core.truth_(inst_36102)){
var statearr_36134_37300 = state_36116__$1;
(statearr_36134_37300[(1)] = (12));

} else {
var statearr_36135_37301 = state_36116__$1;
(statearr_36135_37301[(1)] = (13));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_36117 === (3))){
var inst_36114 = (state_36116[(2)]);
var state_36116__$1 = state_36116;
return cljs.core.async.impl.ioc_helpers.return_chan(state_36116__$1,inst_36114);
} else {
if((state_val_36117 === (12))){
var inst_36077 = (state_36116[(8)]);
var inst_36104 = cljs.core.vec(inst_36077);
var state_36116__$1 = state_36116;
return cljs.core.async.impl.ioc_helpers.put_BANG_(state_36116__$1,(15),out,inst_36104);
} else {
if((state_val_36117 === (2))){
var state_36116__$1 = state_36116;
return cljs.core.async.impl.ioc_helpers.take_BANG_(state_36116__$1,(4),ch);
} else {
if((state_val_36117 === (11))){
var inst_36096 = (state_36116[(2)]);
var inst_36097 = (new Array(n));
var inst_36077 = inst_36097;
var inst_36078 = (0);
var state_36116__$1 = (function (){var statearr_36137 = state_36116;
(statearr_36137[(7)] = inst_36078);

(statearr_36137[(8)] = inst_36077);

(statearr_36137[(10)] = inst_36096);

return statearr_36137;
})();
var statearr_36138_37303 = state_36116__$1;
(statearr_36138_37303[(2)] = null);

(statearr_36138_37303[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_36117 === (9))){
var inst_36077 = (state_36116[(8)]);
var inst_36094 = cljs.core.vec(inst_36077);
var state_36116__$1 = state_36116;
return cljs.core.async.impl.ioc_helpers.put_BANG_(state_36116__$1,(11),out,inst_36094);
} else {
if((state_val_36117 === (5))){
var inst_36078 = (state_36116[(7)]);
var inst_36077 = (state_36116[(8)]);
var inst_36081 = (state_36116[(9)]);
var inst_36088 = (state_36116[(11)]);
var inst_36086 = (inst_36077[inst_36078] = inst_36081);
var inst_36088__$1 = (inst_36078 + (1));
var inst_36090 = (inst_36088__$1 < n);
var state_36116__$1 = (function (){var statearr_36139 = state_36116;
(statearr_36139[(12)] = inst_36086);

(statearr_36139[(11)] = inst_36088__$1);

return statearr_36139;
})();
if(cljs.core.truth_(inst_36090)){
var statearr_36140_37304 = state_36116__$1;
(statearr_36140_37304[(1)] = (8));

} else {
var statearr_36141_37305 = state_36116__$1;
(statearr_36141_37305[(1)] = (9));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_36117 === (14))){
var inst_36109 = (state_36116[(2)]);
var inst_36110 = cljs.core.async.close_BANG_(out);
var state_36116__$1 = (function (){var statearr_36144 = state_36116;
(statearr_36144[(13)] = inst_36109);

return statearr_36144;
})();
var statearr_36145_37306 = state_36116__$1;
(statearr_36145_37306[(2)] = inst_36110);

(statearr_36145_37306[(1)] = (7));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_36117 === (10))){
var inst_36100 = (state_36116[(2)]);
var state_36116__$1 = state_36116;
var statearr_36147_37307 = state_36116__$1;
(statearr_36147_37307[(2)] = inst_36100);

(statearr_36147_37307[(1)] = (7));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_36117 === (8))){
var inst_36077 = (state_36116[(8)]);
var inst_36088 = (state_36116[(11)]);
var tmp36142 = inst_36077;
var inst_36077__$1 = tmp36142;
var inst_36078 = inst_36088;
var state_36116__$1 = (function (){var statearr_36148 = state_36116;
(statearr_36148[(7)] = inst_36078);

(statearr_36148[(8)] = inst_36077__$1);

return statearr_36148;
})();
var statearr_36149_37309 = state_36116__$1;
(statearr_36149_37309[(2)] = null);

(statearr_36149_37309[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
return null;
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
});
return (function() {
var cljs$core$async$state_machine__33219__auto__ = null;
var cljs$core$async$state_machine__33219__auto____0 = (function (){
var statearr_36152 = [null,null,null,null,null,null,null,null,null,null,null,null,null,null];
(statearr_36152[(0)] = cljs$core$async$state_machine__33219__auto__);

(statearr_36152[(1)] = (1));

return statearr_36152;
});
var cljs$core$async$state_machine__33219__auto____1 = (function (state_36116){
while(true){
var ret_value__33220__auto__ = (function (){try{while(true){
var result__33221__auto__ = switch__33218__auto__(state_36116);
if(cljs.core.keyword_identical_QMARK_(result__33221__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
continue;
} else {
return result__33221__auto__;
}
break;
}
}catch (e36153){var ex__33222__auto__ = e36153;
var statearr_36154_37310 = state_36116;
(statearr_36154_37310[(2)] = ex__33222__auto__);


if(cljs.core.seq((state_36116[(4)]))){
var statearr_36155_37311 = state_36116;
(statearr_36155_37311[(1)] = cljs.core.first((state_36116[(4)])));

} else {
throw ex__33222__auto__;
}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
}})();
if(cljs.core.keyword_identical_QMARK_(ret_value__33220__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
var G__37315 = state_36116;
state_36116 = G__37315;
continue;
} else {
return ret_value__33220__auto__;
}
break;
}
});
cljs$core$async$state_machine__33219__auto__ = function(state_36116){
switch(arguments.length){
case 0:
return cljs$core$async$state_machine__33219__auto____0.call(this);
case 1:
return cljs$core$async$state_machine__33219__auto____1.call(this,state_36116);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
cljs$core$async$state_machine__33219__auto__.cljs$core$IFn$_invoke$arity$0 = cljs$core$async$state_machine__33219__auto____0;
cljs$core$async$state_machine__33219__auto__.cljs$core$IFn$_invoke$arity$1 = cljs$core$async$state_machine__33219__auto____1;
return cljs$core$async$state_machine__33219__auto__;
})()
})();
var state__33373__auto__ = (function (){var statearr_36159 = f__33372__auto__();
(statearr_36159[(6)] = c__33371__auto___37290);

return statearr_36159;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped(state__33373__auto__);
}));


return out;
}));

(cljs.core.async.partition.cljs$lang$maxFixedArity = 3);

/**
 * Deprecated - this function will be removed. Use transducer instead
 */
cljs.core.async.partition_by = (function cljs$core$async$partition_by(var_args){
var G__36166 = arguments.length;
switch (G__36166) {
case 2:
return cljs.core.async.partition_by.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
case 3:
return cljs.core.async.partition_by.cljs$core$IFn$_invoke$arity$3((arguments[(0)]),(arguments[(1)]),(arguments[(2)]));

break;
default:
throw (new Error(["Invalid arity: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(arguments.length)].join('')));

}
});

(cljs.core.async.partition_by.cljs$core$IFn$_invoke$arity$2 = (function (f,ch){
return cljs.core.async.partition_by.cljs$core$IFn$_invoke$arity$3(f,ch,null);
}));

(cljs.core.async.partition_by.cljs$core$IFn$_invoke$arity$3 = (function (f,ch,buf_or_n){
var out = cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1(buf_or_n);
var c__33371__auto___37317 = cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1((1));
cljs.core.async.impl.dispatch.run((function (){
var f__33372__auto__ = (function (){var switch__33218__auto__ = (function (state_36219){
var state_val_36220 = (state_36219[(1)]);
if((state_val_36220 === (7))){
var inst_36215 = (state_36219[(2)]);
var state_36219__$1 = state_36219;
var statearr_36225_37318 = state_36219__$1;
(statearr_36225_37318[(2)] = inst_36215);

(statearr_36225_37318[(1)] = (3));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_36220 === (1))){
var inst_36170 = [];
var inst_36171 = inst_36170;
var inst_36172 = new cljs.core.Keyword("cljs.core.async","nothing","cljs.core.async/nothing",-69252123);
var state_36219__$1 = (function (){var statearr_36227 = state_36219;
(statearr_36227[(7)] = inst_36172);

(statearr_36227[(8)] = inst_36171);

return statearr_36227;
})();
var statearr_36228_37319 = state_36219__$1;
(statearr_36228_37319[(2)] = null);

(statearr_36228_37319[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_36220 === (4))){
var inst_36175 = (state_36219[(9)]);
var inst_36175__$1 = (state_36219[(2)]);
var inst_36176 = (inst_36175__$1 == null);
var inst_36177 = cljs.core.not(inst_36176);
var state_36219__$1 = (function (){var statearr_36229 = state_36219;
(statearr_36229[(9)] = inst_36175__$1);

return statearr_36229;
})();
if(inst_36177){
var statearr_36230_37320 = state_36219__$1;
(statearr_36230_37320[(1)] = (5));

} else {
var statearr_36231_37321 = state_36219__$1;
(statearr_36231_37321[(1)] = (6));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_36220 === (15))){
var inst_36171 = (state_36219[(8)]);
var inst_36207 = cljs.core.vec(inst_36171);
var state_36219__$1 = state_36219;
return cljs.core.async.impl.ioc_helpers.put_BANG_(state_36219__$1,(18),out,inst_36207);
} else {
if((state_val_36220 === (13))){
var inst_36201 = (state_36219[(2)]);
var state_36219__$1 = state_36219;
var statearr_36234_37325 = state_36219__$1;
(statearr_36234_37325[(2)] = inst_36201);

(statearr_36234_37325[(1)] = (7));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_36220 === (6))){
var inst_36171 = (state_36219[(8)]);
var inst_36204 = inst_36171.length;
var inst_36205 = (inst_36204 > (0));
var state_36219__$1 = state_36219;
if(cljs.core.truth_(inst_36205)){
var statearr_36240_37330 = state_36219__$1;
(statearr_36240_37330[(1)] = (15));

} else {
var statearr_36243_37331 = state_36219__$1;
(statearr_36243_37331[(1)] = (16));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_36220 === (17))){
var inst_36212 = (state_36219[(2)]);
var inst_36213 = cljs.core.async.close_BANG_(out);
var state_36219__$1 = (function (){var statearr_36246 = state_36219;
(statearr_36246[(10)] = inst_36212);

return statearr_36246;
})();
var statearr_36247_37335 = state_36219__$1;
(statearr_36247_37335[(2)] = inst_36213);

(statearr_36247_37335[(1)] = (7));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_36220 === (3))){
var inst_36217 = (state_36219[(2)]);
var state_36219__$1 = state_36219;
return cljs.core.async.impl.ioc_helpers.return_chan(state_36219__$1,inst_36217);
} else {
if((state_val_36220 === (12))){
var inst_36171 = (state_36219[(8)]);
var inst_36191 = cljs.core.vec(inst_36171);
var state_36219__$1 = state_36219;
return cljs.core.async.impl.ioc_helpers.put_BANG_(state_36219__$1,(14),out,inst_36191);
} else {
if((state_val_36220 === (2))){
var state_36219__$1 = state_36219;
return cljs.core.async.impl.ioc_helpers.take_BANG_(state_36219__$1,(4),ch);
} else {
if((state_val_36220 === (11))){
var inst_36175 = (state_36219[(9)]);
var inst_36171 = (state_36219[(8)]);
var inst_36179 = (state_36219[(11)]);
var inst_36188 = inst_36171.push(inst_36175);
var tmp36249 = inst_36171;
var inst_36171__$1 = tmp36249;
var inst_36172 = inst_36179;
var state_36219__$1 = (function (){var statearr_36258 = state_36219;
(statearr_36258[(12)] = inst_36188);

(statearr_36258[(7)] = inst_36172);

(statearr_36258[(8)] = inst_36171__$1);

return statearr_36258;
})();
var statearr_36261_37339 = state_36219__$1;
(statearr_36261_37339[(2)] = null);

(statearr_36261_37339[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_36220 === (9))){
var inst_36172 = (state_36219[(7)]);
var inst_36184 = cljs.core.keyword_identical_QMARK_(inst_36172,new cljs.core.Keyword("cljs.core.async","nothing","cljs.core.async/nothing",-69252123));
var state_36219__$1 = state_36219;
var statearr_36265_37340 = state_36219__$1;
(statearr_36265_37340[(2)] = inst_36184);

(statearr_36265_37340[(1)] = (10));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_36220 === (5))){
var inst_36175 = (state_36219[(9)]);
var inst_36180 = (state_36219[(13)]);
var inst_36172 = (state_36219[(7)]);
var inst_36179 = (state_36219[(11)]);
var inst_36179__$1 = (f.cljs$core$IFn$_invoke$arity$1 ? f.cljs$core$IFn$_invoke$arity$1(inst_36175) : f.call(null,inst_36175));
var inst_36180__$1 = cljs.core._EQ_.cljs$core$IFn$_invoke$arity$2(inst_36179__$1,inst_36172);
var state_36219__$1 = (function (){var statearr_36268 = state_36219;
(statearr_36268[(13)] = inst_36180__$1);

(statearr_36268[(11)] = inst_36179__$1);

return statearr_36268;
})();
if(inst_36180__$1){
var statearr_36272_37357 = state_36219__$1;
(statearr_36272_37357[(1)] = (8));

} else {
var statearr_36273_37358 = state_36219__$1;
(statearr_36273_37358[(1)] = (9));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_36220 === (14))){
var inst_36175 = (state_36219[(9)]);
var inst_36179 = (state_36219[(11)]);
var inst_36193 = (state_36219[(2)]);
var inst_36197 = [];
var inst_36198 = inst_36197.push(inst_36175);
var inst_36171 = inst_36197;
var inst_36172 = inst_36179;
var state_36219__$1 = (function (){var statearr_36275 = state_36219;
(statearr_36275[(7)] = inst_36172);

(statearr_36275[(8)] = inst_36171);

(statearr_36275[(14)] = inst_36198);

(statearr_36275[(15)] = inst_36193);

return statearr_36275;
})();
var statearr_36279_37365 = state_36219__$1;
(statearr_36279_37365[(2)] = null);

(statearr_36279_37365[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_36220 === (16))){
var state_36219__$1 = state_36219;
var statearr_36282_37366 = state_36219__$1;
(statearr_36282_37366[(2)] = null);

(statearr_36282_37366[(1)] = (17));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_36220 === (10))){
var inst_36186 = (state_36219[(2)]);
var state_36219__$1 = state_36219;
if(cljs.core.truth_(inst_36186)){
var statearr_36283_37367 = state_36219__$1;
(statearr_36283_37367[(1)] = (11));

} else {
var statearr_36285_37368 = state_36219__$1;
(statearr_36285_37368[(1)] = (12));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_36220 === (18))){
var inst_36209 = (state_36219[(2)]);
var state_36219__$1 = state_36219;
var statearr_36289_37369 = state_36219__$1;
(statearr_36289_37369[(2)] = inst_36209);

(statearr_36289_37369[(1)] = (17));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_36220 === (8))){
var inst_36180 = (state_36219[(13)]);
var state_36219__$1 = state_36219;
var statearr_36291_37370 = state_36219__$1;
(statearr_36291_37370[(2)] = inst_36180);

(statearr_36291_37370[(1)] = (10));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
return null;
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
});
return (function() {
var cljs$core$async$state_machine__33219__auto__ = null;
var cljs$core$async$state_machine__33219__auto____0 = (function (){
var statearr_36293 = [null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null];
(statearr_36293[(0)] = cljs$core$async$state_machine__33219__auto__);

(statearr_36293[(1)] = (1));

return statearr_36293;
});
var cljs$core$async$state_machine__33219__auto____1 = (function (state_36219){
while(true){
var ret_value__33220__auto__ = (function (){try{while(true){
var result__33221__auto__ = switch__33218__auto__(state_36219);
if(cljs.core.keyword_identical_QMARK_(result__33221__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
continue;
} else {
return result__33221__auto__;
}
break;
}
}catch (e36294){var ex__33222__auto__ = e36294;
var statearr_36295_37374 = state_36219;
(statearr_36295_37374[(2)] = ex__33222__auto__);


if(cljs.core.seq((state_36219[(4)]))){
var statearr_36299_37375 = state_36219;
(statearr_36299_37375[(1)] = cljs.core.first((state_36219[(4)])));

} else {
throw ex__33222__auto__;
}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
}})();
if(cljs.core.keyword_identical_QMARK_(ret_value__33220__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
var G__37376 = state_36219;
state_36219 = G__37376;
continue;
} else {
return ret_value__33220__auto__;
}
break;
}
});
cljs$core$async$state_machine__33219__auto__ = function(state_36219){
switch(arguments.length){
case 0:
return cljs$core$async$state_machine__33219__auto____0.call(this);
case 1:
return cljs$core$async$state_machine__33219__auto____1.call(this,state_36219);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
cljs$core$async$state_machine__33219__auto__.cljs$core$IFn$_invoke$arity$0 = cljs$core$async$state_machine__33219__auto____0;
cljs$core$async$state_machine__33219__auto__.cljs$core$IFn$_invoke$arity$1 = cljs$core$async$state_machine__33219__auto____1;
return cljs$core$async$state_machine__33219__auto__;
})()
})();
var state__33373__auto__ = (function (){var statearr_36303 = f__33372__auto__();
(statearr_36303[(6)] = c__33371__auto___37317);

return statearr_36303;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped(state__33373__auto__);
}));


return out;
}));

(cljs.core.async.partition_by.cljs$lang$maxFixedArity = 3);


//# sourceMappingURL=cljs.core.async.js.map
